import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, ViewEncapsulation, Input, Output, ViewChild, Pipe, NgModule } from '@angular/core';
import * as i1 from 'formbird-services';
import { FormbirdInjectorService, SearchService, FormbirdServicesModule } from 'formbird-services';
import * as i6 from '@angular/material/icon';
import { MatIconModule } from '@angular/material/icon';
import * as i1$3 from '@angular/platform-browser';
import { BrowserModule } from '@angular/platform-browser';
import * as i9 from '@angular/material/autocomplete';
import { MatAutocompleteTrigger, MatAutocompleteModule } from '@angular/material/autocomplete';
import { FormsModule, ReactiveFormsModule } from '@angular/forms';
import * as i7 from '@angular/material/form-field';
import { MatFormFieldModule } from '@angular/material/form-field';
import * as i8 from '@angular/material/input';
import { MatInputModule } from '@angular/material/input';
import * as i5 from '@angular/material/button';
import { MatButtonModule } from '@angular/material/button';
import { BrowserAnimationsModule } from '@angular/platform-browser/animations';
import { throwError, Subscription, Observable } from 'rxjs';
import * as Handlebars from 'handlebars';
import * as olControl from 'ol/control';
import * as olInteraction from 'ol/interaction';
import { defaults } from 'ol/interaction';
import * as olColor from 'ol/color';
import { asArray } from 'ol/color';
import * as olExtent from 'ol/extent';
import { boundingExtent } from 'ol/extent';
import Feature from 'ol/Feature';
import * as geom from 'ol/geom';
import * as proj from 'ol/proj';
import { transform } from 'ol/proj';
import Fill from 'ol/style/Fill';
import Stroke from 'ol/style/Stroke';
import Style from 'ol/style/Style';
import Circle from 'ol/style/Circle';
import Icon from 'ol/style/Icon';
import LineString from 'ol/geom/LineString';
import TileLayer from 'ol/layer/Tile';
import Map from 'ol/Map';
import OSM from 'ol/source/OSM';
import View from 'ol/View';
import Overlay from 'ol/Overlay';
import * as i1$1 from 'formbird-sc-shared';
import { SclUtilDateService } from 'formbird-sc-shared';
import { chunk, nth, isString, cloneDeep, isNumber } from 'lodash';
import { SharedConstants } from '@formbird/types';
import { UtilHttpStatus } from '@formbird/shared';
import * as moment from 'moment';
import { getDistance } from 'ol/sphere';
import Text from 'ol/style/Text';
import LayerVector from 'ol/layer/Vector';
import SourceVector from 'ol/source/Vector';
import Point from 'ol/geom/Point';
import Polygon, { circular } from 'ol/geom/Polygon';
import * as i1$2 from '@angular/common/http';
import { HttpParams, HttpHeaders } from '@angular/common/http';
import { retry, catchError } from 'rxjs/operators';
import * as i4 from '@angular/common';
import * as i10 from '@angular/material/core';
import MultiLineString from 'ol/geom/MultiLineString';
import MultiPolygon from 'ol/geom/MultiPolygon';
import MultiPoint from 'ol/geom/MultiPoint';
import Group from 'ol/layer/Group';
import TileGrid from 'ol/tilegrid/TileGrid';
import TileWMS from 'ol/source/TileWMS';
import { __awaiter } from 'tslib';
import VectorTileLayer from 'ol/layer/VectorTile';
import VectorTileSource from 'ol/source/VectorTile';
import MVT from 'ol/format/MVT';
import styleFunction from 'ol-mapbox-style/dist/stylefunction';
import Heatmap from 'ol/layer/Heatmap';
import { register } from 'ol/proj/proj4';
import * as condition from 'ol/events/condition';
import Control from 'ol/control/Control';
import GeoJSON from 'ol/format/GeoJSON';
import TileImage from 'ol/source/TileImage';
import Modify from 'ol/interaction/Modify';
import Select from 'ol/interaction/Select';
import FullScreen from 'ol/control/FullScreen';
import Draw, { createRegularPolygon, createBox } from 'ol/interaction/Draw';
import CircleShape from 'ol/geom/Circle';
import Snap from 'ol/interaction/Snap';
import Zoom from 'ol/control/Zoom';
import proj4 from 'proj4';
import Cluster from 'ol/source/Cluster';
import { setDefaultOptions, loadModules } from 'esri-loader';

class GoogleMapLoaderService {
    constructor() {
        this.URL = 'https://maps.googleapis.com/maps/api/js';
        this.KEY = null;
        this.CLIENT = null;
        this.SENSOR = false;
        this.VERSION = '3.14';
        this.LIBRARIES = null;
        this.WINDOW_CALLBACK_NAME = '__google_maps_api_provider_initializator__';
        this.script = null;
        this.google = null;
        this.loading = false;
        this.callbacks = [];
        this.onLoadEvents = [];
    }
    load() {
        let url = this.URL;
        if (this.SENSOR === true) {
            url += '?sensor=true';
        }
        else {
            url += '?sensor=false';
        }
        if (this.KEY != null) {
            url += '&key=' + this.KEY;
        }
        if (this.CLIENT != null) {
            url += '&client=' + this.CLIENT + '&v=' + this.VERSION;
        }
        if (this.LIBRARIES != null) {
            url += '&libraries=' + this.LIBRARIES;
        }
        url += '&callback=' + this.WINDOW_CALLBACK_NAME;
        // console.log('******** google-map-loader.ts, window.google = ' + window.google);
        this.google = window.google;
        const scriptLoadingPromise = new Promise((resolve, reject) => {
            if (this.google == null) {
                this.script = document.createElement('script');
                this.script.type = 'text/javascript';
                this.script.src = url;
                document.body.appendChild(this.script);
                (window)[this.WINDOW_CALLBACK_NAME] = () => {
                    this.google = window.google;
                    resolve(this.google);
                };
                this.script.onerror = (error) => { reject(error); };
            }
            else {
                resolve(this.google);
            }
        });
        return scriptLoadingPromise;
    }
    load_OLD() {
        return new Promise((resolve) => {
            if (this.google === null) {
                if (this.loading === true) {
                    resolve(this.google);
                }
                else {
                    this.loading = true;
                    window[this.WINDOW_CALLBACK_NAME] = (function (self) {
                        return function () {
                            self.google = null;
                            self.loading = false;
                            self.callbacks = [];
                            self.onLoadEvents = [];
                            if (typeof window.google !== 'undefined') {
                                delete window.google;
                            }
                            if (typeof window[self.WINDOW_CALLBACK_NAME] !== 'undefined') {
                                delete window[self.WINDOW_CALLBACK_NAME];
                            }
                            if (self.script !== null) {
                                self.script.parentElement.removeChild(self.script);
                                self.script = null;
                            }
                        };
                    })(this);
                    let url = this.URL;
                    if (this.SENSOR === true) {
                        url += '?sensor=true';
                    }
                    else {
                        url += '?sensor=false';
                    }
                    if (this.KEY != null) {
                        url += '&key=' + this.KEY;
                    }
                    if (this.CLIENT != null) {
                        url += '&client=' + this.CLIENT + '&v=' + this.VERSION;
                    }
                    if (this.LIBRARIES != null) {
                        url += '&libraries=' + this.LIBRARIES;
                    }
                    url += '&callback=' + this.WINDOW_CALLBACK_NAME;
                    this.script = document.createElement('script');
                    this.script.type = 'text/javascript';
                    this.script.src = url;
                    this.script.onload = () => {
                        resolve(window.google);
                    };
                    document.body.appendChild(this.script);
                }
            }
            else {
                resolve(this.google);
            }
        });
    }
}
/** @nocollapse */ /** @nocollapse */ GoogleMapLoaderService.ɵfac = function GoogleMapLoaderService_Factory(t) { return new (t || GoogleMapLoaderService)(); };
/** @nocollapse */ /** @nocollapse */ GoogleMapLoaderService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: GoogleMapLoaderService, factory: GoogleMapLoaderService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(GoogleMapLoaderService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return []; }, null);
})();

class SclMapConstantService {
}
SclMapConstantService.MAP_PRIMARY_ASSET = 'https://fileshare.formbird.com/fb/sc-component/map-icons/primary.png';
SclMapConstantService.MAP_SECONDARY_ASSET = 'https://fileshare.formbird.com/fb/sc-component/map-icons/secondary.png';
SclMapConstantService.MAP_MARKER = 'https://fileshare.formbird.com/fb/sc-component/map-icons/marker.png';
SclMapConstantService.ASSET_PRIMARY_TYPE = 'primaryAsset';
SclMapConstantService.ASSET_SECONDARY_TYPE = 'secondaryAsset';
SclMapConstantService.AVL_SPEED_BEGINNING = 'https://fileshare.formbird.com/fb/sc-component/map-icons/pin30';
SclMapConstantService.HEADING_THRESHOLD_H0 = 22.5;
SclMapConstantService.HEADING_THRESHOLD_H1 = 67.5;
SclMapConstantService.HEADING_THRESHOLD_H2 = 112.5;
SclMapConstantService.HEADING_THRESHOLD_H3 = 157.5;
SclMapConstantService.HEADING_THRESHOLD_H4 = 202.5;
SclMapConstantService.HEADING_THRESHOLD_H5 = 247.5;
SclMapConstantService.HEADING_THRESHOLD_H6 = 292.5;
SclMapConstantService.HEADING_THRESHOLD_H7 = 337.5;
SclMapConstantService.DEFAULT_SEARCH_DELAY = 500;
SclMapConstantService.DEFAULT_SEARCH_LENGTH = 3;
SclMapConstantService.AVL_SPEED_H0 = '_h0';
SclMapConstantService.AVL_SPEED_H1 = '_h1';
SclMapConstantService.AVL_SPEED_H2 = '_h2';
SclMapConstantService.AVL_SPEED_H3 = '_h3';
SclMapConstantService.AVL_SPEED_H4 = '_h4';
SclMapConstantService.AVL_SPEED_H5 = '_h5';
SclMapConstantService.AVL_SPEED_H6 = '_h6';
SclMapConstantService.AVL_SPEED_H7 = '_h7';
SclMapConstantService.EPSG_3857 = 'EPSG:3857';
SclMapConstantService.EPSG_4326 = 'EPSG:4326';
SclMapConstantService.MAP_MARKER_ARROW = 'https://fileshare.formbird.com/fb/sc-component/map-icons/arrow.png';
SclMapConstantService.MAP_MARKER_CROSS_GREEN = 'https://fileshare.formbird.com/fb/sc-component/map-icons/CrosshairGreen.gif';
SclMapConstantService.COMP_TYPE_BOUNDARY = 0; // SclMapConstantService.
SclMapConstantService.COMP_TYPE_ADDRESS_MAP = 1;
SclMapConstantService.COMP_TYPE_STREET_ADDRESS = 2;
SclMapConstantService.COMP_TYPE_SELECTED_ASSET = 3;
SclMapConstantService.DRAWING_MODE_ALL = 0;
SclMapConstantService.DRAWING_MODE_SINGLE = 1;
SclMapConstantService.DRAWING_MODE_MULTI = 2;
SclMapConstantService.STREET = {
    type: 'Feature',
    properties: {
        type: 'street',
        unitNo: '',
        streetNo: '',
        street: '',
        suburb: '',
        postcode: '',
        locationDescription: '',
        country: '',
        iconImage: '',
        iconSize: '',
        state: ''
    },
    geometry: {
        type: 'Point',
        coordinates: []
    }
}; // 15925
SclMapConstantService.DEFAULT_MAP_PARAMETERS = {
    mapViews: [
        {
            serverType: 'tile',
            url: 'https://tile.openstreetmap.org/{z}/{x}/{y}.png',
            crossOrigin: null
        }
    ]
}; // 15754

const compiledHandlebarsTemplates = {};
// this is clone from sclHandlebars.ts but using for mapping and has different parameter
const sclMapHandlebars = (() => {
    return {
        initHandlebars(helpers) {
            // Adding some standard helpers
            // Comparison
            Handlebars.registerHelper('ifEquals', function (arg1, arg2, options) {
                return (arg1 === arg2) ? options.fn(this) : options.inverse(this);
            });
            Handlebars.registerHelper('ifNotEquals', function (arg1, arg2, options) {
                return (arg1 !== arg2) ? options.fn(this) : options.inverse(this);
            });
            Handlebars.registerHelper('switch', function (value, options) {
                let that = {};
                that.switch_value = value;
                that.switch_break = false;
                return options.fn(that);
            });
            Handlebars.registerHelper('case', function (value, options) {
                if (value === this.switch_value) {
                    this.switch_break = true;
                    return options.fn(this);
                }
            });
            Handlebars.registerHelper('default', function (value, options) {
                if (this.switch_break === false) {
                    return value;
                }
            });
            // Date handling
            Handlebars.registerHelper('dateFormat', function (date, format, options) { return moment(date).format(format); });
            Handlebars.registerHelper('dateAdd', function (date, amount, what, options) { return moment(date).add(amount, what).format(); });
            Handlebars.registerHelper('dateFromNow', function (date, options) { return moment(date).fromNow(); });
            Handlebars.registerHelper('dateToNow', function (date, options) { return moment(date).toNow(); });
            Handlebars.registerHelper('dateCalendar', function (date, options) { return moment(date).calendar(); });
            // If component has helpers defined add them in too
            if (typeof helpers !== 'undefined' && helpers !== null) {
                for (const helper of helpers) {
                    if (typeof helper.name === 'string' && typeof helper.function === 'string') {
                        let helpFunc = helper.function;
                        if (typeof helpFunc === 'string') {
                            helpFunc = new Function('return ' + helpFunc)();
                        }
                        Handlebars.registerHelper(helper.name, helpFunc);
                    }
                }
            }
        },
        checkRegisteredHelpers(helpers) {
            if (!helpers) {
                return;
            }
            // console.log('%c ibefore checkRegisteredHelpers : ', 'color:blue');
            // console.log(Handlebars.helpers);
            let isRegistered = true;
            for (let i = 0; i < helpers.length; i++) {
                if (typeof helpers[i].name === 'string' && typeof helpers[i].function === 'string') {
                    if (!(helpers[i].name in Handlebars.helpers)) {
                        isRegistered = false;
                        break;
                    }
                }
            }
            if (!isRegistered) {
                sclMapHandlebars.initHandlebars(helpers);
            }
        },
        processHandlebars(handlebarsString, data, helpers, contextParams, options) {
            if (handlebarsString == null || typeof handlebarsString === 'undefined') {
                return '';
            }
            if ((typeof handlebarsString === 'string' || handlebarsString instanceof String)
                && (handlebarsString.indexOf('{{') < 0)) {
                return handlebarsString;
            }
            sclMapHandlebars.checkRegisteredHelpers(helpers);
            let hStr;
            if ((typeof handlebarsString === 'string' || handlebarsString instanceof String)) {
                hStr = handlebarsString;
            }
            else {
                hStr = JSON.stringify(handlebarsString);
            }
            // begin : 14274
            const handlebarsContext = {
                document: contextParams.doc,
                doc: contextParams.doc,
                account: contextParams.account,
                tpl: contextParams.tpl,
                tplItem: contextParams.tplItem // the current components configuration details
            };
            const invalidField = ['document', 'doc', 'account', 'tpl', 'componentDefinition',
                'results', 'resultsCount', 'resultsIndex', 'result', 'row'];
            if (data) {
                if (Object(data) === data) { // if the second parameter is object has property
                    for (const f in data) {
                        if (f === 'queryResultDocument') {
                            handlebarsContext.row = data[f];
                            handlebarsContext.result = data[f];
                            for (const j in data[f]) {
                                if (data[f].hasOwnProperty(j)) {
                                    if (invalidField.indexOf(j) > -1) {
                                        console.log('Handlebars Context Error: the field ' + j
                                            + ' is already present in document documentId so could not be set.'
                                            + ' It\'s values will NOT be available to handlebars expressions.'
                                            + ' Please advise your Application Developer to not use this field name if possible');
                                        continue;
                                    }
                                    handlebarsContext[j] = data[f][j];
                                }
                            }
                        }
                        else {
                            if (handlebarsContext.hasOwnProperty(f)) {
                                console.log('Handlebars Context Error: the field ' + f
                                    + ' is already present in document documentId so could not be set.'
                                    + ' It\'s values will NOT be available to handlebars expressions.'
                                    + ' Please advise your Application Developer to not use this field name if possible');
                                continue;
                            }
                            handlebarsContext[f] = data[f];
                        }
                    }
                }
                else {
                    console.log('Handlebars Context Error: object ' + data + ' wasn\'t passed in and the parameters is being ignored');
                }
            }
            // end : 14274
            // console.log('handlebarsContext = ' + JSON.stringify(handlebarsContext));
            let result = null;
            try {
                let template;
                if (options === null || options === void 0 ? void 0 : options.handlebarsTemplateName) {
                    // cache the template so it can be used in subsequent runs
                    const templateKey = `${contextParams.tpl.documentId}_${contextParams.tplItem.name}_${options.handlebarsTemplateName}`;
                    if (compiledHandlebarsTemplates[templateKey]) {
                        template = compiledHandlebarsTemplates[templateKey];
                    }
                    else {
                        template = Handlebars.compile(hStr);
                        compiledHandlebarsTemplates[templateKey] = template;
                    }
                }
                else {
                    template = Handlebars.compile(hStr);
                }
                result = template(handlebarsContext);
            }
            catch (err) {
                err.hStr = hStr;
                console.log(err);
            }
            return result;
        },
        processIntHandlebars(handlebarsString, data, helpers, contextParams, options) {
            const hStr = sclMapHandlebars.processHandlebars(handlebarsString, data, helpers, contextParams, options);
            if (hStr) {
                return parseInt(hStr, 0);
            }
            else {
                return 0;
            }
        },
        processFloatHandlebars(handlebarsString, data, helpers, contextParams, options) {
            const hStr = sclMapHandlebars.processHandlebars(handlebarsString, data, helpers, contextParams, options);
            if (hStr) {
                return parseFloat(hStr);
            }
            else {
                return 0;
            }
        },
        processBooleanHandlebars(handlebarsString, data, helpers, contextParams, options) {
            return sclMapHandlebars.processHandlebars(handlebarsString, data, helpers, contextParams, options) === 'true';
        },
        processArrayHandlebars(handlebarsString, data, helpers, contextParams, options) {
            const hStr = sclMapHandlebars.processHandlebars(handlebarsString, data, helpers, contextParams, options);
            if (hStr) {
                try {
                    const obj = JSON.parse(hStr);
                    const arr = [];
                    for (const i in obj) {
                        if (obj.hasOwnProperty(i)) {
                            arr.push(obj[i]);
                        }
                    }
                    return arr;
                }
                catch (err) {
                    return null;
                }
            }
            else {
                return null;
            }
        }
    };
})();

class SclUtilMapService {
    constructor() {
        this.sclUtilDate = new SclUtilDateService();
    }
    isContainAsset(asset, assets) {
        if (!assets) {
            return false;
        }
        for (let i = 0; i < assets.length; i++) {
            const ass = assets[i];
            if (ass.properties.linkAssets[0].documentId === asset.properties.linkAssets[0].documentId) {
                return true;
            }
        }
        return false;
    }
    isContainAssetWithType(asset, features) {
        if (!features) {
            return false;
        }
        for (let i = 0; i < features.length; i++) {
            const ass = features[i];
            if (ass.properties.linkAssets[0].documentId === asset.properties.linkAssets[0].documentId) {
                return true;
            }
        }
        return false;
    }
    containLayer(item, items) {
        if (!items) {
            return false;
        }
        for (let i = 0; i < items.length; i++) {
            const pos = items[i];
            if (pos === 'All' || pos === 'all') {
                return false;
            }
        }
        for (let i = 0; i < items.length; i++) {
            const pos = items[i];
            if (item === pos) {
                return true;
            }
        }
        return false;
    }
    removeItemFromMap(id, sourceVector) {
        const fea = sourceVector.getFeatureById(id);
        if (fea) {
            sourceVector.removeFeature(fea);
        }
    }
    getIdxAssetByType(features, type) {
        for (let i = 0; i < features.length; i++) {
            if (features[i].properties.type === type) {
                return i;
            }
        }
        return -1;
    }
    getQueryGeo(coor, coorNext, filter, geoJsonField) {
        var _a, _b, _c, _d;
        // if (!filter) { return null; }
        let res;
        let filterObj;
        if (typeof filter === 'string') {
            res = filter.replace(/'/g, '"');
            filterObj = JSON.parse(res);
        }
        else {
            filterObj = filter;
        }
        let command = '';
        if (geoJsonField) {
            command = geoJsonField + '.features.geometry';
        }
        else {
            command = 'features.geometry';
        }
        const feature = {};
        feature[command] = {
            shape: {
                type: 'envelope',
                coordinates: [coor, coorNext]
            },
            relation: 'intersects'
        };
        const geoshape = {
            geo_shape: feature
        };
        if ((_b = (_a = filterObj === null || filterObj === void 0 ? void 0 : filterObj.query) === null || _a === void 0 ? void 0 : _a.bool) === null || _b === void 0 ? void 0 : _b.filter) {
            filterObj.query.bool.filter.push(geoshape);
        }
        else if ((_d = (_c = filterObj === null || filterObj === void 0 ? void 0 : filterObj.query) === null || _c === void 0 ? void 0 : _c.bool) === null || _d === void 0 ? void 0 : _d.must) {
            filterObj.query.bool.must.push(geoshape);
        }
        const query = JSON.stringify(filterObj);
        // logger.info("Query get avl event is " + query);
        return query;
    }
    getPointFeature(location, image, name, id, relatedAsset, color, layerDisplayOnly, tooltip, anchor, type, layerName) {
        const graphPoint = new Feature(new geom.Point(location));
        const properties = {
            icon: image,
            name,
            id
        };
        if (color) {
            properties.color = color;
        }
        if (tooltip) {
            properties.tooltip = tooltip;
        }
        if (layerDisplayOnly) {
            properties.layerDisplayOnly = layerDisplayOnly;
        }
        if (type) {
            properties.type = type;
        }
        if (anchor) {
            properties.anchor = anchor;
        }
        if (layerName) {
            properties.layerName = layerName;
        }
        if (relatedAsset) {
            for (const field in relatedAsset) {
                if (relatedAsset.hasOwnProperty(field)) {
                    const value = relatedAsset[field];
                    properties[field] = value;
                }
            }
        }
        const style = new Style({
            image: new Icon({
                anchor: [0.5, 0.5],
                anchorXUnits: 'fraction',
                anchorYUnits: 'fraction',
                opacity: 1.0,
                scale: 1,
                src: image
            })
        });
        graphPoint.setProperties(properties);
        graphPoint.setStyle(style);
        return graphPoint;
    }
    getLineFeature(coordinates, id, name, EPSG, layer, relatedAsset, color, popup, layerName, layerDisplayOnly, lineDash) {
        const feature = this.parseToLine(coordinates, id, EPSG);
        const typeFeature = 'line';
        const lineWidth = layer.lineWidth !== undefined ? layer.lineWidth : 4;
        const lineCap = layer.lineCap !== undefined ? layer.lineCap : 'round';
        const properties = {
            name: name,
            color: color,
            id: id,
            tooltip: popup,
            typeFeature: typeFeature,
            lineWidth: lineWidth,
            lineCap: lineCap
        };
        if (lineDash) {
            properties.lineDash = lineDash;
        }
        if (layerName) {
            properties.layerName = layerName;
        }
        if (layerDisplayOnly) {
            properties.layerDisplayOnly = layerDisplayOnly;
        }
        if (relatedAsset) {
            for (const field in relatedAsset) {
                if (relatedAsset.hasOwnProperty(field)) {
                    properties[field] = relatedAsset[field];
                }
            }
        }
        feature.setProperties(properties);
        return feature;
    }
    parseRelatedField(source, relatedFields, primaryFields, secondaryFields) {
        const relatedAsset = {};
        if (primaryFields) {
            relatedAsset.primaryFields = {};
            for (const field in primaryFields) {
                if (primaryFields.hasOwnProperty(field)) {
                    const fieldAsset = primaryFields[field];
                    relatedAsset.primaryFields[field] = source[fieldAsset];
                }
            }
        }
        if (secondaryFields) {
            relatedAsset.secondaryFields = {};
            for (const field in relatedFields) {
                if (relatedFields.hasOwnProperty(field)) {
                    const fieldAsset = relatedFields[field];
                    relatedAsset.secondaryFields[field] = source[fieldAsset];
                }
            }
        }
        if (relatedFields) {
            relatedAsset.mainFields = {};
            for (const field in relatedFields) {
                if (relatedFields.hasOwnProperty(field)) {
                    const fieldAsset = relatedFields[field];
                    relatedAsset.mainFields[field] = source[fieldAsset];
                }
            }
        }
        return relatedAsset;
    }
    parseToLine(coor, id, toEPSG) {
        const array = [];
        for (let i = 0; i < coor.length; i++) {
            const coordinate = coor[i];
            const coordi = transform([parseFloat(coordinate[0]), parseFloat(coordinate[1])], 'EPSG:4326', toEPSG);
            array.push(coordi);
        }
        const lineFeature = new Feature(new LineString(array));
        lineFeature.setId(id);
        return lineFeature;
    }
    queryLastEvent(imei) {
        const filter = {
            query: {
                bool: {
                    filter: [
                        {
                            match: {
                                'features.properties.imei': {
                                    query: imei
                                }
                            }
                        }
                    ]
                }
            },
            /*"sort": [
                {
                    "features.properties.eventDate": "desc"
                }
            ],*/
            size: 1
        };
        console.log('Query get last event is ' + JSON.stringify(filter));
        return filter;
    }
    parseAVLData(data) {
        const feature = data.features[0];
        const lat = feature.geometry.coordinates[0];
        const lon = feature.geometry.coordinates[1];
        const properties = feature.properties;
        const object = {};
        object.latitude = lat;
        object.longitude = lon;
        const currentDate = new Date(properties.eventDate);
        object.eventDate = currentDate;
        object.speedKPH = parseInt(properties.speedKPH, 10);
        let streetNo;
        let street;
        let town;
        let postcode;
        let state;
        let country;
        if (properties && properties.address) {
            streetNo = properties.address.streetNo;
            street = properties.address.street;
            town = properties.address.town;
            postcode = properties.address.postcode;
            state = properties.address.state;
            country = properties.address.country;
        }
        let address = '';
        if (streetNo) {
            address = streetNo;
        }
        if (street) {
            address += ', ' + street;
        }
        if (state) {
            address += ', ' + state;
        }
        if (town) {
            address += ', ' + town;
        }
        if (postcode) {
            address += ', ' + postcode;
        }
        if (country) {
            address += ', ' + country;
        }
        if (address) {
            object.address = address;
        }
        return object;
    }
    parseAVLData_New(item) {
        const feature = item.locationGeo.features[0];
        const properties = feature.properties;
        const currentDate = new Date();
        const newEventDate = new Date(item.eventDate);
        const obj = {};
        obj.id = item._id;
        obj.imei = item.imeis[0];
        obj.longitude = item.locationGeo.features[0].geometry.coordinates[0];
        obj.latitude = item.locationGeo.features[0].geometry.coordinates[1];
        obj.speedKPH = item.speedKPH;
        obj.heading = item.heading;
        obj.eventDate = item.eventDate;
        obj.address = ''; // TO DO : s? parse khi có json
        return obj;
    }
    checkAVLSpeed(beginning, speedKPH, heading, speedA, speedB, speedC, speedD, speedE) {
        let result = beginning;
        let exist = false;
        if (speedKPH <= speedA) {
            result += '_red_dot';
            exist = true;
        }
        else if (speedA < speedKPH && speedKPH <= speedB) {
            result += '_orange';
            if (SclMapConstantService.HEADING_THRESHOLD_H7 < heading || heading <= SclMapConstantService.HEADING_THRESHOLD_H0) {
                result += SclMapConstantService.AVL_SPEED_H0;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H0 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H1) {
                result += SclMapConstantService.AVL_SPEED_H1;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H1 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H2) {
                result += SclMapConstantService.AVL_SPEED_H2;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H2 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H3) {
                result += SclMapConstantService.AVL_SPEED_H3;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H3 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H4) {
                result += SclMapConstantService.AVL_SPEED_H4;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H4 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H5) {
                result += SclMapConstantService.AVL_SPEED_H5;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H5 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H6) {
                result += SclMapConstantService.AVL_SPEED_H6;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H6 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H7) {
                result += SclMapConstantService.AVL_SPEED_H7;
            }
            exist = true;
        }
        else if (speedB < speedKPH && speedKPH <= speedC) {
            result += '_green';
            if (SclMapConstantService.HEADING_THRESHOLD_H7 < heading || heading <= SclMapConstantService.HEADING_THRESHOLD_H0) {
                result += SclMapConstantService.AVL_SPEED_H0;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H0 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H1) {
                result += SclMapConstantService.AVL_SPEED_H1;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H1 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H2) {
                result += SclMapConstantService.AVL_SPEED_H2;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H2 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H3) {
                result += SclMapConstantService.AVL_SPEED_H3;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H3 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H4) {
                result += SclMapConstantService.AVL_SPEED_H4;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H4 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H5) {
                result += SclMapConstantService.AVL_SPEED_H5;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H5 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H6) {
                result += SclMapConstantService.AVL_SPEED_H6;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H6 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H7) {
                result += SclMapConstantService.AVL_SPEED_H7;
            }
            exist = true;
        }
        else if (speedC < speedKPH && speedKPH <= speedD) {
            result += '_black';
            if (SclMapConstantService.HEADING_THRESHOLD_H7 < heading || heading <= SclMapConstantService.HEADING_THRESHOLD_H0) {
                result += SclMapConstantService.AVL_SPEED_H0;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H0 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H1) {
                result += SclMapConstantService.AVL_SPEED_H1;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H1 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H2) {
                result += SclMapConstantService.AVL_SPEED_H2;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H2 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H3) {
                result += SclMapConstantService.AVL_SPEED_H3;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H3 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H4) {
                result += SclMapConstantService.AVL_SPEED_H4;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H4 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H5) {
                result += SclMapConstantService.AVL_SPEED_H5;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H5 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H6) {
                result += SclMapConstantService.AVL_SPEED_H6;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H6 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H7) {
                result += SclMapConstantService.AVL_SPEED_H7;
            }
            exist = true;
        }
        else if (speedD < speedKPH && speedKPH <= speedE) {
            result += '_yellow';
            if (SclMapConstantService.HEADING_THRESHOLD_H7 < heading || heading <= SclMapConstantService.HEADING_THRESHOLD_H0) {
                result += SclMapConstantService.AVL_SPEED_H0;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H0 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H1) {
                result += SclMapConstantService.AVL_SPEED_H1;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H1 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H2) {
                result += SclMapConstantService.AVL_SPEED_H2;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H2 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H3) {
                result += SclMapConstantService.AVL_SPEED_H3;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H3 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H4) {
                result += SclMapConstantService.AVL_SPEED_H4;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H4 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H5) {
                result += SclMapConstantService.AVL_SPEED_H5;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H5 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H6) {
                result += SclMapConstantService.AVL_SPEED_H6;
            }
            else if (SclMapConstantService.HEADING_THRESHOLD_H6 < heading && heading <= SclMapConstantService.HEADING_THRESHOLD_H7) {
                result += SclMapConstantService.AVL_SPEED_H7;
            }
            exist = true;
        }
        result += '.png';
        if (exist === false) {
            result = 'styles/images/pp/pin30_black.png';
        }
        return result;
    }
    parseAVLTracePoint(point, timeFormat, imei) {
        // let coor = transform([parseFloat(point.latitude),
        // parseFloat(point.longitude)], 'EPSG:4326', 'EPSG:3857');
        const coor = transform([parseFloat(point.longitude), parseFloat(point.latitude)], 'EPSG:4326', 'EPSG:3857');
        const imeiContent = '<div><bold>IMEI : </bold> ' + imei + '</div>';
        let address = '';
        if (typeof point.address !== 'undefined') {
            address = '<div><bold>Address : </bold> ' + point.address + '</div>';
        }
        const gps = '<div><bold>GPS : </bold> ' + point.latitude.toFixed(4) + '/' +
            point.longitude.toFixed(4) + '</div>';
        const eventDate = new Date(point.eventDate);
        const dateFormat = this.sclUtilDate.parseDate(eventDate, timeFormat);
        const dateContent = '<div><bold>Time : </bold> ' + dateFormat + '</div>';
        const speedContent = '<div><bold>Speed : </bold> ' + point.speedKPH + '</div>';
        const tooltip = imeiContent + address + gps + dateContent + speedContent;
        const propertiesData = {
            'address': tooltip,
            'icon': point.icon
        };
        const pointFeature = new Feature(new geom.Point(coor));
        pointFeature.setProperties(propertiesData);
        return pointFeature;
    }
    constructQueryVehicleData(imeis, doc) {
        const feature = {};
        feature.imei = imeis;
        const terms = {
            terms: feature
        };
        const match = {
            match: {
                appTags: {
                    query: 'avlVehicle'
                }
            }
        };
        const filter = {
            query: {
                bool: {
                    filter: [terms, match]
                }
            }
        };
        const query = JSON.stringify(filter);
        // logger.info("Query imeis from list : " + query);
        const options = {};
        // there is no need to set the pageSize to the default. It only needs to be set if
        // it is different to the default
        // options.pageSize = SharedConstants.DEFAULT_PAGE_SIZE;
        options.filter = query;
        options.document = doc;
        return options;
    }
    constructQueryGeoZones(filter, doc) {
        const res = filter.replace(/'/g, '"');
        const filterObj = JSON.parse(res);
        const query = JSON.stringify(filterObj);
        // logger.info("Query geozone from  : " + query);
        const options = {};
        // there is no need to set the pageSize to the default. It only needs to be set if
        // it is different to the default
        // options.pageSize = SharedConstants.DEFAULT_PAGE_SIZE;
        options.filter = query;
        options.document = doc;
        return options;
    }
    constructQueryDocument(docIds, doc) {
        const documentId = {};
        documentId.documentId = docIds;
        const terms = {
            terms: documentId
        };
        const filter = {
            query: {
                bool: {
                    filter: [terms]
                }
            }
        };
        const query = JSON.stringify(filter);
        // logger.info("Query documentId from list : " + query);
        const options = {};
        // there is no need to set the pageSize to the default. It only needs to be set if
        // it is different to the default
        // options.pageSize = SharedConstants.DEFAULT_PAGE_SIZE;
        options.filter = query;
        options.document = doc;
        return options;
    }
    queryVehicleInfo(imei) {
        const filter = {
            query: {
                bool: {
                    filter: [
                        {
                            match: {
                                imei: {
                                    query: imei
                                }
                            }
                        }
                    ]
                }
            }
        };
        const query = JSON.stringify(filter);
        // logger.info("The Query vehicle info is " + query);
        return query;
    }
    parseAVLQuery(date, imei, numOffSet) {
        const startDate = new Date(date);
        startDate.setHours(0);
        startDate.setMinutes(0);
        startDate.setSeconds(0);
        startDate.setHours(startDate.getHours() + numOffSet);
        // logger.info("Start Date is " + startDate);
        const endDate = new Date(date);
        endDate.setHours(23);
        endDate.setMinutes(59);
        endDate.setSeconds(59);
        endDate.setHours(endDate.getHours() + numOffSet);
        // logger.info("end Date is " + endDate);
        const format = 'YYYY-MM-DD HH:mm:ss';
        const startDateFormat = this.sclUtilDate.parseDate(startDate, format);
        const endDateFormat = this.sclUtilDate.parseDate(endDate, format);
        const filter = {
            query: {
                bool: {
                    filter: [
                        {
                            match: {
                                'features.properties.imei': {
                                    query: imei
                                }
                            }
                        },
                        {
                            range: {
                                'features.properties.eventDate': {
                                    gte: startDateFormat,
                                    lte: endDateFormat,
                                    format: 'yyyy-MM-dd HH:mm:ss'
                                }
                            }
                        }
                    ]
                }
            },
            sort: [
                {
                    'features.properties.eventDate': 'asc'
                }
            ]
        };
        const query = JSON.stringify(filter);
        // logger.info("Query get list trace event is " + query);
        return query;
    }
    positionView(view, lng, lat, zoom, EPSG) {
        lat = typeof lat !== 'undefined' ? lat : 0;
        lng = typeof lng !== 'undefined' ? lng : 0;
        zoom = typeof zoom !== 'undefined' ? zoom : 2;
        EPSG = typeof EPSG !== 'undefined' ? EPSG : 'EPSG:3857';
        view.setCenter(transform([lng, lat], 'EPSG:4326', EPSG));
        view.setZoom(zoom);
        return view;
    }
    setView(lng, lat, zoom, EPSG, minResolution, maxResolution) {
        lat = typeof lat !== 'undefined' ? lat : 0;
        lng = typeof lng !== 'undefined' ? lng : 0;
        zoom = typeof zoom !== 'undefined' ? zoom : 2;
        EPSG = typeof EPSG !== 'undefined' ? EPSG : 'EPSG:3857';
        let view;
        if (minResolution && maxResolution) {
            view = new View({
                projection: EPSG,
                center: transform([lng, lat], 'EPSG:4326', EPSG),
                zoom,
                minResolution,
                maxResolution
            });
        }
        else {
            view = new View({
                projection: EPSG,
                center: transform([lng, lat], 'EPSG:4326', EPSG),
                zoom,
                minZoom: 2
            });
        }
        return view;
    }
    createAddressQuery(geoJsonField) {
        const filter = {
            query: {
                bool: {
                    filter: [
                        { exists: { field: geoJsonField } },
                        { term: { appTags: 'property' } }
                    ]
                }
            }
        };
        console.log('The Query Address is ' + JSON.stringify(filter));
        return filter;
    }
    getDocument(result) {
        const prefix = '_source';
        let hold = result;
        if (result && prefix) {
            const split = prefix.split('.');
            for (let i = 0; i < split.length; i++) {
                if (split[i]) {
                    if (hold[split[i]]) {
                        hold = hold[split[i]];
                    }
                    else {
                        hold = null;
                        break;
                    }
                }
                else {
                    break;
                }
            }
        }
        return hold;
    }
    fit(ConfigService, sourceVector, view, map, maxZoomComponent) {
        let maxZoom = 15;
        if (maxZoomComponent) {
            maxZoom = maxZoomComponent;
        }
        else {
            if (ConfigService.clientConfig().maxZoomLevel) {
                maxZoom = ConfigService.clientConfig().maxZoomLevel;
            }
        }
        const featuresExtent = olExtent.createEmpty();
        sourceVector.getFeatures().forEach(function (feature) {
            olExtent.extend(featuresExtent, feature.getGeometry().getExtent());
        });
        view.fit(featuresExtent, map.getSize(), { maxZoom });
    }
    initializeMap(ConfigService, controls, target, view, interactions, disableMouseWheel, mapLayers, multiLayers) {
        let sourceXYZ = [];
        if (multiLayers && multiLayers.length > 0) {
            sourceXYZ = multiLayers;
        }
        else {
            if (mapLayers) {
                sourceXYZ.push(mapLayers);
            }
            else {
                const tile = new TileLayer({
                    source: new OSM({
                        url: ConfigService.clientConfig().openLayers.tileServer.url,
                        crossOrigin: ConfigService.clientConfig().openLayers.tileServer.crossOrigin,
                        wrapDateLine: false,
                        wrapX: false,
                        noWrap: true
                    })
                });
                sourceXYZ.push(tile);
            }
        }
        let mouseWheel = true;
        if (disableMouseWheel) {
            mouseWheel = false;
        }
        const map = new Map({
            controls: olControl.defaults().extend([
                new olControl.FullScreen()
            ]),
            interactions: olInteraction.defaults({ mouseWheelZoom: mouseWheel }),
            layers: sourceXYZ,
            target,
            view
        });
        if (controls.length) {
            for (let i = 0; i < controls.length; i++) {
                map.addControl(controls[i]);
            }
        }
        if (interactions.length) {
            for (let i = 0; i < interactions.length; i++) {
                map.addInteraction(interactions[i]);
            }
        }
        return map;
    }
    initializeMapDefault(controls, target, view, interactions, disableMouseWheel, mapLayers, multiLayers) {
        let sourceXYZ = [];
        if (multiLayers && multiLayers.length > 0) {
            sourceXYZ = multiLayers;
        }
        else {
            if (mapLayers) {
                sourceXYZ.push(mapLayers);
            }
            else {
                const tile = new TileLayer({
                    source: new OSM({
                        wrapDateLine: false,
                        wrapX: false,
                        noWrap: true
                    })
                });
                sourceXYZ.push(tile);
            }
        }
        let mouseWheel = true;
        if (disableMouseWheel) {
            mouseWheel = false;
        }
        const map = new Map({
            controls: olControl.defaults().extend([
                new olControl.FullScreen()
            ]),
            interactions: olInteraction.defaults({ mouseWheelZoom: mouseWheel }),
            layers: sourceXYZ,
            target,
            view
        });
        if (controls.length) {
            for (let i = 0; i < controls.length; i++) {
                map.addControl(controls[i]);
            }
        }
        if (interactions.length) {
            for (let i = 0; i < interactions.length; i++) {
                map.addInteraction(interactions[i]);
            }
        }
        return map;
    }
    getPointStyle(color, icon, imageAnchor, zIndex) {
        let zIn = 0;
        if (zIndex) {
            zIn = zIndex;
        }
        let pointColor = 'green';
        if (color) {
            pointColor = color;
        }
        let image = new Circle({
            radius: 7,
            fill: new Fill({
                color: '#ffcc33'
            })
        });
        if (icon) {
            let anchor = [0.5, 0.5];
            if (imageAnchor) {
                anchor = imageAnchor;
            }
            image = new Icon(({
                src: icon,
                anchor
            }));
        }
        const style = new Style({
            fill: new Fill({
                color: 'rgba(255, 255, 255, 0.2)'
            }),
            stroke: new Stroke({
                color: pointColor,
                width: 2
            }),
            zIndex: zIn,
            image
        });
        return style;
    }
    getLineStyle(color, properties) {
        let lineColor = 'blue';
        if (color) {
            lineColor = color;
        }
        const style = new Style({
            image: new Circle({
                radius: 7,
                fill: new Fill({
                    color: '#ffcc33'
                })
            })
        });
        const stroke = new Stroke({
            color: lineColor,
            width: 2
        });
        if (properties) {
            if (properties.lineWidth) {
                stroke.setWidth(properties.lineWidth);
            }
            if (properties.lineDash) {
                stroke.setLineDash(properties.lineDash);
            }
            if (properties.lineCap) {
                stroke.setLineCap(properties.lineCap);
            }
        }
        style.setStroke(stroke);
        let fillColor = 'rgba(255, 255, 255, 0.2)';
        if (properties && properties.fillColor) {
            // fillColor = properties.fillColor;
            color = asArray(properties.fillColor);
            color = color.slice();
            if (properties.fillOpacity) {
                color[3] = properties.fillOpacity;
            } // change the alpha of the color
            fillColor = color;
        }
        const fill = new Fill({
            color: fillColor
        });
        style.setFill(fill);
        return style;
    }
    getWrapLon(value) {
        const worlds = Math.floor((value + 180) / 360);
        return value - (worlds * 360);
    }
    getGeocodeAddress(url, key, text, field) {
        // let link = "https://www.geocode.farm/v3/json/forward/?addr=" + text + "&key=a2338e05-e3cb425e93ad-109049bfb516";
        let link = url + text;
        if (key) {
            link = link + '&key=' + key;
        }
        if (field) {
            if (field.country) {
                link = link + '&country=' + field.country;
            }
            if (field.language) {
                link = link + '&lang=' + field.language;
            }
        }
        return link;
    }
    getGoogleAddress(text, key) {
        // https://maps.googleapis.com/maps/api/place/textsearch/json?query=123+main+street&key=YOUR_API_KEY
        // let link = "https://maps.googleapis.com/maps/api/place/textsearch/json?query=" + text + "&key=" + key;
        const link = 'https://maps.googleapis.com/maps/api/place/autocomplete/json?query=' + text + '&key=' + key;
        return link;
    }
    getGeocodeCoordinate(url, lat, lon, field, key) {
        let link = url + '?lat=' + lat + '&lon=' + lon + '&key=' + key + '&count=1';
        if (field) {
            if (field.country) {
                link = link + '&country=' + field.country;
            }
            if (field.language) {
                link = link + '&lang=' + field.language;
            }
        }
        return link;
    }
    getAllCoordinates(feature) {
        const coords = [];
        if (feature.geometry.type === 'Polygon') {
            let k;
            for (k = 0; k < feature.geometry.coordinates[0].length; ++k) {
                coords.push(feature.geometry.coordinates[0][k]);
            }
        }
        else if (feature.geometry.type === 'LineString') {
            let j;
            for (j = 0; j < feature.geometry.coordinates.length; ++j) {
                coords.push(feature.geometry.coordinates[j]);
            }
        }
        else if (feature.geometry.type === 'Point') {
            if (feature.geometry.coordinates.length > 0) {
                coords.push(feature.geometry.coordinates);
            }
        }
        else if (feature.geometry.type === 'MultiPolygon') {
            let k;
            for (k = 0; k < feature.geometry.coordinates.length; ++k) { // loop through each multipolygon
                const pol = feature.geometry.coordinates[k];
                let k1;
                for (k1 = 0; k1 < pol.length; ++k1) { // loop throuch each polygon in this multipolygon
                    const pol1 = pol[k1];
                    if (pol1.length >= 3) { // a valid polygon should have >= 3 coordinates
                        let k2;
                        for (k2 = 0; k2 < pol1.length; ++k2) { // loop throuch each coordinates in this polygon
                            coords.push(pol1[k2]);
                        }
                    }
                }
            }
        }
        else if (feature.geometry.type === 'MultiLineString') {
            let k;
            for (k = 0; k < feature.geometry.coordinates.length; ++k) { // loop through each LineString
                const pol = feature.geometry.coordinates[k];
                if (pol.length >= 2) {
                    let k1;
                    for (k1 = 0; k1 < pol.length; ++k1) { // loop throuch each coordinates in this LineString
                        coords.push(pol[k1]);
                    }
                }
            }
        }
        else if (feature.geometry.type === 'MultiPoint') {
            let k;
            for (k = 0; k < feature.geometry.coordinates.length; ++k) { // loop through each LineString
                coords.push(feature.geometry.coordinates[k]);
            }
        }
        return coords;
    }
    isValidFeature(f) {
        if (f.geometry.type === 'LineString') {
            if (f.geometry.coordinates.length >= 2) {
                return true;
            }
        }
        else if (f.geometry.type === 'Polygon') {
            if (f.geometry.coordinates.length >= 1 && f.geometry.coordinates[0].length >= 3) {
                return true;
            }
        }
        else if (f.geometry.type === 'Point' && f.geometry.coordinates.length > 1) {
            return true;
        }
        else if (f.geometry.type === 'MultiPoint' && f.geometry.coordinates.length > 1) {
            return true;
        }
        else if (f.geometry.type === 'MultiLineString') {
            let k;
            for (k = 0; k < f.geometry.coordinates.length; ++k) { // loop through each LineString
                const pol = f.geometry.coordinates[k];
                if (pol.length < 2) {
                    return false;
                }
            }
            return true;
        }
        else if (f.geometry.type === 'MultiPolygon') {
            let k;
            for (k = 0; k < f.geometry.coordinates.length; ++k) { // loop through each multipolygon
                const pol = f.geometry.coordinates[k];
                let k1;
                for (k1 = 0; k1 < pol.length; ++k1) { // loop throuch each polygon in this multipolygon
                    const pol1 = pol[k1];
                    if (pol1.length < 3) { // a valid polygon should have >= 3 coordinates
                        return false;
                    }
                }
            }
            return true;
        }
        return false;
    }
    transformEPSG(long, lat, from, to) {
        const location = transform([parseFloat(long), parseFloat(lat)], from, to);
        return location;
    }
    transformCoordinate(coordinate, from, to) {
        const location = transform(coordinate, from, to);
        return location;
    }
    parseCellTemplate(tmpl) {
        let str = '';
        let errStr = '';
        try {
            let hasUndefined = false;
            const tmplVars = tmpl.match(/{{.+?}}/g || {}).map(function (data) { return data.slice(2, -2); });
            if (!tmplVars) {
                return tmpl;
            }
            for (let i = 0; i < tmplVars.length; i++) {
                // Removing the regex as it just causes problems with special chars
                /*let reg = new RegExp("{{"+tmplVars[i].replace(/\[/g,"\\\[").replace(/\]/g,"\\\]").
                 replace(/\(/g,"\\\(").replace(/\)/g,"\\\)").
                 replace(/\|/g,"\\\|")+"}}");
                 */
                // Just use a substring replace instead of the regex
                const reg = '{{' + tmplVars[i] + '}}';
                if (eval(tmplVars[i])) {
                    tmpl = tmpl.replace(reg, '"' + eval(tmplVars[i]) + '"');
                }
                else {
                    hasUndefined = true;
                    errStr = tmplVars[i] + ' ; ' + errStr;
                    tmpl = tmpl.replace(reg, '');
                }
            }
            if (hasUndefined) {
                // logger.info("sc-datatables cellTemplate Error : variable is Undefined in template " + errStr);
            }
            str = tmpl;
        }
        catch (e) {
            console.error('sc-datatables cellTemplate Error : variable in ' + tmpl +
                ' is Undefined in Document: ' + ' Error : ' + e.message);
            str = '';
        }
        return str;
    }
    // Deprecated - use sclHandlebars.processHandlebars()
    parseHandlerBar(stringHandlerbars, data) {
        if (stringHandlerbars == null) {
            return '';
        }
        const template = Handlebars.compile(stringHandlerbars);
        const result = template(data);
        return result;
    }
    preSuffixNumbers(pre, suff, num) {
        let fixedNum;
        fixedNum = (pre != null ? pre : '') + (num != null ? num : '') + (suff != null ? suff : '');
        if (fixedNum != null && fixedNum.length > 0) {
            return fixedNum;
        }
        else {
            return null;
        }
    }
    parseAddress(address) {
        const sugg = {};
        sugg.street = address.addressLine;
        const res = address.pos[0].split(',');
        sugg.coordinates = {},
            sugg.coordinates.latitude = res[0];
        sugg.coordinates.longitude = res[1];
        sugg.address = {},
            sugg.address.unitNo = this.preSuffixNumbers(address.unitNumberPrefix, address.unitNumberSuffix, address.unitNumber);
        sugg.address.street_number = this.preSuffixNumbers(address.thoroughfareNumberFromPrefix, address.thoroughfareNumberFromSuffix, address.thoroughfareNumberFrom);
        sugg.address.street_name = '';
        if (address.thoroughfareName) {
            sugg.address.street_name = address.thoroughfareName;
        }
        if (address.thoroughfareTrailingType) {
            sugg.address.street_name += ' ' + address.thoroughfareTrailingType;
        }
        sugg.address.locality = address.locality;
        sugg.address.postal_code = address.postcode;
        if (!address.country) {
            sugg.address.country = 'Australia';
        }
        sugg.address.admin_1 = address.state;
        return sugg;
    }
    createBorderMandatory(doc) {
        // let mandatoryF;
        // if( typeof scope.componentDefinition.mandatoryFields === 'undefined' || scope.componentDefinition.mandatoryFields === null ){
        //     mandatoryF = [ "primaryAsset" ];
        // }
        // else {
        //     mandatoryF = scope.componentDefinition.mandatoryFields;
        // }
        // angular.forEach(mandatoryF, function(value, key) {
        //     //include mandatory=true|false in condition of function fnAddMandatoryBorder
        //     if( typeof scope.componentDefinition.mandatory === 'undefined' || scope.componentDefinition.mandatory === null ){
        //         scope.componentDefinition.mandatory=false;
        //     }
        //     if(scope.componentDefinition.mandatory){
        //         let target = "";
        //         if(angular.equals(value,"unitNo")){
        //             target =  angular.element(element).find("#"+'unitNumD')[0];
        //         } else if(angular.equals(value,"streetNo")){
        //             target =  angular.element(element).find("#"+'streetD')[0];
        //         } else if(angular.equals(value,"street")){
        //             target =  angular.element(element).find("#"+'streetNameD')[0];
        //         } else if(angular.equals(value,"suburb")){
        //             target =  angular.element(element).find("#"+'subUrbTownD')[0];
        //         } else if(angular.equals(value,"postcode")){
        //             target =  angular.element(element).find("#"+'postcodeD')[0];
        //         } else if(angular.equals(value,"country")){
        //             target =  angular.element(element).find("#"+'countryD')[0];
        //         } else if(angular.equals(value,"state")){
        //             target =  angular.element(element).find("#"+'stateD')[0];
        //         } else if(angular.equals(value,"locationDescription")){
        //             target =  angular.element(element).find("#"+'descriptionAddressD')[0];
        //         } else if(angular.equals(value,"coordinates")){
        //             target =  angular.element(element).find("#"+'latitudeD')[0];
        //             $(target).css('border','solid red 1px');
        //             target =  angular.element(element).find("#"+'longitudeD')[0];
        //         } else if(angular.equals(value,"primaryAsset")){
        //             target =  angular.element(element).find("#"+'primaryAsset')[0];
        //         } else if(angular.equals(value,"secondaryAsset")){
        //             target =  angular.element(element).find("#"+'secondaryAsset')[0];
        //         }
        //         $(target).css('border','solid red 1px');
        //     }
        // });
        // scope.change();
    }
    parseQuery(filter, geojsonField) {
        let filterObj;
        if (typeof filter === 'string') {
            const res = filter.replace(/'/g, '"');
            //// logger.info("Handlebars parsing before "+res);
            // res = scope.sclUtilMap.parseCellTemplate(res);
            //// logger.info("Handlebars parsing after"+res);
            filterObj = JSON.parse(res);
        }
        else {
            filterObj = filter;
        }
        if (geojsonField) {
            if (filterObj.query.bool.filter) {
                const term = {
                    term: {}
                };
                const value = geojsonField + '.type';
                term.term[value] = 'FeatureCollection';
                filterObj.query.bool.filter.push(term);
            }
            else if (filterObj.query.bool.must) {
                const exist = {
                    match: {}
                };
                const value = geojsonField + '.type';
                exist.match[value] = {
                    query: 'FeatureCollection'
                },
                    filterObj.query.bool.must.push(exist);
            }
        }
        const query = JSON.stringify(filterObj);
        // logger.info("The query is " + query);
        return filterObj;
    }
    processVicmapSearch(url, scope) {
        // jQuery.getJSON(url, null, function(addressResponse) {
        //     let result = (addressResponse.requestResult.result);
        //     if(result){
        //         let results = [];
        //         for (let k = 0; k < result.length; k++) {
        //             let r = result[k];
        //             let p = r.address;
        //             for (let f = 0; f < p.length; f++) {
        //                 let predict = p[f];
        //                 results.push(parseAddress(predict));
        //             }
        //         }
        //         $timeout(function () {
        //             scope.results.data = results;
        //         });
        //     }
        // });
        // return scope;
    }
    search(scope, text, mapField, psmaAutoCompleteURL, psmaKey) {
        // let newText = text.trim();
        // if(newText === scope.preText) return;
        // if(text !== undefined) {
        //     scope.results.data = [];
        //     scope.preText = text;
        //     scope.inputText = text;
        //     if(scope.geocoderDefaultState) text = text + ", " + scope.geocoderDefaultState;
        //     if(scope.geocoderDefaultCountry) text = text + ", " + scope.geocoderDefaultCountry;
        //     //logger.info("Checking for Address : " + text);
        //     let link = this.getGeocodeAddress(scope.autocompleteURL, scope.apiKey, text, mapField);
        //     if(scope.geocodeName === "vicmap"){
        //         link = this.getGeocodeAddress(scope.autocompleteURL, "", text);
        //         this.processVicmapSearch(link, scope);
        //     }
        //     else if(scope.geocodeName === "psma"){
        //         link = scope.psmaAutoCompleteURL + text;
        //         let apiKey = scope.psmaKey;
        //         //link = autocompleteURL + text;
        //         $http.get(link, { headers: {'API-Key': apiKey} }).then(function(data_result){
        //             if(data_result.statusText == "OK"){
        //                 let suggestions = data_result.data.suggest;
        //                 let results = [];
        //                 for(let i = 0; i < suggestions.length; ++i){
        //                     let sugg = {},
        //                     sugg.street = suggestions[i].address;//show in UI
        //                     sugg.id = suggestions[i].id;
        //                     results.push(sugg);
        //                 }
        //             }
        //             scope.results.data = results;
        //         });
        //     }else if(scope.geocodeName === "psmafarm"){
        //         link = scope.psmafarmAutoCompleteURL + text;
        //         $http.get(link, { headers: {'API-Key': scope.psmafarmKey} }).then(function(data_result){
        //             if(data_result.statusText == "OK"){
        //                 let suggestions = data_result.data.suggest;
        //                 let results = [];
        //                 for(let i = 0; i < suggestions.length; ++i){
        //                     let sugg = {},
        //                     sugg.street = suggestions[i].address;//show in UI
        //                     sugg.id = suggestions[i].id;
        //                     results.push(sugg);
        //                 }
        //             }
        //             scope.results.data = results;
        //         });
        //     }
        //     else {
        //         scope.lastLink = link;
        //         $http.get(link).then(function (data_result) {
        //             let data = data_result.data;
        //             if (data && data.geocoding_results && data.geocoding_results.STATUS.status === "SUCCESS") {
        //                 let suggestions = data.geocoding_results.RESULTS;
        //                 let results = [];
        //                 // check if the results are from the latest query not an earlier one that is out of sync
        //                 if ( data_result.config.url !== scope.lastLink ) {
        //                     //logger.info("Search results are from earlier query, "+data_result.config.url+" ignore this set");
        //                     return;
        //                 }
        //                 for (let i = 0; i < suggestions.length; i++) {
        //                     let predict = suggestions[i];
        //                     let sugg = {},
        //                     sugg.street = predict.formatted_address;
        //                     sugg.address = predict.ADDRESS;
        //                     sugg.coordinates = predict.COORDINATES;
        //                     results.push(sugg);
        //                 }
        //                 scope.results.data = results;
        //             }
        //         }).catch(function(error) {
        //             logger.error("Error : " + error);
        //         });
        //     }
        // }
        // return scope;
    }
    fillGoogleAddress(data, streetData) {
        for (let i = 0; i < data.address_components.length; i++) {
            const addressType = data.address_components[i].types[0];
            const val = data.address_components[i].long_name;
            if (addressType === 'subpremise') {
                streetData.properties.unitNo = val;
            }
            else if (addressType === 'street_number') {
                streetData.properties.streetNo = val;
            }
            else if (addressType === 'route') {
                streetData.properties.street = val;
            }
            else if (addressType === 'administrative_area_level_1') {
                streetData.properties.state = val;
            }
            else if (addressType === 'locality') {
                streetData.properties.suburb = val;
            }
            else if (addressType === 'postal_code') {
                streetData.properties.postcode = val;
            }
            else if (addressType === 'country') {
                streetData.properties.country = val;
            }
        }
        if (data.geometry && data.geometry.location) {
            streetData = this.checkStreetGeometry(streetData);
            if (!isNaN(data.geometry.location.lng)) {
                streetData.geometry.coordinates[0] = data.geometry.location.lng;
            }
            else {
                streetData.geometry.coordinates[0] = data.geometry.location.lng();
            }
            if (!isNaN(data.geometry.location.lat)) {
                streetData.geometry.coordinates[1] = data.geometry.location.lat;
            }
            else {
                streetData.geometry.coordinates[1] = data.geometry.location.lat();
            }
        }
        return streetData;
    }
    checkStreetGeometry(streetData) {
        if (!streetData.geometry) {
            const geometry = {
                type: 'Point',
                coordinates: []
            };
            streetData.geometry = geometry;
        }
        return streetData;
    }
    setTooltipPosition(scope, pixel) {
        // let result = {},
        // let featureLeftPos = pixel[0];
        // let featureTopPos = pixel[1];
        // result.left = featureLeftPos + 'px';
        // result.top = featureTopPos + 'px';
        // // set the tooltip position
        // let tooltipHorizontalPosition;
        // let tooltipVerticalPosition;
        // if (featureLeftPos < scope.mapCenter.x) {
        //     tooltipHorizontalPosition = "left";
        //     //featureLeftPos -= 10;
        // } else {
        //     tooltipHorizontalPosition = "right";
        //     //featureLeftPos += 25;
        // }
        // if (featureTopPos < scope.mapCenter.y) {
        //     tooltipVerticalPosition = "bottom";
        //     //featureTopPos += 10;
        // } else {
        //     tooltipVerticalPosition = "top";
        //     //featureTopPos -= 10;
        // }
        // result.tooltipPosition = tooltipVerticalPosition + "-" + tooltipHorizontalPosition;
        // //scope.infoPosition.left = featureLeftPos + 'px';
        // //scope.infoPosition.top = featureTopPos + 'px';
        // return result;
    }
    streetDataRemoveEmpty(street) {
        if (street.properties.hasOwnProperty('unitNo') && (street.properties.unitNo === null
            || street.properties.unitNo.trim().length === 0)) {
            delete street.properties.unitNo;
        }
        if (street.properties.hasOwnProperty('streetNo') && (street.properties.streetNo === null
            || street.properties.streetNo.trim().length === 0)) {
            delete street.properties.streetNo;
        }
        if (street.properties.hasOwnProperty('street') && (street.properties.street === null
            || street.properties.street.trim().length === 0)) {
            delete street.properties.street;
        }
        if (street.properties.hasOwnProperty('suburb') && (street.properties.suburb === null
            || street.properties.suburb.trim().length === 0)) {
            delete street.properties.suburb;
        }
        if (street.properties.hasOwnProperty('postcode') && (street.properties.postcode === null
            || street.properties.postcode.trim().length === 0)) {
            delete street.properties.postcode;
        }
        if (street.properties.hasOwnProperty('locationDescription') && (street.properties.locationDescription === null
            || street.properties.locationDescription.trim().length === 0)) {
            delete street.properties.locationDescription;
        }
        if (street.properties.hasOwnProperty('country') && (street.properties.country === null
            || street.properties.country.trim().length === 0)) {
            delete street.properties.country;
        }
        if (street.properties.hasOwnProperty('iconImage') && (street.properties.iconImage === null
            || street.properties.iconImage.trim().length === 0)) {
            delete street.properties.iconImage;
        }
        if (street.properties.hasOwnProperty('iconSize') && (street.properties.iconSize === null
            || street.properties.iconSize.trim().length === 0)) {
            delete street.properties.iconSize;
        }
        if (street.properties.hasOwnProperty('state') && (street.properties.state === null
            || street.properties.state.trim().length === 0)) {
            delete street.properties.state;
        }
    }
    createOverlay(container) {
        return new Overlay(({
            element: container,
            autoPan: true,
            positioning: 'center-center',
            autoPanAnimation: {
                duration: 250
            }
        }));
    }
    styleFunction(feature, resolution) {
        const p = feature.getProperties();
        const geometry = feature.getGeometry();
        if (geometry && geometry.getType() === 'Point') {
            let icon = '';
            if (p && p.icon) {
                icon = p.icon;
            }
            const stylePoint = [new Style({
                    image: new Icon(({
                        src: icon,
                        anchor: [0.5, 1]
                    }))
                })];
            return stylePoint;
        }
        const styles = [new Style({
                fill: new Fill({
                    color: 'rgba(255, 255, 255, 0.2)'
                }),
                stroke: new Stroke({
                    color: 'red',
                    width: 2
                }),
                image: new Circle({
                    radius: 7,
                    fill: new Fill({
                        color: '#ffcc33'
                    })
                })
            })];
        if (p && p.displayArrorHeads) {
            geometry.forEachSegment((start, end) => {
                const dx = end[0] - start[0];
                const dy = end[1] - start[1];
                const rotation = Math.atan2(dy, dx);
                // arrows
                styles.push(new Style({
                    geometry: new geom.Point(end),
                    image: new Icon({
                        src: SclMapConstantService.MAP_MARKER_ARROW,
                        anchor: [0.75, 0.5],
                        rotateWithView: false,
                        rotation: -rotation
                    })
                }));
            });
        }
        return styles;
    }
    parseLineString(coor, coor1, nextCoor, nextCoor1) {
        return new Feature(new geom.LineString([[coor, coor1], [nextCoor, nextCoor1]]));
    }
    dexieSearchFunction(filterFunc, pageNumber, numberPerPage) {
        return {
            dexieSearchFunction: function (db, callbackFunc) {
                try {
                    const fun = eval('(' + filterFunc + ')');
                    if (fun) {
                        fun(db, function (err, filterDocs) {
                            if (err) {
                                callbackFunc(err);
                            }
                            else {
                                let docs = [];
                                if (filterDocs && filterDocs.length > 0) {
                                    const size = numberPerPage || SharedConstants.DEFAULT_PAGE_SIZE;
                                    const page = pageNumber || SharedConstants.DEFAULT_PAGE;
                                    const docsArray = chunk(filterDocs, size);
                                    docs = nth(docsArray, page);
                                }
                                let results;
                                results = {};
                                results.total = filterDocs.length;
                                results.statusCode = UtilHttpStatus.OK;
                                results.data = docs;
                                results.searchProvier = 'dexie';
                                callbackFunc(null, results);
                            }
                        });
                    }
                }
                catch (err) {
                    console.log(err);
                    callbackFunc(err);
                }
            }
        };
    }
    calculateRotate(bearing, initialImageDirection, initialImageWheelDirection) {
        let calculateRotation = false;
        let calculateFlip = false;
        let rotation = 0;
        let isFlip = false;
        if (typeof (initialImageWheelDirection) == 'number' && (initialImageWheelDirection > 0 && initialImageWheelDirection <= 360)) {
            // we have wheels so may need to flip
            calculateFlip = true;
        }
        if (typeof (initialImageDirection) == 'number' && (initialImageDirection > 0 && initialImageDirection <= 360)) {
            // need to calculate rotation
            calculateRotation = true;
        }
        if (typeof (bearing) == 'number' && (bearing >= 0 && bearing <= 360)) {
            // need to calculate rotation
            calculateRotation = true;
        }
        else {
            // need to calculate rotation
            calculateRotation = false;
        }
        if (calculateRotation) {
            // calculate the rotation from the bearing and the initialImage Direction
            rotation = bearing - initialImageDirection;
            // normalise rotation to be between 0 and 360, we need a modulo so we loose the sign of the negative rotations so
            rotation = ((rotation % 360) + 360) % 360;
            if (calculateFlip) {
                // now calculate the flip if we need one
                const wheelRotation = initialImageWheelDirection - rotation;
                if (wheelRotation < 90 || wheelRotation > 270) {
                    isFlip = true;
                }
            }
        }
        return { rotation, isFlip };
    }
    processHandlebarsOnVisualItem(componentDefinition, contextParams, value, field, handlebarsContext, returnType, handlebarsOptions) {
        let result;
        if (field) {
            switch (returnType) {
                case 'int':
                    return sclMapHandlebars.processIntHandlebars(field, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'float':
                    return sclMapHandlebars.processFloatHandlebars(field, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'boolean':
                    return sclMapHandlebars.processBooleanHandlebars(field, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'array':
                    return sclMapHandlebars.processArrayHandlebars(field, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                default:
                    return sclMapHandlebars.processHandlebars(field, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
            }
        }
        else if (value) {
            switch (returnType) {
                case 'int':
                    return sclMapHandlebars.processIntHandlebars(value, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'float':
                    return sclMapHandlebars.processFloatHandlebars(value, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'boolean':
                    return sclMapHandlebars.processBooleanHandlebars(value, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                case 'array':
                    return sclMapHandlebars.processArrayHandlebars(value, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
                default:
                    return sclMapHandlebars.processHandlebars(value, handlebarsContext, componentDefinition.handlebarsHelpers, contextParams, handlebarsOptions);
            }
        }
        return result;
    }
    processHandlebarsOnLabel(componentDefinition, contextParams, label, handlebarsContext, layer, layerIndex, idCache) {
        label.labelText = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelText, layer.labelTextHandlebars, handlebarsContext, null, null);
        label.labelColor = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelColor, layer.labelColorHandlebars, handlebarsContext, null, null);
        label.labelOutlineColor = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelOutlineColor, layer.labelOutlineColorHandlebars, handlebarsContext, null, null);
        label.labelOutlineWidth = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelOutlineWidth, layer.labelOutlineWidthHandlebarsRemoveElastic, handlebarsContext, 'int', null);
        label.labelFont = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelFont, layer.labelFontHandlebars, handlebarsContext, null, null);
        label.labelFontSize = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelFontSize, layer.labelFontSizeHandlebars, handlebarsContext, 'int', null);
        label.labelTextAlign = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelTextAlign, layer.labelTextAlignHandlebars, handlebarsContext, null, null);
        label.labelTextBaseline = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelTextBaseline, layer.labelTextBaselineHandlebars, handlebarsContext, null, null);
        label.labelOffsetX = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelOffsetX, layer.labelOffsetXHandlebars, handlebarsContext, 'int', null);
        label.labelOffsetY = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelOffsetY, layer.labelOffsetYHandlebars, handlebarsContext, 'int', null);
        label.labelPlacement = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelPlacement, layer.labelPlacementHandlebars, handlebarsContext, null, null);
        label.labelMaxAngle = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelMaxAngle, layer.labelMaxAngleHandlebars, handlebarsContext, 'float', null);
        label.labelOverflow = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelOverflow, layer.labelOverflowHandlebars, handlebarsContext, 'boolean', null);
        label.labelRotationWithView = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelRotationWithView, layer.labelRotationWithViewHandlebars, handlebarsContext, 'boolean', null);
        label.labelRotation = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelRotation, layer.labelRotationHandlebars, handlebarsContext, 'int', null);
        label.labelPadding = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelPadding, layer.labelPaddingHandlebars, handlebarsContext, 'array', null);
        label.labelFontWeight = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelFontWeight, layer.labelFontWeightHandlebars, handlebarsContext, null, null);
        label.labelDisplayZoom = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, label.labelDisplayZoom, layer.labelDisplayZoomHandlebars, handlebarsContext, 'int', null);
        return label;
    }
    processHandlebarsOnLayer(componentDefinition, contextParams, layerClone, handlebarsContext, layer, layerIndex) {
        layerClone.lineCap = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.lineCap, layer.lineCapHandlebars, handlebarsContext, null, null);
        if (!layerClone.lineCap && layer.lineCap) {
            layerClone.lineCap = layer.lineCap;
        }
        layerClone.lineWidth = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.lineWidth, layer.lineWidthHandlebars, handlebarsContext, 'int', null);
        if (!layerClone.lineWidth && layer.lineWidth) {
            layerClone.lineWidth = layer.lineWidth;
        }
        layerClone.lineDash = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.lineDash, layer.lineDashHandlebars, handlebarsContext, 'array', null);
        if (!layerClone.lineDash && layer.lineDash) {
            layerClone.lineDash = layer.lineDash;
        }
        layerClone.fill = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.fill, layer.fillHandlebars, handlebarsContext, null, null);
        if (!layerClone.fill && layer.fill) {
            layerClone.fill = layer.fill;
        }
        layerClone.fillOpacity = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.fillOpacity, layer.fillOpacityHandlebars, handlebarsContext, 'float', null);
        if (!layerClone.fillOpacity && layer.fillOpacity) {
            layerClone.fillOpacity = layer.fillOpacity;
        }
        return layerClone;
    }
    processHandlebarsOnField(componentDefinition, contextParams, handlebarsContext, layerName, layerIndex, fieldName, layerField, layerFieldHandlebars, returnType) {
        // anchor = this.processHandlebarsOnVisualItem(layer.imageAnchor, layer.imageAnchorHandlebars, handlebarsContext, 'array', {
        //   handlebarsTemplateName: `${layer.name}_${layerIndex}_anchor`
        // });
        // if (!anchor && layer.imageAnchor) { anchor = layer.imageAnchor; }
        const field = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layerField, layerFieldHandlebars, handlebarsContext, returnType, null);
        return field;
    }
    processDynamicLayerData(layer, itemData, i, layerIndex, customData, vehicle) {
        const item = itemData.features[0];
        const pro = item.properties;
        const name = (pro.name ? pro.name : '');
        if (pro.labelDisplayZoom && (typeof pro.labelDisplayZoom === 'string' || pro.labelDisplayZoom instanceof String)) {
            pro.labelDisplayZoom = parseInt(pro.labelDisplayZoom);
        }
        // console.log('***** label = ' + pro.label);
        const label = {
            labelText: (typeof (pro.label) === 'string' && pro.label.trim().length > 0)
                ? pro.label : layer.labelText,
            labelTextAlign: (typeof (pro.labelTextAlign) === 'string' && pro.labelTextAlign.trim().length > 0)
                ? pro.labelTextAlign : layer.labelTextAlign,
            labelTextBaseline: (typeof (pro.labelTextBaseline) === 'string' && pro.labelTextBaseline.trim().length > 0)
                ? pro.labelTextBaseline : layer.labelTextBaseline,
            labelColor: (typeof (pro.labelColor) === 'string' && pro.labelColor.trim().length > 0)
                ? pro.labelColor : layer.labelColor,
            labelOutlineColor: (typeof (pro.labelOutlineColor) === 'string' && pro.labelOutlineColor.trim().length > 0)
                ? pro.labelOutlineColor : layer.labelOutlineColor,
            labelOutlineWidth: (typeof (pro.labelOutlineWidth) === 'number' && pro.labelOutlineWidth > 0)
                ? pro.labelOutlineWidth : layer.labelOutlineWidth,
            labelOffsetX: (typeof (pro.labelOffsetX) === 'number') ? pro.labelOffsetX : layer.labelOffsetX,
            labelOffsetY: (typeof (pro.labelOffsetY) === 'number') ? pro.labelOffsetY : layer.labelOffsetY,
            labelPlacement: (typeof (pro.labelPlacement) === 'string' && pro.labelPlacement.trim().length > 0)
                ? pro.labelPlacement : layer.labelPlacement,
            labelMaxAngle: (typeof (pro.labelMaxAngle) === 'number' && pro.labelMaxAngle >= 0 && pro.labelMaxAngle <= 360)
                ? pro.labelMaxAngle : layer.labelMaxAngle,
            labelOverflow: (typeof (pro.labelOverflow) === 'boolean') ? pro.labelOverflow : layer.labelOverflow,
            labelRotationWithView: (typeof (pro.labelRotationWithView) === 'boolean') ? pro.labelRotationWithView : layer.labelRotationWithView,
            labelRotation: (typeof (pro.labelRotation) === 'number' && pro.labelRotation >= 0 && pro.labelRotation <= 360)
                ? pro.labelRotation : layer.labelRotation,
            labelPadding: (Array.isArray(pro.labelPadding)) ? pro.labelPadding : layer.labelPadding,
            labelFont: (typeof (pro.labelFont) === 'string' && pro.labelFont.trim().length > 0)
                ? pro.labelFont : layer.labelFont,
            labelFontWeight: (typeof (pro.labelFontWeight) === 'string' && pro.labelFontWeight.trim().length > 0)
                ? pro.labelFontWeight : layer.labelFontWeight,
            labelFontSize: (typeof (pro.labelFontSize) === 'string' && pro.labelFontSize.trim().length > 0
                && pro.labelFontSize.indexOf('px') > -1) ? pro.labelFontSize : layer.labelFontSize,
            labelDisplayZoom: (typeof (pro.labelDisplayZoom) === 'number' && pro.labelDisplayZoom > 0)
                ? pro.labelDisplayZoom : layer.labelDisplayZoom
        };
        let imageFileNo = '';
        if (layer.imageFileNo) {
            imageFileNo = layer.imageFileNo;
        }
        if (pro.image && Array.isArray(pro.image) && pro.image.length > 0) {
            imageFileNo = pro.image[0].fileNo;
        }
        const calRotate = this.calculateRotate(pro.bearing, pro.initialImageDirection, pro.initialImageWheelDirection); // (pro.bearing ? pro.bearing: 0);
        const rotation = calRotate.rotation;
        let scaleValue = 1;
        if (typeof (pro.imageScale) == 'number' && pro.imageScale > 0) {
            // need to calculate rotation
            scaleValue = pro.imageScale;
        }
        let scale = [scaleValue, scaleValue];
        if (calRotate.isFlip) {
            scale[0] = -scaleValue;
        }
        // console.log('**** rotation = ' + rotation + ', isFlip = ' + calRotate.isFlip);
        const tooltip = ((typeof (pro.tooltip) === 'string' && pro.tooltip.trim().length > 0) ? pro.tooltip : layer.tooltip);
        const dataId = pro.vehicleDocumentId;
        if (!dataId) {
            console.log(`*** invalid vehicleDocumentId: ${dataId}`);
        }
        const id = dataId + '_' + i + '_' + layerIndex;
        const url = 'form/' + dataId;
        const handlebarsContext = {
            results: customData,
            resultsCount: customData.length,
            resultsIndex: i,
            queryResultDocument: itemData,
        };
        if (vehicle) {
            handlebarsContext.vehicle = vehicle;
        }
        return { pro, handlebarsContext, label, item, id, name, tooltip, imageFileNo, url, dataId, rotation, scale };
    }
    processLayerRotation(layer, layerIndex, componentDefinition, contextParams, handlebarsContext) {
        let rotation = 0;
        if (layer.imageRotation) {
            rotation = layer.imageRotation;
        }
        if (layer.imageRotationHandlebars) {
            rotation = this.processHandlebarsOnVisualItem(componentDefinition, contextParams, layer.imageRotation, layer.imageRotationHandlebars, handlebarsContext, 'int', null);
            if (!rotation && layer.imageRotation) {
                rotation = layer.imageRotation;
            }
            if (!rotation) {
                rotation = 0;
            }
        }
        return rotation;
    }
    checkValidStyleString(obj) {
        if (!isString(obj) || obj.trim().length == 0 || obj.indexOf('{') > -1 || obj.indexOf('}') > -1) {
            return false;
        }
        return true;
    }
    checkStyleValue(assetSelection, isPrimary) {
        const styleInfo = cloneDeep(assetSelection);
        if (!this.checkValidStyleString(assetSelection.selectionImageFileNo)) {
            // console.log('invalid value of selectionImageFileNo: ' + assetSelection.selectionImageFileNo);
            styleInfo.selectionImageFileNo = (isPrimary ? SclMapConstantService.MAP_PRIMARY_ASSET : SclMapConstantService.MAP_SECONDARY_ASSET);
        }
        if (!Array.isArray(assetSelection.selectionImageAnchor)) {
            // console.log('invalid value of selectionImageAnchor: ' + assetSelection.selectionImageAnchor);
            styleInfo.selectionImageAnchor = [0.5, 0.5];
        }
        if (!isNumber(assetSelection.selectionImageRotation)) {
            // console.log('invalid value of selectionImageRotation: ' + assetSelection.selectionImageRotation);
            styleInfo.selectionImageRotation = 0;
        }
        if (!this.checkValidStyleString(assetSelection.selectionColor)) {
            // console.log('invalid value of selectionColor: ' + assetSelection.selectionColor);
            styleInfo.selectionColor = 'purple';
        }
        if (!this.checkValidStyleString(assetSelection.selectionFill)) {
            // console.log('invalid value of selectionFill: ' + assetSelection.selectionFill);
            styleInfo.selectionFill = 'purple';
        }
        if (!isNumber(assetSelection.selectionFillOpacity)) {
            // console.log('invalid value of selectionFillOpacity: ' + assetSelection.selectionFillOpacity);
            styleInfo.selectionFillOpacity = 1;
        }
        if (!this.checkValidStyleString(assetSelection.selectionLineCap)) {
            // console.log('invalid value of selectionColor: ' + assetSelection.selectionColor);
            styleInfo.selectionLineCap = null;
        }
        if (!Array.isArray(assetSelection.selectionLineDash)) {
            styleInfo.selectionLineDash = null;
        }
        if (!isNumber(assetSelection.selectionLineWidth)) {
            // console.log('invalid value of selectionImageRotation: ' + assetSelection.selectionImageRotation);
            styleInfo.selectionLineWidth = null;
        }
        return styleInfo;
    }
    toRadians(angleInDegrees) {
        return (angleInDegrees * Math.PI) / 180;
    }
    toDegrees(angleInRadians) {
        return (angleInRadians * 180) / Math.PI;
    }
    offset(c1, distance, earthRadius, bearing) {
        var lat1 = this.toRadians(c1[1]);
        var lon1 = this.toRadians(c1[0]);
        var dByR = distance / earthRadius;
        var lat = Math.asin(Math.sin(lat1) * Math.cos(dByR) + Math.cos(lat1) * Math.sin(dByR) * Math.cos(bearing));
        var lon = lon1 +
            Math.atan2(Math.sin(bearing) * Math.sin(dByR) * Math.cos(lat1), Math.cos(dByR) - Math.sin(lat1) * Math.sin(lat));
        return [this.toDegrees(lon), this.toDegrees(lat)];
    }
    circleToPolygon(center, radius) {
        var n = 4; // there has 32 segments
        var earthRadius = 6378137;
        var bearing = 0;
        var direction = -1;
        var start = this.toRadians(bearing);
        var coordinates = [];
        for (var i = 0; i < n; ++i) {
            coordinates.push(this.offset(center, radius, earthRadius, start + (direction * 2 * Math.PI * -i) / n));
        }
        coordinates.push(coordinates[0]);
        return [coordinates];
    }
    calculateCircleCenterPoint(p1, p2) {
        const x1 = p1[0];
        const y1 = p1[1];
        const x2 = p2[0];
        const y2 = p2[1];
        const x = (x1 + x2) / 2;
        const y = (y1 + y2) / 2;
        console.log(`center = [${x}, ${y}]`);
        return [x, y];
    }
    buildFilterObj(componentDefinition, geoJsonField) {
        const fil = {
            filter: componentDefinition.filter,
            layerDisplayOnly: componentDefinition.layerDisplayOnly,
            geoJsonField,
        };
        if (componentDefinition.color) {
            fil.color = componentDefinition.color;
        }
        if (componentDefinition.fill) {
            fil.fill = componentDefinition.fill;
        }
        if (componentDefinition.fillOpacity) {
            fil.fillOpacity = componentDefinition.fillOpacity;
        }
        if (componentDefinition.tooltips) {
            fil.tooltips = componentDefinition.tooltips;
        }
        if (componentDefinition.lineDash) {
            fil.lineDash = componentDefinition.lineDash;
        }
        if (componentDefinition.lineCap) {
            fil.lineCap = componentDefinition.lineCap;
        }
        if (componentDefinition.lineWidth) {
            fil.lineWidth = componentDefinition.lineWidth;
        }
        if (componentDefinition.imageAnchor) {
            fil.imageAnchor = componentDefinition.imageAnchor;
        }
        if (componentDefinition.imageFileNo) {
            fil.imageFileNo = componentDefinition.imageFileNo;
        }
        if (componentDefinition.labelText) {
            fil.labelText = componentDefinition.labelText;
        }
        if (componentDefinition.labelTextAlign) {
            fil.labelTextAlign = componentDefinition.labelTextAlign;
        }
        if (componentDefinition.labelTextBaseline) {
            fil.labelTextBaseline = componentDefinition.labelTextBaseline;
        }
        if (componentDefinition.labelColor) {
            fil.labelColor = componentDefinition.labelColor;
        }
        if (componentDefinition.labelOutlineColor) {
            fil.labelOutlineColor = componentDefinition.labelOutlineColor;
        }
        if (componentDefinition.labelOutlineWidth) {
            fil.labelOutlineWidth = componentDefinition.labelOutlineWidth;
        }
        if (componentDefinition.labelOffsetX) {
            fil.labelOffsetX = componentDefinition.labelOffsetX;
        }
        if (componentDefinition.labelOffsetY) {
            fil.labelOffsetY = componentDefinition.labelOffsetY;
        }
        if (componentDefinition.labelPlacement) {
            fil.labelPlacement = componentDefinition.labelPlacement;
        }
        if (componentDefinition.labelMaxAngle) {
            fil.labelMaxAngle = componentDefinition.labelMaxAngle;
        }
        if (componentDefinition.labelOverflow) {
            fil.labelOverflow = componentDefinition.labelOverflow;
        }
        if (componentDefinition.labelRotationWithView) {
            fil.labelRotationWithView = componentDefinition.labelRotationWithView;
        }
        if (componentDefinition.labelRotation) {
            fil.labelRotation = componentDefinition.labelRotation;
        }
        if (componentDefinition.labelPadding) {
            fil.labelPadding = componentDefinition.labelPadding;
        }
        if (componentDefinition.labelFont) {
            fil.labelFont = componentDefinition.labelFont;
        }
        if (componentDefinition.labelFontWeight) {
            fil.labelFontWeight = componentDefinition.labelFontWeight;
        }
        if (componentDefinition.labelFontSize) {
            fil.labelFontSize = componentDefinition.labelFontSize;
        }
        if (componentDefinition.labelDisplayZoom) {
            fil.labelDisplayZoom = componentDefinition.labelDisplayZoom;
        }
        if (componentDefinition.type) {
            fil.type = componentDefinition.type;
        }
        return fil;
    }
}
/** @nocollapse */ /** @nocollapse */ SclUtilMapService.ɵfac = function SclUtilMapService_Factory(t) { return new (t || SclUtilMapService)(); };
/** @nocollapse */ /** @nocollapse */ SclUtilMapService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclUtilMapService, factory: SclUtilMapService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclUtilMapService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return []; }, null);
})();

class AddressDetails {
    constructor() {
        this.properties = {};
        this.geometry = {};
        this.type = 'Feature';
        this.properties = {
            type: 'street',
            unitNo: '',
            streetNo: '',
            street: '',
            suburb: '',
            postcode: '',
            locationDescription: '',
            country: '',
            iconImage: '',
            iconSize: '',
            state: ''
        };
        this.geometry = {
            type: 'Point',
            coordinates: []
        };
    }
}

const sclUtilMapService$1 = new SclUtilMapService();
const googleMapLoaderService = new GoogleMapLoaderService();
class SclMapGeoGoogleService {
    constructor() {
        this.autocompleteUrl = 'https://maps.googleapis.com/maps/api/place/autocomplete/json?input=';
        this.geocodeUrl = 'https://maps.googleapis.com/maps/api/geocode/json?latlng=';
        this.googleLoader = null;
        this.waitTime = 5000; // miliseconds
        this.loadLookup = false;
        this.intervalSetupLookUpCount = 0;
    }
    reverse(coor, cb, cbErr, cbTimeout) {
        if (!this.apiKeyReverse) {
            this.apiKeyReverse = this.apiKey;
        }
        if (!this.apiKeyReverse) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('apiKey null');
            }
            return;
        }
        let link = this.geocodeUrl + coor[1] + ',' + coor[0] + '&key=' + this.apiKeyReverse;
        link = this.getLinkOptions(link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe(data => {
            if (data.status === 'OK') {
                const datas = data.results[0];
                let streetData = new AddressDetails();
                streetData = sclUtilMapService$1.fillGoogleAddress(datas, streetData);
                if (cb && typeof cb === 'function') {
                    cb(streetData, { lat: datas.geometry.location.lat, lng: datas.geometry.location.lng });
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    let errorMsg = 'Google reverse Error';
                    if (data !== null && data.error_message !== null) {
                        errorMsg = data.error_message;
                    }
                    cbErr(errorMsg);
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                // logger.info(err);
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Google reverse Error');
                }
            }
        });
    }
    setupLookUp() {
        const apiKey = this.apiKey;
        googleMapLoaderService.KEY = apiKey;
        googleMapLoaderService.LIBRARIES = 'places,drawing,visualization';
        googleMapLoaderService.SENSOR = true;
        if (this.intervalSetupLookUp) {
            return;
        }
        this.intervalSetupLookUp = setInterval(() => {
            this.autocompleteStreet = document.getElementById(this.initObj.keyName + 'autocomplete');
            if (this.autocompleteStreet) {
                clearInterval(this.intervalSetupLookUp);
                this.intervalSetupLookUp = null;
                this.intervalSetupLookUpCount = 0; // reset
                // console.log('find autocompletebox');
                googleMapLoaderService.load().then((google) => {
                    const autocompleteObj = new google.maps.places.Autocomplete(this.autocompleteStreet, { types: ['geocode'] });
                    google.maps.event.addListener(autocompleteObj, 'place_changed', () => {
                        const place = autocompleteObj.getPlace();
                        let streetData = new AddressDetails();
                        streetData = sclUtilMapService$1.fillGoogleAddress(place, streetData);
                        if (this.cbSelectOption && typeof this.cbSelectOption === 'function') {
                            this.cbSelectOption(streetData);
                        }
                    });
                });
            }
            else {
                this.intervalSetupLookUpCount++;
                if (this.intervalSetupLookUpCount > 11) {
                    console.log('can\'t load google geo service because can\'t find autocomplete box');
                    clearInterval(this.intervalSetupLookUp);
                    this.intervalSetupLookUp = null;
                    this.intervalSetupLookUpCount = 0; // reset
                }
                else {
                    console.log('waiting for autocomplete box loading..');
                }
            }
        }, 100);
    }
    lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet, cbTimeout) {
        if (params == null || params.length < 1) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('params invalid. [0] : autocompleteBox');
            }
            return;
        }
        if (this.apiKey == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('apiKey is null');
            }
            return;
        }
        if (this.googleLoader === null) {
            this.autocompleteBox = params[0];
            if (!this.loadLookup) {
                this.loadLookup = true;
                this.cbSelectOption = cbSelectOption;
                this.setupLookUp();
            }
        }
    }
    removeLookUp() {
        const id = this.initObj.keyName + 'MapGeoGoogle';
        const lst = document.querySelectorAll('#' + id);
        if (lst && lst.length > 0) {
            for (let i = 0; i < lst.length; i++) {
                lst[i].remove();
            }
        }
        this.autocompleteBox = null;
        this.googleLoader = null;
    }
    removeStreet(cb) {
        if (this.autocompleteStreet == null) {
            this.autocompleteStreet = document.getElementById(this.initObj.keyName + 'autocomplete');
        }
        if (this.autocompleteStreet == null) {
            if (cb && typeof cb === 'function') {
                cb();
            }
            return;
        }
        this.autocompleteStreet.value = '';
        if (cb && typeof cb === 'function') {
            cb();
        }
    }
    getLinkOptions(link) {
        if (this.country) {
            link += '&country=' + this.country;
        }
        if (this.language) {
            link += '&lang=' + this.language;
        }
        return link;
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapGeoGoogleService.ɵfac = function SclMapGeoGoogleService_Factory(t) { return new (t || SclMapGeoGoogleService)(); };
/** @nocollapse */ /** @nocollapse */ SclMapGeoGoogleService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapGeoGoogleService, factory: SclMapGeoGoogleService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapGeoGoogleService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return []; }, null);
})();

class SclMapGeoCodeFarmService {
    constructor() {
        this.autocompleteUrl = 'https://www.geocode.farm/v3/json/forward/?addr=';
        this.geocodeUrl = 'https://www.geocode.farm/v3/json/reverse/';
        this.apiKey = 'a2338e05-e3cb425e93ad-109049bfb516';
        this.apiKeyReverse = 'a2338e05-e3cb425e93ad-109049bfb516';
        this.waitTime = 5000; // miliseconds
        this.preText = '';
    }
    reverse(coor, cb, cbErr, cbTimeout) {
        let link = this.geocodeUrl + '?lat=' + coor[1] + '&lon=' + coor[0] + '&key=' + this.apiKeyReverse + '&count=1';
        link = this.getLinkOptions(link);
        // logger.info("Codefarm reverse , link = " + link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe(data => {
            // let data = results.data;
            if (data && data.geocoding_results.STATUS.status === 'SUCCESS') {
                const suggestions = data.geocoding_results.RESULTS[0];
                const address = suggestions.ADDRESS;
                const streetData = new AddressDetails();
                streetData.properties.streetNo = address.street_number;
                streetData.properties.street = address.street_name;
                streetData.properties.suburb = address.locality;
                streetData.properties.postcode = address.postal_code;
                streetData.properties.country = address.country;
                streetData.properties.state = address.admin_1;
                streetData.geometry.coordinates[0] = coor[0]; // lon
                streetData.geometry.coordinates[1] = coor[1]; // lat
                if (cb && typeof cb === 'function') {
                    cb(streetData, { lat: parseFloat(suggestions.COORDINATES.latitude), lng: parseFloat(suggestions.COORDINATES.longitude) });
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Codefarm reverse Error');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                // logger.info(err);
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Codefarm reverse Error');
                }
            }
        });
    }
    lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet, cbTimeout) {
        if (params == null || params.length < 1) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('params is invalid, [0] : autocompleteBox');
            }
            return;
        }
        if (this.autocompleteBox == null) {
            this.autocompleteBox = params[0];
        }
        if (params.length > 1) {
            this.search(params[1], cb, cbErr, cbTimeout);
        }
    }
    removeLookUp() {
        const id = this.initObj.keyName + 'MapGeoCodFarm';
        const lst = document.querySelectorAll('#' + id);
        if (lst && lst.length > 0) {
            for (let i = 0; i < lst.length; i++) {
                lst[i].remove();
            }
        }
        this.autocompleteBox = null;
    }
    removeStreet(cb) {
        if (this.autocompleteStreet == null) {
            this.autocompleteStreet = document.getElementById('#' + this.initObj.keyName + 'autocomplete');
            // angular.element(element).find('#' + scope.fieldName +'autocomplete');
        }
        if (this.autocompleteStreet == null) {
            if (cb && typeof cb === 'function') {
                cb();
            }
            return;
        }
        this.autocompleteStreet.value = '';
        if (cb && typeof cb === 'function') {
            cb();
        }
    }
    search(sPartialAddress, cb, cbErr, cbTimeout) {
        if (this.apiKey == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('apiKey is null');
            }
            return;
        }
        if (sPartialAddress == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('text is null');
            }
            return;
        }
        const results = [];
        const newText = sPartialAddress.trim();
        if (newText === this.preText) {
            if (cb && typeof cb === 'function') {
                cb([]);
            }
            return;
        }
        this.preText = newText;
        if (newText.length < 3) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('text is less than 3 words');
            }
            return;
        }
        // if(scope.geocoderDefaultState) sPartialAddress += ", " + scope.geocoderDefaultState;
        // if(scope.geocoderDefaultCountry) sPartialAddress += ", " + scope.geocoderDefaultCountry;
        // sPartialAddress += ", VIC, Australia";
        sPartialAddress += '&country=au&lang=en';
        let link = this.autocompleteUrl + sPartialAddress + '&key=' + this.apiKey;
        link = this.getLinkOptions(link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe((data) => {
            if (data && data.geocoding_results && data.geocoding_results.STATUS.status === 'SUCCESS') {
                const suggestions = data.geocoding_results.RESULTS;
                for (let i = 0; i < suggestions.length; i++) {
                    const predict = suggestions[i];
                    const sugg = {};
                    sugg.street = predict.formatted_address;
                    sugg.address = predict.ADDRESS;
                    sugg.coordinates = predict.COORDINATES;
                    results.push(sugg);
                }
                if (cb && typeof cb === 'function') {
                    cb(results);
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Codefarm lookup Error ');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Codefarm lookup Error ');
                }
            }
        });
    }
    selectionOption(tpl, model, cb) {
        const address = tpl.address;
        const coordinates = tpl.coordinates;
        const obj = new AddressDetails();
        if (address.unitNo) {
            obj.properties.unitNo = address.unitNo;
        }
        obj.properties.streetNo = address.street_number;
        obj.properties.street = address.street_name;
        obj.properties.suburb = address.locality;
        obj.properties.postcode = address.postal_code;
        obj.properties.country = address.country;
        obj.properties.state = address.admin_1;
        const lat = parseFloat(coordinates.latitude);
        const lon = parseFloat(coordinates.longitude);
        obj.geometry.coordinates[0] = lon;
        obj.geometry.coordinates[1] = lat;
        if (cb && typeof cb === 'function') {
            cb(obj);
        }
    }
    getLinkOptions(link) {
        if (this.country) {
            link += '&country=' + this.country;
        }
        if (this.language) {
            link += '&lang=' + this.language;
        }
        return link;
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapGeoCodeFarmService.ɵfac = function SclMapGeoCodeFarmService_Factory(t) { return new (t || SclMapGeoCodeFarmService)(); };
/** @nocollapse */ /** @nocollapse */ SclMapGeoCodeFarmService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapGeoCodeFarmService, factory: SclMapGeoCodeFarmService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapGeoCodeFarmService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return []; }, null);
})();

const sclMapConstant$4 = SclMapConstantService;
class SclMapGeoHereService {
    constructor() {
        this.autocompleteUrl = 'https://geocoder.api.here.com/6.2/geocode.json';
        this.geocodeUrl = 'https://reverse.geocoder.api.here.com/6.2/reversegeocode.json';
        this.appId = 'UFP3Mq8ODsPalgiBwWVS';
        this.appCode = '8bZacaYx2CxDy1PUV3sN2w'; // appcode
        this.waitTime = 5000; // miliseconds
        this.radius = 50;
        this.preText = '';
        this.hasPrimaryAssetAddressLookup = false;
    }
    setSuburb(address) {
        const gotDistrict = address.Label.indexOf(address.District);
        const gotCity = address.Label.indexOf(address.City);
        if (gotDistrict >= 0 && gotCity >= 0) {
            if (gotDistrict < gotCity) {
                return address.City;
            }
            else {
                return address.District;
            }
        }
        else if (gotDistrict < 0) {
            return address.City;
        }
        else {
            return address.District;
        }
    }
    setupReverse(geo) {
        if (geo.radius) {
            this.radius = geo.radius;
        }
        if (geo.primaryAssetAddressLookupRadius) {
            this.primaryAssetAddressLookupRadius = geo.primaryAssetAddressLookupRadius;
        }
    }
    reverse(coor, cb, cbErr, cbTimeout) {
        const lat = coor[1];
        const lon = coor[0];
        let radius = coor[2];
        if (this.hasPrimaryAssetAddressLookup === true) {
            radius = this.primaryAssetAddressLookupRadius;
        }
        else {
            radius = this.radius;
        }
        let link = this.geocodeUrl + '?app_id=' + this.appId + '&app_code=' + this.appCode
            + '&prox=' + lat + ',' + lon + ',' + radius + '&mode=retrieveAddresses&maxresults=1&gen=9';
        link = this.getLinkOptions(link);
        //// logger.info("HERE reverse , link = " + link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe(data => {
            if (data && data.Response && data.Response.View && data.Response.View.length > 0
                && data.Response.View[0].Result && data.Response.View[0].Result.length > 0) {
                const suggestions = data.Response.View[0].Result[0];
                const address = suggestions.Location.Address;
                const streetData = new AddressDetails();
                streetData.properties.streetNo = address.HouseNumber;
                streetData.properties.street = address.Street;
                streetData.properties.suburb = this.setSuburb(address);
                streetData.properties.postcode = address.PostalCode;
                streetData.properties.country = address.Country;
                streetData.properties.state = address.State;
                streetData.geometry.coordinates[0] = lon; // lon
                streetData.geometry.coordinates[1] = lat; // lat
                if (cb && typeof cb === 'function') {
                    cb(streetData, { lat: suggestions.Location.DisplayPosition.Latitude,
                        lng: suggestions.Location.DisplayPosition.Longitude });
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('here.com reverse address lookup Error');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                // logger.info(err);
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('here.com reverse address lookup Error');
                }
            }
        });
    }
    lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet, cbTimeout) {
        if (params == null || params.length < 1) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('params is invalid, [0] : autocompleteBox');
            }
            return;
        }
        if (this.autocompleteBox == null) {
            this.autocompleteBox = params[0];
        }
        if (params.length > 1) {
            this.search(params[1], cb, cbErr, cbTimeout);
        }
    }
    removeLookUp() {
        const id = this.initObj.keyName + 'MapGeoHere';
        const elem = document.getElementById(id);
        if (elem) {
            elem.remove();
        }
        this.autocompleteBox = null;
    }
    removeStreet(cb) {
        if (this.autocompleteStreet == null) {
            this.autocompleteStreet = document.getElementById(this.initObj.keyName + 'autocomplete');
        }
        if (this.autocompleteStreet == null) {
            if (cb && typeof cb === 'function') {
                cb();
            }
            return;
        }
        this.autocompleteStreet.value = '';
        if (cb && typeof cb === 'function') {
            cb();
        }
    }
    search(sPartialAddress, cb, cbErr, cbTimeout) {
        if (!this.appId) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('here.com address lookup: appId is null');
            }
            return;
        }
        if (!this.appCode) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('here.com address lookup: appCode is null');
            }
            return;
        }
        if (sPartialAddress == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('here.com address lookup: text is null');
            }
            return;
        }
        const results = [];
        const newText = sPartialAddress.trim();
        if (newText === this.preText) {
            if (cb && typeof cb === 'function') {
                cb([]);
            }
            return;
        }
        this.preText = newText;
        if (newText.length < 3) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('here.com address lookup: text is less than 3 characters');
            }
            return;
        }
        let link = this.autocompleteUrl + '?app_id=' + this.appId + '&app_code=' + this.appCode + '&searchtext=' + sPartialAddress;
        link = this.getLinkOptions(link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe(data => {
            if (data && data.Response && data.Response.View && data.Response.View.length > 0) {
                const suggestions = data.Response.View[0].Result;
                for (let i = 0; i < suggestions.length; i++) {
                    const predict = suggestions[i];
                    const sugg = {};
                    sugg.street = predict.Location.Address.Label;
                    sugg.address = predict.Location.Address;
                    sugg.coordinates = predict.Location.DisplayPosition;
                    results.push(sugg);
                }
                //// logger.info('result = ' + JSON.stringify(results));
                if (cb && typeof cb === 'function') {
                    cb(results);
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('here.com address lookup Error ');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                // logger.info(err);
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('here.com address lookup Error ');
                }
            }
        });
    }
    selectionOption(tpl, model, cb) {
        const address = tpl.address;
        const coordinates = tpl.coordinates;
        const obj = new AddressDetails();
        obj.properties.streetNo = address.HouseNumber;
        obj.properties.street = address.Street;
        obj.properties.suburb = this.setSuburb(address);
        obj.properties.postcode = address.PostalCode;
        obj.properties.country = address.Country;
        obj.properties.state = address.State;
        const lat = parseFloat(coordinates.Latitude);
        const lon = parseFloat(coordinates.Longitude);
        obj.geometry.coordinates[0] = lon;
        obj.geometry.coordinates[1] = lat;
        if (cb && typeof cb === 'function') {
            cb(obj);
        }
    }
    getLinkOptions(link) {
        if (this.state) {
            link += ' ' + this.state;
        }
        if (this.country) {
            link += ' ' + this.country;
        }
        return link;
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapGeoHereService.ɵfac = function SclMapGeoHereService_Factory(t) { return new (t || SclMapGeoHereService)(); };
/** @nocollapse */ /** @nocollapse */ SclMapGeoHereService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapGeoHereService, factory: SclMapGeoHereService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapGeoHereService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return []; }, null);
})();

const sclMapConstant$3 = SclMapConstantService;
class SclMapGeoPSMAService {
    constructor(formbirdInjectorService) {
        this.formbirdInjectorService = formbirdInjectorService;
        this.autocompleteUrl = 'https://api.psma.com.au/v1/predictive/address?query=';
        this.addressUrl = 'https://api.psma.com.au/v1/predictive/address/';
        this.geocodeUrl = 'https://api.psma.com.au/v1/addresses?radius=';
        this.geocodeUrlNext = 'https://api.psma.com.au/v1/addresses/'; // GAVIC419864439/geo/
        this.apiKeyReverse = 'z1mhEpstfwLdqzVTBAX1dkR5iVy6LaLq'; // "7hLa5GrKDVM5alRX1mGLm8xGmbz3JyKA"; --> old key
        this.waitTime = 5000; // miliseconds
        this.reverseNoAddressIncrement = 0;
        this.reverseNoAddressRetry = 0;
        this.enableReverseRadiusDisplay = false;
        this.showReverseAddressPoint = 0;
        this.psmaRadius = 50;
        this.psmaHasStreetData = false;
        this.psmaAddressData = [];
        this.psmaAddressDetailUrl = '';
        this.dropPinSelectsAddres = false;
        this.reverseAddress = [];
        this.psmaPoints = [];
        this.psmaFinalRadius = 0;
        this.psmaOutOfRadius = [];
        this.psmaIndexAddress = -1;
        this.psmaCountGetGPS = 0;
        this.isFeatureRemoving = false; // use to stop reverse service get address
        this.page = 1;
        this.callLookUp = false;
        this.preText = '';
        this.hasPrimaryAssetAddressLookup = false;
        this.notificationService = this.formbirdInjectorService.get('NotificationService');
    }
    setupReverse(geo) {
        if (geo.reverseNoAddressIncrement) {
            this.reverseNoAddressIncrement = geo.reverseNoAddressIncrement;
        }
        if (geo.reverseNoAddressRetry) {
            this.reverseNoAddressRetry = (geo.reverseNoAddressRetry <= 0 ? 1 : (geo.reverseNoAddressRetry + 1));
        }
        if (geo.enableReverseRadiusDisplay) {
            this.enableReverseRadiusDisplay = geo.enableReverseRadiusDisplay;
        }
        if (geo.showReverseAddressPoint) {
            this.showReverseAddressPoint = geo.showReverseAddressPoint;
        }
        if (geo.radius) {
            this.psmaRadius = geo.radius;
        }
        if (this.initObj.assetField.dropPinSelectsAddress && geo.dropPinSelectsAddress) {
            this.dropPinSelectsAddress = this.initObj.assetField.dropPinSelectsAddress;
        }
        else if (geo.addressDetailUrl) {
            this.psmaAddressDetailUrl = geo.addressDetailUrl;
        }
        if (geo.primaryAssetAddressLookupRadius) {
            this.primaryAssetAddressLookupRadius = geo.primaryAssetAddressLookupRadius;
        }
        this.count = (this.reverseNoAddressRetry <= 0 ? 1 : this.reverseNoAddressRetry);
        this.reverseAddress = []; // reset
        this.psmaFinalRadius = 0;
        this.psmaOutOfRadius = [];
        this.psmaIndexAddress = -1;
        this.psmaCountGetGPS = 0;
        this.isFeatureRemoving = false;
        this.psmaHasStreetData = false;
        this.psmaAddressData = [];
        this.callLookUp = false;
    }
    verifyObj(addressDetails) {
        const isNull = (strVal) => {
            if (!strVal || strVal === 'null') {
                return false;
            }
            else {
                return true;
            }
        };
        const processData = {};
        processData.street_type = !isNull(addressDetails.streetType) ? '' : addressDetails.streetType;
        // SUFFIX
        processData.street_suffix = !isNull(addressDetails.streetSuffix) ? '' : addressDetails.streetSuffix;
        processData.street_type_description = !isNull(addressDetails.streetTypeDescription) ? '' : addressDetails.streetTypeDescription;
        processData.street_number_2 = !isNull(addressDetails.streetNumber2) ? '' : addressDetails.streetNumber2;
        processData.unit_no = !isNull(addressDetails.complexUnitIdentifier) ? '' : addressDetails.complexUnitIdentifier;
        processData.complex_unit_type = !isNull(addressDetails.complexUnitType) ? '' : addressDetails.complexUnitType;
        processData.complex_level_type = !isNull(addressDetails.complexLevelType) ? '' : addressDetails.complexLevelType;
        processData.complex_level_number = !isNull(addressDetails.complexLevelNumber) ? '' : addressDetails.complexLevelNumber;
        processData.street_number_1 = !isNull(addressDetails.streetNumber1) ? '' : addressDetails.streetNumber1;
        processData.street_name = !isNull(addressDetails.streetName) ? '' : addressDetails.streetName;
        processData.locality_name = !isNull(addressDetails.localityName) ? '' : addressDetails.localityName;
        processData.postcode = !isNull(addressDetails.postcode) ? '' : addressDetails.postcode;
        processData.state_territory = !isNull(addressDetails.stateTerritory) ? '' : addressDetails.stateTerritory;
        processData.site_name = !isNull(addressDetails.siteName) ? '' : addressDetails.siteName;
        return processData;
    }
    updateStreetData(coor, addressData) {
        const streetData = new AddressDetails();
        streetData.properties.unitNo = addressData.unit_no;
        // DUAL NUMBERS
        streetData.properties.streetNo = addressData.street_number_1 +
            (addressData.street_number_2 === '' ? '' : '-' + addressData.street_number_2).trim();
        streetData.properties.street = (addressData.street_name + ' ' +
            (addressData.street_type_description === '' ? addressData.street_type :
                addressData.street_type_description) + ' ' + (addressData.street_suffix === '' ?
            '' : addressData.street_suffix)).trim();
        streetData.properties.suburb = addressData.locality_name;
        streetData.properties.postcode = addressData.postcode;
        streetData.properties.state = addressData.state_territory;
        if (addressData.site_name) {
            streetData.properties.locationDescription = addressData.site_name;
        }
        if (addressData.complex_unit_type) {
            (streetData.properties.locationDescription += '\n' + addressData.complex_unit_type + ' ' + addressData.unit_no).trim();
        }
        if (addressData.complex_level_type) {
            (streetData.properties.locationDescription += '\n' + addressData.complex_level_type + ' ' + addressData.complex_level_number).trim();
        }
        if (coor != null) {
            streetData.geometry.coordinates[0] = coor[0]; // lon
            streetData.geometry.coordinates[1] = coor[1]; // lat
        }
        return streetData;
    }
    reverse(coor, cb, cbErr, cbTimeout) {
        const lon = coor[0];
        const lat = coor[1];
        const radius = coor[2];
        if (coor.length < 4) {
            coor[3] = (this.reverseNoAddressRetry <= 0 ? 1 : this.reverseNoAddressRetry);
        }
        const count = coor[3];
        // let psmaFinalRadius = radius;
        const self = this;
        self.lat = lat;
        self.lon = lon;
        self.count = count;
        self.radius = 1;
        if (this.hasPrimaryAssetAddressLookup === true) {
            self.radius = this.primaryAssetAddressLookupRadius;
        }
        else {
            self.radius = radius;
        }
        if (this.enableReverseRadiusDisplay) {
            this.createLayer();
            this.removeFeatures(false);
        }
        // draw points which are out of previous radius
        for (let i = 0; i < this.psmaOutOfRadius.length; i++) {
            const item = this.psmaOutOfRadius[i];
            if (item.distance <= this.psmaFinalRadius) {
                this.createPoint(item.coor, item.index, item.distance);
            }
        }
        this.psmaOutOfRadius = [];
        // draw circle
        if (this.enableReverseRadiusDisplay) {
            self.createPointClick([self.lon, self.lat], self.radius);
        }
        const reverseAddressText = [];
        const link = this.geocodeUrl + self.radius + '&latLong=' + self.lat + ',' + self.lon + '&page=' + this.page;
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime }, { Authorization: this.apiKeyReverse }).subscribe(result => {
            if (self.callLookUp) {
                return;
            }
            const resData = result.data;
            if (resData) {
                if (resData.length > 0) {
                    for (let i = 0; i < resData.length; i++) {
                        const item = resData[i];
                        if (item.addressId && self.reverseAddress.indexOf(item.addressId) === -1) {
                            self.reverseAddress.push(item.addressId);
                            reverseAddressText.push(item.formattedAddress);
                        }
                    }
                    if (self.psmaIndexAddress === -1) {
                        self.psmaIndexAddress = 1;
                    }
                    self.psmaReversItem(resData[0].addressId, resData[0].formattedAddress, 1, [self.lon, self.lat], self.radius, self.count, self.page, function (pRadius, obj, addressDetails) {
                        let finalRadius = 0;
                        if (self.hasPrimaryAssetAddressLookup === true) {
                            finalRadius = self.primaryAssetAddressLookupRadius;
                        }
                        else {
                            finalRadius = (self.psmaRadius < 1 ? 1 : self.psmaRadius) +
                                (self.reverseNoAddressIncrement * self.reverseNoAddressRetry);
                            if (finalRadius > 100) {
                                finalRadius = 100;
                            }
                        }
                        const verifiedObj = this.verifyObj(addressDetails);
                        if (obj.distance <= finalRadius && obj.index === 1 && self.psmaHasStreetData === false) {
                            self.psmaHasStreetData = true;
                            // SUFFIX
                            const streetData = this.updateStreetData((self.dropPinSelectsAddress === true ? obj.coor : coor), verifiedObj);
                            // Simplified call to pass object
                            if (cb && typeof cb === 'function') {
                                cb(streetData, { lat: obj.coor[1], lng: obj.coor[0] });
                            }
                        }
                        else if (obj.distance > finalRadius && obj.index === 1 && self.psmaHasStreetData === false && self.count === 1) {
                            let minDistance = obj.distance;
                            let idx = obj.index;
                            for (let i = 0; i < self.psmaAddressData.length; i++) {
                                const item = self.psmaAddressData[i];
                                if (minDistance > item.obj.distance) {
                                    minDistance = item.obj.distance;
                                    idx = obj.index;
                                }
                            }
                            //// logger.info("minDistance = " + JSON.stringify(self.psmaAddressData[idx]));
                            if (minDistance > finalRadius) {
                                this.notificationService.warning('No address could be determined ' + finalRadius + ' metres from that point. ' +
                                    'Please try a different point, if you need an address.');
                                if (cbErr && typeof cbErr === 'function') {
                                    cbErr();
                                }
                            }
                            else {
                                self.psmaHasStreetData = true;
                                addressDetails = self.psmaAddressData[idx].addressDetails;
                                // SUFFIX
                                const streetData = this.updateStreetData((self.dropPinSelectsAddress === true ? obj.coor : null), verifiedObj);
                                if (cb && typeof cb === 'function') {
                                    cb(streetData, { lat: obj.coor[1], lng: obj.coor[0] });
                                }
                            }
                        }
                    }.bind(this), () => {
                        // error
                        console.log('***** PSMA error undefined');
                    });
                    let allowDraw = false;
                    if (self.enableReverseRadiusDisplay) {
                        if (self.reverseAddress.length > self.showReverseAddressPoint) {
                            for (let i = self.reverseAddress.length - 1; i > self.showReverseAddressPoint - 1; --i) {
                                self.reverseAddress.splice(i, 1);
                            }
                            allowDraw = true;
                        }
                        else if (self.reverseAddress.length < self.showReverseAddressPoint
                            && result.data && result.data.links && result.data.links.next) {
                            self.page++;
                            self.reverse([self.lon, self.lat, self.radius, self.count], cb, cbErr, cbTimeout);
                            allowDraw = false;
                        }
                        else {
                            allowDraw = true;
                        }
                    }
                    if (allowDraw) {
                        for (let i = 0; i < self.reverseAddress.length; ++i) {
                            self.psmaIndexAddress++;
                            self.psmaReversItem(self.reverseAddress[i], reverseAddressText[i], self.psmaIndexAddress, [self.lon, self.lat], self.radius, self.count, self.page, function (radius1, obj, addressDetails) {
                                let idx = self.psmaOutOfRadius.findIndex(item => item.addressId === obj.addressId);
                                if (obj.distance > radius1) {
                                    if (idx < 0) {
                                        self.psmaOutOfRadius.push(obj);
                                    }
                                }
                                else {
                                    self.createPoint(obj.coor, obj.index, obj.distance);
                                }
                                if (self.psmaOutOfRadius.length === self.reverseAddress.length && self.count > 1) {
                                    self.count--;
                                    self.radius += self.reverseNoAddressIncrement;
                                    if (self.radius > 100) {
                                        self.radius = 100;
                                    }
                                    self.reverse([self.lon, self.lat, self.radius, self.count], cb, cbErr, cbTimeout);
                                }
                                idx = self.psmaAddressData.findIndex(item => item.obj.addressId === obj.addressId);
                                if (idx < 0) {
                                    self.psmaAddressData.push({ obj, addressDetails });
                                }
                            }.bind(this), () => {
                                // error
                                console.log('***** PSMA error undefined');
                            });
                        }
                    }
                }
                else if (self.count > 1) {
                    self.radius += self.reverseNoAddressIncrement;
                    if (self.radius > 100) {
                        self.radius = 100;
                    }
                    self.count -= 1;
                    self.reverse([self.lon, self.lat, self.radius, self.count], cb, cbErr, cbTimeout);
                }
                else {
                    let finalRadius = 0;
                    if (self.hasPrimaryAssetAddressLookup === true) {
                        finalRadius = self.primaryAssetAddressLookupRadius;
                    }
                    else {
                        finalRadius = (self.psmaRadius < 1 ? 1 : self.psmaRadius) +
                            (self.reverseNoAddressIncrement * self.reverseNoAddressRetry);
                        if (finalRadius > 100) {
                            finalRadius = 100;
                        }
                    }
                    this.notificationService.warning('No address could be determined ' + finalRadius + ' metres from that point. ' +
                        'Please try a different point, if you need an address.');
                    if (cbErr && typeof cbErr === 'function') {
                        cbErr();
                    }
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('PSMA reverse Error ');
                }
            }
        }, error => {
            if (error.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                // logger.info(error);
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('PSMA reverse Error ' + error);
                }
            }
        });
    }
    // new reverseItem function
    psmaReversItem(addressId, formattedAddress, index, coorCenter, radius, count, page, cb, cbErr) {
        const link = this.geocodeUrlNext + addressId + '/?include=geo,addressDetails';
        const self = this;
        this.initObj.httpService.getAPI(link, null, { Authorization: this.apiKeyReverse }).subscribe(dataResult => {
            if (self.callLookUp) {
                return;
            }
            if (dataResult && dataResult.geo) {
                const coor = dataResult.geo.geometry.coordinates;
                let distance = 0;
                distance = getDistance(coor, coorCenter); // openlayer 5 // 15737
                console.log('addressId = ' + addressId
                    + '\n\t - address text = ' + formattedAddress
                    + '\n\t - distance = ' + distance + '\n\t - radius = ' + radius
                    + '\n\t - coor = ' + coor + '\n\t - coorCenter = ' + coorCenter);
                const obj = { coor, index, distance, addressId: dataResult.addressId };
                if (cb && typeof cb === 'function') {
                    cb(radius, obj, dataResult.addressDetails);
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('PSMA reverse Item Error ');
                }
            }
        }, error => {
            // logger.info(error);
            if (cbErr && typeof cbErr === 'function') {
                cbErr('PSMA reverse Error ' + error);
            }
        });
    }
    psmaStyleFunction(feature, resolution) {
        if (typeof feature !== 'object' || typeof feature.getProperties() === 'undefined') {
            return null;
        }
        const description = feature.getProperties().description;
        const label = (typeof description === 'undefined' || description === null) ? '' : description + '';
        //// logger.info("description = " + description + ", label = " + label);
        const style = new Style({
            fill: new Fill({
                color: 'rgba(255,255,255,0.4)'
            }),
            stroke: new Stroke({
                color: '#3399CC',
                width: 1.25
            }),
            text: new Text({
                font: '12px Arial',
                fill: new Fill({ color: '#000' }),
                stroke: new Stroke({
                    color: '#fff', width: 2
                }),
                textBaseline: 'top',
                // get the text from the feature - `this` is ol.Feature
                // and show only under certain resolution
                text: label
            }),
            image: new Circle({
                radius: 3,
                fill: new Fill({
                    color: [255, 127, 39, 1]
                }),
                stroke: new Stroke({
                    color: [255, 0, 0, 1],
                    width: 1.5
                })
            }),
            zIndex: 10000
        });
        return style;
    }
    createLayer() {
        if (typeof this.initObj.mapFunc === 'undefined' || this.initObj.mapFunc === null) {
            if (this.map == null) {
                console.log('Error create layer vector for openlayer map, map variable is null value, need to assign map variable');
                return;
            }
            if (this.psmaSourceVector == null) {
                this.psmaSourceVector = new SourceVector({ features: this.psmaPoints });
            }
            if (this.psmaLayer == null) {
                this.psmaLayer = new LayerVector({
                    title: 'PSMA',
                    visible: true,
                    source: this.psmaSourceVector,
                    style: this.psmaStyleFunction
                });
            }
            else {
                this.map.removeLayer(this.psmaLayer);
            }
            this.map.addLayer(this.psmaLayer);
        }
        else {
            const obj = this.initObj.mapFunc.mapObj.psmaCreateLayer(this.psmaPoints);
            this.psmaSourceVector = obj.psmaSourceVector;
            this.psmaLayer = obj.psmaLayer;
        }
    }
    createPoint(coor, index, distance) {
        if (this.isFeatureRemoving || this.callLookUp) {
            return;
        }
        const des = (index + 1) + '';
        const properties = { description: des, coor };
        if (!this.psmaPoints) {
            this.psmaPoints = [];
        }
        if (typeof this.initObj.mapFunc === 'undefined' || this.initObj.mapFunc === null) {
            const coorMap = proj.transform(coor, 'EPSG:4326', this.EPSG); // 'EPSG:3111'
            const iconFeature = new Feature(new Point(coorMap));
            iconFeature.setProperties(properties);
            this.psmaPoints.push(iconFeature);
            this.psmaSourceVector.addFeature(iconFeature);
        }
        else {
            this.psmaPoints = this.initObj.mapFunc.mapObj.psmaCreatePoint(coor, properties, this.psmaPoints);
        }
    }
    createPointClick(coor, radius) {
        if (this.isFeatureRemoving || this.callLookUp) {
            return;
        }
        //// logger.info("createPointClick, coor = " + JSON.stringify(coor) + ", radius = " + radius);
        if (!this.psmaPoints) {
            this.psmaPoints = [];
        }
        if (typeof this.initObj.mapFunc === 'undefined' || this.initObj.mapFunc === null) {
            // let wgs84Sphere = new ol.Sphere(6378137);//openlayer 4
            // let circle4326 = ol.geom.Polygon.circular(wgs84Sphere, coor, radius, 64);//openlayer 4
            const circle4326 = circular(coor, radius); // openlayer 5
            const circle3857 = circle4326.clone().transform('EPSG:4326', this.EPSG); // 'EPSG:3111'
            const clickFeature = new Feature(circle3857);
            this.psmaPoints.push(clickFeature);
            this.psmaSourceVector.addFeature(clickFeature);
        }
        else {
            this.psmaPoints = this.initObj.mapFunc.mapObj.psmaCreatePointClick(coor, radius, this.psmaPoints);
        }
    }
    removeFeatures(isRemove) {
        if (this.psmaPoints == null) {
            this.psmaPoints = [];
            return;
        }
        const obj = this.initObj.mapFunc.mapObj.psmaRemovePoint(this.psmaPoints, this.psmaSourceVector);
        this.psmaPoints = obj.psmaPoints;
        this.psmaSourceVector = obj.psmaSourceVector;
        this.psmaPoints = [];
        this.isFeatureRemoving = isRemove;
    }
    lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet, cbTimeout) {
        this.callLookUp = true;
        if (params == null || params.length < 1) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('params is invalid, [0] : autocompleteBox');
            }
            return;
        }
        if (this.autocompleteBox == null) {
            this.autocompleteBox = params[0];
        }
        if (params.length > 1) {
            this.search(params[1], cb, cbErr, cbTimeout);
        }
    }
    removeLookUp() {
        const id = this.initObj.keyName + 'MapGeoPSMA';
        const lst = document.querySelectorAll('#' + id);
        if (lst && lst.length > 0) {
            for (let i = 0; i < lst.length; i++) {
                lst[i].remove();
            }
        }
        this.autocompleteBox = null;
    }
    removeStreet(cb) {
        if (this.autocompleteStreet == null) {
            this.autocompleteStreet = document.getElementById(this.initObj.keyName + 'autocomplete');
        }
        if (this.autocompleteStreet == null) {
            if (cb && typeof cb === 'function') {
                cb();
            }
            return;
        }
        this.autocompleteStreet.value = '';
        if (this.psmaPoints && this.psmaPoints.length > 0) {
            if (!this.psmaSourceVector) {
                const obj = this.initObj.mapFunc.mapObj.psmaCreateLayer(this.psmaPoints);
                this.psmaSourceVector = obj.psmaSourceVector;
            }
            this.psmaSourceVector.clear();
        }
        this.removeFeatures(true);
        if (cb && typeof cb === 'function') {
            cb();
        }
    }
    search(sPartialAddress, cb, cbErr, cbTimeout) {
        if (this.apiKey == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('psma address lookup: apiKey is null');
            }
            return;
        }
        if (sPartialAddress == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('psma address lookup: text is null');
            }
            return;
        }
        this.callLookUp = true;
        const newText = sPartialAddress.trim();
        if (newText === this.preText) {
            if (cb && typeof cb === 'function') {
                cb(null);
            }
            return;
        }
        this.preText = newText;
        if (newText.length < 3) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('psma address lookup: text is less than 3 characters');
            }
            return;
        }
        let link = this.autocompleteUrl + sPartialAddress;
        link = this.getLinkOptions(link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime }, { Authorization: this.apiKey }).subscribe(dataResult => {
            if (dataResult && dataResult.suggest) {
                const suggestions = dataResult.suggest;
                const results = [];
                for (let i = 0; i < suggestions.length; i++) {
                    const predict = suggestions[i];
                    const sugg = {};
                    sugg.street = predict.address; // show in UI
                    sugg.id = predict.id;
                    results.push(sugg);
                }
                if (cb && typeof cb === 'function') {
                    cb(results);
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('PSMA reverse Error ');
                }
            }
        }, error => {
            if (error.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                // logger.info(error);
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('PSMA Address Matching Error ' + error);
                }
            }
        });
    }
    selectionOption(tpl, model, cb) {
        const link = this.addressUrl + tpl.id;
        this.callLookUp = true;
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime }, { Authorization: this.apiKey }).subscribe(dataResult => {
            if (dataResult != null && dataResult.address) {
                const obj = new AddressDetails();
                const properties = dataResult.address.properties;
                // SITE NAME
                if (properties.site_name) {
                    obj.properties.locationDescription = properties.site_name;
                }
                // UNIT IDENTIFIER
                if (properties.complex_unit_identifier) {
                    obj.properties.unitNo = properties.complex_unit_identifier;
                    if (obj.properties.locationDescription) {
                        obj.properties.locationDescription += '\n';
                    }
                    obj.properties.locationDescription += ((properties.complex_unit_type_description ?
                        properties.complex_unit_type_description : (properties.complex_unit_type ?
                        properties.complex_unit_type : '')) + ' ' +
                        properties.complex_unit_identifier).trim();
                }
                // LEVEL
                if (properties.complex_level_number) {
                    if (obj.properties.locationDescription) {
                        obj.properties.locationDescription += '\n';
                    }
                    obj.properties.locationDescription += ((properties.complex_level_type_description ?
                        properties.complex_level_type_description : (properties.complex_level_type ?
                        properties.complex_level_type : '')) + ' ' +
                        properties.complex_level_number).trim();
                }
                obj.properties.locationDescription.trim();
                obj.properties.streetNo = properties.street_number_1;
                // DUAL NUMBERS
                if (typeof properties.street_number_2 !== 'undefined' &&
                    properties.street_number_2 != null &&
                    properties.street_number_2 !== 'null' &&
                    properties.street_number_2 !== '') {
                    obj.properties.streetNo = obj.properties.streetNo + '-' +
                        properties.street_number_2;
                }
                let streetType = '';
                if (typeof properties.street_type_description !== 'undefined' &&
                    properties.street_type_description !== null &&
                    properties.street_type_description !== 'null' &&
                    properties.street_type_description !== '') {
                    streetType = properties.street_type_description;
                }
                else if (typeof properties.street_type !== 'undefined' &&
                    properties.street_type !== null &&
                    properties.street_type !== 'null' &&
                    properties.street_type !== '') {
                    streetType = properties.street_type;
                }
                //// logger.info("Street Type is ^"+street_type+"^");
                obj.properties.street = (properties.street_name + ' ' + streetType).trim();
                // SUFFIX
                if (typeof properties.street_suffix !== 'undefined' &&
                    properties.street_suffix !== null &&
                    properties.street_suffix !== 'null' &&
                    properties.street_suffix !== '') {
                    obj.properties.street = obj.properties.street + ' ' +
                        properties.street_suffix;
                }
                obj.properties.suburb = properties.locality_name;
                obj.properties.postcode = properties.postcode;
                // obj.properties.country = properties.country;
                obj.properties.state = properties.state_territory;
                const lat = dataResult.address.geometry.coordinates[1];
                const lon = dataResult.address.geometry.coordinates[0];
                obj.geometry.coordinates[0] = lon;
                obj.geometry.coordinates[1] = lat;
                if (cb && typeof cb === 'function') {
                    cb(obj);
                }
            }
            else {
                if (cb && typeof cb === 'function') {
                    cb('PSMA reverse Error ');
                }
            }
        });
    }
    getLinkOptions(link) {
        if (this.state) {
            link += '&stateTerritory=' + this.state;
        }
        return link;
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapGeoPSMAService.ɵfac = function SclMapGeoPSMAService_Factory(t) { return new (t || SclMapGeoPSMAService)(i0.ɵɵinject(i1.FormbirdInjectorService)); };
/** @nocollapse */ /** @nocollapse */ SclMapGeoPSMAService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapGeoPSMAService, factory: SclMapGeoPSMAService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapGeoPSMAService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return [{ type: i1.FormbirdInjectorService }]; }, null);
})();

class SclMapGeoPsmaFarmService {
    constructor() {
        this.preText = '';
        this.apiKey = 'lGD0Y7HDCc6g1f6wkMZYQWHDlvMTy9ua'; // key Lookup of GeoPsma
        this.apiKeyReverse = 'a2338e05-e3cb425e93ad-109049bfb516'; // key Reverse of GeoCodeFarm
        this.waitTime = 5000;
        this.autocompleteUrl = 'https://api.psma.com.au/predictive/address?query=';
        this.addressUrl = 'https://api.psma.com.au/predictive/address/';
        this.geocodeUrl = 'https://www.geocode.farm/v3/json/reverse/';
    }
    reverse(coor, cb, cbErr, cbTimeout) {
        let link = this.geocodeUrl + '?lat=' + coor[1] + '&lon=' + coor[0] + '&key=' + this.apiKeyReverse + '&count=1';
        link = this.getLinkOptions(link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe(data => {
            if (data && data.geocoding_results.STATUS.status === 'SUCCESS') {
                const suggestions = data.geocoding_results.RESULTS[0];
                const address = suggestions.ADDRESS;
                const streetData = new AddressDetails();
                streetData.properties.streetNo = address.street_number;
                streetData.properties.street = address.street_name;
                streetData.properties.suburb = address.locality;
                streetData.properties.postcode = address.postal_code;
                streetData.properties.country = address.country;
                streetData.properties.state = address.admin_1;
                streetData.geometry.coordinates[0] = coor[0]; // lon
                streetData.geometry.coordinates[1] = coor[1]; // lat
                if (cb && typeof cb === 'function') {
                    cb(streetData, { lat: parseFloat(suggestions.COORDINATES.latitude), lng: parseFloat(suggestions.COORDINATES.longitude) });
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('PsmaFarm reverse Error');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('PsmaFarm reverse Error');
                }
            }
        });
    }
    lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet, cbTimeout) {
        if (params == null || params.length < 1) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('params is invalid, [0] : autocompleteBox');
            }
            return;
        }
        if (this.autocompleteBox == null) {
            this.autocompleteBox = params[0];
        }
        if (params.length > 1) {
            this.search(params[1], cb, cbErr, cbTimeout);
        }
    }
    search(sPartialAddress, cb, cbErr, cbTimeout) {
        if (this.apiKey == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('psma-farm address lookup: apiKey is null');
            }
            return;
        }
        if (sPartialAddress == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('psma-farm address lookup: text is null');
            }
            return;
        }
        const newText = sPartialAddress.trim();
        if (newText === this.preText) {
            if (cb && typeof cb === 'function') {
                cb(null);
            }
            return;
        }
        this.preText = newText;
        if (newText.length < 3) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('psma-farm address lookup: text is less than 3 characters');
            }
            return;
        }
        const link = this.autocompleteUrl + sPartialAddress;
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime }, { Authorization: this.apiKey })
            .subscribe(dataResult => {
            if (dataResult && dataResult.suggest) {
                const suggestions = dataResult.suggest;
                const results = [];
                for (let i = 0; i < suggestions.length; i++) {
                    const predict = suggestions[i];
                    const sugg = {};
                    sugg.street = predict.address; // show in UI
                    sugg.id = predict.id;
                    results.push(sugg);
                }
                if (cb && typeof cb === 'function') {
                    cb(results);
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('PsmaFarm lookup Error ');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('PsmaFarm lookup Error ');
                }
            }
        });
    }
    selectionOption(tpl, model, cb) {
        const link = this.addressUrl + tpl.id;
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime }, { Authorization: this.apiKey })
            .subscribe(dataResult => {
            if (dataResult != null && dataResult.address) {
                const obj = new AddressDetails();
                const properties = dataResult.address.properties;
                // SITE NAME
                if (properties.site_name) {
                    obj.properties.locationDescription = properties.site_name;
                }
                // UNIT IDENTIFIER
                if (properties.complex_unit_identifier) {
                    obj.properties.unitNo = properties.complex_unit_identifier;
                    if (obj.properties.locationDescription) {
                        obj.properties.locationDescription += '\n';
                    }
                    obj.properties.locationDescription += ((properties.complex_unit_type_description ?
                        properties.complex_unit_type_description : (properties.complex_unit_type ?
                        properties.complex_unit_type : '')) + ' ' +
                        properties.complex_unit_identifier).trim();
                }
                // LEVEL
                if (properties.complex_level_number) {
                    if (obj.properties.locationDescription) {
                        obj.properties.locationDescription += '\n';
                    }
                    obj.properties.locationDescription += ((properties.complex_level_type_description ?
                        properties.complex_level_type_description : (properties.complex_level_type ?
                        properties.complex_level_type : '')) + ' ' +
                        properties.complex_level_number).trim();
                }
                obj.properties.locationDescription.trim();
                obj.properties.streetNo = properties.street_number_1;
                // DUAL NUMBERS
                if (typeof properties.street_number_2 !== 'undefined' &&
                    properties.street_number_2 !== null &&
                    properties.street_number_2 !== 'null' &&
                    properties.street_number_2 !== '') {
                    obj.properties.streetNo = obj.properties.streetNo + '-' +
                        properties.street_number_2;
                }
                let streetType = '';
                if (typeof properties.street_type_description !== 'undefined' &&
                    properties.street_type_description !== null &&
                    properties.street_type_description !== 'null' &&
                    properties.street_type_description !== '') {
                    streetType = properties.street_type_description;
                }
                else if (typeof properties.street_type !== 'undefined' &&
                    properties.street_type !== null &&
                    properties.street_type !== 'null' &&
                    properties.street_type !== '') {
                    streetType = properties.street_type;
                }
                obj.properties.street = (properties.street_name + ' ' + streetType).trim();
                // SUFFIX
                if (typeof properties.street_suffix !== 'undefined' &&
                    properties.street_suffix !== null &&
                    properties.street_suffix !== 'null' &&
                    properties.street_suffix !== '') {
                    obj.properties.street = obj.properties.street + ' ' +
                        properties.street_suffix;
                }
                obj.properties.suburb = properties.locality_name;
                obj.properties.postcode = properties.postcode;
                obj.properties.state = properties.state_territory;
                const lat = dataResult.address.geometry.coordinates[1];
                const lon = dataResult.address.geometry.coordinates[0];
                obj.geometry.coordinates[0] = lon;
                obj.geometry.coordinates[1] = lat;
                if (cb && typeof cb === 'function') {
                    cb(obj);
                }
            }
        });
    }
    getLinkOptions(link) {
        if (this.country) {
            link += '&country=' + this.country;
        }
        if (this.language) {
            link += '&lang=' + this.language;
        }
        return link;
    }
    removeFeatures(isRemove) {
        if (this.psmaPoints == null) {
            this.psmaPoints = [];
            return;
        }
        const obj = this.initObj.mapFunc.mapObj.psmaRemovePoint(this.psmaPoints, this.psmaSourceVector);
        this.psmaPoints = obj.psmaPoints;
        this.psmaSourceVector = obj.psmaSourceVector;
        this.psmaPoints = [];
        this.isFeatureRemoving = isRemove;
    }
    removeStreet(cb) {
        if (this.autocompleteStreet == null) {
            this.autocompleteStreet = document.getElementById(this.initObj.keyName + 'autocomplete');
        }
        if (this.autocompleteStreet == null) {
            if (cb && typeof cb === 'function') {
                cb();
            }
            return;
        }
        this.autocompleteStreet.value = '';
        if (this.psmaPoints && this.psmaPoints.length > 0) {
            if (!this.psmaSourceVector) {
                const obj = this.initObj.mapFunc.mapObj.psmaCreateLayer(this.psmaPoints);
                this.psmaSourceVector = obj.psmaSourceVector;
            }
            this.psmaSourceVector.clear();
        }
        this.removeFeatures(true);
        if (cb && typeof cb === 'function') {
            cb();
        }
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapGeoPsmaFarmService.ɵfac = function SclMapGeoPsmaFarmService_Factory(t) { return new (t || SclMapGeoPsmaFarmService)(); };
/** @nocollapse */ /** @nocollapse */ SclMapGeoPsmaFarmService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapGeoPsmaFarmService, factory: SclMapGeoPsmaFarmService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapGeoPsmaFarmService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return []; }, null);
})();

class SclMapGeoVicmapService {
    constructor() {
        this.autocompleteUrl = 'https://api.maps.vic.gov.au/vicmapapi/map/addressSearch?jsoncallback=data&format=json&addressLine=';
        this.geocodeUrl = 'https://www.geocode.farm/v3/json/reverse/';
        this.apiKeyReverse = 'a2338e05-e3cb425e93ad-109049bfb516'; // temprature use of geocodefarm
        this.geocoderDefaultCountry = 'Australia';
        this.geocoderDefaultState = 'VIC';
        this.waitTime = 5000; // miliseconds
    }
    reverse(coor, cb, cbErr, cbTimeout) {
        let link = this.geocodeUrl + '?lat=' + coor[1] + '&lon=' + coor[0] + '&key=' + this.apiKeyReverse + '&count=1';
        link = this.getLinkOptions(link);
        this.initObj.httpService.getAPI(link, { timeout: this.waitTime })
            .subscribe(data => {
            if (data && data.geocoding_results.STATUS.status === 'SUCCESS') {
                const suggestions = data.geocoding_results.RESULTS[0];
                const address = suggestions.ADDRESS;
                const streetData = new AddressDetails();
                streetData.properties.streetNo = address.street_number;
                streetData.properties.street = address.street_name;
                streetData.properties.suburb = address.locality;
                streetData.properties.postcode = address.postal_code;
                streetData.properties.country = address.country;
                streetData.properties.state = address.admin_1;
                streetData.geometry.coordinates[0] = coor[0]; // lon
                streetData.geometry.coordinates[1] = coor[1]; // lat
                if (cb && typeof cb === 'function') {
                    cb(streetData, { lat: parseFloat(suggestions.COORDINATES.latitude), lng: parseFloat(suggestions.COORDINATES.longitude) });
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Vicmap reverse Error');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Vicmap reverse Error');
                }
            }
        });
    }
    lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet, cbTimeout) {
        if (params == null || params.length < 1) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('params is invalid, [0] : autocompleteBox');
            }
            return;
        }
        if (this.autocompleteBox == null) {
            this.autocompleteBox = params[0];
        }
        if (params.length > 1) {
            this.search(params[1], cb, cbErr, cbTimeout);
        }
    }
    removeLookUpfunction() {
        const id = this.initObj.keyName + 'MapGeoVicmap';
        const lst = document.querySelectorAll('#' + id);
        if (lst && lst.length > 0) {
            for (let i = 0; i < lst.length; i++) {
                lst[i].remove();
            }
        }
        this.autocompleteBox = null;
    }
    removeStreet(cb) {
        if (this.autocompleteStreet == null) {
            this.autocompleteStreet = document.getElementById(this.initObj.keyName + 'autocomplete');
        }
        if (this.autocompleteStreet == null) {
            if (cb && typeof cb === 'function') {
                cb();
            }
            return;
        }
        this.autocompleteStreet.value = '';
        if (cb && typeof cb === 'function') {
            cb();
        }
    }
    search(sPartialAddress, cb, cbErr, cbTimeout) {
        if (sPartialAddress == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('vicmap address lookup: text is null');
            }
            return;
        }
        if (sPartialAddress.trim().length < 3) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('vicmap address lookup: text is less than 3 characters');
            }
            return;
        }
        const link = this.autocompleteUrl + sPartialAddress.trim() + ', ' + this.geocoderDefaultState + ', ' + this.geocoderDefaultCountry;
        const options = {
            responseType: 'text',
            timeout: this.waitTime
        };
        const httpClient = this.initObj.httpService.getHttpClient();
        httpClient.get(link, options)
            .subscribe((addressResponse) => {
            // addressResponse is string
            if (addressResponse == null) {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('null data');
                }
                return;
            }
            addressResponse = addressResponse.replace('?(', ''); // remove ?(
            addressResponse = addressResponse.substring(0, addressResponse.length - 2); // remove );
            const results = JSON.parse(addressResponse);
            const result = results.requestResult.result;
            if (result) {
                const results1 = [];
                for (let k = 0; k < result.length; k++) {
                    const r = result[k];
                    const p = r.address;
                    for (let f = 0; f < p.length; f++) {
                        const address = p[f];
                        const sugg = {};
                        sugg.street = address.addressLine;
                        const res = address.pos[0].split(',');
                        sugg.coordinates = {};
                        sugg.coordinates.latitude = res[0];
                        sugg.coordinates.longitude = res[1];
                        sugg.address = {};
                        if (address.unitNumberPrefix) {
                            sugg.address.unitNo = address.unitNumberPrefix;
                            sugg.address.unitNo += address.unitNumber;
                        }
                        else {
                            sugg.address.unitNo = address.unitNumber;
                        }
                        sugg.address.street_number = address.thoroughfareNumberFrom;
                        sugg.address.street_name = '';
                        if (address.thoroughfareName) {
                            sugg.address.street_name = address.thoroughfareName;
                        }
                        if (address.thoroughfareTrailingType) {
                            sugg.address.street_name += ' ' + address.thoroughfareTrailingType;
                        }
                        sugg.address.locality = address.locality;
                        sugg.address.postal_code = address.postcode;
                        if (!address.country) {
                            sugg.address.country = 'Australia';
                        }
                        sugg.address.admin_1 = address.state;
                        results1.push(sugg);
                    }
                }
                if (results1.length > 0) {
                    if (cb && typeof cb === 'function') {
                        cb(results1);
                    }
                }
                else {
                    if (cbErr && typeof cbErr === 'function') {
                        cbErr('Vicmap lookup Error ');
                    }
                }
            }
            else {
                // logger.error("search vicmap error");
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('search vicmap no data');
                }
            }
        }, err => {
            console.log(err);
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                //// logger.info(err);
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Vicmap lookup Error ');
                }
            }
        });
    }
    selectionOption(tpl, model, cb) {
        const address = tpl.address;
        const coordinates = tpl.coordinates;
        const obj = new AddressDetails();
        // { properties: {}, geometry: { coordinates: [] } };
        if (address.unitNo) {
            obj.properties.unitNo = address.unitNo;
        }
        obj.properties.streetNo = address.street_number;
        obj.properties.street = address.street_name;
        obj.properties.suburb = address.locality;
        obj.properties.postcode = address.postal_code;
        obj.properties.country = address.country;
        obj.properties.state = address.admin_1;
        // let coordinates = tpl.coordinates;
        const lat = parseFloat(coordinates.latitude);
        const lon = parseFloat(coordinates.longitude);
        obj.geometry.coordinates[0] = lon;
        obj.geometry.coordinates[1] = lat;
        if (cb && typeof cb === 'function') {
            cb(obj);
        }
    }
    getLinkOptions(link) {
        if (this.country) {
            link += '&country=' + this.country;
        }
        if (this.language) {
            link += '&lang=' + this.language;
        }
        return link;
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapGeoVicmapService.ɵfac = function SclMapGeoVicmapService_Factory(t) { return new (t || SclMapGeoVicmapService)(); };
/** @nocollapse */ /** @nocollapse */ SclMapGeoVicmapService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapGeoVicmapService, factory: SclMapGeoVicmapService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapGeoVicmapService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return []; }, null);
})();

const sclMapConstant$2 = SclMapConstantService;
const sclUtilMapService = new SclUtilMapService();
const formbirdInjectorService = new FormbirdInjectorService();
const searchService = new SearchService(formbirdInjectorService);
class SclMapGeoDocService {
    constructor(sclSearchClientService) {
        this.sclSearchClientService = sclSearchClientService;
        this.waitTime = 5000; // miliseconds
        this.radius = 50;
        this.preText = '';
        this.filter = '';
        this.lookUpCb = null;
        this.lookUpCbErr = null;
        this.lookUpCbSelectOption = null;
        this.lookUpCbRemoveStreet = null;
        this.dexieSearchFilter = null;
        this.queryName = null;
        this.relatedDocument = null;
    }
    setupReverse(geo) {
        if (geo.radius) {
            this.radius = geo.radius;
        }
    }
    buildSearchOption(filter) {
        const options = {
            page: 0,
            pageSize: this.initObj.pageSize,
            document: this.initObj.document,
            filter: filter,
            searchOptions: null,
            queryName: null,
            dataSource: null,
            sourceFilter: [this.geoJsonField, 'documentId', 'systemHeader.summaryName']
        };
        if (this.dexieSearchFilter) {
            options.searchOptions = sclUtilMapService.dexieSearchFunction(this.dexieSearchFilter, options.page, options.pageSize);
        }
        else if (this.queryName) {
            options.dataSource = this.sclSearchClientService.getDefaultSearchProvider(this);
            options.queryName = this.queryName;
        }
        if (this.relatedDocument) {
            for (const field in this.relatedDocument) {
                if (this.relatedDocument.hasOwnProperty(field) && options.sourceFilter.indexOf(field) < 0) {
                    options.sourceFilter.push(this.relatedDocument[field]);
                }
            }
        }
        return options;
    }
    reverse(coor, cb, cbErr, cbTimeout) {
        if (this.lookUpCb == null) {
            this.lookUpCb = this.initObj.lookUpCb;
        }
        if (this.lookUpCbErr == null) {
            this.lookUpCbErr = this.initObj.lookUpCbErr;
        }
        if (this.lookUpCbSelectOption == null) {
            this.lookUpCbSelectOption = this.initObj.lookUpCbSelectOption;
        }
        if (this.lookUpCbRemoveStreet == null) {
            this.lookUpCbRemoveStreet = this.initObj.lookUpCbRemoveStreet;
        }
        if (this.initObj.clearStreetSearchTextBox && typeof this.initObj.clearStreetSearchTextBox === 'function') {
            this.initObj.clearStreetSearchTextBox(null);
        }
        const lat = coor[1];
        const lon = coor[0];
        let radius = coor[2];
        const coorNext = coor;
        if (this.filter.trim().length > 0) {
            const newFilter = sclMapHandlebars.processHandlebars(this.filter, null, null, this.initObj.contextParams);
            const filter = sclUtilMapService.getQueryGeo(coor, coorNext, newFilter, this.geoJsonField);
            const options = this.buildSearchOption(filter);
            searchService.search(options).then(data => {
                if (data && data.data && data.data.hits && data.data.hits.hits && data.data.hits.hits.length > 0) {
                    const customData = data.data.hits.hits;
                    const suggestions = customData[0]._source; // get the first item
                    const streetData = new AddressDetails();
                    let sugLon = lon;
                    let sugLat = lat;
                    if (suggestions && suggestions[this.geoJsonField] && suggestions[this.geoJsonField].features
                        && suggestions[this.geoJsonField].features.length == 1) {
                        if (suggestions[this.geoJsonField].features[0].properties) {
                            const address = suggestions[this.geoJsonField].features[0].properties;
                            streetData.properties.streetNo = address.streetNo;
                            streetData.properties.street = address.street;
                            streetData.properties.suburb = address.suburb;
                            streetData.properties.postcode = address.postcode;
                            streetData.properties.country = address.country;
                            streetData.properties.state = address.state;
                        }
                        if (suggestions[this.geoJsonField].features[0].geometry && suggestions[this.geoJsonField].features[0].coordinates
                            && suggestions[this.geoJsonField].features[0].coordinates.length == 2) {
                            sugLon = suggestions[this.geoJsonField].features[0].coordinates[0];
                            sugLat = suggestions[this.geoJsonField].features[0].coordinates[1];
                        }
                        streetData.geometry.coordinates[0] = lon; // lon
                        streetData.geometry.coordinates[1] = lat; // lat
                        streetData.objRelated = this.getRelatedField(suggestions);
                        if (cb && typeof cb === 'function') {
                            cb(streetData, { lat: sugLat, lng: sugLon });
                        }
                    }
                    else {
                        if (cbErr && typeof cbErr === 'function') {
                            cbErr('There has no data');
                        }
                    }
                }
                else {
                    if (cbErr && typeof cbErr === 'function') {
                        cbErr('There has no data');
                    }
                }
            }, err => {
                if (err.status === -1) {
                    if (cbTimeout && typeof cbTimeout === 'function') {
                        cbTimeout();
                    }
                }
                else {
                    // logger.info(err);
                    if (cbErr && typeof cbErr === 'function') {
                        cbErr('DOC reverse address Error ');
                    }
                }
            });
        }
        else {
            console.log('cant not run reverse function because filter is empty or is NULL');
        }
    }
    lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet, cbTimeout, customData) {
        // cb, cbErr, cbSelectOption, cbRemoveStreet
        this.lookUpCb = cb;
        this.lookUpCbErr = cbErr;
        this.lookUpCbSelectOption = cbSelectOption;
        this.lookUpCbRemoveStreet = cbRemoveStreet;
        if (params == null || params.length < 1) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('params is invalid, [0] : autocompleteBox');
            }
            return;
        }
        if (this.autocompleteBox == null) {
            this.autocompleteBox = params[0];
        }
        if (params.length > 1) {
            this.search(params[1], cb, cbErr, cbTimeout);
        }
    }
    removeLookUp() {
        const id = this.initObj.keyName + 'MapGeoDoc';
        const elem = document.getElementById(id);
        if (elem) {
            elem.remove();
        }
        this.autocompleteBox = null;
    }
    removeStreet(cb) {
        if (this.autocompleteStreet == null) {
            this.autocompleteStreet = document.getElementById(this.initObj.keyName + 'autocomplete');
        }
        if (this.autocompleteStreet == null) {
            if (cb && typeof cb === 'function') {
                cb();
            }
            return;
        }
        this.autocompleteStreet.value = '';
        if (cb && typeof cb === 'function') {
            cb();
        }
    }
    getObjectNotWildcardSummaryName(mustObject) {
        const mustSelected = [];
        mustObject.map((key, index) => {
            let isFoundSummaryName = false;
            if (key.wildcard) {
                for (const sss in key.wildcard) {
                    if (sss === 'systemHeader.summaryName.lcase') {
                        isFoundSummaryName = true;
                    }
                    else {
                        isFoundSummaryName = false;
                    }
                }
            }
            else {
                isFoundSummaryName = false;
            }
            if (!isFoundSummaryName) {
                mustSelected.push(mustObject[index]);
            }
        });
        return mustSelected;
    }
    search(sPartialDocName, cb, cbErr, cbTimeout) {
        if (sPartialDocName == null) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('Text is NULL');
            }
            return;
        }
        const newText = sPartialDocName.trim();
        if (newText === this.preText) {
            if (cb && typeof cb === 'function') {
                cb([]);
            }
            return;
        }
        this.preText = newText;
        if (newText.length < 3) {
            if (cbErr && typeof cbErr === 'function') {
                cbErr('Text is less than 3 charcters');
            }
            return;
        }
        let filter = sclMapHandlebars.processHandlebars(this.filter, null, null, this.initObj.contextParams);
        if (typeof filter === 'string') {
            filter = filter.replace(/'/g, '"');
        }
        // begin 15263
        const filterObj = JSON.parse(filter);
        if (filterObj.query.bool.should === undefined) {
            filterObj.query.bool.should = [];
        }
        if (filterObj.query.bool.must instanceof Object && filterObj.query.bool.must.constructor === Object) {
            const objMust = filterObj.query.bool.must;
            filterObj.query.bool.must = [];
            filterObj.query.bool.must.push(objMust);
        }
        else {
            if (filterObj.query.bool.must === undefined) {
                filterObj.query.bool.must = [];
            }
        }
        filterObj.query.bool.must = this.getObjectNotWildcardSummaryName(filterObj.query.bool.must);
        filterObj.query.bool.must.push({ wildcard: { 'systemHeader.summaryName.lcase': '*' + newText.toLowerCase() + '*' } });
        filter = JSON.stringify(filterObj);
        const options = this.buildSearchOption(filter);
        searchService.search(options).then(data => {
            if (data && data.data && data.data.hits && data.data.hits.hits && data.data.hits.hits.length > 0) {
                const customData = data.data.hits.hits;
                this.lookUpResultDataCb(customData, cb);
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('DOC address lookup Error ');
                }
            }
        }, err => {
            if (err.status === -1) {
                if (cbTimeout && typeof cbTimeout === 'function') {
                    cbTimeout();
                }
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('DOC address lookup Error ');
                }
            }
        });
    }
    lookUpResultDataCb(customData, cb) {
        const results = [];
        for (let i = 0; i < customData.length; i++) {
            const item = customData[i]._source;
            const sugg = {};
            sugg.street = item.systemHeader.summaryName;
            sugg.address = item;
            if (item[this.geoJsonField] && item[this.geoJsonField].features && item[this.geoJsonField].features.length > 0
                && item[this.geoJsonField].features[0].geometry && item[this.geoJsonField].features[0].geometry.coordinates) {
                const lat = item[this.geoJsonField].features[0].geometry.coordinates[1];
                const lng = item[this.geoJsonField].features[0].geometry.coordinates[0];
                sugg.coordinates = {
                    "Latitude": lat,
                    "Longitude": lng
                };
            }
            else {
                console.log(sugg.street + ' - ' + item.documentId + ' does not have geometry data');
            }
            results.push(sugg);
        }
        if (cb && typeof cb === 'function') {
            cb(results);
        }
    }
    selectionOption(tpl, model, cb) {
        const data = tpl.address;
        const coordinates = tpl.coordinates;
        const obj = new AddressDetails();
        if (data[this.geoJsonField] && data[this.geoJsonField].features && data[this.geoJsonField].features.length > 0
            && data[this.geoJsonField].features[0].properties) {
            const address = data[this.geoJsonField].features[0].properties;
            obj.properties.streetNo = address.streetNo;
            obj.properties.street = address.street;
            obj.properties.suburb = address.suburb;
            obj.properties.postcode = address.postcode;
            obj.properties.country = address.country;
            obj.properties.state = address.state;
        }
        if (coordinates) {
            const lat = parseFloat(coordinates.Latitude);
            const lon = parseFloat(coordinates.Longitude);
            obj.geometry.coordinates[0] = lon;
            obj.geometry.coordinates[1] = lat;
        }
        obj.objRelated = this.getRelatedField(data);
        if (this.lookUpCbSelectOption && typeof this.lookUpCbSelectOption === 'function') {
            this.lookUpCbSelectOption(obj);
        }
    }
    getLinkOptions(link) {
        if (this.state) {
            link += ' ' + this.state;
        }
        if (this.country) {
            link += ' ' + this.country;
        }
        return link;
    }
    getRelatedField(addressData) {
        let relatedObj = null;
        if (this.relatedDocument) {
            for (const field in this.relatedDocument) {
                if (this.relatedDocument.hasOwnProperty(field)) {
                    const dataField = this.relatedDocument[field];
                    const value = addressData[dataField];
                    if (value) {
                        if (relatedObj == null) {
                            relatedObj = {};
                        }
                        relatedObj[field] = value;
                    }
                }
            }
        }
        return relatedObj;
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapGeoDocService.ɵfac = function SclMapGeoDocService_Factory(t) { return new (t || SclMapGeoDocService)(i0.ɵɵinject(i1$1.SclSearchClientService)); };
/** @nocollapse */ /** @nocollapse */ SclMapGeoDocService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapGeoDocService, factory: SclMapGeoDocService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapGeoDocService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return [{ type: i1$1.SclSearchClientService }]; }, null);
})();

class SclMapGeoService {
    constructor(formbirdInjectorService, sclSearchClientService) {
        this.formbirdInjectorService = formbirdInjectorService;
        this.sclSearchClientService = sclSearchClientService;
        this.providerLookUp = null;
        this.providerReverse = null;
        this.geoProviders = [];
        this.cbLookUp = null;
        this.cbLookUpErr = null;
        this.cbSelectOption = null;
        this.currentProviderLookUpIndex = 0;
        this.country = '';
        this.language = '';
        this.isInit = false;
        this.setTimeWait = 300;
        this.lookUpGoogle = false;
        this.sclMapGeoCodeFarmService = new SclMapGeoCodeFarmService();
        this.sclMapGeoGoogleService = new SclMapGeoGoogleService();
        this.sclMapGeoHereService = new SclMapGeoHereService();
        this.sclMapGeoPSMAService = new SclMapGeoPSMAService(formbirdInjectorService);
        this.sclMapGeoPsmaFarmService = new SclMapGeoPsmaFarmService();
        this.sclMapGeoVicMapService = new SclMapGeoVicmapService();
        this.sclMapGeoDocService = new SclMapGeoDocService(sclSearchClientService);
    }
    init(geocodeSearchService, pInstance, map, EPSG, options) {
        if (this.isInit) {
            return;
        }
        let googleIndex = -1; // 14831
        if (this.geoProviders === null) {
            this.geoProviders = [];
        }
        if (geocodeSearchService.length === 0) {
            this.geoProviders = [{
                    name: 'geocodefarm',
                    apiKey: 'a2338e05-e3cb425e93ad-109049bfb516',
                    timeWait: 10000
                }];
        }
        else {
            for (let i = 0; i < geocodeSearchService.length; ++i) {
                this.geoProviders.push(geocodeSearchService[i]);
                if (geocodeSearchService[i].name === 'google') {
                    googleIndex = i;
                }
            }
        }
        this.initObj = options;
        this.currentProviderReverseIndex = 0;
        this.currentProviderLookUpIndex = 0;
        // this.instance(this.geoProviders[this.currentProviderReverseIndex]);
        if (geocodeSearchService.country) {
            this.country = geocodeSearchService.country;
        }
        if (geocodeSearchService.language) {
            this.language = geocodeSearchService.language;
        }
        this.MapGeo = pInstance;
        this.map = map;
        this.EPSG = EPSG;
        this.isInit = true;
        // 14831
        // console.log('%c googleIndex = ' + googleIndex + ', this.geoProviders.length = ' + this.geoProviders.length, 'color:blue');
        if (googleIndex === 0) {
            this.instance(this.geoProviders[googleIndex]);
        }
    }
    instance(geo) {
        let provider = {};
        this.lookUpGoogle = false;
        switch (geo.name) {
            case 'geocodefarm':
                provider = this.sclMapGeoCodeFarmService;
                break;
            case 'google':
                provider = this.sclMapGeoGoogleService;
                this.lookUpGoogle = true;
                break;
            case 'vicmap':
                provider = this.sclMapGeoVicMapService;
                break;
            case 'psma':
                provider = this.sclMapGeoPSMAService;
                break;
            case 'psmafarm':
                provider = this.sclMapGeoPsmaFarmService;
                break;
            case 'here':
                provider = this.sclMapGeoHereService;
                break;
            case 'doc':
                provider = this.sclMapGeoDocService;
                break;
            default:
                provider = this.sclMapGeoGoogleService;
                break;
        }
        provider.initObj = this.initObj;
        if (geo.apiKey) {
            provider.apiKey = geo.apiKey;
            // provider.apiKeyReverse = geo.apiKey;
        }
        if (geo.apiKeyReverse) {
            provider.apiKeyReverse = geo.apiKeyReverse;
        }
        if (geo.timeWait) {
            provider.waitTime = geo.timeWait;
        }
        if (geo.country) {
            provider.country = geo.country;
        }
        if (geo.state) {
            provider.state = geo.state;
        }
        if (geo.language) {
            provider.language = geo.language;
        }
        if (geo.autocompleteUrl) {
            provider.autocompleteUrl = geo.autocompleteUrl;
        }
        if (geo.addressUrl) {
            provider.addressUrl = geo.addressUrl;
        }
        if (geo.geocodeUrl) {
            provider.geocodeUrl = geo.geocodeUrl;
        }
        if (geo.geocodeUrlNext) {
            provider.geocodeUrlNext = geo.geocodeUrlNext;
        }
        if (geo.appId) {
            provider.appId = geo.appId;
        }
        if (geo.appCode) {
            provider.appCode = geo.appCode;
            // provider.apiKeyReverse = geo.appCode;
        }
        if (geo.radius) {
            provider.radius = geo.radius;
        }
        if (geo.filter) {
            provider.filter = geo.filter;
        }
        if (geo.geoJsonField) {
            provider.geoJsonField = geo.geoJsonField;
        }
        if (geo.relatedDocument) {
            provider.relatedDocument = geo.relatedDocument;
        }
        if (geo.dexieSearchFilter) {
            provider.dexieSearchFilter = geo.dexieSearchFilter;
        }
        if (geo.queryName) {
            provider.queryName = geo.queryName;
        }
        provider.geo = geo;
        if (this.lookUpGoogle) {
            provider.loadLookup = true;
            provider.setupLookUp();
        }
        // console.log('%c instance , lookUpGoogle = ' + this.lookUpGoogle, 'color:blue');
        return provider;
    }
    reverse(coor, cb, cbErr) {
        const mapGeo = this;
        const pCoor = coor;
        const pCb = cb;
        const pCbErr = cbErr;
        if (this.providerReverse == null) {
            this.providerReverse = this.instance(this.geoProviders[this.currentProviderReverseIndex]);
        }
        // use for testing psma
        if (this.providerReverse.geo.name === 'psma') {
            this.providerReverse.map = this.map;
            this.providerReverse.EPSG = this.EPSG;
            if (this.providerReverse.geo.radius == null) {
                coor[2] = this.providerReverse.psmaRadius;
            }
            else {
                coor[2] = (this.providerReverse.geo.radius < 1 ? 1 : this.providerReverse.geo.radius);
            }
            if (typeof this.providerReverse.geo.hasPrimaryAssetAddressLookup !== 'undefined' &&
                this.providerReverse.geo.hasPrimaryAssetAddressLookup !== null) {
                this.providerReverse.hasPrimaryAssetAddressLookup = this.providerReverse.geo.hasPrimaryAssetAddressLookup; // 15393
            }
            this.providerReverse.setupReverse(this.providerReverse.geo);
        }
        else if (this.providerReverse.geo.name === 'here') {
            if (typeof this.providerReverse.geo.hasPrimaryAssetAddressLookup !== 'undefined' &&
                this.providerReverse.geo.hasPrimaryAssetAddressLookup !== null) {
                this.providerReverse.hasPrimaryAssetAddressLookup = this.providerReverse.geo.hasPrimaryAssetAddressLookup; // 15393
            }
            this.providerReverse.setupReverse(this.providerReverse.geo);
        }
        //
        this.providerReverse.reverse(coor, cb, cbErr, function () {
            //// logger.info("MapGeo.reverse timeout");
            mapGeo.currentProviderReverseIndex++;
            if (mapGeo.currentProviderReverseIndex < mapGeo.geoProviders.length) {
                mapGeo.providerReverse = mapGeo.instance(mapGeo.geoProviders[mapGeo.currentProviderReverseIndex]);
                mapGeo.providerReverse.autocompleteBox = mapGeo.autocompleteBox;
                mapGeo.reverse(pCoor, pCb, pCbErr);
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('all time out');
                }
            }
        });
    }
    lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet) {
        if (this.geoProviders.length === 0) {
            this.geoProviders = [{
                    name: 'geocodefarm',
                    apiKey: 'a2338e05-e3cb425e93ad-109049bfb516',
                    timeWait: 1000
                }];
        }
        this.cbLookUp = cb;
        this.cbLookUpErr = cbErr;
        this.cbSelectOption = cbSelectOption;
        this.cbRemoveStreet = cbRemoveStreet;
        if (this.autocompleteBox == null) {
            this.autocompleteBox = params[0];
        }
        if (this.providerLookUp == null) {
            this.providerLookUp = this.instance(this.geoProviders[this.currentProviderLookUpIndex]);
        }
        const mapGeo = this;
        if (params[0] == null) {
            params[0] = this.autocompleteBox;
        }
        if (params.length > 1 && params[1].trim().length === 0) {
            return;
        }
        if (this.lookUpGoogle) {
            this.providerLookUp.cbSelectOption = cbSelectOption;
        }
        this.providerLookUp.lookUp(params, cb, cbErr, cbSelectOption, cbRemoveStreet, function () {
            //// logger.info("MapGeo.lookUp timeout");
            mapGeo.currentProviderLookUpIndex++;
            if (mapGeo.currentProviderLookUpIndex < mapGeo.geoProviders.length) {
                // new notice box
                const id = this.initObj.keyName + 'LoadingProvider';
                const len = document.querySelectorAll('#' + id).length; // angular.element(element).find('#' + id).length;
                if (len === 0) {
                    const child = document.createElement('div');
                    child.setAttribute('id', id);
                    child.setAttribute('style', 'float:left; position:relative; overflow:hidden; background-color: black; ' +
                        'opacity: 0.2; width: 200px; text-align: center; border-radius: 10px;');
                    child.innerHTML = '<span style="color:white; display:inline-block;">Loading ' +
                        mapGeo.geoProviders[mapGeo.currentProviderLookUpIndex].name + ' provider</span>';
                    mapGeo.autocompleteBox.append(child);
                }
                setTimeout(() => {
                    console.log('TODO finish waiting');
                    // if (angular.element(element).find('#' + id).length > 0) {
                    //     angular.element(element).find('#' + id).remove();
                    // }
                    const lst = document.querySelectorAll('#' + id);
                    if (lst && lst.length > 0) {
                        for (let i = 0; i < lst.length; i++) {
                            lst[i].remove();
                        }
                    }
                    mapGeo.providerLookUp.removeLookUp();
                    mapGeo.providerLookUp = mapGeo.instance(mapGeo.geoProviders[mapGeo.currentProviderLookUpIndex]);
                    params[0] = mapGeo.autocompleteBox;
                    mapGeo.lookUp(params, mapGeo.cbLookUp, mapGeo.cbLookUpErr, mapGeo.cbSelectOption, mapGeo.cbRemoveStreet);
                }, 1000);
            }
            else {
                if (cbErr && typeof cbErr === 'function') {
                    cbErr('Address lookup for that text location has timed out.  Please try again.');
                }
            }
        });
    }
    selectionOption(tpl, model) {
        if (this.providerLookUp == null) {
            return;
        } // call this method invalid way
        this.providerLookUp.selectionOption(tpl, model, this.cbSelectOption);
    }
    removeStreet() {
        if (this.geoProviders.length === 0) {
            this.geoProviders = [{
                    name: 'geocodefarm',
                    apiKey: 'a2338e05-e3cb425e93ad-109049bfb516',
                    timeWait: 1000
                }];
        }
        if (this.providerLookUp == null) {
            this.providerLookUp = this.instance(this.geoProviders[this.currentProviderLookUpIndex]);
        }
        // if ( this.providerLookUp.geo.name !== 'google') { return; }
        if (this.providerReverse && this.providerReverse.psmaPoints && this.providerReverse.psmaPoints.length > 0) {
            this.providerReverse.removeFeatures(true);
        }
        this.providerLookUp.removeStreet(this.cbRemoveStreet);
    }
    removeFeatures() {
        if (!this.isInit || this.geoProviders.length === 0 || this.providerReverse == null || this.providerReverse.geo.name !== 'psma') {
            return;
        }
        this.providerReverse.removeFeatures(true);
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapGeoService.ɵfac = function SclMapGeoService_Factory(t) { return new (t || SclMapGeoService)(i0.ɵɵinject(i1.FormbirdInjectorService), i0.ɵɵinject(i1$1.SclSearchClientService)); };
/** @nocollapse */ /** @nocollapse */ SclMapGeoService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapGeoService, factory: SclMapGeoService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapGeoService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return [{ type: i1.FormbirdInjectorService }, { type: i1$1.SclSearchClientService }]; }, null);
})();

class HttpService {
    constructor(http) {
        this.http = http;
    }
    // Handle API errors
    handleError(error) {
        if (error.error instanceof ErrorEvent) {
            // A client-side or network error occurred. Handle it accordingly.
            console.error('An error occurred:', error.error.message);
        }
        else {
            // The backend returned an unsuccessful response code.
            // The response body may contain clues as to what went wrong,
            console.error(`Backend returned code ${error.status}, ` +
                `body was: ${error.error}`);
        }
        // return an observable with a user-facing error message
        return throwError('Something bad happened; please try again later.');
    }
    errorHanlder(error) {
        return throwError(error.message || 'Server Error');
    }
    // GET
    getAPI(link, variables, pHeaders) {
        const httpParams = new HttpParams();
        for (const field in variables) {
            if (variables.hasOwnProperty(field)) {
                httpParams.set(field, variables[field]);
            }
        }
        httpParams.set('responseType', 'text');
        const options = { params: httpParams, headers: new HttpHeaders() };
        for (const field in pHeaders) {
            if (pHeaders.hasOwnProperty(field)) {
                options.headers = options.headers.set(field, pHeaders[field]);
                // console.log('%c set headers , key = ' + field + ', value = ' + pHeaders[field], 'color:blue');
            }
        }
        // options.headers = options.headers.set('responseType', 'text');
        // return this.http.get(link, options).pipe(retry(1), catchError(this.handleError))
        return this.http.get(link, options).pipe(retry(1), catchError(this.errorHanlder));
    }
    getHttpClient() {
        return this.http;
    }
}
/** @nocollapse */ /** @nocollapse */ HttpService.ɵfac = function HttpService_Factory(t) { return new (t || HttpService)(i0.ɵɵinject(i1$2.HttpClient)); };
/** @nocollapse */ /** @nocollapse */ HttpService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: HttpService, factory: HttpService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(HttpService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root',
                }]
        }], function () { return [{ type: i1$2.HttpClient }]; }, null);
})();

const _c0 = ["streetGeo"];
function GeoAutocompleteComponent_div_0_mat_option_8_Template(rf, ctx) {
    if (rf & 1) {
        i0.ɵɵelementStart(0, "mat-option", 8);
        i0.ɵɵtext(1);
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const street_r4 = ctx.$implicit;
        i0.ɵɵproperty("value", street_r4);
        i0.ɵɵadvance(1);
        i0.ɵɵtextInterpolate1(" ", street_r4.street, " ");
    }
}
const _c1 = function () { return { "cursor": "not-allowed" }; };
function GeoAutocompleteComponent_div_0_Template(rf, ctx) {
    if (rf & 1) {
        const _r6 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "div", 1);
        i0.ɵɵelementStart(1, "button", 2);
        i0.ɵɵlistener("click", function GeoAutocompleteComponent_div_0_Template_button_click_1_listener() { i0.ɵɵrestoreView(_r6); const ctx_r5 = i0.ɵɵnextContext(); return ctx_r5.removeStreet(null); });
        i0.ɵɵelementStart(2, "mat-icon");
        i0.ɵɵtext(3, "close");
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(4, "mat-form-field", 3);
        i0.ɵɵelementStart(5, "input", 4);
        i0.ɵɵlistener("input", function GeoAutocompleteComponent_div_0_Template_input_input_5_listener($event) { i0.ɵɵrestoreView(_r6); const ctx_r7 = i0.ɵɵnextContext(); return ctx_r7.lookUp($event.target.value); });
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(6, "mat-autocomplete", 5, 6);
        i0.ɵɵlistener("optionSelected", function GeoAutocompleteComponent_div_0_Template_mat_autocomplete_optionSelected_6_listener($event) { i0.ɵɵrestoreView(_r6); const ctx_r8 = i0.ɵɵnextContext(); return ctx_r8.mapGeo.selectionOption($event.option.value); });
        i0.ɵɵtemplate(8, GeoAutocompleteComponent_div_0_mat_option_8_Template, 2, 2, "mat-option", 7);
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const _r2 = i0.ɵɵreference(7);
        const ctx_r0 = i0.ɵɵnextContext();
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("id", "btnRemove" + ctx_r0.keyName)("disabled", ctx_r0.disabled);
        i0.ɵɵadvance(4);
        i0.ɵɵproperty("id", ctx_r0.keyName + "InputAutoComplete")("matAutocomplete", _r2)("readonly", ctx_r0.disabled)("ngStyle", ctx_r0.disabled ? i0.ɵɵpureFunction0(8, _c1) : "");
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("displayWith", ctx_r0.getDisplayFn());
        i0.ɵɵadvance(2);
        i0.ɵɵproperty("ngForOf", ctx_r0.streets);
    }
}
function GeoAutocompleteComponent_div_1_Template(rf, ctx) {
    if (rf & 1) {
        const _r10 = i0.ɵɵgetCurrentView();
        i0.ɵɵelementStart(0, "div", 1);
        i0.ɵɵelementStart(1, "button", 2);
        i0.ɵɵlistener("click", function GeoAutocompleteComponent_div_1_Template_button_click_1_listener() { i0.ɵɵrestoreView(_r10); const ctx_r9 = i0.ɵɵnextContext(); return ctx_r9.mapGeo.removeStreet(); });
        i0.ɵɵelementStart(2, "mat-icon");
        i0.ɵɵtext(3, "close");
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementStart(4, "mat-form-field", 3);
        i0.ɵɵelementStart(5, "input", 9);
        i0.ɵɵlistener("input", function GeoAutocompleteComponent_div_1_Template_input_input_5_listener($event) { i0.ɵɵrestoreView(_r10); const ctx_r11 = i0.ɵɵnextContext(); return ctx_r11.lookUp($event.target.value); });
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
        i0.ɵɵelementEnd();
    }
    if (rf & 2) {
        const ctx_r1 = i0.ɵɵnextContext();
        i0.ɵɵadvance(1);
        i0.ɵɵproperty("id", "ggRemove" + ctx_r1.keyName)("disabled", ctx_r1.disabled);
        i0.ɵɵadvance(4);
        i0.ɵɵproperty("id", ctx_r1.keyName + "autocomplete")("readonly", ctx_r1.disabled)("ngStyle", ctx_r1.disabled ? i0.ɵɵpureFunction0(5, _c1) : "");
    }
}
class GeoAutocompleteComponent {
    constructor(cdRef, httpService, changedDocumentService, formbirdInjectorService, sclSearchClientService) {
        this.cdRef = cdRef;
        this.httpService = httpService;
        this.changedDocumentService = changedDocumentService;
        this.formbirdInjectorService = formbirdInjectorService;
        this.sclSearchClientService = sclSearchClientService;
        this.autocompleteBox = {};
        this.getStreetData = new EventEmitter();
        this.removeStreetCb = new EventEmitter();
        this.lookUpResultCb = new EventEmitter();
        this.lookUpErrorCb = new EventEmitter();
        this.init = new EventEmitter();
        // streetData;
        this.currentStreetData = '';
        this.streets = [];
        this.isGoogle = false;
        this.checkMapReadyCount = 0;
        this.subs = new Subscription(); // 15295
        this.broadcastService = this.formbirdInjectorService.get('BroadcastService');
        this.mapGeo = new SclMapGeoService(formbirdInjectorService, sclSearchClientService);
    }
    ngOnDestroy() {
        this.subs.unsubscribe();
    }
    ngOnInit() {
    }
    ngAfterViewInit() {
        if (this.isReady) {
            return;
        }
        this.isReady = setInterval(() => {
            if (this.isParentReady === true) {
                console.log('done loading parent component !!!');
                clearInterval(this.isReady);
                this.isReady = null; // reset
                this.initialize();
            }
            else {
                this.checkMapReadyCount++;
                if (this.checkMapReadyCount > 11) {
                    console.log('can\'t init geo-component because parent component can\'t finish loading !!!');
                    clearInterval(this.isReady);
                    this.isReady = null; // reset
                }
                else {
                    console.log('waiting for parent component finish loading... ');
                }
            }
        }, 100);
    }
    ngOnChanges(changes) {
        // if (changes['autoCompleteBox']) {
        //     this.autocompleteBox = changes['autoCompleteBox'].currentValue;
        // }
        // if (changes['mapGeo']) {
        //   this.mapGeo = changes['mapGeo'].currentValue;
        // }
        // if (changes['keyName']) {
        //   this.keyName = changes['keyName'].currentValue;
        // }
        // if(changes['disabled']){
        //   this.disabled = changes['disabled'].currentValue;
        // }
        if (changes.autoCompleteBox) {
            this.autocompleteBox = changes.autoCompleteBox.currentValue;
        }
        if (changes.mapGeo) {
            this.mapGeo = changes.mapGeo.currentValue;
        }
        if (changes.keyName) {
            this.keyName = changes.keyName.currentValue;
        }
        if (changes.disabled) {
            this.disabled = changes.disabled.currentValue;
        }
    }
    getDisplayFn() {
        return (val) => val ? val.street : val;
    }
    lookUp(value) {
        // console.log('%c lookUp, value = ' + value , 'color:blue');
        this.streets = [];
        this.mapGeo.lookUp([this.autocompleteBox, value], this.lookUpCb.bind(this), this.lookUpCbErr.bind(this), this.lookUpCbSelectOption.bind(this), this.lookUpCbRemoveStreet.bind(this));
    }
    lookUpCb(results) {
        if (results == null) {
            return;
        }
        this.streets = results.filter(street => {
            street.street.toLowerCase().includes(this.currentStreetData);
            // if(street.id != null){
            return street;
            // }
        });
        // auto focus to show drop down popup
        this.trigger._onChange(''); // auto focus
        this.trigger.openPanel(); // auto focus
        this.cdRef.detectChanges();
        this.lookUpResultCb.emit();
    }
    lookUpCbErr(err) {
        console.log('error = ' + err);
        // NotificationService.error(err);
        this.lookUpErrorCb.emit();
    }
    lookUpCbSelectOption(streetData) {
        if (this.mapGeo != null) {
            this.mapGeo.removeFeatures();
        }
        if (streetData == null) {
            return;
        }
        this.getStreetData.emit(streetData);
        // console.log("scope.streetData = " + JSON.stringify(scope.streetData));
    }
    lookUpCbRemoveStreet() {
        this.removeStreetCb.emit();
    }
    initialize() {
        if (Array.isArray(this.geocodeSearchService) && this.geocodeSearchService.length > 0
            && this.geocodeSearchService[0].name === 'google') {
            this.isGoogle = true;
        }
        if (this.EPSG === 'undefined' || this.EPSG == null) {
            this.EPSG = 'EPSG:3857';
        }
        this.mapGeo.init(this.geocodeSearchService, this.mapGeo, this.map, this.EPSG, {
            keyName: this.keyName,
            assetField: this.componentDefinition,
            httpService: this.httpService,
            mapFunc: this.mapFunc,
            contextParams: this.contextParams,
            lookUpCb: this.lookUpCb.bind(this),
            lookUpCbErr: this.lookUpCbErr.bind(this),
            lookUpCbSelectOption: this.lookUpCbSelectOption.bind(this),
            lookUpCbRemoveStreet: this.lookUpCbRemoveStreet.bind(this),
            pageSize: this.pageSize,
            document: this.document,
            clearStreetSearchTextBox: this.clearStreetSearchTextBox.bind(this)
        });
        this.init.emit({ geoAutoComplete: this });
        // 15295
        this.watchReadOnly();
        const formResetSub = this.broadcastService.on('formReset').subscribe(() => {
            this.clearInputData(null);
            this.cdRef.detectChanges();
        });
    }
    clearInputData(keyName) {
        this.currentStreetData = '';
        this.streets = [];
        this.clearStreetSearchTextBox(keyName);
    }
    removeStreet(keyName) {
        if (this.disabled == true) {
            return;
        }
        this.clearInputData(keyName);
        if (this.mapGeo) {
            this.mapGeo.cbRemoveStreet = this.removeStreetCbFunc.bind(this);
            this.mapGeo.removeStreet();
        }
        this.cdRef.detectChanges();
    }
    removeStreetCbFunc() {
        this.removeStreetCb.emit();
        this.mapGeo.cbRemoveStreet = null; // reset
    }
    // 15295
    watchReadOnly() {
        const compSub = this.changedDocumentService.watchComponentDef(this.fieldName, this.template.documentId).subscribe(componentDefinition => {
            this.disabled = (componentDefinition === null || componentDefinition === void 0 ? void 0 : componentDefinition.enabled) === false;
            this.cdRef.detectChanges();
        });
        this.subs.add(compSub);
    }
    clearStreetSearchTextBox(keyName) {
        let iput = document.getElementById(this.keyName + 'InputAutoComplete');
        if (keyName) {
            iput = document.getElementById(keyName + 'InputAutoComplete');
        }
        if (iput) {
            iput.value = '';
        }
        // gg
        let iputGG = document.getElementById(this.keyName + 'autocomplete');
        if (keyName) {
            iputGG = document.getElementById(keyName + 'autocomplete');
        }
        if (iputGG) {
            iputGG.value = '';
        }
    }
}
/** @nocollapse */ /** @nocollapse */ GeoAutocompleteComponent.ɵfac = function GeoAutocompleteComponent_Factory(t) { return new (t || GeoAutocompleteComponent)(i0.ɵɵdirectiveInject(i0.ChangeDetectorRef), i0.ɵɵdirectiveInject(HttpService), i0.ɵɵdirectiveInject(i1.ChangedDocumentService), i0.ɵɵdirectiveInject(i1.FormbirdInjectorService), i0.ɵɵdirectiveInject(i1$1.SclSearchClientService)); };
/** @nocollapse */ /** @nocollapse */ GeoAutocompleteComponent.ɵcmp = /** @pureOrBreakMyCode */ i0.ɵɵdefineComponent({ type: GeoAutocompleteComponent, selectors: [["geo-auto-complete"]], viewQuery: function GeoAutocompleteComponent_Query(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵviewQuery(MatAutocompleteTrigger, 5);
            i0.ɵɵviewQuery(_c0, 7);
        }
        if (rf & 2) {
            let _t;
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.trigger = _t.first);
            i0.ɵɵqueryRefresh(_t = i0.ɵɵloadQuery()) && (ctx.streetGeo = _t.first);
        }
    }, inputs: { disabled: "disabled", keyName: "keyName", autocompleteBox: "autocompleteBox", geocodeSearchService: "geocodeSearchService", map: "map", EPSG: "EPSG", mapFunc: "mapFunc", componentDefinition: "componentDefinition", isParentReady: "isParentReady", contextParams: "contextParams", pageSize: "pageSize", document: "document", template: "template", fieldName: "fieldName" }, outputs: { getStreetData: "getStreetData", removeStreetCb: "removeStreetCb", lookUpResultCb: "lookUpResultCb", lookUpErrorCb: "lookUpErrorCb", init: "init" }, features: [i0.ɵɵNgOnChangesFeature], decls: 2, vars: 2, consts: [["class", "clear-auto-complete-wrap", 4, "ngIf"], [1, "clear-auto-complete-wrap"], ["type", "button", "mat-button", "", 1, "close-icon", 3, "id", "disabled", "click"], ["appearance", "standard"], ["matInput", "", "placeholder", "Search address", "name", "streetGeo", 3, "id", "matAutocomplete", "readonly", "ngStyle", "input"], [1, "ft-geo-auto-complete", 3, "displayWith", "optionSelected"], ["autogeo", "matAutocomplete"], [3, "value", 4, "ngFor", "ngForOf"], [3, "value"], ["matInput", "", "placeholder", "Search", "type", "text", 1, "form-control-geo-auto-complete", "mat-input-element", 3, "id", "readonly", "ngStyle", "input"]], template: function GeoAutocompleteComponent_Template(rf, ctx) {
        if (rf & 1) {
            i0.ɵɵtemplate(0, GeoAutocompleteComponent_div_0_Template, 9, 9, "div", 0);
            i0.ɵɵtemplate(1, GeoAutocompleteComponent_div_1_Template, 6, 6, "div", 0);
        }
        if (rf & 2) {
            i0.ɵɵproperty("ngIf", !(ctx.mapGeo == null ? null : ctx.mapGeo.lookUpGoogle));
            i0.ɵɵadvance(1);
            i0.ɵɵproperty("ngIf", ctx.mapGeo == null ? null : ctx.mapGeo.lookUpGoogle);
        }
    }, directives: [i4.NgIf, i5.MatButton, i6.MatIcon, i7.MatFormField, i8.MatInput, i9.MatAutocompleteTrigger, i4.NgStyle, i9.MatAutocomplete, i4.NgForOf, i10.MatOption], styles: [".clear-auto-complete-wrap{width:100%;position:relative}.clear-auto-complete-wrap>button{position:absolute;top:-40px;right:0;z-index:999;min-width:unset!important;width:32px;height:auto;padding:0}.clear-auto-complete-wrap>button .mat-icon{height:16px!important;width:16px!important;font-size:16px!important}.selectedAsset .clear-auto-complete-wrap>button{top:-25px}.ft-geo-auto-complete{margin-top:-20px}\n"], encapsulation: 2 });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(GeoAutocompleteComponent, [{
            type: Component,
            args: [{ selector: 'geo-auto-complete', encapsulation: ViewEncapsulation.None, template: "<div class=\"clear-auto-complete-wrap\" *ngIf=\"!mapGeo?.lookUpGoogle\">\n    <button type=\"button\" [id]=\"'btnRemove'+keyName\" mat-button class=\"close-icon\" (click)=\"removeStreet(null)\" [disabled]=\"disabled\">\n        <mat-icon>close</mat-icon>\n    </button>\n    <mat-form-field appearance=\"standard\">\n        <input [id]=\"keyName+'InputAutoComplete'\" matInput placeholder=\"Search address\" [matAutocomplete]=\"autogeo\" name=\"streetGeo\"\n        (input)=\"lookUp($event.target.value)\"\n        [readonly]=\"disabled\" [ngStyle]=\"disabled ? {'cursor':'not-allowed'} : ''\">\n    </mat-form-field>\n    <mat-autocomplete class=\"ft-geo-auto-complete\" #autogeo=\"matAutocomplete\" [displayWith]=\"getDisplayFn()\"\n        (optionSelected)=\"mapGeo.selectionOption($event.option.value)\">\n        <mat-option *ngFor=\"let street of streets\" [value]=\"street\">\n            {{street.street}}\n        </mat-option>\n    </mat-autocomplete>\n</div>\n\n\n<div class=\"clear-auto-complete-wrap\" *ngIf=\"mapGeo?.lookUpGoogle\">\n\n    <button type=\"button\" [id]=\"'ggRemove'+keyName\" mat-button class=\"close-icon\" (click)=\"mapGeo.removeStreet()\" [disabled]=\"disabled\">\n        <mat-icon>close</mat-icon>\n    </button>\n    <mat-form-field appearance=\"standard\">\n\n            <input matInput class=\"form-control-geo-auto-complete mat-input-element\" [id]=\"keyName+'autocomplete'\"\n                (input)=\"lookUp($event.target.value)\"\n                placeholder=\"Search\" type=\"text\" [readonly]=\"disabled\" [ngStyle]=\"disabled ? {'cursor':'not-allowed'} : ''\">\n\n    </mat-form-field>\n\n</div>\n", styles: [".clear-auto-complete-wrap{width:100%;position:relative}.clear-auto-complete-wrap>button{position:absolute;top:-40px;right:0;z-index:999;min-width:unset!important;width:32px;height:auto;padding:0}.clear-auto-complete-wrap>button .mat-icon{height:16px!important;width:16px!important;font-size:16px!important}.selectedAsset .clear-auto-complete-wrap>button{top:-25px}.ft-geo-auto-complete{margin-top:-20px}\n"] }]
        }], function () { return [{ type: i0.ChangeDetectorRef }, { type: HttpService }, { type: i1.ChangedDocumentService }, { type: i1.FormbirdInjectorService }, { type: i1$1.SclSearchClientService }]; }, { disabled: [{
                type: Input
            }], keyName: [{
                type: Input
            }], autocompleteBox: [{
                type: Input
            }], geocodeSearchService: [{
                type: Input
            }], map: [{
                type: Input
            }], EPSG: [{
                type: Input
            }], mapFunc: [{
                type: Input
            }], componentDefinition: [{
                type: Input
            }], isParentReady: [{
                type: Input
            }], contextParams: [{
                type: Input
            }], pageSize: [{
                type: Input
            }], document: [{
                type: Input
            }], template: [{
                type: Input
            }], fieldName: [{
                type: Input
            }], getStreetData: [{
                type: Output
            }], removeStreetCb: [{
                type: Output
            }], lookUpResultCb: [{
                type: Output
            }], lookUpErrorCb: [{
                type: Output
            }], init: [{
                type: Output
            }], trigger: [{
                type: ViewChild,
                args: [MatAutocompleteTrigger, { static: false }]
            }], streetGeo: [{
                type: ViewChild,
                args: ['streetGeo', { static: true }]
            }] });
})();

class SanitizeHtmlPipe {
    constructor(_sanitizer) {
        this._sanitizer = _sanitizer;
    }
    transform(v) {
        return this._sanitizer.bypassSecurityTrustHtml(v);
    }
}
/** @nocollapse */ /** @nocollapse */ SanitizeHtmlPipe.ɵfac = function SanitizeHtmlPipe_Factory(t) { return new (t || SanitizeHtmlPipe)(i0.ɵɵdirectiveInject(i1$3.DomSanitizer, 16)); };
/** @nocollapse */ /** @nocollapse */ SanitizeHtmlPipe.ɵpipe = /** @pureOrBreakMyCode */ i0.ɵɵdefinePipe({ name: "sanitizeHtml", type: SanitizeHtmlPipe, pure: true });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SanitizeHtmlPipe, [{
            type: Pipe,
            args: [{
                    name: 'sanitizeHtml'
                }]
        }], function () { return [{ type: i1$3.DomSanitizer }]; }, null);
})();

class SanitizingModule {
    static forRoot() {
        return {
            ngModule: SanitizingModule
        };
    }
}
/** @nocollapse */ /** @nocollapse */ SanitizingModule.ɵfac = function SanitizingModule_Factory(t) { return new (t || SanitizingModule)(); };
/** @nocollapse */ /** @nocollapse */ SanitizingModule.ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: SanitizingModule });
/** @nocollapse */ /** @nocollapse */ SanitizingModule.ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ providers: [], imports: [[]] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SanitizingModule, [{
            type: NgModule,
            args: [{
                    imports: [],
                    exports: [
                        SanitizeHtmlPipe
                    ],
                    declarations: [
                        SanitizeHtmlPipe
                    ],
                    providers: []
                }]
        }], null, null);
})();
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(SanitizingModule, { declarations: [SanitizeHtmlPipe], exports: [SanitizeHtmlPipe] }); })();

class GeoAutoCompleteModule {
    constructor() {
    }
}
/** @nocollapse */ /** @nocollapse */ GeoAutoCompleteModule.ɵfac = function GeoAutoCompleteModule_Factory(t) { return new (t || GeoAutoCompleteModule)(); };
/** @nocollapse */ /** @nocollapse */ GeoAutoCompleteModule.ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: GeoAutoCompleteModule });
/** @nocollapse */ /** @nocollapse */ GeoAutoCompleteModule.ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ providers: [], imports: [[
            BrowserAnimationsModule,
            FormsModule,
            ReactiveFormsModule,
            MatFormFieldModule,
            MatInputModule,
            MatAutocompleteModule,
            MatIconModule,
            MatButtonModule,
            SanitizingModule
        ]] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(GeoAutoCompleteModule, [{
            type: NgModule,
            args: [{
                    imports: [
                        BrowserAnimationsModule,
                        FormsModule,
                        ReactiveFormsModule,
                        MatFormFieldModule,
                        MatInputModule,
                        MatAutocompleteModule,
                        MatIconModule,
                        MatButtonModule,
                        SanitizingModule
                    ],
                    exports: [
                        GeoAutocompleteComponent
                    ],
                    declarations: [
                        GeoAutocompleteComponent
                    ],
                    entryComponents: [
                        GeoAutocompleteComponent
                    ],
                    providers: []
                }]
        }], function () { return []; }, null);
})();
(function () {
    (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(GeoAutoCompleteModule, { declarations: [GeoAutocompleteComponent], imports: [BrowserAnimationsModule,
            FormsModule,
            ReactiveFormsModule,
            MatFormFieldModule,
            MatInputModule,
            MatAutocompleteModule,
            MatIconModule,
            MatButtonModule,
            SanitizingModule], exports: [GeoAutocompleteComponent] });
})();

class FormbirdMappingModule {
}
/** @nocollapse */ /** @nocollapse */ FormbirdMappingModule.ɵfac = function FormbirdMappingModule_Factory(t) { return new (t || FormbirdMappingModule)(); };
/** @nocollapse */ /** @nocollapse */ FormbirdMappingModule.ɵmod = /** @pureOrBreakMyCode */ i0.ɵɵdefineNgModule({ type: FormbirdMappingModule });
/** @nocollapse */ /** @nocollapse */ FormbirdMappingModule.ɵinj = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjector({ providers: [], imports: [[BrowserModule, MatIconModule, FormbirdServicesModule, MatAutocompleteModule, GeoAutoCompleteModule]] });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(FormbirdMappingModule, [{
            type: NgModule,
            args: [{
                    declarations: [],
                    imports: [BrowserModule, MatIconModule, FormbirdServicesModule, MatAutocompleteModule, GeoAutoCompleteModule],
                    exports: [],
                    providers: [],
                }]
        }], null, null);
})();
(function () { (typeof ngJitMode === "undefined" || ngJitMode) && i0.ɵɵsetNgModuleScope(FormbirdMappingModule, { imports: [BrowserModule, MatIconModule, FormbirdServicesModule, MatAutocompleteModule, GeoAutoCompleteModule] }); })();

class SclAssetLayersService {
    constructor() { }
    getAssetPoint(customData, fieldData, typeAsset, geoJsonField, primaryAssetAddressSelection) {
        let name = '';
        if (customData.systemHeader.summaryName) {
            name = customData.systemHeader.summaryName;
        }
        else {
            name = customData.assetId;
        }
        const id = customData.documentId;
        const propertiesLinkAsset = {
            documentId: id,
            name
        };
        const asset = {
            type: 'Feature',
            properties: {
                type: typeAsset,
                linkAssets: []
            }
        };
        if (!id) {
            return '';
        }
        if (primaryAssetAddressSelection && geoJsonField && customData[geoJsonField]) {
            const pointFeature = customData[geoJsonField].features[0];
            asset.street = {};
            asset.street.geometry = {
                type: 'Point',
                coordinates: pointFeature.geometry.coordinates
            };
            asset.street.properties = pointFeature.properties;
        }
        const relatedFields = fieldData.relatedFields;
        if (relatedFields) {
            for (const field in relatedFields) {
                if (relatedFields.hasOwnProperty(field)) {
                    const fieldAsset = relatedFields[field];
                    const value = customData[fieldAsset];
                    if (value) {
                        propertiesLinkAsset[field] = value;
                    }
                }
            }
        }
        asset.properties.linkAssets.push(propertiesLinkAsset);
        return asset;
    }
    getGeometryAssetPoint(customData, fieldData, geoJsonField, primaryAssetAddressSelection) {
        let name = '';
        if (customData.systemHeader.summaryName) {
            name = customData.systemHeader.summaryName;
        }
        else {
            name = customData.assetId;
        }
        const id = customData.documentId;
        const propertiesLinkAsset = {
            documentId: id,
            name
        };
        const asset = {
            type: 'Feature',
            properties: {
                type: 'primaryAsset',
                linkAssets: []
            }
        };
        if (!id) {
            return '';
        }
        if (primaryAssetAddressSelection && geoJsonField) {
            if (customData[geoJsonField]) {
                const pointFeature = customData[geoJsonField].features[0];
                asset.street = {};
                asset.street.geometry = {
                    type: 'Point',
                    coordinates: pointFeature.geometry.coordinates
                };
                asset.street.properties = pointFeature.properties;
            }
        }
        const relatedFields = fieldData.relatedFields;
        if (relatedFields) {
            for (const field in relatedFields) {
                if (relatedFields.hasOwnProperty(field)) {
                    const fieldAsset = relatedFields[field];
                    const value = customData[fieldAsset];
                    if (value) {
                        propertiesLinkAsset[field] = value;
                    }
                }
            }
        }
        asset.properties.linkAssets.push(propertiesLinkAsset);
        return asset;
    }
    getAssetProperties(feature, relatedFields, coordinates, typeAsset, typeSelection) {
        let name = '';
        let id = '';
        if (feature.getProperties()) {
            name = feature.getProperties().name;
            id = feature.getProperties().id;
        }
        const propertiesLinkAsset = {
            documentId: id,
            name
        };
        const asset = {
            type: 'Feature',
            properties: {
                type: typeAsset,
                linkAssets: []
            }
        };
        if (!typeSelection || typeSelection === 'featureCollection') {
            asset.geometry = {
                type: 'Point',
                coordinates
            };
        }
        if (!id) {
            return '';
        }
        if (relatedFields) {
            for (const field in relatedFields) {
                if (relatedFields.hasOwnProperty(field)) {
                    const value = feature.getProperties()[field];
                    if (value) {
                        propertiesLinkAsset[field] = value;
                    }
                }
            }
        }
        asset.properties.linkAssets.push(propertiesLinkAsset);
        return asset;
    }
    getAssetPropertiesSelection(feature, relatedFields, coordinates, typeAsset, typeSelection) {
        let name = '';
        let id = '';
        if (feature.getProperties()) {
            name = feature.getProperties().name;
            id = feature.getProperties().id;
        }
        const propertiesLinkAsset = {
            documentId: id,
            name
        };
        const asset = {
            type: 'Feature',
            properties: {
                type: typeAsset,
                linkAssets: []
            }
        };
        if (!typeSelection || typeSelection === 'featureCollection') {
            asset.geometry = {
                type: 'Point',
                coordinates
            };
        }
        if (!id) {
            return '';
        }
        if (!typeSelection || typeSelection === 'featureCollection') {
            if (relatedFields) {
                for (const field in relatedFields) {
                    if (relatedFields.hasOwnProperty(field)) {
                        propertiesLinkAsset[field] = relatedFields[field];
                    }
                }
            }
        }
        asset.properties.linkAssets.push(propertiesLinkAsset);
        return asset;
    }
    createSelectionObject(title, icon, anchor) {
        const selection = {};
        selection.imageAnchor = anchor;
        selection.imageFileNo = icon;
        selection.selectionType = 'multiple';
        selection.uiLabel = title;
        selection.relatedVisible = true;
        selection.selectionOutput = 'documentCollection';
        return selection;
    }
    getRelatedFieldSelection(feature, type) {
        const relatedFields = {};
        const pro = feature.getProperties();
        let fields = [];
        if (type == 'primary') {
            fields = pro.primaryFields;
        }
        else {
            fields = pro.secondaryFields;
        }
        if (fields) {
            for (const field in fields) {
                if (fields[field]) {
                    relatedFields[field] = fields[field];
                }
            }
        }
        else {
            for (const field in pro.mainFields) {
                if (pro.mainFields[field]) {
                    relatedFields[field] = pro.mainFields[field];
                }
            }
        }
        return relatedFields;
    }
    removeUnselectedAsset(assets, unSelectedAssetIds, type) {
        for (let i = 0; i < unSelectedAssetIds.length; i++) {
            const priAsset = unSelectedAssetIds[i];
            for (let j = 0; j < assets.length; j++) {
                const id = assets[j].properties.linkAssets[0].documentId;
                if (id === priAsset) {
                    console.log('TODO sort out the missing sourceVector variable');
                    // sclUtilMap.removeItemFromMap(id + '_' + type, sourceVector);
                    // assets.splice(j, 1);
                }
            }
        }
    }
    removeUnselectedAssetItem(existAsset, assets, type) {
        if (existAsset) {
            for (let j = 0; j < assets.length; j++) {
                const item = assets[j];
                const id = item.properties.linkAssets[0].documentId + '_' + type;
                if (id === existAsset.properties.linkAssets[0].documentId) {
                    console.log('TODO sort out the missing sourceVector variable');
                    // sclUtilMap.removeItemFromMap(id, sourceVector);
                    // assets.splice(j, 1);
                    return true;
                }
            }
        }
        return false;
    }
    getPointFeature(location, image, name, id, relatedAsset, color, layerDisplayOnly, tooltip, anchor, type, layerName, url) {
        const graphPoint = new Feature(new Point(location));
        const properties = {
            icon: image,
            name,
            id
        };
        if (color) {
            properties.color = color;
        }
        if (tooltip) {
            properties.tooltip = tooltip;
        }
        if (layerDisplayOnly) {
            properties.layerDisplayOnly = layerDisplayOnly;
        }
        if (type) {
            properties.type = type;
        }
        if (anchor) {
            properties.anchor = anchor;
        }
        if (layerName) {
            properties.layerName = layerName;
        }
        if (url) {
            properties.url = url;
        }
        if (relatedAsset) {
            for (const field in relatedAsset) {
                if (relatedAsset.hasOwnProperty(field)) {
                    const value = relatedAsset[field];
                    properties[field] = value;
                }
            }
        }
        graphPoint.setProperties(properties);
        return graphPoint;
    }
    parseToLine(coor, id, toEPSG) {
        const feature = new Feature(new LineString(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    parseToMultiLine(coor, id, toEPSG) {
        const feature = new Feature(new MultiLineString(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    parseToPolygon(coor, id, toEPSG) {
        const feature = new Feature(new Polygon(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    parseToMultiPolygon(coor, id, toEPSG) {
        const feature = new Feature(new MultiPolygon(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    parseToPoint(coor, id, toEPSG) {
        const feature = new Feature(new Point(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    parseToMultiPoint(coor, id, toEPSG) {
        const feature = new Feature(new MultiPoint(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    parseAssetsFromFeatures(features, assetField, coor, typeAsset) {
        const assets = [];
        for (let i = 0; i < features.length; i++) {
            const asset = this.getAssetProperties(features[i], assetField.relatedFields, coor, typeAsset);
            if (!asset) {
                return;
            }
            assets.push(asset);
        }
        return assets;
    }
    isContainFeature(id, assets) {
        if (!assets) {
            return false;
        }
        for (let i = 0; i < assets.length; i++) {
            const ass = assets[i];
            if (ass.properties.linkAssets[0].documentId === id) {
                return true;
            }
        }
        return false;
    }
    createFeatureByType(coordinates, type, EPSG, id) {
        let feature;
        if (type === 'Point') {
            feature = this.parseToPoint(coordinates, id, EPSG);
        }
        else if (type === 'MultiPoint') {
            feature = this.parseToMultiPoint(coordinates, id, EPSG);
        }
        else if (type === 'LineString') {
            feature = this.parseToLine(coordinates, id, EPSG);
        }
        else if (type === 'MultiLineString') {
            feature = this.parseToMultiLine(coordinates, id, EPSG);
        }
        else if (type === 'Polygon') {
            feature = this.parseToPolygon(coordinates, id, EPSG);
        }
        else if (type === 'MultiPolygon') {
            feature = this.parseToMultiPolygon(coordinates, id, EPSG);
        }
        return feature;
    }
    createLineProperties(layer, name, color, id, popup, primaryMultiPopup, secondaryMultiPopup, layerDisplayOnly, relatedAsset, url) {
        const isDashedLine = (layer && layer.lineDash !== undefined && layer.lineDash instanceof Array &&
            layer.lineDash.length > 0);
        let lineWidth = 4;
        if (layer && isNumber(layer.lineWidth)) {
            lineWidth = layer.lineWidth;
        }
        let lineDash = isDashedLine ? layer.lineDash : undefined;
        if (layer && isDashedLine) {
            lineDash = layer.lineDash;
        }
        let lineCap = 'round';
        if (layer && layer.lineCap) {
            lineCap = layer.lineCap;
        }
        const properties = {};
        if (name) {
            properties.name = name;
        }
        if (color) {
            properties.color = color;
        }
        if (id) {
            properties.id = id;
        }
        if (popup) {
            properties.tooltip = popup;
        }
        if (url) {
            properties.url = url;
        }
        if (primaryMultiPopup) {
            properties.primaryMultiPopup = primaryMultiPopup;
        }
        if (secondaryMultiPopup) {
            properties.secondaryMultiPopup = secondaryMultiPopup;
        }
        if (lineWidth) {
            properties.lineWidth = lineWidth;
        }
        if (lineDash) {
            properties.lineDash = lineDash;
        }
        if (lineCap) {
            properties.lineCap = lineCap;
        }
        if (layerDisplayOnly) {
            properties.layerDisplayOnly = layerDisplayOnly;
        }
        if (layer && layer.fill) {
            properties.fillColor = layer.fill;
        }
        if (layer && isNumber(layer.fillOpacity)) {
            properties.fillOpacity = layer.fillOpacity;
        }
        if (relatedAsset) {
            for (const field in relatedAsset) {
                if (relatedAsset[field]) {
                    properties[field] = relatedAsset[field];
                }
            }
        }
        return properties;
    }
}
/** @nocollapse */ /** @nocollapse */ SclAssetLayersService.ɵfac = function SclAssetLayersService_Factory(t) { return new (t || SclAssetLayersService)(); };
/** @nocollapse */ /** @nocollapse */ SclAssetLayersService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclAssetLayersService, factory: SclAssetLayersService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclAssetLayersService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return []; }, null);
})();

class SclProjectionConstantService {
}
SclProjectionConstantService.EPSG = {
    'EPSG:28355': '+proj=utm +zone=55 +south +ellps=GRS80 +towgs84=0,0,0,0,0,0,0 +units=m +no_defs',
    'EPSG:3111': '+proj=lcc +lat_1=-36 +lat_2=-38 +lat_0=-37 +lon_0=145 +x_0=2500000 +y_0=2500000 +ellps=GRS80 ' +
        '+towgs84=0,0,0,0,0,0,0 +units=m +no_defs',
    'EPSG:3857': '+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +k=1.0 +units=m ' +
        '+nadgrids=@null +wktext  +no_defs',
    'EPSG:4326': '+proj=longlat +datum=WGS84 +no_defs',
    'EPSG:900913': '+proj=merc +a=6378137 +b=6378137 +lat_ts=0.0 +lon_0=0.0 +x_0=0.0 +y_0=0 +k=1.0 ' +
        '+units=m +nadgrids=@null +wktext  +no_defs'
};

class SclMapViewsService {
    constructor() { }
    getMultiLayers(mapViews) {
        const layers = [];
        let existShow = false;
        for (let i = 0; i < mapViews.length; i++) {
            const mapView = mapViews[i];
            if (mapView.isShow) {
                existShow = true;
                break;
            }
        }
        for (let i = 0; i < mapViews.length; i++) {
            const mapView = mapViews[i];
            let isShow = false;
            if (mapView.isShow) {
                isShow = mapView.isShow;
            }
            if (!existShow && i === 0) {
                existShow = true;
                isShow = true;
            }
            let tile = null;
            if (mapView.groupView) {
                const listLayers = [];
                for (let j = 0; j < mapView.groupView.length; j++) {
                    const view = mapView.groupView[j];
                    const member = this.getTile(view, isShow);
                    listLayers.push(member);
                }
                tile = new Group({
                    visible: isShow,
                    title: mapView.uiLabel,
                    layers: listLayers
                });
            }
            else {
                tile = this.getTile(mapView, isShow);
            }
            layers.push(tile);
        }
        return layers;
    }
    getTile(mapView, isShow) {
        let tile;
        tile = '';
        if (mapView.serverType === 'tile') {
            tile = new TileLayer({
                title: mapView.uiLabel,
                visible: isShow,
                source: new OSM({
                    url: mapView.url,
                    crossOrigin: mapView.crossOrigin,
                    wrapDateLine: false,
                    wrapX: false,
                    noWrap: true
                })
            });
        }
        else if (mapView.serverType === 'geoserver') {
            let tileGrid;
            if (mapView.extent) {
                tileGrid = new TileGrid({
                    extent: mapView.extent,
                    resolutions: mapView.resolutions,
                    tileSize: mapView.tileSize
                });
            }
            const tileWMS = new TileWMS({
                url: mapView.url,
                params: mapView.params,
                projection: mapView.EPSG,
                serverType: mapView.serverType,
                tileGrid,
                wrapDateLine: false,
                wrapX: false,
                noWrap: true
            });
            tile = new TileLayer({
                title: mapView.uiLabel,
                visible: isShow,
                source: tileWMS
            });
            if (mapView.extent) {
                tile.setExtent(mapView.extent);
            }
        }
        return tile;
    }
    createUIButton(document, action, classAction, title, text) {
        const button = document.createElement('BUTTON');
        button.setAttribute('class', classAction);
        button.setAttribute('title', title);
        button.addEventListener('click', action, false);
        if (text) {
            button.innerHTML = text;
        }
        const spanButton = document.createElement('SPAN');
        spanButton.setAttribute('role', 'tooltip');
        button.appendChild(spanButton);
        return button;
    }
    createCheckbox(document, name) {
        const checkbox = document.createElement('input');
        checkbox.setAttribute('type', 'checkbox');
        checkbox.setAttribute('id', name);
        return checkbox;
    }
    createRadio(document, title, visible, name) {
        const radio = document.createElement('input');
        radio.setAttribute('type', 'radio');
        radio.setAttribute('name', name);
        radio.setAttribute('id', title);
        if (visible) {
            radio.setAttribute('checked', 'checked');
        }
        return radio;
    }
    createLabel(document, name, innerHTML) {
        const label = document.createElement('label');
        label.setAttribute('for', name);
        if (innerHTML) {
            label.innerHTML = innerHTML;
        }
        return label;
    }
    addRadioButton(document, element, layers, compId) {
        layers.forEach(function (layer, i) {
            const title = layer.get('title');
            const radio = this.createRadio(document, compId + title, layer.getVisible(), compId);
            radio.onclick = function () {
                layers.forEach(function (layer, j) {
                    let value = layer.get('title');
                    if (!value || value === 'Vector') {
                        return;
                    }
                    const newTil = compId + title;
                    value = compId + value;
                    if (value === newTil) {
                        layer.setVisible(true);
                        if (layer instanceof Group) {
                            layer.getLayers().forEach(function (sublayer, k) {
                                sublayer.setVisible(true);
                            });
                        }
                    }
                    else {
                        layer.setVisible(false);
                    }
                });
            },
                element.appendChild(radio);
            const label = this.createLabel(document, compId + title, title);
            element.appendChild(label);
        });
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapViewsService.ɵfac = function SclMapViewsService_Factory(t) { return new (t || SclMapViewsService)(); };
/** @nocollapse */ /** @nocollapse */ SclMapViewsService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapViewsService, factory: SclMapViewsService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapViewsService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return []; }, null);
})();

const sclUtilMap = new SclUtilMapService();
const sclProjectionConstant$1 = SclProjectionConstantService;
const sclMapViews$1 = new SclMapViewsService();
const sclMapConstant$1 = SclMapConstantService;
const sclAssetLayers$1 = new SclAssetLayersService();
/** inherits has been removed in OpenLayers 6, according to
 * https://github.com/openlayers/openlayers/blob/master/changelog/upgrade-notes.md#removal-of-deprecated-methods
 * This function replaces it
 */
function olInherits(child, parent) {
    child.prototype = Object.create(parent.prototype);
    child.prototype.constructor = child;
}
class SclMappingFunctionOpenLayersService {
    constructor(cdRef) {
        this.cdRef = cdRef;
        this.proj4s = proj4;
        this.actionType = '';
        this.selectedAssets = [];
        this.openSansAdded = false;
        this.wmsState = { hasTile: false, hasEvent: false, finishLoad: false, tileCount: 0, hasTransparency: false, waitMapRender: null };
        this.type = -1; // 0 : boundary, 1 : address, 2: street-address, 3: selected-asset
        this.layerAssets = [];
        this.layerIndexFilter = -1;
        this.layerIndexUser = -1;
        this.layerIndexAddress = -1;
        this.layerIndexPrimary = -1;
        this.layerIndexSecondary = -1;
        this.layerIndexTooltips = -1;
        this.layerIndexControl = -1;
        // this.stlBoundary;//styleBoundary
        this.fitObject = { hasCall: false, service: null, maxZoom: null, initialZoomChange: null };
        this.positionObject = { hasCall: false, lat: null, lon: null, zoom: null, epsg: null };
        this.isDrawModeSingle = true; // for sc-boundary
        this.color = 'black';
        this.multiColor = 'red'; // for sc-boundary
        this.layersRedraw = false;
        this.layersRedrawCount = 0;
        this.assetOfLayers = {}; // <layerIndex, [assets]>;//for sc-selected-asset test re-draw
        this.heightNum = 1;
        // heat map
        this.lstHeatWeight = [];
        this.heatDatas = [];
        this.zoomFloor = 12; // 14254
        this.compActionType = ''; // 14310: '' = no action, 'primary', 'secondary', ....
        this.isMapReady = false;
        // call this function for draw on map
        this.controlBtns = [];
        this.fromFitData = false; // 14930
        this.heightMapInit = 0; // 15755
        this.hasClickButtonZoom = false; // 15860
        this.onMapWheelScroll = null; // 15973
        this.fitPadding = 0;
        this.countGetImgSrc = 0;
        this.minResolution = null;
        this.maxResolution = null; // 16045#c68427
        this.drawButtonsForOnlySingleMode = [];
        this.drawMenuChild = null;
        this.pointBtn = null;
        this.lineBtn = null;
        this.polygonBtn = null;
        this.circleBtn = null;
        this.squareBtn = null;
        this.boxBtn = null;
        this.menuBtn = null;
        this.menuPointBtn = null;
        this.menuLineBtn = null;
        this.menuPolygonBtn = null;
        this.menuCircleBtn = null;
        this.menuSquareBtn = null;
        this.menuBoxBtn = null;
        this.menuWrapper = null;
        this.isBottom = false;
        this.totalDrawTool = 6; // total tool for drawing (point, line, polygon, circle, square, box)
        this.drawToolButtonSize = 40;
        this.isDrawCircleAsPolygon = false;
        this.showTooltip = true;
        this.drawingTools = ['point', 'line', 'polygon', 'circle', 'square', 'box', 'currentLocation', 'delete'];
        this.allowDrawingMode = SclMapConstantService.DRAWING_MODE_ALL;
        console.log('************ OL using dynamic style');
    }
    load(cb) {
        if (cb && typeof cb === 'function') {
            cb();
        }
    }
    interactionSelect() {
        this.select = new Select();
    }
    interactionModify() {
        this.modify = new Modify({
            features: this.select.getFeatures()
        });
        this.modify.on('modifyend', (e) => {
            if (this.setDirtyFunction && typeof this.setDirtyFunction === 'function') {
                this.setDirtyFunction();
                // scope.$apply();
            }
        });
    }
    interactionSelectMultiple(isActive, cb) {
        this.selectMultiple = new Select({
            multi: true,
            condition: condition.click,
            toggleCondition: condition.primaryAction,
            style: this.styleSelectedFunc.bind(this)
        });
        this.selectMultiple.setActive(isActive);
        const self = this;
        this.selectMultiple.on('select', function (e) {
            // add feature to layer user
            const selected = e.target.getFeatures();
            for (let i = 0; i < selected.getLength(); i++) {
                const fea = selected.getArray()[i];
                if (fea === 'undefined' || fea == null) {
                    continue;
                }
                const pro = fea.getProperties();
                if (pro == null) {
                    continue;
                }
                if (!pro.layerDisplayOnly) {
                    self.addFeature(fea, self.layerIndexUser);
                }
            }
            if (cb && typeof cb === 'function') {
                cb(e);
            }
        });
    }
    checkGeoJson(geojson) {
        if (typeof geojson.features === 'undefined' || geojson.features.length == null || geojson.features.length === 0) {
            return false;
        }
        const f0 = geojson.features[0];
        if (typeof f0.type !== 'undefined' && typeof f0.geometry !== 'undefined'
            && typeof f0.geometry.type !== 'undefined') {
            return true;
        }
        return false;
    }
    clampZoomFloor() {
        // console.log('%c clampZoomFloor, currentZoom = ' + this.view.getZoom() + ', zoomFloor = ' + this.zoomFloor, 'color:blue');
        if (this.view.getZoom() > this.zoomFloor) {
            this.view.setZoom(this.zoomFloor);
        }
    }
    getTile(mapView, isShow) {
        let tile;
        this.wmsState = { hasTile: false, hasEvent: false, finishLoad: false, tileCount: 0, hasTransparency: false, waitMapRender: null };
        const self = this;
        let tileLoading = 0;
        let tileLoaded = 0;
        if (mapView.serverType === 'tile') {
            let crossOrigin = (mapView.crossOrigin ? mapView.crossOrigin : 'anomymous');
            const tileSource = new OSM({
                url: mapView.url,
                crossOrigin: crossOrigin,
                wrapDateLine: false,
                wrapX: false,
                noWrap: true
            });
            tile = new TileLayer({
                title: mapView.uiLabel,
                visible: isShow,
                source: tileSource
            });
            this.wmsState.hasTile = true;
            tileSource.on('tileloadstart', function (event) {
                // do some stuff start loading tiles...
                self.wmsState.hasEvent = true;
                // console.log("%c tileSource.tileloadstart", 'color:blue');
                tileLoading++;
            });
            tileSource.on('tileloadend', function (event) {
                // do some stuff tiles were loaded...
                // console.log("%c tileSource.tileloadend", 'color:blue');
                tileLoaded++;
                if (tileLoaded === tileLoading) {
                    // do stuff
                    // console.log("%c FINISH LOAD TILE", 'color:blue');
                    self.wmsState.tileCount = tileLoaded;
                    self.wmsState.finishLoad = true;
                    if (this.fromFitData) {
                        this.checkMapEmpty(this.canvas);
                    }
                    if (self.afterLoadSelectedAssetFn && typeof self.afterLoadSelectedAssetFn === 'function') {
                        self.afterLoadSelectedAssetFn();
                    }
                }
            });
            tileSource.on('tileloaderror', function (event) {
                // Changed Notification to logger message as errors are not helpful in most cases
                console.log('tileloaderror, There has been an error returned from the mapping service tileloader - is the map visible?');
            });
        }
        else {
            let tileGrid;
            if (mapView.extent) {
                tileGrid = new TileGrid({
                    extent: mapView.extent,
                    resolutions: mapView.resolutions,
                    tileSize: mapView.tileSize
                });
            }
            const tileWMS = new TileWMS({
                url: mapView.url,
                params: mapView.params,
                projection: mapView.EPSG,
                serverType: mapView.serverType,
                tileGrid,
                wrapDateLine: false,
                wrapX: false,
                noWrap: true,
                crossOrigin: 'anomymous'
            });
            this.wmsState.hasTile = true;
            tileWMS.on('tileloadstart', function (event) {
                // do some stuff start loading tiles...
                self.wmsState.hasEvent = true;
                // console.log("%c tileWMS.tileloadstart, tile_loading = " + tile_loading + ", tile_loaded = " + tile_loaded, 'color:blue');
                tileLoading++;
            });
            tileWMS.on('tileloadend', function (event) {
                // do some stuff tiles were loaded...
                // console.log("%c tileWMS.tileloadend", 'color:blue');
                tileLoaded++;
                if (tileLoaded === tileLoading) {
                    // do stuff
                    // console.log('%c FINISH LOAD TILE WMS, tile_loading = ' + tileLoading + ', tile_loaded = ' + tileLoaded, 'color:blue');
                    // console.log('event = ', event);
                    self.wmsState.tileCount = tileLoaded;
                    self.wmsState.finishLoad = true;
                    if (this.fromFitData) {
                        this.checkMapEmpty(this.canvas);
                    }
                    if (self.afterLoadSelectedAssetFn && typeof self.afterLoadSelectedAssetFn === 'function') {
                        self.afterLoadSelectedAssetFn();
                    }
                }
            });
            tileWMS.on('tileloaderror', function (event) {
                // Changed Notification to logger message as errors are not helpful in most cases
                console.log('There has been an error returned from the mapping service tileloader - is the map visible?');
                // console.log("%c tileWMS.tileloaderror", 'color:blue');
            });
            tile = new TileLayer({
                title: mapView.uiLabel,
                visible: isShow,
                source: tileWMS,
                crossOrigin: 'anomymous'
            });
            if (mapView.extent) {
                tile.setExtent(mapView.extent);
            }
        }
        return tile;
    }
    multiLayers(mapViews) {
        const layers = [];
        if (typeof mapViews !== 'undefined' && mapViews !== null) {
            let existShow = false;
            for (let i = 0; i < mapViews.length; i++) {
                const mapView = mapViews[i];
                if (mapView.isShow) {
                    existShow = true;
                    break;
                }
            }
            for (let i = 0; i < mapViews.length; i++) {
                const mapView = mapViews[i];
                if (typeof mapView.EPSG !== 'undefined' && mapView.EPSG !== null) {
                    proj4.defs(mapView.EPSG, sclProjectionConstant$1.EPSG[mapView.EPSG]);
                }
                let isVisible = true;
                if (mapView.visible != null) {
                    isVisible = mapView.visible;
                }
                if (isVisible === false) {
                    continue;
                } // go to next element
                let isShow = false;
                if (mapView.isShow) {
                    isShow = mapView.isShow;
                }
                if (!existShow && i === 0) {
                    existShow = true;
                    isShow = true;
                }
                let tile = null;
                if (mapView.groupView) {
                    const listLayers = [];
                    for (let j = 0; j < mapView.groupView.length; j++) {
                        const view = mapView.groupView[j];
                        const member = this.getTile(view, isShow);
                        listLayers.push(member);
                    }
                    tile = new Group({
                        visible: isShow,
                        title: mapView.uiLabel,
                        layers: listLayers
                    });
                }
                else {
                    tile = this.getTile(mapView, isShow);
                }
                layers.push(tile);
            }
        }
        return layers;
    }
    setView(lng, lat, zoom, EPSG, minResolution, maxResolution, maxZoom) {
        lat = typeof lat !== 'undefined' ? lat : 0;
        lng = typeof lng !== 'undefined' ? lng : 0;
        zoom = typeof zoom !== 'undefined' ? zoom : 2;
        EPSG = typeof EPSG !== 'undefined' ? EPSG : 'EPSG:3857';
        maxZoom = typeof maxZoom !== 'undefined' ? maxZoom : 19; // 13924-2
        this.minResolution = minResolution;
        this.maxResolution = maxResolution;
        let view;
        if (EPSG !== sclMapConstant$1.EPSG_3857) {
            const projection = sclProjectionConstant$1.EPSG;
            proj4.defs(EPSG, projection[EPSG]);
        }
        // the following gave an error that proj4 wasn't found in ol.proj. The register function
        // can be imported directly, as in
        // https://openlayers.org/en/latest/apidoc/module-ol_proj_proj4.html
        // if (proj.proj4 && proj.proj4.register) { proj.proj4.register(proj4); }
        register(proj4);
        if (minResolution && maxResolution) {
            view = new View({
                projection: EPSG,
                center: proj.transform([lng, lat], 'EPSG:4326', EPSG),
                zoom,
                // maxZoom: 12,//13885
                maxZoom,
                minResolution,
                maxResolution
            });
        }
        else {
            view = new View({
                projection: EPSG,
                center: proj.transform([lng, lat], 'EPSG:4326', EPSG),
                zoom,
                // maxZoom: 12,//13885
                maxZoom,
                minZoom: 2,
                maxResolution: 2116.67090000847,
                minResolution: 0.0116670900008467
            });
        }
        return view;
    }
    createLayerSourceNormal(zIndex, pStyle, title, source, layerDisplayOnly) {
        return new LayerVector({ title, source, zIndex, style: pStyle, isHeatMap: false, layerDisplayOnly });
    }
    createLayerCluster(zIndex, pStyle, title, source, layerDisplayOnly, distance) {
        let d = 20; // default distance
        if (distance) {
            d = distance;
        }
        const clusterSource = new Cluster({
            distance: d,
            source: source
        });
        const clusterLayer = new LayerVector({
            name: 'Cluster',
            source: clusterSource,
            // Cluster style
            style: pStyle,
            zIndex,
            isHeatMap: false,
            layerDisplayOnly,
            isCluster: true
        });
        return clusterLayer;
    }
    createEmptyLayer(zIndex, pStyle, title, isHeatMap, options) {
        let newLayer;
        let src = new SourceVector();
        let layerDisplayOnly = false;
        if (options && options.layerDisplayOnly) {
            layerDisplayOnly = options.layerDisplayOnly;
        }
        if (isHeatMap) {
            let gradient = ['#00f', '#0ff', '#0f0', '#ff0', '#f00']; // default from ol
            if (options != null && typeof options.gradient !== 'undefined') {
                gradient = options.gradient;
            }
            let opacity = 1;
            if (options != null && typeof options.opacity !== 'undefined') {
                opacity = options.opacity;
            }
            let radius = 8; // default from ol
            if (options != null && typeof options.radius !== 'undefined') {
                radius = options.radius;
            }
            let blur = 15; // default from ol
            if (options != null && typeof options.blur !== 'undefined') {
                blur = options.blur;
            }
            let shadow = 250; // default from ol
            if (options != null && typeof options.shadow !== 'undefined') {
                shadow = options.shadow;
            }
            newLayer = new Heatmap({
                source: src,
                zIndex,
                gradient,
                opacity,
                radius,
                blur,
                shadow,
                renderMode: 'image',
                title,
                isHeatMap,
                layerDisplayOnly
            }); // renderMode = image for better performance
        }
        else {
            if (options && options.type === 'cluster') {
                newLayer = this.createLayerCluster(zIndex, pStyle, title, src, layerDisplayOnly, options.clusterDistance);
            }
            else {
                newLayer = this.createLayerSourceNormal(zIndex, pStyle, title, src, layerDisplayOnly);
            }
        }
        // newLayer.set('isHeatMap', isHeatMap);
        return newLayer;
    }
    createLayerAsset(layerQuery, styleLayer, hasFilterQuery, styleFilter, hasSecondary, styleSecondary, hasPrimary, stylePrimary, hasUserItems, styleSelected, hasAddressPoint, stylePoint) {
        // 1) UI controls (zoom, map selector. etc)
        // 2) Tooltips, other popup controls
        // 3) User added items : address pins, selections, etc
        // 4) Objects returned from "primaryAssetFilter"
        // 5) Objects returned from "secondaryAssetFilter"
        // 6) Objects returned from a "filter" query at the root of the component
        // 7) Items returned from the layers[0] entry
        // 8) items returned from layers[1] entry
        // 9) Items returned from layers[n] entry, where n is the last layer in the array
        // 10) Base map images
        let layerIndex = 0;
        if (this.layerAssets == null) {
            this.layerAssets = [];
        }
        if (layerQuery) { // 9,8,7
            for (let i = 0; i < layerQuery.length; i++) {
                if (layerQuery[i].query.indexOf('_layer') < 0) {
                    continue;
                }
                layerIndex++;
                if (layerQuery[i].layer.type === 'cluster') {
                    this.layerAssets.push(this.createEmptyLayer(layerIndex, styleLayer, 'layer' + layerIndex, layerQuery[i].isHeatMap, layerQuery[i].layer));
                }
                else {
                    this.layerAssets.push(this.createEmptyLayer(layerIndex, null, 'layer' + layerIndex, layerQuery[i].isHeatMap, layerQuery[i].layer));
                }
            }
        }
        if (hasFilterQuery) { // 6
            layerIndex++;
            this.layerAssets.push(this.createEmptyLayer(layerIndex, styleLayer, 'filter', null, null));
            this.layerIndexFilter = layerIndex;
        }
        if (hasSecondary) { // 5
            layerIndex++;
            this.layerAssets.push(this.createEmptyLayer(layerIndex, styleSecondary, 'secondary', null, null));
            this.layerIndexSecondary = layerIndex;
        }
        if (hasPrimary) { // 4
            layerIndex++;
            this.layerAssets.push(this.createEmptyLayer(layerIndex, stylePrimary, 'primary', null, null));
            this.layerIndexPrimary = layerIndex;
        }
        if (hasUserItems) { // 3
            layerIndex++;
            this.layerAssets.push(this.createEmptyLayer(layerIndex, styleSelected, 'selectedItems', null, null));
            this.layerIndexUser = layerIndex;
        }
        if (hasAddressPoint) { // 3
            layerIndex++;
            this.layerAssets.push(this.createEmptyLayer(layerIndex, stylePoint, 'addressPoint', null, null));
            this.layerIndexAddress = layerIndex;
        }
        // tooltips
        this.layerIndexTooltips = layerIndex + 1;
        // controls button
        this.layerIndexControl = layerIndex + 2;
    }
    createLayers(initObj) {
        this.layerAssets = [];
        this.layerAssets.push(this.vector);
        if (this.type === SclMapConstantService.COMP_TYPE_BOUNDARY) { // sc-boundary
            // this.createLayerAsset(initObj.layerAssets, this.styleBoundary.bind(this), true, null, false,
            //   null, false, null, false, null, true, this.styleBoundary.bind(this));
            this.createLayerAsset(initObj.layerAssets, this.styleAddress.bind(this), true, null, false, null, false, null, false, null, true, this.styleAddress.bind(this));
        }
        else if (this.type === SclMapConstantService.COMP_TYPE_ADDRESS_MAP) { // sc-address-map
            // if (initObj.layerAssets) {
            //   this.createLayerAsset(initObj.layerAssets, this.styleAddress.bind(this), true, this.styleAddress.bind(this),
            //     false, null, false, null, true, this.styleSelectedFunc.bind(this), false, null);
            // } else { this.createLayerAsset([], this.styleAddress.bind(this), true, this.styleAddress.bind(this),
            //   false, null, false, null, true, this.styleSelectedFunc.bind(this), false, null); }
            if (initObj.layerAssets) {
                this.createLayerAsset(initObj.layerAssets, this.styleAddress.bind(this), true, null, false, null, false, null, true, null, false, null);
            }
            else {
                this.createLayerAsset([], null, true, null, false, null, false, null, true, null, false, null);
            }
        }
        else if (this.type === SclMapConstantService.COMP_TYPE_STREET_ADDRESS) { // sc-street-address
            this.createLayerAsset(initObj.layerAssets, this.styleAddress.bind(this), true, null, false, null, false, null, false, null, true, this.styleStAddress.bind(this));
        }
        else if (this.type === SclMapConstantService.COMP_TYPE_SELECTED_ASSET) { // sc-selected-asset
            // if (initObj.layerAssets) {
            //   this.createLayerAsset(initObj.layerAssets, this.styleAsset.bind(this), true, this.styleAsset.bind(this),
            //     true, this.styleSecondaryAssetFunc.bind(this), true, this.stylePrimaryAssetFunc.bind(this),
            //     false, null, true, this.styleAsset.bind(this));
            // } else { this.createLayerAsset([], this.styleAsset.bind(this), true, this.styleAsset.bind(this),
            //   true, this.styleSecondaryAssetFunc.bind(this), true, this.stylePrimaryAssetFunc.bind(this),
            //   false, null, true, this.styleAsset.bind(this)); }
            if (initObj.layerAssets) {
                this.createLayerAsset(initObj.layerAssets, null, true, null, true, null, true, null, false, null, true, null); // 15886: high CPU
            }
            else {
                this.createLayerAsset([], null, true, null, true, null, true, null, false, null, true, null);
            } // 15886: high CPU
        }
    }
    createHeatMap(layerIndex) {
        this.layerAssets[layerIndex].getSource().clear(); // reset
        const min = Math.min.apply(null, this.lstHeatWeight);
        const max = Math.max.apply(null, this.lstHeatWeight);
        for (let i = 0; i < this.heatDatas.length; i++) {
            let weight = (this.heatDatas[i].weight - min) / (max - min); // clamp weight 0..1
            if (isNaN(weight)) {
                if (max === min) {
                    weight = 1;
                }
                else {
                    weight = 0;
                }
            }
            if (weight > 1) {
                weight = 1;
            }
            // created for owl range of data
            const coord = proj.transform(this.heatDatas[i].location, 'EPSG:4326', this.EPSG);
            const lonLat = new Point(coord);
            const pf = new Feature({
                geometry: lonLat,
                weight // e.g. temperature
            });
            this.layerAssets[layerIndex].getSource().addFeature(pf);
        }
        this.heatDatas = []; // reset
        this.lstHeatWeight = []; // reset
    }
    drawGeoJSON(geoJson) {
        if (!geoJson || !geoJson.features) {
            return;
        }
        for (let i = geoJson.features.length - 1; i > -1; i--) {
            if (geoJson.features[i].properties
                && geoJson.features[i].geometry
                && geoJson.features[i].geometry.coordinates
                && geoJson.features[i].properties.radius) {
                let center = null;
                if (geoJson.features[i].geometry.coordinates.length == 2
                    && geoJson.features[i].geometry.type == 'Point') {
                    center = geoJson.features[i].geometry.coordinates;
                }
                else if (geoJson.features[i].geometry.coordinates.length == 1
                    && geoJson.features[i].geometry.coordinates[0].length > 3
                    && geoJson.features[i].geometry.type == 'Polygon') {
                    center = sclUtilMap.calculateCircleCenterPoint(geoJson.features[i].geometry.coordinates[0][0], geoJson.features[i].geometry.coordinates[0][2]);
                }
                if (!center) {
                    continue;
                }
                const radius = geoJson.features[i].properties.radius;
                const centerProj = proj.transform([center[0], center[1]], 'EPSG:4326', this.EPSG);
                const circle = new CircleShape(centerProj, radius);
                const circleFeature = new Feature(circle);
                this.vector.getSource().addFeature(circleFeature);
                geoJson.features.splice(i, 1);
            }
        }
        const featuresJSON = (new GeoJSON())
            .readFeatures(geoJson, { featureProjection: this.EPSG, dataProjection: 'EPSG:4326' });
        this.vector.getSource().addFeatures(featuresJSON);
        // if (EPSG) {
        //   const featuresJSON = (new GeoJSON())
        //   .readFeatures(geoJson,
        //     {featureProjection: EPSG, dataProjection: 'EPSG:4326'});
        //   this.vector.getSource().addFeatures(featuresJSON);
        // } else {
        //   this.vector.getSource().addFeatures({
        //     features: (new GeoJSON()).readFeatures(geoJson)
        //   });
        // }
    }
    init(initObj) {
        var _a;
        this.EPSG = initObj.EPSG;
        if (this.EPSG === sclMapConstant$1.EPSG_4326) {
            this.EPSG = 'EPSG:3857';
        }
        if (this.EPSG !== sclMapConstant$1.EPSG_4326) {
            const projection = sclProjectionConstant$1.EPSG;
            this.proj4s.defs(this.EPSG, projection[this.EPSG]);
        }
        this.divWrapper = initObj.divWrapper;
        this.selectedAssets = [];
        if (initObj.setDirty) {
            this.setDirtyFunction = initObj.setDirty;
        }
        this.type = initObj.style;
        let savedGeoJSON;
        if (initObj.formatGeoJSON) { // use for sc-boundary
            savedGeoJSON = initObj.formatGeoJSON;
            if (initObj.formatGeoJSON.crs) {
                this.EPSG = initObj.formatGeoJSON.crs.properties.name;
            }
        }
        if (initObj.setupMapDone) {
            this.setupMapDone = initObj.setupMapDone;
        }
        // 13835
        this.source = new SourceVector();
        if (initObj.selectionStyle) {
            this.selectionStyle = initObj.selectionStyle;
        }
        if (initObj.primaryAssetSelection) {
            this.primaryAssetSelection = initObj.primaryAssetSelection;
        }
        if (initObj.secondaryAssetSelection) {
            this.secondaryAssetSelection = initObj.secondaryAssetSelection;
        }
        if (initObj.color) {
            this.color = initObj.color;
        }
        if (initObj.multiColor) {
            this.multiColor = initObj.multiColor;
        }
        if (initObj.layersRedraw) {
            this.layersRedraw = initObj.layersRedraw;
        }
        if (initObj.heightNum) {
            this.heightNum = initObj.heightNum;
        }
        if (initObj.mapId) {
            this.mapId = initObj.mapId;
        }
        if (initObj.onTilesLoaded) {
            this.onTilesLoaded = initObj.onTilesLoaded;
        }
        if (initObj.zoomFloor) {
            this.zoomFloor = initObj.zoomFloor;
        }
        if (initObj.getLocationFn) {
            this.getLocationFn = initObj.getLocationFn;
        }
        if (initObj.setupTooltipUI) {
            this.setupTooltipUI = initObj.setupTooltipUI;
        }
        if (initObj.target) {
            this.mapDiv = initObj.target;
            this.heightMapInit = initObj.target.offsetHeight;
        }
        if (initObj.fullScreenEvent) {
            this.fullScreenEvent = initObj.fullScreenEvent;
        }
        if (initObj.clusterClick) {
            this.clusterClick = initObj.clusterClick;
        }
        if (initObj.onMapWheelScroll) {
            this.onMapWheelScroll = initObj.onMapWheelScroll;
        }
        this.defaultLat = (initObj.defaultLat ? initObj.defaultLat : -37.8);
        this.defaultLon = (initObj.defaultLon ? initObj.defaultLon : 144.9);
        this.defaultZoom = (initObj.defaultZoom ? initObj.defaultZoom : 10);
        this.isDrawCircleAsPolygon = (initObj.isDrawCircleAsPolygon ? initObj.isDrawCircleAsPolygon : false);
        if (initObj.componentDefinition) {
            if (initObj.componentDefinition.drawingMode) {
                this.isDrawModeSingle = (initObj.componentDefinition.drawingMode === 'single' ?
                    true : false);
            }
            this.allowDrawingMode = (this.isDrawModeSingle ? SclMapConstantService.DRAWING_MODE_SINGLE
                : SclMapConstantService.DRAWING_MODE_MULTI);
            if (initObj.componentDefinition.drawingTools) {
                this.drawingTools = initObj.componentDefinition.drawingTools;
                if ((this.isDrawModeSingle && this.drawingTools.indexOf('multi') > -1)
                    || (!this.isDrawModeSingle && this.drawingTools.indexOf('single') > -1)) {
                    this.allowDrawingMode = SclMapConstantService.DRAWING_MODE_ALL;
                }
            }
        }
        if (this.heightNum < 3) {
            this.isBottom = true;
        }
        else {
            this.isBottom = false;
        }
        if (this.type === SclMapConstantService.COMP_TYPE_BOUNDARY && this.heightNum < 3
            || (this.type === SclMapConstantService.COMP_TYPE_SELECTED_ASSET && this.heightNum === 1)) { // sc-boundary
            this.isBottom = true;
        }
        else {
            this.isBottom = false;
        }
        if (initObj.style === SclMapConstantService.COMP_TYPE_BOUNDARY) {
            this.vector = this.createLayerSourceNormal(0, this.styleBoundary.bind(this), 'layerTile', this.source, false);
            if (initObj.layers) {
                this.tileLayers = initObj.layers;
            }
            if (savedGeoJSON && this.checkGeoJson(savedGeoJSON)) {
                // console.log(`*** coordinates = ${JSON.stringify(savedGeoJSON)}`);
                this.drawGeoJSON(savedGeoJSON);
            }
        }
        else if (initObj.style === SclMapConstantService.COMP_TYPE_ADDRESS_MAP) {
            this.vector = this.createLayerSourceNormal(0, this.styleAddress.bind(this), 'layerTile', this.source, false);
            if (initObj.layers) {
                this.tileLayers = initObj.layers;
            }
        }
        else if (initObj.style === SclMapConstantService.COMP_TYPE_STREET_ADDRESS) {
            this.vector = this.createLayerSourceNormal(0, this.styleStAddress.bind(this), 'layerTile', this.source, false);
            if (initObj.layers) {
                this.tileLayers = initObj.layers;
            }
            if (savedGeoJSON && this.checkGeoJson(savedGeoJSON)) {
                this.drawGeoJSON(savedGeoJSON);
            }
        }
        else if (initObj.style === SclMapConstantService.COMP_TYPE_SELECTED_ASSET) {
            this.addressImageAnchor = initObj.addressImageAnchor;
            this.primaryImageAnchor = initObj.primaryImageAnchor;
            this.secondaryImageAnchor = initObj.secondaryImageAnchor;
            this.vector = this.createLayerSourceNormal(0, this.styleAsset.bind(this), 'layerTile', this.source, false);
            if (initObj.layers) {
                this.tileLayers = initObj.layers;
            }
            if (savedGeoJSON && this.checkGeoJson(savedGeoJSON)) {
                this.drawGeoJSON(savedGeoJSON);
            }
        }
        this.createLayers(initObj);
        const mZoom = (this.type === SclMapConstantService.COMP_TYPE_ADDRESS_MAP ? 12 : 19); // 13885 && 13924-2
        this.view = this.setView(this.defaultLon, this.defaultLat, this.defaultZoom, this.EPSG, initObj.minResolution, initObj.maxResolution, mZoom); //
        if (savedGeoJSON) {
            this.clampZoomFloor();
        }
        const controls = (initObj.controls) ? initObj.controls : [];
        this.map = this.initializeMap(initObj, controls, this.view, null, this.tileLayers);
        // 13835 : zoom-in/out, i, fullscreen control
        const lst = document.querySelectorAll('.ol-overlaycontainer-stopevent'); // ol v4.6.5
        if (lst != null && lst.length > 0) {
            for (let i = 0; i < lst.length; i++) {
                lst[i].style.zIndex = this.layerIndexControl;
                const childs = lst[i].children;
                if (childs == null || childs.length === 0) {
                    continue;
                }
                for (let j = 0; j < childs.length; j++) {
                    childs[j].style.zIndex = this.layerIndexControl;
                }
            }
        }
        let numInFlightTiles = 0;
        this.map.getLayers().forEach(function (layer) {
            if (layer.type && layer.type === 'TILE') {
                const source = layer.getSource();
                if (source instanceof TileImage) {
                    source.on('tileloadstart', function () { numInFlightTiles++; });
                    source.on('tileloadend', function () { numInFlightTiles--; });
                }
            }
        });
        this.map.on('postrender', (evt) => {
            if (!evt.frameState) {
                return;
            }
            let numHeldTiles = 0;
            const wanted = evt.frameState.wantedTiles;
            for (const layer in wanted) {
                if (wanted.hasOwnProperty(layer)) {
                    numHeldTiles += Object.keys(wanted[layer]).length;
                }
            }
            const ready = numInFlightTiles === 0 && numHeldTiles === 0;
            if (this.map.get('ready') !== ready) {
                this.map.set('ready', ready);
                if (this.type === SclMapConstantService.COMP_TYPE_SELECTED_ASSET && this.bounds) {
                    this.view.fit(this.bounds);
                    if (this.fitCoordCount === 1) {
                        let currentZoom = this.view.getZoom();
                        currentZoom = currentZoom - 2;
                        if (currentZoom < 0) {
                            currentZoom = 1;
                        }
                        this.view.setZoom(currentZoom);
                    }
                    this.clampZoomFloor();
                    // console.log('%c , map.ready = ' + ready + ', sc-selected-asset clamp Zoom' , 'color:blue' );
                    this.bounds = null; // reset
                }
                if (ready) {
                    if (this.canvas == null) {
                        this.canvas = document.querySelector(initObj.mapId + ' canvas');
                    }
                    this.checkMapEmpty(this.canvas);
                    this.isMapReady = true;
                }
            }
        });
        this.map.set('ready', false);
        function whenMapIsReady(callback) {
            if (this.map.get('ready')) {
                callback();
            }
            else {
                this.map.once('change:ready', whenMapIsReady.bind(null, callback));
            }
        }
        const lstCv = initObj.target.getElementsByTagName('canvas');
        if (lstCv && lstCv.length > 0) {
            const cv = lstCv[0];
            this.canvas = cv;
        }
        console.log(`**** INIT MAP, componentDefinition.visible = ${(_a = initObj === null || initObj === void 0 ? void 0 : initObj.componentDefinition) === null || _a === void 0 ? void 0 : _a.visible}`);
        if (initObj.componentDefinition && (typeof initObj.componentDefinition.visible === 'undefined' ||
            initObj.componentDefinition.visible)) {
            let mapWidth = this.map.getSize()[0];
            let mapHeight = this.map.getSize()[1];
            let wrapperWitdh = (this.divWrapper ? this.divWrapper.offsetWidth : mapWidth);
            let wrapperHeight = (this.divWrapper ? this.divWrapper.offsetHeight : mapHeight);
            let count = 0; // make sure checkCanvasId don't run forever if some exception cases happening
            const limitCheckCanvas = 10; // make sure checkCanvasId don't run forever if some exception cases happening
            const checkCanvasId = setInterval(() => {
                mapWidth = this.map.getSize()[0];
                mapHeight = this.map.getSize()[1];
                wrapperWitdh = (this.divWrapper ? this.divWrapper.offsetWidth : mapWidth);
                wrapperHeight = (this.divWrapper ? this.divWrapper.offsetHeight : mapHeight);
                console.log('this.canvas = ' + this.canvas + ', mapWidth = ' + mapWidth
                    + ', mapHeight = ' + mapHeight + ', wrapperWitdh = ' + wrapperWitdh
                    + ', wrapperHeight = ' + wrapperHeight);
                if (this.canvas) {
                    if (this.canvas.style.display === 'none' || mapWidth <= 0 || wrapperWitdh !== mapWidth || mapHeight <= 0 ||
                        wrapperHeight !== mapHeight) {
                        this.show = true;
                        this.canvas.style.display = 'block';
                        this.map.setSize(wrapperWitdh, wrapperHeight);
                        this.map.updateSize();
                        if (initObj.watchDocFn && typeof initObj.watchDocFn === 'function') {
                            const doc = initObj.watchDocFn();
                            const extent = this.vector.getSource().getExtent();
                            if (extent != null && extent.length === 4 && isFinite(extent[0])
                                && isFinite(extent[1]) && isFinite(extent[2]) && isFinite(extent[3])) {
                                this.map.getView().fit(extent, [500, 500], { maxZoom: 15 });
                                this.clampZoomFloor();
                            }
                        }
                        if (initObj.style === SclMapConstantService.COMP_TYPE_STREET_ADDRESS) {
                            this.fit(initObj.configService, null, initObj.initialZoomChange, null); // test test
                        }
                        // console.log('map update size , width = ' + mapWidth + ', height = ' + mapHeight
                        // + ', wrapperWitdh = ' + wrapperWitdh + ', wrapperHeight = ' + wrapperHeight);
                    }
                    else {
                        clearInterval(checkCanvasId);
                    }
                }
                else {
                    const lstCv1 = initObj.target.getElementsByTagName('canvas');
                    if (lstCv1 && lstCv1.length > 0) {
                        const cv = lstCv1[0];
                        this.canvas = cv;
                    }
                }
                // if we have map control then put to map
                this.setupMapControl();
                if (this.layersRedraw === true && this.testDiv !== null) {
                    const offsetHeight = this.testDiv.offsetHeight;
                    const top = mapHeight - offsetHeight;
                    const css = { top: top + 'px', left: '10px', display: 'flex' };
                    Object.assign(this.testDiv.style, css);
                }
                count++;
                if (count > limitCheckCanvas) {
                    console.log('%c out of limit check canvas', 'color:blue');
                    console.log(`**** out of limit check canvas, componentDefinition.visible = ${initObj.componentDefinition.visible}`);
                    clearInterval(checkCanvasId);
                }
            }, 500);
            setTimeout(() => {
                if (mapWidth === wrapperWitdh &&
                    this.wmsState.hasTile &&
                    this.wmsState.hasEvent === false &&
                    this.wmsState.finishLoad === false) {
                    // Changed Notification to logger message as errors are not helpful in most cases
                    console.log('There has been an error returned from the mapping service tileloader - is the map visible?');
                }
            }, 1000);
            if (initObj.toolTipOnFeatureHover && typeof initObj.toolTipOnFeatureHover === 'function') {
                this.toolTipOnFeatureHover = initObj.toolTipOnFeatureHover;
            }
        }
        // TO DO : make sure canvas won't effect by some div parent is hidden when init map
        // scope.$watch('tplItem.visible', function(value) {
        //     if(value && self.map != null){
        //         if(typeof cv !== 'undefined' || cv != null){
        //             let checkCanvasId2 = setInterval(function(){
        //                 let mapWidth = self.map.getSize()[0], mapHeight = self.map.getSize()[1];
        //                 if(cv.style.display == 'none' || mapWidth <= 0 || mapHeight <= 0){
        //                     scope.show = true;
        //                     cv.style.display = 'block';
        //                     self.map.updateSize();
        //                     UtilService.safeApply(scope);
        //                 }
        //                 else{
        //                     clearInterval(checkCanvasId2);
        //                     if(initObj.style == 2){
        //                         self.fit(initObj.configService, null, initObj.initialZoomChange);
        //                     }
        //                 }
        //             }, 500);
        //         }
        //     }
        // }, true);
        // test test
        this.checkMapLoadDone = setInterval(() => {
            if (this.wmsState.finishLoad) {
                // console.log('%c checkMapLoadDone FINISH', 'color:blue');
                clearInterval(this.checkMapLoadDone);
                this.checkMapLoadDone = null;
                if (this.setupMapDone) {
                    this.setupMapDone();
                }
                if (this.setupTooltipUI && (typeof this.setupTooltipUI === 'function')) {
                    this.setupTooltipUI();
                    this.setupTooltipUI = null; // call one time when init map
                }
            }
        }, 500);
    }
    checkIsFullScreenSupport() {
        const body = document.body;
        return !!(body.webkitRequestFullscreen ||
            (body.mozRequestFullScreen) ||
            (body.msRequestFullscreen) ||
            (body.requestFullscreen));
    }
    setupMapControl() {
        if (this.elementCtrl != null) {
            const css = (this.isBottom ? 'ol-custom-control-bottom' : 'ol-custom-control');
            this.elementCtrl.classList.add(css); // must define this class in css of each component
            this.mapControlStyle(this.elementCtrl, this.mapDiv.offsetHeight);
        }
    }
    mapControlStyle(elem, mapHeight) {
        if (this.elementCtrl == null) {
            return {};
        }
        if (this.isBottom) {
            elem.style.bottom = '10px';
            elem.style.display = 'flex';
        }
        else {
            const offsetHeight = this.elementCtrl.offsetHeight;
            const offsetWidth = this.elementCtrl.offsetWidth;
            let elemHeight = offsetHeight;
            if (offsetHeight < offsetWidth) {
                elemHeight = offsetWidth;
            }
            const top = (mapHeight / 2) - (elemHeight / 2);
            elem.style.top = top + 'px';
            // console.log('%c ****mapControlStyle, offsetHeight = ' + offsetHeight + ', offsetWidth = ' + offsetWidth
            //  + ', elemHeight = ' + elemHeight  + ', mapHeight = ' + mapHeight + ', top = ' + top
            //   + ', elem.style.top = ' + elem.style.top, 'color:blue');
            elem.style.setProperty('display', 'grid', 'important');
        }
    }
    mapMoveEnd(moveEndFunc) {
        this.map.on('moveend', moveEndFunc);
    }
    createTextStyle(label, color, type) {
        const currentZoom = this.view.getZoom();
        const displayZoom = (!label.labelDisplayZoom ? 9 : (label.labelDisplayZoom > 17 ? 17 : label.labelDisplayZoom));
        const text = (currentZoom < displayZoom ? '' : (label.labelText ? label.labelText : ''));
        const align = (label.labelTextAlign === '' || label.labelTextAlign == null) ? undefined : label.labelTextAlign;
        const baseLine = (label.labelTextBaseline === '' || label.labelTextBaseline == null) ? undefined : label.labelTextBaseline;
        const fillColor = (label.labelColor === '' || label.labelColor == null) ? color : label.labelColor;
        const outlineColor = (label.labelOutlineColor === '' || label.labelOutlineColor == null) ? 'white' : label.labelOutlineColor;
        const outlineWidth = (label.labelOutlineWidth === '' || label.labelOutlineWidth == null
            || label.labelOutlineWidth === 0) ? 5 : label.labelOutlineWidth;
        const offsetX = (label.labelOffsetX === '' || label.labelOffsetX == null || label.labelOffsetX === 0) ? 0 : label.labelOffsetX;
        const offsetY = (label.labelOffsetY === '' || label.labelOffsetY == null || label.labelOffsetY === 0) ? 0 : label.labelOffsetY;
        let placement = (label.labelPlacement === '' || label.labelPlacement == null) ? 'point' : label.labelPlacement;
        const maxAngle = (label.labelMaxAngle === '' || label.labelMaxAngle == null) ? 90 : parseFloat(label.labelMaxAngle);
        const overflow = (typeof label.labelOverflow !== 'undefined' && label.labelOverflow !== null) ? label.labelOverflow : true;
        const rotationWithView = (label.labelRotationWithView === true);
        const rotation = (label.labelRotation === '' || label.labelRotation == null) ? 0 : label.labelRotation;
        const padding = (label.labelPadding === '' || label.labelPadding == null) ? undefined : label.labelPadding;
        const weight = (label.labelFontWeight === '' || label.labelFontWeight == null) ? 'normal' : label.labelFontWeight;
        let size = (label.labelFontSize === '' || label.labelFontSize == null || label.labelFontSize === 0) ? '12px' : label.labelFontSize;
        const fontValue = (label.labelFont === '' || label.labelFont == null) ? 'Arial' : label.labelFont;
        if (typeof size === 'string') {
            size = size.replace('px', '');
        }
        const font = weight + ' ' + size + 'px ' + fontValue;
        // rotation = rotation * 3.14 / 180;
        if (type === 'Point') {
            placement = 'point';
        }
        return new Text({
            textAlign: align,
            textBaseline: baseLine,
            font,
            text,
            fill: new Fill({ color: fillColor }),
            stroke: new Stroke({ color: outlineColor, width: outlineWidth }),
            offsetX,
            offsetY,
            placement,
            maxAngle,
            overflow,
            rotationWithView,
            rotation,
            padding
        });
    }
    updateLabelByZoom() {
        const currentZoom = this.view.getZoom();
        for (let i = 1; i < this.layerAssets.length; i++) {
            try {
                if (this.layerAssets[i].get('isCluster') || !this.layerAssets[i].getSource()) {
                    continue;
                }
                this.layerAssets[i].getSource().getFeatures().forEach((fea) => {
                    const lb = fea.get('label');
                    if (lb) {
                        const displayZoom = (!lb.labelDisplayZoom ? 9 : (lb.labelDisplayZoom > 17 ? 17 : lb.labelDisplayZoom));
                        const text = (currentZoom < displayZoom ? '' : (lb.labelText ? lb.labelText : ''));
                        const style = fea.getStyle();
                        if (style && style.length > 0) {
                            const txt = style[0].getText();
                            if (txt) {
                                txt.setText(text);
                                fea.setStyle(style);
                            }
                        }
                    }
                });
            }
            catch (err) {
                console.log(err);
            }
        }
    }
    getAnchor(icon, anchor) {
        if ((icon === sclMapConstant$1.MAP_MARKER || icon === sclMapConstant$1.MAP_PRIMARY_ASSET
            || icon === sclMapConstant$1.MAP_SECONDARY_ASSET) && anchor == null) {
            anchor = [0.5, 1.0]; // system defined Images
        }
        if (anchor == null) {
            anchor = [0.5, 0.5];
        } // no image anchor & is override image
        return anchor;
    }
    updateLabel(feature, label) {
        const currentZoom = this.view.getZoom();
        const displayZoom = (!label.labelDisplayZoom ? 9 : (label.labelDisplayZoom > 17 ? 17 : label.labelDisplayZoom));
        const text = (currentZoom < displayZoom ? '' : (label.labelText ? label.labelText : ''));
        if (this.type === SclMapConstantService.COMP_TYPE_ADDRESS_MAP) { // sc-address-map
            const style = feature.getStyle();
            if (style && style.length > 0) {
                const txt = feature.getStyle()[0].getText();
                if (txt) {
                    txt.setText(text);
                }
            }
        }
    }
    getCircleStyle(properties, label, t) {
        let strokeColor = 'blue';
        let fillColor = 'blue';
        let width = 2;
        if (properties.color) {
            strokeColor = properties.color;
        }
        if (properties.fillColor) {
            fillColor = properties.fillColor;
        }
        if (properties.lineWidth) {
            width = properties.lineWidth;
        }
        const stroke = new Stroke({
            color: strokeColor,
            width: width
        });
        if (properties && properties.fillColor && properties.fillOpacity) {
            let color = olColor.asArray(properties.fillColor);
            color = color.slice();
            color[3] = properties.fillOpacity; // change the alpha of the color
            fillColor = color;
        }
        const fill = new Fill({
            color: fillColor
        });
        let image = new Circle({
            radius: properties.radius,
            fill: new Fill({
                color: fillColor // '#ffcc33'
            })
        });
        const style = new Style({
            image: image,
            fill: fill,
            stroke: stroke
        });
        // return style;
        const styles = [style];
        // label style
        if (label != null) {
            style.setText(this.createTextStyle(label, strokeColor, t));
        }
        return styles;
    }
    getPointStyle(color, icon, imageAnchor, geom, label, t, rotation) {
        let pointColor = 'green';
        if (color) {
            pointColor = color;
        }
        let image = null;
        if (icon) {
            let anchor = imageAnchor;
            anchor = this.getAnchor(icon, anchor);
            const angle = (rotation ? (rotation * (Math.PI / 180)) : 0);
            image = new Icon(({
                src: icon,
                anchor,
                rotation: angle
            }));
        }
        else {
            image = new Circle({
                radius: 7,
                fill: new Fill({
                    color: pointColor // '#ffcc33'
                })
            });
        }
        const style = new Style({
            fill: new Fill({
                color: 'rgba(255, 255, 255, 0.2)'
            }),
            stroke: new Stroke({
                color: pointColor,
                width: 2
            }),
            image
        });
        // return style;
        const styles = [style];
        // label style
        if (label != null) {
            style.setText(this.createTextStyle(label, color, t));
        }
        return styles;
    }
    getPointStyleScale(feature, p, style) {
        let scaleX = 1;
        let scaleY = 1;
        if (p.scale) {
            if (Array.isArray(p.scale) && p.scale.length == 2) {
                // console.log('getPointStyleScale, scale is array, p.scale = ', p.scale);
                scaleX = p.scale[0];
                scaleY = p.scale[1];
            }
            else if (isNumber(p.scale)) {
                // console.log('getPointStyleScale, scale is number, p.scale = ' + p.scale);
                scaleX = p.scale;
                scaleY = p.scale;
            }
        }
        // load image event
        const img = new Image();
        img.src = p.icon;
        img.onload = () => {
            this.countGetImgSrc++;
            feature.set('size', [img.width, img.height]);
            let maxSize = img.width;
            if (img.width < img.height) {
                maxSize = img.height;
            }
            if (this.fitPadding < maxSize) {
                this.fitPadding = maxSize;
            }
            if (scaleX != 1 || scaleY != 1) {
                // console.log('image scale & flip');
                style.setImage(this.drawImage(img, scaleX, scaleY, style));
            }
            // console.log('image onload');
        };
    }
    getMultiPointStyle(properties) {
        let strokeColor = 'blue';
        let fillColor = 'blue';
        if (properties.color) {
            strokeColor = properties.color;
        }
        if (properties.fillColor) {
            fillColor = properties.fillColor;
        }
        let image = new Circle({
            radius: 7,
            fill: new Fill({
                color: fillColor // '#ffcc33'
            })
        });
        const styles = [];
        const style = new Style({
            image
        });
        if (properties.icon) {
            let anchor = [0.5, 1];
            if (properties.anchor) {
                anchor = properties.anchor;
            }
            anchor = this.getAnchor(properties.icon, anchor);
            image = new Icon(({
                src: properties.icon,
                anchor
            }));
        }
        const stroke = new Stroke({
            color: strokeColor,
            width: 2
        });
        style.setStroke(stroke);
        if (properties && properties.fillColor) {
            let color = olColor.asArray(properties.fillColor);
            color = color.slice();
            if (properties.fillOpacity) {
                color[3] = properties.fillOpacity;
            } // change the alpha of the color
            fillColor = color;
        }
        const fill = new Fill({
            color: fillColor
        });
        style.setFill(fill);
        styles.push(style);
        return styles;
    }
    getLineStyle(pColor, properties, geom, t) {
        let lineColor = 'blue';
        if (pColor) {
            lineColor = pColor;
        }
        const styles = [];
        const style = new Style({
            image: new Circle({
                radius: 7,
                fill: new Fill({
                    color: '#ffcc33'
                })
            })
        });
        const stroke = new Stroke({
            color: lineColor,
            width: 2
        });
        if (properties) {
            if (properties.lineWidth) {
                stroke.setWidth(properties.lineWidth);
            }
            if (properties.lineDash) {
                stroke.setLineDash(properties.lineDash);
            }
            if (properties.lineCap) {
                stroke.setLineCap(properties.lineCap);
            }
        }
        style.setStroke(stroke);
        let fillColor = 'rgba(255, 255, 255, 0.2)';
        if (properties && properties.fillColor) {
            let color = olColor.asArray(properties.fillColor);
            color = color.slice();
            if (properties.fillOpacity) {
                color[3] = properties.fillOpacity;
            } // change the alpha of the color
            fillColor = 'rgba(' + color[0] + ', ' + color[1] + ', ' + color[2] + ', ' + color[3] + ')';
        }
        const fill = new Fill({
            color: fillColor
        });
        style.setFill(fill);
        styles.push(style);
        // label style
        if (typeof properties.label !== undefined && properties.label != null) {
            style.setText(this.createTextStyle(properties.label, pColor, t));
        }
        return styles;
    }
    lableStyle(geom, label, color, t) {
        return new Style({
            geometry: geom,
            text: this.createTextStyle(label, color, t)
        });
    }
    colorWithAlpha(color, alpha) {
        let c = olColor.asArray(color);
        c = c.slice();
        c[3] = alpha;
        return c;
    }
    // sc-boundary
    styleBoundary(feature) {
        if (feature == null) {
            return;
        } // feature is null
        const type = feature.getGeometry().getType();
        if (type && type.indexOf('Multi') > -1) {
            return new Style({
                fill: new Fill({
                    color: this.colorWithAlpha(this.multiColor, 0.3), // 'rgba(255, 255, 255, 0.2)',
                }),
                stroke: new Stroke({
                    color: this.multiColor,
                    width: 2
                }),
                image: new Circle({
                    radius: 7,
                    fill: new Fill({
                        color: this.multiColor
                    })
                })
            });
        }
        else {
            const p = feature.getProperties();
            if (p && p.icon) {
                let anchor = [0.5, 1]; // system defined image
                if (p.icon === sclMapConstant$1.MAP_PRIMARY_ASSET || p.icon === sclMapConstant$1.MAP_SECONDARY_ASSET
                    || p.icon === sclMapConstant$1.MAP_MARKER) {
                    anchor = [0.5, 1]; // system defined image
                }
                else {
                    anchor = [0.5, 0.5]; // no image anchor & is override image , sc-boundary has no anchor config entry
                }
                const iconStyle = new Icon(({
                    src: p.icon,
                    anchor
                }));
                return new Style({
                    image: iconStyle
                });
            }
            else {
                return new Style({
                    fill: new Fill({
                        color: this.colorWithAlpha(this.color, 0.3) // 'rgba(255, 255, 255, 0.2)'
                    }),
                    stroke: new Stroke({
                        color: this.color,
                        width: 2
                    }),
                    image: new Circle({
                        radius: 7,
                        fill: new Fill({
                            color: this.color
                        })
                    })
                });
            }
        }
    }
    // sc-address-map
    styleAddress(feature, resolution) {
        if (feature == null) {
            return;
        } // feature is null
        let p = feature.getProperties();
        if (p.features && p.features.length > 0) { // cluster style
            p = p.features[0].getProperties();
        }
        const fIndex = p.zIndex;
        const geom = feature.getGeometry();
        if (!geom) {
            return;
        }
        //
        let color = p.color;
        if (p.radius) {
            if (fIndex === this.layerIndexUser) {
                return this.getCircleSelectionStyle(p, this.selectionStyle);
            }
            else {
                return this.getCircleStyle(p, p.label, 'Point');
            }
        }
        //
        let t = geom.getType();
        if (!t) {
            return;
        }
        let style = [];
        if (t === 'Point') {
            // style = this.getPointStyle(color, p.icon, p.anchor, feature.getGeometry(), p.label, t);
            if (fIndex === this.layerIndexUser) {
                color = (this.selectionStyle && this.selectionStyle.selectionColor ? this.selectionStyle.selectionColor : p.color);
                style = this.getPointSelectionStyle(feature, color, this.selectionStyle);
            }
            else {
                style = this.getPointStyle(color, p.icon, p.anchor, feature.getGeometry(), p.label, t, p.rotation);
                if (p.icon && !p.size) {
                    // console.log('getPointStyleScale');
                    this.getPointStyleScale(feature, p, style[0]);
                }
                else {
                    // console.log('getPointStyle');
                    this.countGetImgSrc++;
                }
            }
        }
        else if (t === 'MultiPoint') {
            if (fIndex === this.layerIndexUser) {
                color = (this.selectionStyle && this.selectionStyle.selectionColor ? this.selectionStyle.selectionColor : p.color);
                style = this.getMultiPointSelectedStyle(p, this.selectionStyle);
            }
            else {
                style = this.getMultiPointStyle(p);
            }
        }
        else {
            t = 'Line';
            if (fIndex === this.layerIndexUser) {
                color = (this.selectionStyle && this.selectionStyle.selectionColor ? this.selectionStyle.selectionColor : p.color);
                style = this.getLineSelectionStyle(p, color, this.selectionStyle);
            }
            else {
                style = this.getLineStyle(color, p, feature.getGeometry(), t);
            }
        }
        return style;
    }
    drawImage(img, scaleX, scaleY, oldStyle) {
        // console.log(`******** draw image *******`);
        const x = Math.round(img.width * scaleX);
        const y = Math.round(img.height * scaleY);
        const canvas = document.createElement('canvas');
        canvas.width = Math.abs(x);
        canvas.height = Math.abs(y);
        var ctx = canvas.getContext('2d');
        ctx.translate(Math.abs(Math.min(0, x)), Math.abs(Math.min(0, y)));
        ctx.scale(x < 0 ? -1 : 1, y < 0 ? -1 : 1);
        ctx.drawImage(img, 0, 0, Math.abs(x), Math.abs(y));
        const dataUrl = canvas.toDataURL();
        canvas.remove();
        const anchor = oldStyle.getImage().anchor_;
        const angle = oldStyle.getImage().getRotation();
        const iconOptions = {
            src: dataUrl,
            anchor,
            rotation: angle
        };
        return new Icon(iconOptions);
    }
    // sc-street-address
    styleStAddress(feature, resolution) {
        if (feature == null) {
            return;
        } // feature is null
        const styles = {
            Point: [new Style({
                    image: sclMapConstant$1.MAP_MARKER,
                    anchor: [0.5, 1] // system defined image
                })],
            LineString: [new Style({
                    stroke: new Stroke({
                        color: 'blue',
                        width: 2
                    })
                })]
        };
        if (feature.getProperties() && feature.getGeometry().getType() === 'Point') {
            const type = feature.getProperties().typeFeature;
            if (type && type === 'tree') {
                console.log('TODO - determine what image should be displayed for the tree type');
                return new Style({
                //     image
                });
            }
            if (feature.getProperties().icon) {
                const style = new Style({
                    image: new Icon(({
                        src: feature.getProperties().icon,
                        anchor: [0.5, 1] // system defined image
                    }))
                });
                return style;
            }
        }
        return styles[feature.getGeometry().getType()];
    }
    // sc-selected-asset
    styleAsset(feature, resolution) {
        if (feature == null) {
            return;
        } // feature is null
        let p = feature.getProperties();
        if (p.features && p.features.length > 0) { // cluster style
            p = p.features[0].getProperties();
        }
        const color = p.color;
        const geom = feature.getGeometry();
        if (!geom) {
            return;
        }
        if (p.radius) {
            return this.getCircleStyle(p, p.label, 'Point');
        }
        let t = geom.getType();
        if (!t) {
            return;
        }
        if (t === 'Point') {
            let anchor = p.anchor;
            const assetType = feature.get('assetType');
            const id = p.id;
            const zIndex = '';
            if (id === 'address') {
                // zIndex = 1000;
                anchor = this.addressImageAnchor;
            }
            if (assetType === sclMapConstant$1.ASSET_PRIMARY_TYPE) {
                // zIndex = 1000;
                if (p.primary) {
                    anchor = p.primary.anchor;
                }
                else {
                    anchor = this.primaryImageAnchor;
                }
            }
            if (assetType === sclMapConstant$1.ASSET_SECONDARY_TYPE) {
                // zIndex = 1000;
                if (p.secondary) {
                    anchor = p.secondary.anchor;
                }
                else {
                    anchor = this.secondaryImageAnchor;
                }
            }
            anchor = this.getAnchor(p.icon, anchor);
            const pointStyle = this.getPointStyle(color, p.icon, anchor, feature.getGeometry(), p.label, t, p.rotation);
            if (p.icon && !p.size) {
                this.getPointStyleScale(feature, p, pointStyle[0]);
            }
            feature.set('feaStyle', pointStyle);
            return pointStyle;
        }
        else if (t === 'MultiPoint') {
            return this.getMultiPointStyle(p);
        }
        else {
            t = 'Line';
            const lineStyle = this.getLineStyle(color, p, feature.getGeometry(), t);
            return lineStyle;
        }
        return null;
    }
    // use for primary selected asset
    stylePrimaryAssetFunc(feature, resolution) {
        return this.styleSelectedAssetFunc(feature, this.primaryAssetSelection, true);
    }
    // use for secondary selected asset
    styleSecondaryAssetFunc(feature, resolution) {
        return this.styleSelectedAssetFunc(feature, this.secondaryAssetSelection, false);
    }
    styleSelectedAssetFunc(feature, assetSelection, isPrimary) {
        if (feature == null) {
            return;
        }
        let style = [];
        const p = feature.getProperties();
        if (isPrimary) {
            if (p.primary) {
                assetSelection.selectionImageFileNo = p.primary.image;
                assetSelection.selectionImageAnchor = p.primary.anchor;
                assetSelection.selectionImageRotation = p.primary.rotation;
                assetSelection.selectionColor = p.primary.color;
                assetSelection.selectionFill = p.primary.fillColor;
                assetSelection.selectionFillOpacity = p.primary.fillOpacity;
                assetSelection.selectionLineCap = p.primary.lineCap;
                assetSelection.selectionLineDash = p.primary.lineDash;
                assetSelection.selectionLineWidth = p.primary.lineWidth;
            }
            else if (!assetSelection.selectionImageFileNo) {
                assetSelection.selectionImageFileNo = sclMapConstant$1.MAP_PRIMARY_ASSET;
            }
        }
        else {
            if (p.secondary) {
                assetSelection.selectionImageFileNo = p.secondary.image;
                assetSelection.selectionImageAnchor = p.secondary.anchor;
                assetSelection.selectionImageRotation = p.secondary.rotation;
                assetSelection.selectionColor = p.secondary.color;
                assetSelection.selectionFill = p.secondary.fillColor;
                assetSelection.selectionFillOpacity = p.secondary.fillOpacity;
                assetSelection.selectionLineCap = p.secondary.lineCap;
                assetSelection.selectionLineDash = p.secondary.lineDash;
                assetSelection.selectionLineWidth = p.secondary.lineWidth;
            }
            else if (!assetSelection.selectionImageFileNo) {
                assetSelection.selectionImageFileNo = sclMapConstant$1.MAP_SECONDARY_ASSET;
            }
        }
        assetSelection = sclUtilMap.checkStyleValue(assetSelection, isPrimary);
        const geom = feature.getGeometry();
        if (!geom) {
            return;
        }
        let t = geom.getType();
        if (p && p.layerDisplayOnly) {
            if (t === 'Point') {
                if (p.radius) {
                    style = this.getCircleStyle(p, p.label, t);
                }
                else {
                    style = this.getPointStyle(p.color, p.icon, p.anchor, null, null, null, p.rotation);
                }
                feature.set('feaStyle', style);
            }
            else {
                style = this.getLineStyle(p.color, p, null, null);
            }
            return style;
        }
        let color = (assetSelection && assetSelection.selectionColor ? assetSelection.selectionColor : p.color);
        if (t === 'Point') {
            if (p.radius) {
                style = this.getCircleSelectionStyle(p, assetSelection);
            }
            else {
                style = this.getPointSelectionStyle(feature, color, assetSelection);
            }
            feature.set('feaStyle', style);
        }
        else if (t === 'MultiPoint') {
            style.push(this.getMultiPointSelectedStyle(p, assetSelection));
        }
        else {
            style.push(this.getLineSelectionStyle(p, color, assetSelection));
        }
        if (typeof p.label !== undefined && p.label != null) {
            color = p.color;
            style.push(this.lableStyle(geom, p.label, color, t));
        }
        return style;
    }
    getCircleSelectionStyle(properties, selection) {
        let strokeColor = '#ffcc33';
        let fillColor = '#ffcc33';
        if (properties.color) {
            strokeColor = properties.color;
        }
        if (properties.fillColor) {
            fillColor = properties.fillColor;
        }
        else {
            fillColor = strokeColor;
        }
        if (selection) {
            if (selection.selectionColor) {
                strokeColor = selection.selectionColor;
            }
            if (selection.selectionFill) {
                let color1 = olColor.asArray(selection.selectionFill);
                color1 = color1.slice();
                if (selection.selectionFillOpacity) {
                    color1[3] = selection.selectionFillOpacity;
                }
                fillColor = color1;
            }
        }
        let image = new Circle({
            radius: properties.radius,
            fill: new Fill({
                color: fillColor
            })
        });
        const style = new Style({
            image
        });
        let icon = properties.icon;
        if (selection && selection.selectionImageFileNo) {
            icon = selection.selectionImageFileNo;
        }
        if (icon) {
            let anchor = properties.anchor;
            let rotation = 0;
            if (selection) {
                if (selection.selectionImageAnchor) {
                    anchor = selection.selectionImageAnchor;
                }
                if (selection.selectionImageRotation) {
                    rotation = selection.selectionImageRotation;
                }
            }
            else {
                if (icon === sclMapConstant$1.MAP_PRIMARY_ASSET) {
                    anchor = this.primaryImageAnchor;
                }
                else if (icon === sclMapConstant$1.MAP_SECONDARY_ASSET) {
                    anchor = this.secondaryImageAnchor;
                }
            }
            if (anchor === undefined || anchor === null) {
                if (icon === sclMapConstant$1.MAP_PRIMARY_ASSET || icon === sclMapConstant$1.MAP_SECONDARY_ASSET) {
                    anchor = [0.5, 1]; // system defined image
                }
                else {
                    if (typeof properties.assetType !== 'undefined' && properties.assetType === SclMapConstantService.ASSET_PRIMARY_TYPE) {
                        if (this.primaryImageAnchor !== undefined) {
                            anchor = this.primaryImageAnchor;
                        }
                        if (properties.primary && properties.primary.anchor) {
                            anchor = properties.primary.anchor;
                        }
                    }
                    else if (typeof properties.assetType !== 'undefined' && properties.assetType === SclMapConstantService.ASSET_SECONDARY_TYPE) {
                        if (this.secondaryImageAnchor !== undefined) {
                            anchor = this.secondaryImageAnchor;
                        }
                        if (properties.secondary && properties.secondary.anchor) {
                            anchor = properties.secondary.anchor;
                        }
                    }
                    else {
                        anchor = [0.5, 0.5];
                    } // no image anchor & is override image
                }
            }
            const angle = (rotation ? (rotation * (Math.PI / 180)) : 0);
            image = new Icon(({
                src: icon,
                anchor,
                rotation: angle
            }));
        }
        const stroke = new Stroke({
            color: strokeColor,
            width: 2
        });
        style.setStroke(stroke);
        if (properties && properties.fillColor) {
            let color = olColor.asArray(properties.fillColor);
            color = color.slice();
            if (properties.fillOpacity) {
                color[3] = properties.fillOpacity;
            } // change the alpha of the color
            fillColor = color;
        }
        if (selection & selection.selectionFill) {
            let color1 = olColor.asArray(selection.selectionFill);
            color1 = color1.slice();
            if (selection.selectionFillOpacity) {
                color1[3] = selection.selectionFillOpacity;
            }
            fillColor = color1;
        }
        const fill = new Fill({
            color: fillColor
        });
        style.setFill(fill);
        return style;
    }
    // copy from sclStyleUtil.getPointSelectionStyle
    getPointSelectionStyle(feature, color, selection) {
        const p = feature.getProperties();
        let icon = p.icon;
        let anchor = p.anchor;
        let rotation = 0;
        if (selection) {
            if (selection.selectionImageFileNo) {
                icon = selection.selectionImageFileNo; // 15783 // '/api/getFile/' + selection.selectionImageFileNo;
            }
            if (selection.selectionImageAnchor) {
                anchor = selection.selectionImageAnchor;
            }
            if (selection.selectionImageRotation) {
                rotation = selection.selectionImageRotation;
            }
        }
        if (icon === sclMapConstant$1.MAP_PRIMARY_ASSET) {
            anchor = this.primaryImageAnchor;
        }
        else if (icon === sclMapConstant$1.MAP_SECONDARY_ASSET) {
            anchor = this.secondaryImageAnchor;
        }
        else if (icon === sclMapConstant$1.MAP_MARKER) {
            anchor = [0.5, 1];
        } // system defined image
        if (anchor === undefined || anchor === null) {
            if (icon === sclMapConstant$1.MAP_PRIMARY_ASSET || icon === sclMapConstant$1.MAP_SECONDARY_ASSET
                || icon === sclMapConstant$1.MAP_MARKER) {
                anchor = [0.5, 1]; // system defined image
            }
            else {
                if (typeof p.assetType !== 'undefined' && p.assetType === SclMapConstantService.ASSET_PRIMARY_TYPE) {
                    if (this.primaryImageAnchor !== undefined) {
                        anchor = this.primaryImageAnchor;
                    }
                    if (p.primary) {
                        anchor = p.primary.anchor;
                    }
                }
                else if (typeof p.assetType !== 'undefined' && p.assetType === SclMapConstantService.ASSET_SECONDARY_TYPE) {
                    if (this.secondaryImageAnchor !== undefined) {
                        anchor = this.secondaryImageAnchor;
                    }
                    if (p.secondary) {
                        anchor = p.secondary.anchor;
                    }
                }
                else {
                    anchor = [0.5, 0.5];
                } // no image anchor & is override image
            }
        }
        const angle = (rotation ? (rotation * (Math.PI / 180)) : 0);
        let iconStyle = null;
        if (icon) {
            iconStyle = new Icon(({
                src: icon,
                anchor,
                rotation: angle
            }));
        }
        else {
            iconStyle = new Circle({
                radius: 7,
                fill: new Fill({
                    color: color // '#ffcc33'
                })
            });
        }
        if (selection) {
            if (selection.selectionImageAnchor) {
                iconStyle = new Icon(({
                    src: icon,
                    anchor,
                    rotation: angle
                }));
            }
        }
        const stylePoint = [new Style({
                image: iconStyle,
                // zIndex: 10
            })];
        return stylePoint;
    }
    // copy from sclStyleUtil.getLineSelectionStyle
    getLineSelectionStyle(properties, color, selection) {
        if (properties.type === 'MultiPoint') {
            const multiPointStyle = this.getMultiPointSelectedStyle(properties, selection);
            return multiPointStyle;
        }
        else {
            if (selection && selection.selectionColor) {
                color = selection.selectionColor;
            }
            const lineStyle = this.getLineStyle2(color, properties);
            if (selection) {
                if (selection.selectionColor) {
                    lineStyle.getStroke().setColor(selection.selectionColor);
                }
                if (selection.selectionLineDash) {
                    if (Array.isArray(selection.selectionLineDash)) {
                        lineStyle.getStroke().setLineDash(selection.selectionLineDash);
                    }
                }
                if (selection.selectionLineWidth) {
                    lineStyle.getStroke().setWidth(selection.selectionLineWidth);
                }
                if (selection.selectionLineCap) {
                    lineStyle.getStroke().setLineCap(selection.selectionLineCap);
                }
                if (selection.selectionFill) {
                    let color1 = olColor.asArray(selection.selectionFill);
                    color1 = color1.slice();
                    if (selection.selectionFillOpacity) {
                        color1[3] = selection.selectionFillOpacity;
                    }
                    lineStyle.getFill().setColor(color1);
                }
            }
            return lineStyle;
        }
    }
    getLineStyle2(color, properties) {
        let lineColor = 'blue';
        if (color) {
            lineColor = color;
        }
        const style = new Style({
            image: new Circle({
                radius: 7,
                fill: new Fill({
                    color: '#ffcc33'
                })
            })
        });
        const stroke = new Stroke({
            color: lineColor,
            width: 2
        });
        if (properties) {
            if (properties.lineWidth) {
                stroke.setWidth(properties.lineWidth);
            }
            if (properties.lineDash) {
                stroke.setLineDash(properties.lineDash);
            }
            if (properties.lineCap) {
                stroke.setLineCap(properties.lineCap);
            }
        }
        style.setStroke(stroke);
        let fillColor = 'rgba(255, 255, 255, 0.2)';
        if (properties && properties.fillColor) {
            let color1 = olColor.asArray(properties.fillColor);
            color1 = color1.slice();
            if (properties.fillOpacity) {
                color1[3] = properties.fillOpacity;
            } // change the alpha of the color
            fillColor = color1;
        }
        const fill = new Fill({
            color: fillColor
        });
        style.setFill(fill);
        return style;
    }
    getMultiPointSelectedStyle(properties, selection) {
        let strokeColor = '#ffcc33';
        let fillColor = '#ffcc33';
        if (properties.color) {
            strokeColor = properties.color;
        }
        if (properties.fillColor) {
            fillColor = properties.fillColor;
        }
        else {
            fillColor = strokeColor;
        }
        if (selection) {
            if (selection.selectionColor) {
                strokeColor = selection.selectionColor;
            }
            if (selection.selectionFill) {
                let color1 = olColor.asArray(selection.selectionFill);
                color1 = color1.slice();
                if (selection.selectionFillOpacity) {
                    color1[3] = selection.selectionFillOpacity;
                }
                fillColor = color1;
            }
        }
        let image = new Circle({
            radius: 7,
            fill: new Fill({
                color: fillColor
            })
        });
        const style = new Style({
            image
        });
        let icon = properties.icon;
        if (selection && selection.selectionImageFileNo) {
            icon = selection.selectionImageFileNo;
        }
        if (icon) {
            let anchor = properties.anchor;
            let rotation = 0;
            if (selection) {
                if (selection.selectionImageAnchor) {
                    anchor = selection.selectionImageAnchor;
                }
                if (selection.selectionImageRotation) {
                    rotation = selection.selectionImageRotation;
                }
            }
            else {
                if (icon === sclMapConstant$1.MAP_PRIMARY_ASSET) {
                    anchor = this.primaryImageAnchor;
                }
                else if (icon === sclMapConstant$1.MAP_SECONDARY_ASSET) {
                    anchor = this.secondaryImageAnchor;
                }
            }
            if (anchor === undefined || anchor === null) {
                if (icon === sclMapConstant$1.MAP_PRIMARY_ASSET || icon === sclMapConstant$1.MAP_SECONDARY_ASSET) {
                    anchor = [0.5, 1]; // system defined image
                }
                else {
                    if (typeof properties.assetType !== 'undefined' && properties.assetType === SclMapConstantService.ASSET_PRIMARY_TYPE) {
                        if (this.primaryImageAnchor !== undefined) {
                            anchor = this.primaryImageAnchor;
                        }
                        if (properties.primary && properties.primary.anchor) {
                            anchor = properties.primary.anchor;
                        }
                    }
                    else if (typeof properties.assetType !== 'undefined' && properties.assetType === SclMapConstantService.ASSET_SECONDARY_TYPE) {
                        if (this.secondaryImageAnchor !== undefined) {
                            anchor = this.secondaryImageAnchor;
                        }
                        if (properties.secondary && properties.secondary.anchor) {
                            anchor = properties.secondary.anchor;
                        }
                    }
                    else {
                        anchor = [0.5, 0.5];
                    } // no image anchor & is override image
                }
            }
            const angle = (rotation ? (rotation * (Math.PI / 180)) : 0);
            image = new Icon(({
                src: icon,
                anchor,
                rotation: angle
            }));
        }
        const stroke = new Stroke({
            color: strokeColor,
            width: 2
        });
        style.setStroke(stroke);
        if (properties && properties.fillColor) {
            let color = olColor.asArray(properties.fillColor);
            color = color.slice();
            if (properties.fillOpacity) {
                color[3] = properties.fillOpacity;
            } // change the alpha of the color
            fillColor = color;
        }
        if (selection & selection.selectionFill) {
            let color1 = olColor.asArray(selection.selectionFill);
            color1 = color1.slice();
            if (selection.selectionFillOpacity) {
                color1[3] = selection.selectionFillOpacity;
            }
            fillColor = color1;
        }
        const fill = new Fill({
            color: fillColor
        });
        style.setFill(fill);
        return style;
    }
    styleSelectedFunc(feature, resolution) {
        if (feature == null) {
            return;
        }
        let style = [];
        const p = feature.getProperties();
        const geom = feature.getGeometry();
        let t = geom.getType();
        let color = (this.selectionStyle && this.selectionStyle.selectionColor ? this.selectionStyle.selectionColor : p.color);
        if (geom && t === 'Point') {
            t = 'Point';
            style = this.getPointSelectionStyle(feature, color, this.selectionStyle);
        }
        else {
            style.push(this.getLineSelectionStyle(p, color, this.selectionStyle));
        }
        if (typeof p.label !== undefined && p.label != null) {
            color = p.color;
            style.push(this.lableStyle(geom, p.label, color, t));
        }
        return style;
    }
    addStyleControlButton(btn, zoomOptions) {
        btn.onmouseover = () => {
            if (btn.style.backgroundColor === 'grey') {
                return;
            }
            btn.style.backgroundColor = 'lightgrey';
            if (zoomOptions) {
                if (zoomOptions.isZoomIn) {
                    btn.setAttribute('title', 'Zoom in (' + this.view.getZoom() + ')');
                }
                else {
                    btn.setAttribute('title', 'Zoom out (' + this.view.getZoom() + ')');
                }
            }
        };
        btn.onmouseout = () => {
            if (btn.style.backgroundColor === 'grey') {
                return;
            }
            btn.style.backgroundColor = 'white';
        };
        btn.onclick = () => {
            this.hasClickButtonZoom = true;
        };
    }
    initializeMap(initObj, controls, view, mapLayers, multiLayers) {
        const ConfigService = initObj.configService;
        const interactions = initObj.interactions;
        const disableMouseWheel = initObj.disableMouseWheel;
        let sourceXYZ = [];
        if (multiLayers && multiLayers.length > 0) {
            sourceXYZ = multiLayers;
        }
        else {
            if (mapLayers) {
                sourceXYZ.push(mapLayers);
            }
            else {
                const tile = new TileLayer({
                    source: new OSM({
                        url: 'https://osm.formbird.com/tiles/{z}/{x}/{y}.png',
                        // crossOrigin: ConfigService.clientConfig().openLayers.tileServer.crossOrigin,
                        wrapDateLine: false,
                        wrapX: false,
                        noWrap: true
                    })
                });
                sourceXYZ.push(tile);
            }
        }
        let mouseWheel = true;
        if (disableMouseWheel) {
            mouseWheel = false;
        }
        // define full screen button icon
        const fspan = document.createElement('i');
        fspan.setAttribute('class', 'material-icons');
        fspan.innerHTML = 'fullscreen';
        fspan.style.fontSize = '30px';
        const fSpanActive = document.createElement('i');
        fSpanActive.setAttribute('class', 'material-icons');
        fSpanActive.innerHTML = 'fullscreen_exit';
        fSpanActive.style.fontSize = '30px';
        const fullscreenCtrl = new FullScreen({
            label: fspan, labelActive: fSpanActive, tipLabel: 'Fullscreen'
        });
        const fullscreenBtn = fullscreenCtrl.element.childNodes[0];
        this.addStyleControlButton(fullscreenBtn, null);
        document.addEventListener('fullscreenchange', (evt) => {
            this.fullscreenChangeHandle(fspan);
        });
        document.addEventListener("webkitfullscreenchange", (evt) => { this.fullscreenChangeHandle(fspan); }, false);
        document.addEventListener("mozfullscreenchange", (evt) => { this.fullscreenChangeHandle(fspan); }, false);
        // define zoom button
        const zoomBtn = new Zoom({
            className: 'ol-zoom my-new-class-name'
        });
        const zoomBtnIn = zoomBtn.element.childNodes[0];
        const zoomBtnOut = zoomBtn.element.childNodes[1];
        this.addStyleControlButton(zoomBtnIn, { isZoomIn: true });
        this.addStyleControlButton(zoomBtnOut, { isZoomIn: false });
        if (initObj.componentDefinition) {
            let clConfig;
            if (initObj.configService) {
                clConfig = initObj.configService.clientConfig();
            }
            if (initObj.componentDefinition.tileServerGL && clConfig && clConfig.openLayers && clConfig.openLayers.tileServerGL) {
                const mapUrl = clConfig.openLayers.tileServerGL.url;
                const layerMVT = new VectorTileLayer({
                    source: new VectorTileSource({
                        format: new MVT({ featureClass: Feature }),
                        url: mapUrl,
                        maxZoom: 14
                    })
                });
                // const layerXYZ = new TileLayer({
                //   source: new XYZ({
                //     url: 'http://admina-virtualbox:8080/styles/basic-preview/{z}/{x}/{y}.png'
                //   } )
                // } );
                const styleUrl = mapUrl.replace('data/v3/{z}/{x}/{y}.pbf', 'styles/basic-preview/style.json');
                fetch(styleUrl).then(function (response) {
                    response.json().then(function (glStyle) {
                        styleFunction(layerMVT, glStyle, 'openmaptiles');
                    });
                });
                sourceXYZ = [layerMVT];
            }
        }
        const map = new Map({
            controls: olControl.defaults({
                attribution: false,
                zoom: false,
            }).extend([
                fullscreenCtrl,
                zoomBtn
            ]),
            interactions: defaults({ mouseWheelZoom: mouseWheel }),
            layers: sourceXYZ,
            target: this.mapDiv,
            view
        });
        // console.log('%c initializeMap, zoom = ' + view.getZoom() , 'color:blue');
        if (controls != null && controls.length) {
            for (let i = 0; i < controls.length; i++) {
                controls[i].element.style.zIndex = this.layerIndexControl;
                map.addControl(controls[i]);
            }
        }
        if (interactions != null && interactions.length) {
            for (let i = 0; i < interactions.length; i++) {
                map.addInteraction(interactions[i]);
            }
        }
        if (this.layerAssets.length > 0) {
            for (let iLa = 0; iLa < this.layerAssets.length; iLa++) {
                map.addLayer(this.layerAssets[iLa]);
            }
        }
        if (mouseWheel) {
            if (this.onMapWheelScroll && typeof this.onMapWheelScroll === 'function') {
                this.mapDiv.onwheel = this.onMapWheelScroll;
            }
        }
        return map;
    }
    fullscreenChangeHandle(fspan) {
        let isFullScreen = false;
        if (fspan.innerHTML === 'fullscreen') {
            fspan.innerHTML = 'fullscreen_exit';
            isFullScreen = true;
        }
        else {
            fspan.innerHTML = 'fullscreen';
        }
        // update control position
        if (!window.screenTop && !window.screenY) {
            //  console.log('NOT FULL SCREEN');
            let heightMap = this.heightMapInit;
            if (heightMap <= 0) {
                heightMap = this.mapDiv.offsetHeight;
            }
            this.handleFullScreen(isFullScreen, heightMap);
            // console.log('mapHeight = ' + this.mapDiv.offsetHeight);
        }
        else {
            //  console.log('FULL SCREEN');
            this.handleFullScreen(isFullScreen, this.mapDiv.offsetHeight);
        }
        // console.log('%c fullscreenchange... isFullScreen = ' + isFullScreen + '\n\t, canvas.offsetHeight = ' + this.canvas.offsetHeight
        //     + '\n\t, canvas.clientHeight = ' + this.canvas.clientHeight + '\n\t, mapDiv.offsetHeight = ' + this.mapDiv.offsetHeight
        //     + '\n\t, screen.height = ' + screen.height + '\n\t, map init height = ' + this.heightMapInit, 'color:blue');
        this.updateMenuChildCss();
    }
    handleFullScreen(isFullScreen, mapHeight) {
        // const mapHeight = this.mapDiv.offsetHeight; // this.canvas.offsetHeight;
        // // if(isFullScreen) mapHeight = window.innerHeight;
        if (this.elementCtrl != null) {
            this.mapControlStyle(this.elementCtrl, mapHeight);
        }
        if (this.fullScreenEvent != null && typeof this.fullScreenEvent === 'function') {
            this.fullScreenEvent(mapHeight, isFullScreen);
        }
    }
    addInteractionSnap() {
        this.snap = [];
        for (let i = 0; i < this.layerAssets.length; i++) {
            if (this.layerAssets[i].get('isHeatMap') || this.layerAssets[i].get('layerDisplayOnly')) {
                continue;
            } // ignore heat layer
            const iSnap = new Snap({
                source: this.layerAssets[i].getSource(),
                pixelTolerance: 5
            });
            this.snap.push(iSnap);
            this.map.addInteraction(iSnap);
        }
    }
    removeInteractionSnap() {
        if (!this.snap) {
            return;
        }
        for (let i = 0; i < this.snap.length; i++) {
            this.map.removeInteraction(this.snap[i]);
        }
        this.snap = []; // reset
    }
    drawDefaultStyle(drawStart, drawEnd) {
        this.draw = new Draw({
            source: this.source,
            type: this.drawType,
            snapTolerance: 1
        });
        this.map.addInteraction(this.draw);
        if (drawStart) {
            this.draw.on('drawstart', (evt) => {
                if (typeof drawStart === 'function') {
                    drawStart(evt);
                }
            });
        }
        if (drawEnd) {
            this.draw.on('drawend', (evt) => {
                if (typeof drawEnd === 'function') {
                    drawEnd(evt);
                }
            });
        }
    }
    drawPrimaryStyle(drawStart, drawEnd) {
        if (this.drawType == null) {
            this.drawType = 'Point';
        }
        let color = '#0099FF'; // default ol blue
        if (this.compActionType === 'primary') {
            color = 'LimeGreen';
        }
        if (this.compActionType === 'secondary') {
            color = 'black';
        }
        // remove old interaction
        if (this.selectPointerMove !== null) {
            this.map.removeInteraction(this.selectPointerMove);
        }
        this.selectPointerMove = new Select({
            condition: condition.pointerMove,
            style: this.selectInteractionStyle.bind(this),
            filter: function (f) {
                if ((f.getGeometry() && f.getGeometry().getType() !== 'Point')) {
                    return true;
                }
            }
        });
        if (this.selectPointerMove !== null) {
            this.map.addInteraction(this.selectPointerMove);
        }
        //
        this.draw = new Draw({
            source: this.source,
            type: this.drawType,
            style: new Style({
                image: new Circle({
                    radius: 7,
                    fill: new Fill({
                        color
                    }),
                    stroke: new Stroke({
                        color: 'white',
                        width: 2
                    })
                })
            })
        });
        this.map.addInteraction(this.draw);
        if (drawStart) {
            this.draw.on('drawstart', (evt) => {
                if (typeof drawStart === 'function') {
                    drawStart(evt);
                }
            });
        }
        if (drawEnd) {
            this.draw.on('drawend', (evt) => {
                const fea = evt.feature;
                if (fea) {
                    const geom = fea.getGeometry();
                    // let type = geom.getType();
                    const coord = geom.getCoordinates();
                    const coor = proj.transform(coord, this.EPSG, 'EPSG:4326');
                    evt.latLng = { lat: parseFloat(coor[1]), lng: parseFloat(coor[0]) };
                }
                if (typeof drawEnd === 'function') {
                    drawEnd(evt);
                }
            });
        }
    }
    drawCustomStyle(drawStart, drawEnd) {
        let geometryFunction;
        if (this.drawType == null) {
            this.drawType = 'Point';
        }
        let color = 'blue';
        if (!this.isDrawModeSingle) { // multi mode
            color = 'green';
        }
        let drawType = this.drawType;
        if (this.drawType === 'Circle') {
            // geometryFunction = function (coordinates, geometry, projection) {
            //   if (!geometry) {
            //     geometry = new Polygon([]);
            //   }
            //   // proj.transform([lng, lat], 'EPSG:4326', EPSG),
            //   const center = proj.transform(coordinates[0], projection, 'EPSG:4326');
            //   const last = proj.transform(coordinates[1], projection, 'EPSG:4326');
            //   const radius = getDistance(center, last);
            //   const circle = circular(center, radius, 128);
            //   circle.transform('EPSG:4326', projection);
            //   geometry.setCoordinates(circle.getCoordinates());
            //   return geometry;
            // };
        }
        else if (this.drawType === 'Square') {
            drawType = 'Circle';
            geometryFunction = createRegularPolygon(4);
        }
        else if (this.drawType === 'Box') {
            drawType = 'Circle';
            geometryFunction = createBox();
        }
        this.draw = new Draw({
            source: this.source,
            type: drawType,
            geometryFunction: geometryFunction,
            style: new Style({
                image: new Circle({
                    radius: 7,
                    fill: new Fill({
                        color
                    }),
                    stroke: new Stroke({
                        color: 'white',
                        width: 2
                    })
                })
            })
        });
        this.map.addInteraction(this.draw);
        if (drawStart) {
            this.draw.on('drawstart', (evt) => {
                let color1 = 'blue';
                if (!this.isDrawModeSingle &&
                    (this.drawType === 'LineString' || this.drawType === 'Polygon' ||
                        this.drawType === 'MultiLineString' || this.drawType === 'MultiPolygon' ||
                        this.drawType === 'Circle' || this.drawType === 'Square' ||
                        this.drawType === 'Box')) {
                    color1 = 'green';
                }
                const s = new Style({
                    stroke: new Stroke({
                        color: color1,
                        width: 2
                    }),
                    image: new Circle({
                        radius: 7,
                        fill: new Fill({
                            color: color1
                        }),
                        stroke: new Stroke({
                            color: 'white',
                            width: 2
                        })
                    })
                });
                if (evt && evt.feature) {
                    evt.feature.setStyle(s);
                }
                if (typeof drawStart === 'function') {
                    drawStart(evt);
                }
            });
        }
        if (drawEnd) {
            this.draw.on('drawend', (evt) => {
                // const geom = evt.feature.getGeometry();
                // const t = geom.getType();
                let color2 = this.color;
                let fillColor = this.color;
                if (!this.isDrawModeSingle) {
                    color2 = this.multiColor;
                    fillColor = this.multiColor;
                }
                fillColor = this.colorWithAlpha(fillColor, 0.3);
                const s = new Style({
                    fill: new Fill({
                        color: fillColor
                    }),
                    stroke: new Stroke({
                        color: color2,
                        width: 2
                    }),
                    image: new Circle({
                        radius: 7,
                        fill: new Fill({
                            color: color2
                        })
                    })
                });
                if (evt && evt.feature) {
                    evt.feature.setStyle(s);
                }
                if (typeof drawEnd === 'function') {
                    drawEnd(evt);
                }
            });
        }
    }
    selectInteractionStyle(feature, resolution) {
        const type = feature.getGeometry().getType();
        let color = 'rgba(0,153,255,1.0)';
        if (this.compActionType === 'primary') {
            color = 'LimeGreen';
        }
        else if (this.compActionType === 'secondary') {
            color = 'black';
        }
        if (type === 'Point') {
            return feature.get('feaStyle');
        }
        else if (type === 'MultiPoint') {
            const image = new Circle({
                radius: 7,
                fill: new Fill({
                    color: color
                })
            });
            return new Style({
                image
            });
        }
        else {
            return new Style({
                stroke: new Stroke({
                    color: color,
                    width: 0,
                }),
                fill: new Fill({
                    color: 'rgba(255,255,255,0.5)',
                })
            });
        }
    }
    selectInteraction() {
        // remove old interaction
        if (this.selectPointerMove !== null) {
            this.map.removeInteraction(this.selectPointerMove);
        }
        this.selectPointerMove = new Select({
            condition: condition.pointerMove,
            style: this.selectInteractionStyle.bind(this),
            // filter: function(f) {
            //   if ((f.getGeometry() && f.getGeometry().getType() !== 'Point') ) {
            //     return true;
            //   }
            // }
        });
        if (this.selectPointerMove !== null) {
            this.map.addInteraction(this.selectPointerMove);
            this.selectPointerMove.on('select', this.toolTipOnFeatureHover);
        }
    }
    addInteractionDraw(drawStart, drawEnd) {
        if (this.drawType == null) {
            this.drawType = 'Point';
        }
        this.map.removeInteraction(this.selectPointerMove);
        if (this.type === SclMapConstantService.COMP_TYPE_BOUNDARY) { // sc-boundary
            this.drawCustomStyle(drawStart, drawEnd);
        }
        else if (this.type === SclMapConstantService.COMP_TYPE_SELECTED_ASSET) { // sc-selected-asset
            // this.map.removeInteraction(this.selectPointerMove);
            this.drawPrimaryStyle(drawStart, drawEnd);
        }
        else {
            this.drawDefaultStyle(drawStart, drawEnd);
        }
    }
    removeInteractionDraw() {
        this.map.removeInteraction(this.draw);
        if (this.type === SclMapConstantService.COMP_TYPE_SELECTED_ASSET) { // sc-selected-asset
            if (this.compActionType === '') {
                this.selectInteraction();
            }
        }
    }
    addInteraction() {
        this.addInteractionDraw({}, {});
        this.vector.getSource().on('addfeature', event => {
            if (this.setDirtyFunction && typeof this.setDirtyFunction === 'function') {
                this.setDirtyFunction();
                // scope.$apply();
            }
        });
    }
    btnAddEvent(btn) {
        if (!btn) {
            return;
        }
        btn.onmouseover = () => {
            if (btn.style.backgroundColor === 'grey') {
                return;
            }
            btn.style.backgroundColor = 'lightgrey';
        };
        btn.onmouseout = () => {
            if (btn.style.backgroundColor === 'grey') {
                return;
            }
            btn.style.backgroundColor = 'white';
        };
    }
    deselectAllControlBtn(currentBtnId) {
        for (let i = 0; i < this.controlBtns.length; i++) {
            if (!this.controlBtns[i] || this.controlBtns[i].id === currentBtnId) {
                continue;
            }
            this.controlBtns[i].style.backgroundColor = 'white';
        }
    }
    showMenuButton(isShow) {
        this.menuBtn.style.display = (isShow ? 'block' : 'none');
    }
    modeAction(e) {
        this.hideDrawTools();
        this.showMenu(false);
        this.showMenuButton(true);
        this.showTooltip = true;
        this.deselectAllControlBtn(e.currentTarget.id);
        this.map.removeInteraction(this.select);
        this.map.removeInteraction(this.draw);
        this.map.removeInteraction(this.modify);
        // hide circle, box, square
        const cssOnlySingleMode = (this.isDrawModeSingle ? 'block' : 'none');
        for (let i = 0; i < this.drawButtonsForOnlySingleMode.length; i++) {
            this.drawButtonsForOnlySingleMode[i].style.display = cssOnlySingleMode;
        }
        if (this.allowDrawingMode !== SclMapConstantService.DRAWING_MODE_ALL) {
            return;
        }
        if (this.isDrawModeSingle) {
            if (e && e.currentTarget && e.currentTarget.title) {
                e.currentTarget.title = 'Multi mode';
            }
            this.isDrawModeSingle = false;
            this.modeLabel.innerHTML = 'layers';
        }
        else {
            if (e && e.currentTarget && e.currentTarget.title) {
                e.currentTarget.title = 'Single mode';
            }
            this.isDrawModeSingle = true;
            this.modeLabel.innerHTML = 'layers_clear';
        }
        this.actionType = 'mode';
    }
    selectAction(e) {
        this.hideDrawTools();
        this.showMenuButton(true);
        this.deselectAllControlBtn(e.currentTarget.id);
        this.map.removeInteraction(this.draw);
        if (e.currentTarget.style.backgroundColor === 'grey') {
            e.currentTarget.style.backgroundColor = 'white';
            this.actionType = '';
            this.showTooltip = true;
            this.selectInteraction();
        }
        else {
            e.currentTarget.style.backgroundColor = 'grey';
            this.actionType = 'select';
            this.map.addInteraction(this.select);
            this.map.addInteraction(this.modify);
            this.showTooltip = false;
            this.map.removeInteraction(this.selectPointerMove);
        }
    }
    updateMenuChildCss() {
        const mapDivSize = (this.isBottom ? this.mapDiv.offsetHeight : this.mapDiv.offsetWidth);
        if (!mapDivSize) {
            return;
        }
        const availableCountDrawTool = (this.isDrawModeSingle ? this.totalDrawTool :
            this.totalDrawTool - this.drawButtonsForOnlySingleMode.length);
        const sizeMenuChilds = availableCountDrawTool * this.drawToolButtonSize;
        if (this.isBottom) {
            const heighRemain = mapDivSize - this.menuBtn.offsetHeight - 10;
            // console.log(`**** sub menu height = ${this.drawMenuChild.offsetHeight}`
            // + `, mapHeight = ${this.mapDiv.offsetHeight}, button menu height = ${this.menuBtn.offsetHeight}`);
            if (sizeMenuChilds > heighRemain) {
                this.drawMenuChild.style.height = heighRemain + 'px';
                this.drawMenuChild.style.top = -heighRemain + 'px';
                this.drawMenuChild.style.overflow = 'scroll';
                this.drawMenuChild.style['overflow-x'] = 'hidden';
                this.drawMenuChild.scrollTop = heighRemain;
            }
            else {
                this.drawMenuChild.style.removeProperty('height');
                this.drawMenuChild.style.removeProperty('overflow');
                this.drawMenuChild.style.removeProperty('overflow-x');
                this.drawMenuChild.style.top = -(sizeMenuChilds + this.drawToolButtonSize) + 'px';
            }
        }
        else {
            const widthRemain = mapDivSize - this.menuBtn.offsetWidth - 10;
            // console.log(`**** sub menu width = ${this.drawMenuChild.offsetWidth}`
            // + `, mapWidth = ${this.mapDiv.offsetWidth}, button menu width = ${this.menuBtn.offsetWidth}`);
            if (sizeMenuChilds > widthRemain) {
                // console.log(`*** width remain = ${widthRemain}`);
                this.drawMenuChild.style.width = widthRemain + 'px';
                this.drawMenuChild.style.left = this.drawToolButtonSize + 'px';
                this.drawMenuChild.style.overflow = 'scroll';
                this.drawMenuChild.style['overflow-y'] = 'hidden';
            }
            else {
                this.drawMenuChild.style.removeProperty('width');
                this.drawMenuChild.style.removeProperty('overflow');
                this.drawMenuChild.style.removeProperty('overflow-y');
                this.drawMenuChild.style.left = this.drawToolButtonSize + 'px';
            }
        }
    }
    showMenu(isShow) {
        if (!this.drawMenuChild) {
            return;
        }
        const displayBottom = (this.isBottom ? 'block' : '-webkit-box');
        const display = (isShow ? displayBottom : 'none');
        this.drawMenuChild.style.display = display;
        this.showMenuChilds(isShow);
        const cssOnlySingleMode = (this.isDrawModeSingle ? 'block' : 'none');
        // hide circle, box, square for multi mode
        for (let i = 0; i < this.drawButtonsForOnlySingleMode.length; i++) {
            this.drawButtonsForOnlySingleMode[i].style.display = cssOnlySingleMode;
        }
        this.updateMenuChildCss();
    }
    showMenuChilds(isShow) {
        const display = isShow ? 'block' : 'none';
        if (this.menuPointBtn) {
            this.menuPointBtn.style.display = display;
        }
        if (this.menuLineBtn) {
            this.menuLineBtn.style.display = display;
        }
        if (this.menuPolygonBtn) {
            this.menuPolygonBtn.style.display = display;
        }
        if (this.menuCircleBtn) {
            this.menuCircleBtn.style.display = display;
        }
        if (this.menuSquareBtn) {
            this.menuSquareBtn.style.display = display;
        }
        if (this.menuBoxBtn) {
            this.menuBoxBtn.style.display = display;
        }
    }
    menuChildAction(childIndex) {
        if ((this.allowDrawingMode == SclMapConstantService.DRAWING_MODE_SINGLE && !this.isDrawModeSingle)
            || (this.allowDrawingMode == SclMapConstantService.DRAWING_MODE_MULTI && this.isDrawModeSingle)) {
            return;
        }
        this.hideDrawTools();
        this.showMenu(false);
        this.showMenuButton(false);
        switch (childIndex) {
            case 0:
                this.pointAction({ currentTarget: this.pointBtn });
                this.pointBtn.style.display = 'block';
                break;
            case 1:
                this.lineAction({ currentTarget: this.lineBtn });
                this.lineBtn.style.display = 'block';
                break;
            case 2:
                this.polygonAction({ currentTarget: this.polygonBtn });
                this.polygonBtn.style.display = 'block';
                break;
            case 3:
                this.circleAction({ currentTarget: this.circleBtn });
                this.circleBtn.style.display = 'block';
                break;
            case 4:
                this.squareAction({ currentTarget: this.squareBtn });
                this.squareBtn.style.display = 'block';
                break;
            case 5:
                this.boxAction({ currentTarget: this.boxBtn });
                this.boxBtn.style.display = 'block';
                break;
            default: break;
        }
    }
    menuAction(e) {
        this.deselectAllControlBtn(e.currentTarget.id);
        this.map.removeInteraction(this.draw);
        if (e.currentTarget.style.backgroundColor === 'grey') {
            e.currentTarget.style.backgroundColor = 'white';
            this.actionType = '';
            this.showMenu(false);
            this.showTooltip = true;
        }
        else {
            e.currentTarget.style.backgroundColor = 'grey';
            this.actionType = 'menu';
            this.showMenu(true);
            this.showTooltip = false;
        }
    }
    hideDrawTool(element) {
        if (!element) {
            return;
        }
        element.style.display = 'none';
    }
    hideDrawTools() {
        this.hideDrawTool(this.pointBtn);
        this.hideDrawTool(this.lineBtn);
        this.hideDrawTool(this.polygonBtn);
        this.hideDrawTool(this.circleBtn);
        this.hideDrawTool(this.squareBtn);
        this.hideDrawTool(this.boxBtn);
    }
    shapeAction(e, drawTypeSingle, drawTypeMulti) {
        this.deselectAllControlBtn(e.currentTarget.id);
        this.map.removeInteraction(this.modify);
        this.map.removeInteraction(this.draw);
        this.map.removeInteraction(this.select);
        if (e.currentTarget.style.backgroundColor === 'grey') {
            e.currentTarget.style.backgroundColor = 'white';
            this.actionType = '';
            this.drawType = '';
            this.showMenu(true);
            this.hideDrawTools();
            this.showMenuButton(true);
        }
        else {
            e.currentTarget.style.backgroundColor = 'grey';
            this.actionType = 'edit';
            this.drawType = (this.isDrawModeSingle ? drawTypeSingle : drawTypeMulti);
            this.addInteraction();
            this.showMenu(false);
        }
    }
    pointAction(e) {
        this.shapeAction(e, 'Point', 'MultiPoint');
    }
    lineAction(e) {
        this.shapeAction(e, 'LineString', 'MultiLineString');
    }
    polygonAction(e) {
        this.shapeAction(e, 'Polygon', 'MultiPolygon');
    }
    circleAction(e) {
        this.shapeAction(e, 'Circle', 'Circle');
    }
    squareAction(e) {
        this.shapeAction(e, 'Square', 'Square');
    }
    boxAction(e) {
        this.shapeAction(e, 'Box', 'Box');
    }
    deleteAction(e) {
        this.hideDrawTools();
        this.showMenuButton(true);
        this.map.removeInteraction(this.modify);
        this.map.removeInteraction(this.draw);
        this.deselectAllControlBtn(e.currentTarget.id);
        if (e.currentTarget.style.backgroundColor === 'grey') {
            e.currentTarget.style.backgroundColor = 'white';
            this.actionType = '';
            this.showTooltip = true;
        }
        else {
            e.currentTarget.style.backgroundColor = 'grey';
            this.actionType = 'delete';
            this.showTooltip = false;
        }
    }
    locationAction(e) {
        this.hideDrawTools();
        this.showMenuButton(true);
        this.actionType = 'location';
        if (this.getLocationFn && typeof this.getLocationFn === 'function') {
            this.getLocationFn();
        }
        // this.getLocation();
        this.deselectAllControlBtn(e.currentTarget.id);
        if (e.currentTarget.style.backgroundColor === 'grey') {
            e.currentTarget.style.backgroundColor = 'white';
        }
        else {
            e.currentTarget.style.backgroundColor = 'grey';
        }
    }
    getLocation() {
        // NOTE : no need here, will move to component ifself
        // if(scope.disabled) return;
        // scope.isVisible = "true";
        // if (navigator.geolocation) {
        //     navigator.geolocation.getCurrentPosition(scope.showPosition);
        // } else {
        //     scope.error = "Geolocation is not supported by this browser.";
        // }
    }
    // clone from sclMapViews.addRadioButton and have modify
    addRadioButton(document, element, layers, compId) {
        layers.forEach((layer, i) => {
            const title = layer.get('title');
            const radio = sclMapViews$1.createRadio(document, compId + title, layer.getVisible(), compId);
            radio.onclick = () => {
                layers.forEach((layer1, j) => {
                    let value = layer1.get('title');
                    if (!value || value === 'Vector') {
                        return;
                    }
                    const newTil = compId + title;
                    value = compId + value;
                    if (value === newTil) {
                        layer1.setVisible(true);
                        if (layer1 instanceof Group) {
                            layer1.getLayers().forEach((sublayer, k) => {
                                sublayer.setVisible(true);
                            });
                        }
                    }
                    else {
                        layer1.setVisible(false);
                    }
                });
            };
            element.appendChild(radio);
            // label for this radio
            const label = sclMapViews$1.createLabel(document, compId + title, '');
            // sLabel is a span inside label
            const sLabel = document.createElement('span');
            sLabel.innerHTML = title;
            sLabel.style.verticalAlign = '-webkit-baseline-middle';
            sLabel.style.color = 'black';
            label.appendChild(sLabel);
            element.appendChild(label);
        });
    }
    addMapViewControl(element, mapViewLayers, compId, layerIds) {
        const elementMapView = document.createElement('div');
        elementMapView.className = 'select-action ol-control custom-control';
        elementMapView.style.top = '10px'; // map view control always on top of map
        if (typeof mapViewLayers !== 'undefined' || mapViewLayers !== null) {
            const radioElement = document.createElement('div');
            radioElement.className = 'radio-group';
            this.addRadioButton(document, radioElement, mapViewLayers, compId);
            elementMapView.appendChild(radioElement);
            mapViewLayers.forEach((layer, i) => {
                const title = compId + layer.get('title');
                layerIds.push(title);
            });
        }
        element.append(elementMapView);
    }
    createDrawButton(actionFn, btnTitle, btnSymbol, btnId) {
        const btn = sclMapViews$1.createUIButton(document, actionFn, 'ol-has-tooltip', btnTitle, null);
        const iSpan = document.createElement('i');
        iSpan.setAttribute('class', 'material-icons');
        iSpan.innerHTML = btnSymbol;
        btn.appendChild(iSpan);
        btn.id = btnId;
        return btn;
    }
    addControlDraw(compId, pOptions, cb) {
        const layerIds = [];
        const self = this;
        const ActionControl = function (ctrlOptions) {
            const options = ctrlOptions || {};
            const element = document.createElement('div');
            if (pOptions != null) {
                self.addMapViewControl(element, pOptions.mapViewLayers, compId, layerIds);
            }
            const modeBtn = sclMapViews$1.createUIButton(document, self.modeAction.bind(self), 'ol-has-tooltip', (self.isDrawModeSingle ? 'Single mode' : 'Multi mode'), null);
            self.modeLabel = document.createElement('i');
            self.modeLabel.setAttribute('class', 'material-icons');
            self.modeLabel.innerHTML = (self.isDrawModeSingle ? 'layers_clear' : 'layers');
            modeBtn.appendChild(self.modeLabel);
            modeBtn.id = compId + 'Mode';
            layerIds.push(modeBtn.id);
            self.btnAddEvent(modeBtn);
            const selectBtn = self.createDrawButton(self.selectAction.bind(self), 'Select', 'create', compId + 'Select');
            layerIds.push(selectBtn.id);
            self.menuBtn = self.createDrawButton(self.menuAction.bind(self), 'Menu', 'menu', compId + 'Menu');
            layerIds.push(self.menuBtn.id);
            if (self.drawingTools.indexOf('point') > -1) {
                self.menuPointBtn = self.createDrawButton(self.menuChildAction.bind(self, 0), 'Point', 'pin_drop', compId + 'mPoint');
                self.pointBtn = self.createDrawButton(self.pointAction.bind(self), 'Point', 'pin_drop', compId + 'Point');
                layerIds.push(self.pointBtn.id);
            }
            if (self.drawingTools.indexOf('line') > -1) {
                self.menuLineBtn = self.createDrawButton(self.menuChildAction.bind(self, 1), 'Line', 'linear_scale', compId + 'mLine');
                self.lineBtn = self.createDrawButton(self.lineAction.bind(self), 'Line', 'linear_scale', compId + 'Line');
                layerIds.push(self.lineBtn.id);
            }
            if (self.drawingTools.indexOf('polygon') > -1) {
                self.menuPolygonBtn = self.createDrawButton(self.menuChildAction.bind(self, 2), 'Polygon', 'turned_in_not', compId + 'mPolygon');
                self.polygonBtn = self.createDrawButton(self.polygonAction.bind(self), 'Polygon', 'turned_in_not', compId + 'Polygon');
                layerIds.push(self.polygonBtn.id);
            }
            if (self.drawingTools.indexOf('circle') > -1) {
                self.menuCircleBtn = self.createDrawButton(self.menuChildAction.bind(self, 3), 'Circle', 'radio_button_unchecked', compId + 'mCircle');
                self.drawButtonsForOnlySingleMode.push(self.menuCircleBtn);
                self.circleBtn = self.createDrawButton(self.circleAction.bind(self), 'Circle', 'radio_button_unchecked', compId + 'Circle');
                layerIds.push(self.circleBtn.id);
            }
            if (self.drawingTools.indexOf('square') > -1) {
                self.menuSquareBtn = self.createDrawButton(self.menuChildAction.bind(self, 4), 'Square', 'crop_rotate', compId + 'mSquare');
                self.drawButtonsForOnlySingleMode.push(self.menuSquareBtn);
                self.squareBtn = self.createDrawButton(self.squareAction.bind(self), 'Square', 'crop_rotate', compId + 'Square');
                layerIds.push(self.squareBtn.id);
            }
            if (self.drawingTools.indexOf('box') > -1) {
                self.menuBoxBtn = self.createDrawButton(self.menuChildAction.bind(self, 5), 'Box', 'check_box_outline_blank', compId + 'mBox');
                self.drawButtonsForOnlySingleMode.push(self.menuBoxBtn);
                self.boxBtn = self.createDrawButton(self.boxAction.bind(self), 'Box', 'check_box_outline_blank', compId + 'Box');
                layerIds.push(self.boxBtn.id);
            }
            let locationBtn;
            if (self.drawingTools.indexOf('currentLocation') > -1) {
                locationBtn = self.createDrawButton(self.locationAction.bind(self), 'Current Location', 'my_location', compId + 'Current Location');
                layerIds.push(locationBtn.id);
            }
            let deleteBtn;
            if (self.drawingTools.indexOf('delete') > -1) {
                deleteBtn = self.createDrawButton(self.deleteAction.bind(self), 'Delete', 'delete', compId + 'Delete');
                layerIds.push(deleteBtn.id);
            }
            self.drawMenuChild = document.createElement('div');
            self.drawMenuChild.className = (self.isBottom ? 'draw-menu-bottom' : 'draw-menu');
            if (self.isBottom) {
                if (self.menuBoxBtn) {
                    self.drawMenuChild.appendChild(self.menuBoxBtn);
                }
                if (self.menuSquareBtn) {
                    self.drawMenuChild.appendChild(self.menuSquareBtn);
                }
                if (self.menuCircleBtn) {
                    self.drawMenuChild.appendChild(self.menuCircleBtn);
                }
                if (self.menuPolygonBtn) {
                    self.drawMenuChild.appendChild(self.menuPolygonBtn);
                }
                if (self.menuLineBtn) {
                    self.drawMenuChild.appendChild(self.menuLineBtn);
                }
                if (self.menuPointBtn) {
                    self.drawMenuChild.appendChild(self.menuPointBtn);
                }
            }
            else {
                if (self.menuPointBtn) {
                    self.drawMenuChild.appendChild(self.menuPointBtn);
                }
                if (self.menuLineBtn) {
                    self.drawMenuChild.appendChild(self.menuLineBtn);
                }
                if (self.menuPolygonBtn) {
                    self.drawMenuChild.appendChild(self.menuPolygonBtn);
                }
                if (self.menuCircleBtn) {
                    self.drawMenuChild.appendChild(self.menuCircleBtn);
                }
                if (self.menuSquareBtn) {
                    self.drawMenuChild.appendChild(self.menuSquareBtn);
                }
                if (self.menuBoxBtn) {
                    self.drawMenuChild.appendChild(self.menuBoxBtn);
                }
            }
            self.menuWrapper = document.createElement('div');
            if (self.pointBtn) {
                self.menuWrapper.appendChild(self.pointBtn);
            }
            if (self.lineBtn) {
                self.menuWrapper.appendChild(self.lineBtn);
            }
            if (self.polygonBtn) {
                self.menuWrapper.appendChild(self.polygonBtn);
            }
            if (self.circleBtn) {
                self.menuWrapper.appendChild(self.circleBtn);
            }
            if (self.squareBtn) {
                self.menuWrapper.appendChild(self.squareBtn);
            }
            if (self.boxBtn) {
                self.menuWrapper.appendChild(self.boxBtn);
            }
            if (self.menuBtn) {
                self.menuWrapper.appendChild(self.menuBtn);
            }
            if (self.drawMenuChild) {
                self.menuWrapper.appendChild(self.drawMenuChild);
            }
            self.showMenu(false);
            self.hideDrawTools();
            const elementCtrl = document.createElement('div');
            elementCtrl.className = 'select-action ol-control custom-control';
            elementCtrl.appendChild(modeBtn);
            elementCtrl.appendChild(selectBtn);
            elementCtrl.appendChild(self.menuWrapper);
            if (locationBtn) {
                elementCtrl.appendChild(locationBtn);
            }
            if (deleteBtn) {
                elementCtrl.appendChild(deleteBtn);
            }
            self.elementCtrl = elementCtrl;
            self.controlBtns = [modeBtn, selectBtn, self.menuBtn, self.pointBtn, self.lineBtn, self.polygonBtn,
                self.circleBtn, self.squareBtn, self.boxBtn, locationBtn, deleteBtn, self.menuPointBtn,
                self.menuLineBtn, self.menuPolygonBtn, self.menuCircleBtn, self.menuSquareBtn, self.menuBoxBtn];
            self.btnAddEvent(selectBtn);
            self.btnAddEvent(self.menuBtn);
            self.btnAddEvent(self.pointBtn);
            self.btnAddEvent(self.lineBtn);
            self.btnAddEvent(self.polygonBtn);
            self.btnAddEvent(self.circleBtn);
            self.btnAddEvent(self.squareBtn);
            self.btnAddEvent(self.boxBtn);
            self.btnAddEvent(locationBtn);
            self.btnAddEvent(deleteBtn);
            self.btnAddEvent(self.menuPointBtn);
            self.btnAddEvent(self.menuLineBtn);
            self.btnAddEvent(self.menuPolygonBtn);
            self.btnAddEvent(self.menuCircleBtn);
            self.btnAddEvent(self.menuSquareBtn);
            self.btnAddEvent(self.menuBoxBtn);
            element.appendChild(elementCtrl);
            Control.call(this, {
                element,
                target: options.target
            });
        };
        olInherits(ActionControl, Control);
        this.map.addControl(new ActionControl({}));
        cb(layerIds);
    }
    testRedraw(e) {
        console.log('click btn, id = ' + e.currentTarget.id);
        const idx = parseInt(e.currentTarget.id, 10);
        this.clearAllFeaturesLayer(idx);
        setTimeout(() => {
            if (idx in this.assetOfLayers) {
                for (let i = 0; i < this.assetOfLayers[idx].length; i++) {
                    if (!this.layerAssets[idx].getSource()) {
                        continue;
                    }
                    this.layerAssets[idx].getSource().addFeature(this.assetOfLayers[idx][i]);
                    console.log('redraw feature of layerIdx = ' + idx);
                }
            }
        }, 1000);
    }
    addTestBtn(element) {
        const testDiv = document.createElement('div');
        testDiv.className = 'select-action ol-control custom-control';
        let idx = 1;
        for (let i = 0; i < this.layersRedrawCount; i++) {
            const testBtn = sclMapViews$1.createUIButton(document, this.testRedraw.bind(this), 'ol-has-tooltip', (idx + ''), null);
            testBtn.setAttribute('id', idx);
            const iSpan = document.createElement('i');
            iSpan.innerHTML = idx + '';
            testBtn.appendChild(iSpan);
            testDiv.appendChild(testBtn);
            idx++;
        }
        this.testDiv = testDiv;
        element.appendChild(testDiv);
    }
    addControl(ActionControl, element, options) {
        if (this.layersRedraw) {
            this.addTestBtn(element);
        }
        Control.call(ActionControl, {
            element,
            target: options.target
        });
    }
    setupControl(ActionControl) {
        olInherits(ActionControl, Control);
    }
    mapClickEvent(cb) {
        this.map.on('click', (evt) => {
            const coor = proj.transform(evt.coordinate, this.EPSG, 'EPSG:4326');
            evt.latLng = { lat: parseFloat(coor[1]), lng: parseFloat(coor[0]) };
            const featureOnClick = this.map.forEachFeatureAtPixel(evt.pixel, (feature, layer) => {
                const fs = feature.get('features');
                if (fs) {
                    return fs;
                }
                return feature;
            });
            if (featureOnClick) {
                if (Array.isArray(featureOnClick) && featureOnClick.length > 0) {
                    if (this.clusterClick && typeof this.clusterClick === 'function') {
                        this.clusterClick(featureOnClick, evt.pixel);
                    }
                }
                else {
                    if (cb && typeof cb === 'function') {
                        cb(evt);
                    }
                }
            }
            else {
                if (cb && typeof cb === 'function') {
                    cb(evt);
                }
            }
            // if (cb && typeof cb === 'function') {
            //   cb(evt);
            // }
        });
    }
    mapPointerMoveEvent(cb) {
        this.map.on('pointermove', (evt) => {
            if (cb && typeof cb === 'function') {
                cb(evt);
            }
        });
    }
    getPointFeature(location, image, name, id, relatedAsset, color, layerDisplayOnly, tooltip, anchor, type, layerName) {
        const graphPoint = new Feature(new Point(location));
        if (arguments.length === 2) {
            graphPoint.setProperties({
                icon: image
            });
        }
        else {
            const properties = {
                icon: image,
                name,
                id
            };
            if (color) {
                properties.color = color;
            }
            if (tooltip) {
                properties.tooltip = tooltip;
            }
            if (layerDisplayOnly) {
                properties.layerDisplayOnly = layerDisplayOnly;
            }
            if (type) {
                properties.type = type;
            }
            if (anchor) {
                properties.anchor = anchor;
            }
            if (layerName) {
                properties.layerName = layerName;
            }
            if (relatedAsset) {
                for (const field in relatedAsset) {
                    if (relatedAsset.hasOwnProperty(field)) {
                        const value = relatedAsset[field];
                        properties[field] = value;
                    }
                }
            }
            graphPoint.setProperties(properties);
        }
        return graphPoint;
    }
    updateLocation(lat, lon, id, image, name, proId, isMapClick) {
        // let location = proj.transform([lon, lat], 'EPSG:4326', 'EPSG:3857');
        const location = proj.transform([lon, lat], 'EPSG:4326', this.EPSG);
        if (isMapClick === false) {
            this.view.setCenter(location);
            this.view.setResolution(1);
        }
        if (proId != null && this.marker != null && this.marker.getId() === proId) {
            // let checkFeature = this.getFeatureById(proId);//13835 // this.source.getFeatureById(proId);
            // if(checkFeature){
            //    this.removeFeature(checkFeature);//13835 //this.source.removeFeature(checkFeature);
            //    this.removeFeature(this.marker);
            //    this.marker = null;
            // }
            this.marker.getGeometry().setCoordinates(location);
        }
        else {
            if (!image) {
                image = sclMapConstant$1.MAP_MARKER;
            }
            this.marker = this.getPointFeature(location, image, name, proId, null, null, null, null, null, null, null);
            this.marker.setId(proId);
            // this.source.addFeature(this.marker);//13835
            this.marker.setStyle(this.styleAsset(this.marker, null)); // 15886: set static style instead of using style from layer to prevent high CPU
            this.layerAssets[this.layerIndexAddress].getSource().addFeature(this.marker);
        }
    }
    removeLocation(feature) {
        if (feature && this.layerAssets[this.layerIndexAddress] && this.layerAssets[this.layerIndexAddress].getSource()) {
            this.layerAssets[this.layerIndexAddress].getSource().removeFeature(feature);
        }
        this.marker = null;
    }
    zoomToLocation(lat, lon) {
        const location = proj.transform([lon, lat], 'EPSG:4326', this.EPSG);
        this.view.setCenter(location);
        this.view.setResolution(1);
    }
    zoomToValue(zoomValue) {
        // if (!zoomValue && this.defaultZoom ) { zoomValue = this.defaultZoom; }// 14707
        if (zoomValue) {
            this.view.setZoom(zoomValue);
        }
    }
    // 14781
    centerDefault() {
        this.zoomToLocation(this.defaultLat, this.defaultLon);
    }
    // 14781
    fitLayers(layersIndexFit, hasDefaultCoord) {
        const extent = olExtent.createEmpty();
        if (hasDefaultCoord) {
            const location = proj.transform([this.defaultLon, this.defaultLat], 'EPSG:4326', this.EPSG);
            const fExtent = [location[0], location[1], location[0], location[1]];
            olExtent.extend(extent, fExtent);
        }
        let padding = 0; // 15141: #4
        for (let i = 0; i < layersIndexFit.length; i++) {
            const idx = layersIndexFit[i];
            if (!this.layerAssets[idx].getSource()) {
                continue;
            }
            const fs = this.layerAssets[idx].getSource().getFeatures();
            if (fs == null || fs.length === 0) {
                continue;
            }
            this.layerAssets[idx].getSource().getFeatures().forEach(function (feature) {
                const fExt = feature.getGeometry().getExtent();
                olExtent.extend(extent, fExt);
                if (feature.getGeometry().getType() === 'Point') {
                    padding = 32; // 15141: #4
                }
            }.bind(this));
        }
        if (extent !== null && extent.length === 4 && isFinite(extent[0]) && isFinite(extent[1])
            && isFinite(extent[2]) && isFinite(extent[3])) {
            this.view.fit(extent, { padding: [padding, padding, padding, padding] }); // 15141: #4
        }
    }
    createMarkerAsset(lat, lon, id, image, name, type) {
        const location = proj.transform([lon, lat], 'EPSG:4326', this.EPSG);
        const f = this.getPointFeature(location, image, name, id, null, null, null, null, null, null, null);
        if (type) {
            f.set('assetType', type);
        }
        f.setId(id);
        // this.source.addFeature(f);//13835
        if (type === sclMapConstant$1.ASSET_PRIMARY_TYPE) {
            f.setStyle(this.stylePrimaryAssetFunc(f, null));
            this.layerAssets[this.layerIndexPrimary].getSource().addFeature(f);
            this.storeSelectedAssets(f, true);
        }
        else if (type === sclMapConstant$1.ASSET_SECONDARY_TYPE) {
            f.setStyle(this.styleSecondaryAssetFunc(f, null));
            this.layerAssets[this.layerIndexSecondary].getSource().addFeature(f);
            this.storeSelectedAssets(f, false);
        }
        else {
            f.setStyle(this.styleAsset(f, null));
            this.layerAssets[this.layerIndexAddress].getSource().addFeature(f);
        }
        return location;
    }
    getGEOJSON(cb) {
        const features = this.vector.getSource().getFeatures();
        const format = new GeoJSON();
        if (this.type === SclMapConstantService.COMP_TYPE_BOUNDARY) { // sc-boundary
            const fp = 'EPSG:4326';
            const data = format.writeFeaturesObject(features, { featureProjection: this.EPSG, dataProjection: fp });
            const finalData = { type: 'FeatureCollection', features: [] };
            const multiPoint = { type: 'Feature', properties: null, geometry: { type: 'MultiPoint', coordinates: [] } };
            const multiPolygon = { type: 'Feature', properties: null, geometry: { type: 'MultiPolygon', coordinates: [] } };
            const multiLineString = { type: 'Feature', properties: null, geometry: { type: 'MultiLineString', coordinates: [] } };
            for (let i = 0; i < data.features.length; i++) {
                if (data.features[i].geometry.type === 'MultiPoint') {
                    for (let j = 0; j < data.features[i].geometry.coordinates.length; j++) {
                        multiPoint.geometry.coordinates.push(data.features[i].geometry.coordinates[j]);
                    }
                }
                else if (data.features[i].geometry.type === 'MultiPolygon') {
                    for (let j = 0; j < data.features[i].geometry.coordinates.length; j++) {
                        multiPolygon.geometry.coordinates.push(data.features[i].geometry.coordinates[j]);
                    }
                }
                else if (data.features[i].geometry.type === 'MultiLineString') {
                    for (let j = 0; j < data.features[i].geometry.coordinates.length; j++) {
                        multiLineString.geometry.coordinates.push(data.features[i].geometry.coordinates[j]);
                    }
                }
                else if (data.features[i].geometry.type === 'GeometryCollection') {
                    // console.log(`***** getGEOJSON, circle here`);
                    const geom = features[i].getGeometry();
                    const radius = geom.getRadius();
                    let center = geom.getCenter();
                    center = proj.transform(center, this.EPSG, 'EPSG:4326');
                    const shapeJson = {
                        type: 'Feature',
                        geometry: {},
                        properties: {
                            radius,
                            subType: 'Circle',
                        }
                    };
                    if (this.isDrawCircleAsPolygon) {
                        const coords = sclUtilMap.circleToPolygon(center, radius);
                        shapeJson.geometry.type = 'Polygon';
                        shapeJson.geometry.coordinates = coords;
                    }
                    else {
                        shapeJson.geometry.type = 'Point';
                        shapeJson.geometry.coordinates = center;
                    }
                    finalData.features.push(shapeJson);
                    // console.log(`*** shapeJson = `, shapeJson );
                    // console.log(JSON.stringify(shapeJson) );
                }
                else {
                    finalData.features.push(data.features[i]);
                }
            }
            if (multiPoint.geometry.coordinates.length > 0) {
                finalData.features.push(multiPoint);
            }
            if (multiPolygon.geometry.coordinates.length > 0) {
                finalData.features.push(multiPolygon);
            }
            if (multiLineString.geometry.coordinates.length > 0) {
                finalData.features.push(multiLineString);
            }
            if (cb && typeof cb === 'function') {
                cb(finalData);
            }
        }
        else {
            const data = format.writeFeaturesObject(features);
            if (cb && typeof cb === 'function') {
                cb(data);
            }
        }
    }
    transformEPSG(long, lat, from, to) {
        const location = proj.transform([parseFloat(long), parseFloat(lat)], from, to);
        return location;
    }
    checkMapEmpty(pCanvas) {
        if (pCanvas == null) {
            return;
        }
        try {
            const ctx = pCanvas.getContext('2d');
            const imageData = ctx.getImageData(0, 0, pCanvas.width, pCanvas.height);
            const data = imageData.data;
            const imageDataLength = data.length;
            let totalAlpha = 0;
            let countTransparent = 0;
            for (let i = 3; i < imageDataLength; i += 4) {
                totalAlpha++;
                if (data[i] === 0) {
                    countTransparent++;
                }
            }
            if (totalAlpha === countTransparent && totalAlpha > 0) {
                // console.log('%c map is empty', 'color:green');
                // if(NotificationService) NotificationService.warning('The map is empty !');
                if (this.fromFitData) {
                    console.log('We have no map tiles to display.  '
                        + 'Your map is centered at LAT, LONG which may not be with in your map tile service.'
                        + '  Please check that location and the data you are trying to display.');
                }
            }
            this.fromFitData = false;
        }
        catch (err) {
            console.log('*** checkMapEmpty error = ', err);
        }
    }
    fit(ConfigService, maxZoom, initialZoomChange, isCheckEmpty) {
        // console.log('OL, fit');
        if (this.type !== SclMapConstantService.COMP_TYPE_ADDRESS_MAP) {
            let maxZoom1 = 15;
            if (maxZoom) {
                maxZoom1 = maxZoom;
            }
            else {
                if (ConfigService.clientConfig().maxZoomLevel) {
                    maxZoom1 = ConfigService.clientConfig().maxZoomLevel;
                }
            }
            const featuresExtent = this.source.getExtent();
            if (featuresExtent != null && featuresExtent.length === 4 && isFinite(featuresExtent[0]) && isFinite(featuresExtent[1])
                && isFinite(featuresExtent[2]) && isFinite(featuresExtent[3])) {
                this.view.fit(featuresExtent, { size: this.map.getSize(), maxZoom1 });
            }
            if (this.layerAssets != null && this.layerAssets.length > 0) {
                for (let i = 0; i < this.layerAssets.length; i++) {
                    const extent = this.layerAssets[i].getSource().getExtent();
                    if (extent != null && extent.length === 4 && isFinite(extent[0]) && isFinite(extent[1]) && isFinite(extent[2]) &&
                        isFinite(extent[3])) {
                        this.view.fit(extent, this.map.getSize());
                    }
                }
            }
        }
        else {
            const extent = olExtent.createEmpty();
            if (this.layerAssets != null && this.layerAssets.length > 0) {
                for (let i = 0; i < this.layerAssets.length; i++) {
                    if (!this.layerAssets[i].getSource()) {
                        continue;
                    }
                    const fs = this.layerAssets[i].getSource().getFeatures();
                    if (fs == null || fs.length === 0) {
                        continue;
                    }
                    this.layerAssets[i].getSource().getFeatures().forEach(function (feature) {
                        try {
                            olExtent.extend(extent, feature.getGeometry().getExtent());
                        }
                        catch (err) {
                            console.log(err);
                        }
                    });
                }
            }
            if (extent != null && extent.length === 4 && isFinite(extent[0]) && isFinite(extent[1]) && isFinite(extent[2]) &&
                isFinite(extent[3])) {
                this.view.fit(extent);
            }
        }
        if (initialZoomChange != null && initialZoomChange !== 0) {
            let currentZoom = this.view.getZoom();
            currentZoom += initialZoomChange;
            this.view.setZoom(currentZoom);
        }
        // 13885
        if (this.type === SclMapConstantService.COMP_TYPE_ADDRESS_MAP && this.view.getZoom() > 12) {
            this.view.setZoom(12);
        }
        if (isCheckEmpty === undefined || isCheckEmpty === null || isCheckEmpty === true) {
            // this.checkMapEmpty(this.canvas); 
            this.fromFitData = true;
        }
        this.clampZoomFloor();
    }
    fitCoords(coords) {
        // calculate bounds base on collection of coordinates
        if (!coords || coords.length === 0) {
            return;
        }
        this.bounds = olExtent.createEmpty();
        this.fitCoordCount = coords.length;
        for (let i = 0; i < coords.length; i++) {
            const iCoord = proj.transform(coords[i], 'EPSG:4326', this.EPSG);
            const geom = new Point(iCoord);
            olExtent.extend(this.bounds, geom.getExtent());
        }
        this.view.fit(this.bounds);
        if (coords.length === 1) {
            let currentZoom = this.view.getZoom();
            currentZoom = currentZoom - 2;
            if (currentZoom < 0) {
                currentZoom = 1;
            }
            this.view.setZoom(currentZoom);
        }
        // console.log('%c fitCoord, mapZoom = ' + this.view.getZoom(), 'color:blue');
        this.clampZoomFloor();
    }
    mapReadOnly(isReadOnly) {
        if (isReadOnly) {
            this.map.removeInteraction(this.modify);
            this.map.removeInteraction(this.draw);
        }
        else {
            if (this.actionType) {
                if (this.actionType === 'select') {
                    this.map.addInteraction(this.modify);
                }
                else if (this.actionType !== 'delete') {
                    this.addInteraction();
                }
            }
        }
    }
    getAllFeatures() {
        let features = [];
        if (this.vector.getSource()) {
            features = this.vector.getSource().getFeatures();
        }
        if (this.layerAssets != null && this.layerAssets.length > 0) {
            for (let i = 0; i < this.layerAssets.length; i++) {
                if (!this.layerAssets[i].getSource()) {
                    continue;
                }
                const fs = this.layerAssets[i].getSource().getFeatures();
                if (fs != null && fs.length > 0) {
                    fs.forEach(function (f) {
                        features.push(f);
                    });
                }
            }
        }
        return features;
    }
    getFeaturesFromMap(features, pixel, type, assetSelectionsAvailable, sType) {
        const existedFeatures = [];
        const self = this;
        this.map.forEachFeatureAtPixel(pixel, function (feature, layer) {
            if (feature && layer) {
                if (layer.get('isCluster')) {
                    const lstFeature = feature.get('features');
                    for (let i = 0; i < lstFeature.length; i++) {
                        const result = self.getAFeatureFromMap(lstFeature[i], features, type, assetSelectionsAvailable, sType);
                        if (result.f) {
                            features.push(result.f);
                        }
                        if (result.existedFeature) {
                            existedFeatures.push(result.existedFeature);
                        }
                    }
                }
                else {
                    const result = self.getAFeatureFromMap(feature, features, type, assetSelectionsAvailable, sType);
                    if (result.f) {
                        features.push(result.f);
                    }
                    if (result.existedFeature) {
                        existedFeatures.push(result.existedFeature);
                    }
                }
            }
        });
        return existedFeatures;
    }
    getAFeatureFromMap(feature, features, type, assetSelectionsAvailable, sType) {
        let existedFeature, f;
        if (!feature.getProperties() || feature.getProperties().id === undefined) {
            return { existedFeature, feature };
        }
        const p = feature.getProperties();
        // if(p.layerDisplayOnly) return;
        if (assetSelectionsAvailable == null && p.layerDisplayOnly) {
            return { existedFeature, feature };
        }
        else {
            const iAssetSelectionsAvailable = assetSelectionsAvailable[((p.zIndex - 1) < 0 ? 0 : (p.zIndex - 1))];
            if (iAssetSelectionsAvailable != null && iAssetSelectionsAvailable.indexOf(sType) < 0) {
                let sType2 = sType;
                if (sType != null && sType.trim().length > 0) {
                    sType = sType.charAt(0).toUpperCase() + ((sType != null && sType.trim().length > 1) ? sType.slice(1) : '');
                }
                console.log('sc-selected-asset: The assetSelectiosAvailable field is not set to allow ' + sType +
                    ' selections for this layer');
                return { existedFeature, feature };
            }
        }
        if (p.id === 'address') {
            return { existedFeature, feature };
        }
        if ((type === SclMapConstantService.ASSET_PRIMARY_TYPE && p.id && p.id.indexOf('_secondary') > -1)
            || (type === SclMapConstantService.ASSET_SECONDARY_TYPE && p.id && p.id.indexOf('_primary') > -1)) {
            return { existedFeature, feature };
        }
        if (p.assetType !== type) {
            // if (p.assetType.indexOf(type) < 0) {
            let isExist = false;
            for (let i = 0; i < features.length; i++) {
                if (features[i].getProperties().name === p.name) {
                    isExist = true;
                    break;
                }
            }
            if (!isExist) {
                f = feature;
            }
        }
        else {
            existedFeature = feature;
        }
        return { existedFeature, f };
    }
    getAssetProperties(feature, relatedFields, coordinates, typeAsset, typeSelection) {
        let name = '';
        let id = '';
        let radius = null;
        const p = feature.getProperties();
        if (p) {
            name = p.name;
            id = p.id;
            radius = p.radius;
        }
        const propertiesLinkAsset = {
            documentId: id,
            name
        };
        const asset = {
            type: 'Feature',
            properties: {
                type: typeAsset,
                linkAssets: []
            }
        };
        if (radius) {
            asset.properties.radius = radius;
            asset.properties.subType = 'Circle';
        }
        if (!typeSelection || typeSelection === 'featureCollection') {
            asset.geometry = {
                type: 'Point',
                coordinates
            };
        }
        else if (typeSelection !== 'undefined' && typeSelection === 'Asset') {
            let t = feature.getGeometry().getType();
            if (t == 'Circle') {
                t = 'Point';
            }
            asset.geometry = {
                type: t,
                coordinates
            };
        }
        if (!id) {
            return '';
        }
        if (relatedFields) {
            for (const field in relatedFields) {
                if (relatedFields.hasOwnProperty(field)) {
                    const value = p[field];
                    if (value) {
                        propertiesLinkAsset[field] = value;
                    }
                }
            }
        }
        asset.properties.linkAssets.push(propertiesLinkAsset);
        return asset;
    }
    removeUnselectedAssetItem(existAsset, assets, assetType) {
        if (existAsset) {
            let isExist = false;
            let idExistAsset = existAsset.properties.linkAssets[0].documentId;
            if (idExistAsset && idExistAsset.indexOf('_') > -1) {
                idExistAsset = idExistAsset.split('_')[0];
            }
            for (let j = 0; j < assets.length; j++) {
                const item = assets[j];
                let idItem = item.properties.linkAssets[0].documentId;
                if (idItem == null) {
                    continue;
                }
                if (idItem.indexOf('_') > -1) {
                    idItem = idItem.split('_')[0];
                }
                const id = item.properties.linkAssets[0].documentId + '_' + assetType;
                if (idItem === idExistAsset) {
                    assets.splice(j, 1);
                    isExist = true;
                }
            }
            const len = this.selectedAssets.length;
            for (let i = len - 1; i > -1; i--) {
                let iId = this.selectedAssets[i].getId();
                if (iId && iId.indexOf('_') > -1) {
                    iId = iId.split('_')[0];
                }
                if (iId === idExistAsset) {
                    const f = this.selectedAssets[i];
                    if (f == null || f.getId() == null) {
                        continue;
                    }
                    if (assetType === SclMapConstantService.ASSET_PRIMARY_TYPE) {
                        const source = this.layerAssets[this.layerIndexPrimary].getSource();
                        const fea = source.getFeatureById(f.getId());
                        if (fea && source) {
                            source.removeFeature(fea);
                            this.selectedAssets.splice(i, 1);
                        }
                    }
                    else if (assetType === SclMapConstantService.ASSET_SECONDARY_TYPE) {
                        const source = this.layerAssets[this.layerIndexSecondary].getSource();
                        const fea = source.getFeatureById(f.getId());
                        if (fea && source) {
                            source.removeFeature(fea);
                            this.selectedAssets.splice(i, 1);
                        }
                    }
                    isExist = true;
                }
            }
            return isExist;
        }
        return false;
    }
    parseAssetsFromFeatures(features, assetField, coor, typeAsset, mode) {
        if (mode === 'Asset') {
            const asset = this.getAssetProperties(features, assetField.relatedFields, coor, typeAsset, mode);
            return asset;
        }
        else {
            const assets = [];
            for (let i = 0; i < features.length; i++) {
                const asset = this.getAssetProperties(features[i], assetField.relatedFields, coor[i], typeAsset, null);
                if (!asset) {
                    return;
                }
                assets.push(asset);
            }
            return assets;
        }
    }
    getAllFeaturesSelected() {
        if (this.selectMultiple) {
            return this.selectMultiple.getFeatures();
        }
        else {
            return [];
        }
    }
    addInteractionSelect(currentSelected) {
        if (this.selectMultiple) {
            this.map.addInteraction(this.selectMultiple);
        }
    }
    removeInteractionSelect() {
        if (this.selectMultiple) {
            this.map.removeInteraction(this.selectMultiple);
        }
    }
    showLayer(options) {
        if (options.isShow) {
            this.layerAssets[options.layerIndex].setVisible(true);
        }
        else {
            this.layerAssets[options.layerIndex].setVisible(false);
        }
    }
    activeInteractionSelect(isActive) {
        if (this.selectMultiple) {
            this.selectMultiple.setActive(isActive);
        }
    }
    drawActionDelete(evt) {
        this.map.forEachFeatureAtPixel(evt.pixel, (f, l) => {
            if (!f) {
                return;
            }
            const p = f.getProperties();
            if (p && p.zIndex) {
                return;
            }
            this.vector.getSource().removeFeature(f);
            if (this.type === SclMapConstantService.COMP_TYPE_BOUNDARY && this.setDirtyFunction && typeof this.setDirtyFunction === 'function') {
                this.setDirtyFunction();
                // scope.$apply();
            }
        });
    }
    drawActionProperties(evt) {
        const feature = this.map.forEachFeatureAtPixel(evt.pixel, function (feature1, layer) {
            return feature1;
        });
    }
    setPointProperties(relatedAsset, color, layerDisplayOnly, tooltip, anchor, type, layerName, url) {
        const properties = {};
        if (color) {
            properties.color = color;
        }
        if (tooltip) {
            properties.tooltip = tooltip;
        }
        if (layerDisplayOnly) {
            properties.layerDisplayOnly = layerDisplayOnly;
        }
        if (type) {
            properties.type = type;
        }
        if (anchor) {
            properties.anchor = anchor;
        }
        if (layerName) {
            properties.layerName = layerName;
        }
        if (url) {
            properties.url = url;
        }
        if (relatedAsset) {
            for (const field in relatedAsset) {
                if (relatedAsset.hasOwnProperty(field)) {
                    const value = relatedAsset[field];
                    properties[field] = value;
                }
            }
        }
        return properties;
    }
    sclAssetLayersGetPointFeature(location, image, name, id, relatedAsset, color, layerDisplayOnly, tooltip, anchor, type, layerName, url) {
        let graphPoint;
        if (type === 'MultiPoint') {
            graphPoint = new Feature(new MultiPoint(location));
        }
        else {
            graphPoint = new Feature(new Point(location));
        }
        const properties = this.setPointProperties(relatedAsset, color, layerDisplayOnly, tooltip, anchor, type, layerName, url);
        properties.icon = image;
        properties.name = name;
        properties.id = id;
        graphPoint.setProperties(properties);
        return graphPoint;
    }
    parseToLine(coor, id, toEPSG) {
        const feature = new Feature(new LineString(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    parseToMultiLine(coor, id, toEPSG) {
        const feature = new Feature(new MultiLineString(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    parseToPolygon(coor, id, toEPSG) {
        const feature = new Feature(new Polygon(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    parseToMultiPolygon(coor, id, toEPSG) {
        const feature = new Feature(new MultiPolygon(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    parseToPoint(coor, id, toEPSG) {
        const feature = new Feature(new Point(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    parseToMultiPoint(coor, id, toEPSG) {
        const feature = new Feature(new MultiPoint(coor));
        const geom = feature.getGeometry().transform('EPSG:4326', toEPSG);
        feature.setId(id);
        return feature;
    }
    sclAssetLayersCreateFeatureByType(coordinates, type, EPSG, id) {
        let feature;
        if (type === 'Point') {
            feature = this.parseToPoint(coordinates, id, EPSG);
        }
        else if (type === 'MultiPoint') {
            feature = this.parseToMultiPoint(coordinates, id, EPSG);
        }
        else if (type === 'LineString') {
            feature = this.parseToLine(coordinates, id, EPSG);
        }
        else if (type === 'MultiLineString') {
            feature = this.parseToMultiLine(coordinates, id, EPSG);
        }
        else if (type === 'Polygon') {
            feature = this.parseToPolygon(coordinates, id, EPSG);
        }
        else if (type === 'MultiPolygon') {
            feature = this.parseToMultiPolygon(coordinates, id, EPSG);
        }
        return feature;
    }
    traverseCoor(coor, obj) {
        if (Array.isArray(coor)) {
            for (let i = 0; i < coor.length; i++) {
                if (Array.isArray(coor[i])) {
                    this.traverseCoor(coor[i], obj);
                }
                else {
                    if (isNaN(coor[i])) {
                        obj.hasNaN = true;
                    }
                    else {
                        coor[i] = Number(coor[i]);
                    }
                }
            }
        }
    }
    createFeatureCircle(coord, type, options) {
        const relatedAssets = (options.relatedAsset ? options.relatedAsset : '');
        const url = (options.url ? options.url : '');
        const primaryMultiPopup = (options.primaryMultiPopup ? options.primaryMultiPopup : '');
        const secondaryMultiPopup = (options.secondaryMultiPopup ? options.secondaryMultiPopup : '');
        const lon = Number(coord[0]);
        const lat = Number(coord[1]);
        if (isNaN(lon) || isNaN(lat)) {
            return null;
        }
        const center = proj.transform([lon, lat], 'EPSG:4326', options.EPSG);
        let feature = new Feature(new CircleShape(center, options.radius));
        const p = this.setPointProperties(relatedAssets, options.color, options.layerDisplayOnly, options.tooltip, null, type, '', url);
        p.name = options.name;
        p.id = options.id;
        p.radius = options.radius;
        if (options.layer) {
            const layer = options.layer;
            if (layer.fill) {
                p.fillColor = layer.fill;
            }
            if (isNumber(layer.fillOpacity)) {
                p.fillOpacity = layer.fillOpacity;
            }
            if (isNumber(layer.lineWidth)) {
                p.lineWidth = layer.lineWidth;
            }
        }
        if (options.label != null) {
            p.label = options.label;
        }
        feature.setProperties(p);
        feature.setId(options.id);
        return feature;
    }
    createFeaturePoint(coord, type, options) {
        let feature;
        const relatedAssets = (options.relatedAsset ? options.relatedAsset : '');
        const url = (options.url ? options.url : '');
        const primaryMultiPopup = (options.primaryMultiPopup ? options.primaryMultiPopup : '');
        const secondaryMultiPopup = (options.secondaryMultiPopup ? options.secondaryMultiPopup : '');
        const lon = Number(coord[0]);
        const lat = Number(coord[1]);
        if (isNaN(lon) || isNaN(lat)) {
            return null;
        }
        const location = proj.transform([lon, lat], 'EPSG:4326', options.EPSG);
        let point = sclMapConstant$1.MAP_MARKER;
        if (options.point) {
            point = options.point;
        }
        if (options.imageFileNo) {
            if (options.imageFileNo === sclMapConstant$1.MAP_MARKER
                || options.imageFileNo === sclMapConstant$1.MAP_PRIMARY_ASSET
                || options.imageFileNo === sclMapConstant$1.MAP_SECONDARY_ASSET) {
                point = options.imageFileNo;
            }
            else {
                point = options.imageFileNo; // 15783 '/api/getFile/' + options.imageFileNo; 
            }
        }
        if (options.image) {
            point = options.image;
        }
        feature = this.sclAssetLayersGetPointFeature(location, point, options.name, options.id, relatedAssets, options.color, options.layerDisplayOnly, options.tooltip, options.anchor, '', '', url);
        const p = feature.getProperties();
        p.isCluster = true;
        if (options.label != null) {
            p.label = options.label;
        }
        if (options.rotation) {
            p.rotation = options.rotation;
        }
        if (options.scale) {
            p.scale = options.scale;
        }
        feature.setProperties(p);
        feature.setId(options.id);
        return feature;
    }
    createFeatureByType(coord, type, options) {
        let feature;
        const relatedAssets = (options.relatedAsset ? options.relatedAsset : '');
        const url = (options.url ? options.url : '');
        const primaryMultiPopup = (options.primaryMultiPopup ? options.primaryMultiPopup : '');
        const secondaryMultiPopup = (options.secondaryMultiPopup ? options.secondaryMultiPopup : '');
        const radius = options.radius;
        if (type === 'Point') {
            if (radius) {
                feature = this.createFeatureCircle(coord, type, options);
            }
            else {
                feature = this.createFeaturePoint(coord, type, options);
            }
        }
        else {
            if (options.layerType === 'cluster') {
                type = 'Point';
                const centerPoint = options.centerPoint;
                delete options.centerPoint;
                feature = this.createFeaturePoint(centerPoint, type, options);
            }
            else {
                const hasNaN = false;
                const obj = { hasNaN };
                this.traverseCoor(coord, obj);
                if (obj.hasNaN) {
                    return null;
                }
                feature = this.sclAssetLayersCreateFeatureByType(coord, type, options.EPSG, options.id);
                if (feature == null) {
                    return null;
                }
                let color = 'purple';
                // Changed to use color setup in selected asset for handlebars
                if (options.color) {
                    color = options.color;
                }
                const properties = sclAssetLayers$1.createLineProperties(options.layer, options.name, color, options.id, options.tooltip, primaryMultiPopup, secondaryMultiPopup, options.layerDisplayOnly, relatedAssets, url);
                if (options.label != null) {
                    properties.label = options.label;
                }
                feature.setProperties(properties);
            }
        }
        return feature;
    }
    setFeatureProperties(feature, properties) {
        for (const p in properties) {
            if (properties.hasOwnProperty(p)) {
                feature.set(p, properties[p]);
            }
        }
    }
    resetFeatureProperties(feature, properties) {
        feature.setProperties(properties);
    }
    getFeatureProperty(feature, propertyName) {
        const pros = feature.getProperties();
        return pros[propertyName];
    }
    getFeatureProperties(feature, fieldNames) {
        const p = {};
        const pro = feature.getProperties();
        for (let i = 0; i < fieldNames.length; i++) {
            p[fieldNames[i]] = pro[fieldNames[i]];
        }
        return p;
    }
    getFeatureId(feature) {
        return feature.getId();
    }
    setFeatureId(feature, id) {
        feature.setId(id);
    }
    getFeatureGeomType(feature) {
        const geom = feature.getGeometry();
        const type = geom.getType();
        return type;
    }
    getFeatureById(id) {
        let f = null;
        for (let i = 0; i < this.layerAssets.length; i++) {
            if (!this.layerAssets[i].getSource()) {
                continue;
            }
            if (this.layerAssets[i].get('isCluster')) {
                const src = this.layerAssets[i].getSource().getSource();
                f = src.getFeatureById(id);
            }
            else {
                f = this.layerAssets[i].getSource().getFeatureById(id);
            }
            if (f != null) {
                break;
            }
        }
        return f;
    }
    getFeatureByLayer(id, layerIndex) {
        if (layerIndex > this.layerAssets.length - 1) {
            return null;
        }
        let f = null;
        if (!this.layerAssets[layerIndex].getSource()) {
            return null;
        }
        f = this.layerAssets[layerIndex].getSource().getFeatureById(id);
        return f;
    }
    getFeatureByPixel(pixel) {
        return this.map.forEachFeatureAtPixel(pixel, function (feature, layer) {
            if (layer == null) {
                return null;
            }
            else {
                if (layer.get('isCluster')) {
                    const fs = feature.get('features');
                    if (fs && fs.length > 0) {
                        return { feature: fs[0], layerIdx: layer.getZIndex() };
                    }
                    else {
                        return { feature: null, layerIdx: layer.getZIndex() };
                    }
                }
                else {
                    return { feature, layerIdx: layer.getZIndex() };
                }
            }
        }, {
            hitTolerance: 10
        });
    }
    featureClone(fea, layerIndex) {
        const fClone = fea.clone();
        const pClone = fClone.getProperties();
        pClone.id = this.getFeatureId(fea);
        pClone.zIndex = layerIndex;
        fClone.setProperties(pClone);
        fClone.setId(pClone.id);
        return fClone;
    }
    getEventByPixel(pixel) {
        return this.map.getEventPixel(pixel);
    }
    getFeaturesCollection(options) {
        let fs = [];
        this.map.forEachFeatureAtPixel(options.pixel, (feature, layer) => {
            if (layer && !layer.get('isHeatMap') && layer.get('layerDisplayOnly') === false) { // 13521
                const layerIdx = layer.getZIndex();
                if (layerIdx && layerIdx < this.layerAssets.length) {
                    if (this.layerAssets[layerIdx].get('isCluster')) {
                        const lst = this.layerAssets[layerIdx].getSource().getSource().getFeatures();
                        const p = feature.getProperties();
                        const lstClicked = p.features;
                        for (let i = 0; i < lstClicked.length; i++) {
                            fs.push({ feature: lstClicked[i], layerIdx: layerIdx });
                            const fId = this.getFeatureId(lstClicked[i]);
                            let id = fId;
                            if (id.indexOf('_') > -1) {
                                id = id.split('_')[0];
                            }
                            for (let j = 0; j < lst.length; j++) {
                                const jId = this.getFeatureId(lst[j]);
                                if (jId === fId) {
                                    continue;
                                }
                                if (jId.indexOf(id) > -1) {
                                    fs.push({ feature: lst[j], layerIdx: layerIdx });
                                }
                            }
                        }
                    }
                    else if (this.layerAssets[layerIdx].getSource()) {
                        const id = feature.getId();
                        if (id) {
                            fs.push({ feature, layerIdx });
                        }
                        if (id && id.indexOf('_') > -1) {
                            const id0 = id.split('_')[0];
                            const lst = this.layerAssets[layerIdx].getSource().getFeatures();
                            if (lst == null || lst.length === 0) {
                                return fs;
                            }
                            lst.forEach((f, j) => {
                                const fId = f.getId();
                                if (fId && fId.indexOf(id0) > -1 && fId !== id) {
                                    fs.push({ feature: f, layerIdx: layer.getZIndex() });
                                }
                            });
                        }
                    }
                    if (typeof options.mode === 'undefined' || options.mode === null) {
                        return fs;
                    }
                }
            }
        }, {
            hitTolerance: 10
        });
        return fs;
    }
    getFeaturesCollectionId(id) {
        const fs = [];
        for (let i = 0; i < this.layerAssets.length; i++) {
            if (!this.layerAssets[i].getSource()) {
                continue;
            }
            const lst = this.layerAssets[i].getSource().getFeatures();
            if (lst == null || lst.length === 0) {
                continue;
            }
            lst.forEach(function (f, j) {
                const fId = f.getId();
                if (fId && fId.indexOf(id) > -1) {
                    // make sure this feature was not added in array
                    let isExist = false;
                    for (let k = 0; k < fs.length; k++) {
                        if (fs[k].getId() === fId) {
                            isExist = true;
                            break;
                        }
                    }
                    if (!isExist) {
                        fs.push(f);
                    }
                }
            });
        }
        return fs;
    }
    addFeature(feature, layerIndex) {
        if (feature == null) {
            return;
        }
        const p = feature.getProperties();
        p.zIndex = 0;
        if (layerIndex && layerIndex < this.layerAssets.length && this.layerAssets[layerIndex].getSource()) {
            p.zIndex = layerIndex;
            feature.setProperties(p);
            if (this.layerAssets[layerIndex].get('isCluster')) {
                const src = this.layerAssets[layerIndex].getSource().getSource();
                src.addFeature(feature);
            }
            else {
                if (this.type === SclMapConstantService.COMP_TYPE_BOUNDARY
                    || this.type === SclMapConstantService.COMP_TYPE_ADDRESS_MAP
                    || this.type === SclMapConstantService.COMP_TYPE_STREET_ADDRESS) {
                    feature.setStyle(this.styleAddress(feature, null));
                }
                else if (this.type === SclMapConstantService.COMP_TYPE_SELECTED_ASSET
                    && layerIndex !== this.layerIndexPrimary && layerIndex !== this.layerIndexSecondary) { // sc-selected-asset
                    feature.setStyle(this.styleAsset(feature, layerIndex));
                }
                this.layerAssets[layerIndex].getSource().addFeature(feature);
            }
        }
        feature.setProperties(p);
    }
    removeFeature(feature, layerIndex) {
        if (layerIndex) {
            if (layerIndex > this.layerAssets.length || !this.layerAssets[layerIndex].getSource()) {
                return;
            }
            this.layerAssets[layerIndex].getSource().removeFeature(feature);
        }
        else {
            const fId = feature.getId();
            this.removeItemFromMap(fId);
        }
    }
    removeItemFromMap(id) {
        for (let i = 0; i < this.layerAssets.length; i++) {
            if (!this.layerAssets[i].getSource()) {
                continue;
            }
            if (this.layerAssets[i].get('isCluster')) {
                const src = this.layerAssets[i].getSource().getSource();
                const f = src.getFeatureById(id);
                if (f) {
                    src.removeFeature(f);
                    break;
                }
            }
            else {
                const f = this.layerAssets[i].getSource().getFeatureById(id);
                if (f) {
                    this.layerAssets[i].getSource().removeFeature(f);
                    break;
                }
            }
        }
    }
    getMapSize() {
        return this.map.getSize();
    }
    getBoundingBox(options) {
        // get coordinate of view port
        if (this.view === null || typeof this.view === 'undefined') {
            return null;
        }
        const zoom = this.view.getZoom();
        const extent = this.view.calculateExtent(this.map.getSize());
        const bottomLeft = proj.transform(olExtent.getBottomLeft(extent), options.EPSG, sclMapConstant$1.EPSG_4326);
        const topRight = proj.transform(olExtent.getTopRight(extent), options.EPSG, sclMapConstant$1.EPSG_4326);
        if (isNaN(bottomLeft[0]) || isNaN(bottomLeft[1]) || isNaN(topRight[0]) || isNaN(topRight[1])) {
            return null;
        }
        const left = bottomLeft[0];
        const bottom = bottomLeft[1];
        const right = topRight[0];
        const top = topRight[1];
        // console.log(`*** left = ${left}, bottom = ${bottom}, right = ${right}, top = ${top}`);
        let minLon = left;
        let maxLon = right;
        if (left > right) {
            minLon = right;
            maxLon = left;
        }
        let minLat = bottom;
        let maxLat = top;
        if (bottom > top) {
            minLat = top;
            maxLat = bottom;
        }
        return { minLon, maxLat, maxLon, minLat, zoom };
    }
    getLayerSourceBoundingBox(layerIndex, systemMapLimit, EPSG) {
        const extent = this.layerAssets[this.layerIndexFilter].getSource().getExtent();
        const bottomLeft = proj.transform(olExtent.getBottomLeft(extent), EPSG, sclMapConstant$1.EPSG_4326);
        const topRight = proj.transform(olExtent.getTopRight(extent), EPSG, sclMapConstant$1.EPSG_4326);
        if (isNaN(bottomLeft[0]) || isNaN(bottomLeft[1]) || isNaN(topRight[0]) || isNaN(topRight[1])) {
            return null;
        }
        let l = bottomLeft[0]; // left
        let b = bottomLeft[1]; // bottom
        let r = topRight[0]; // right
        let t = topRight[1]; // top
        // systemMapLimit : [ [ top, left ], [bottom, right ] ] 
        const boxLimit = {
            left: systemMapLimit[0][1],
            bottom: systemMapLimit[1][0],
            right: systemMapLimit[1][1],
            top: systemMapLimit[0][0],
        };
        if (l < boxLimit.left) {
            l = boxLimit.left;
        }
        if (r > boxLimit.right) {
            r = boxLimit.right;
        }
        if (b < boxLimit.bottom) {
            b = boxLimit.bottom;
        }
        if (t > boxLimit.top) {
            t = boxLimit.top;
        }
        const box = this.validateBoxInBound({ l, b, r, t }, boxLimit);
        return proj.transformExtent(box, sclMapConstant$1.EPSG_4326, EPSG);
    }
    validateBoxInBound(box, boxLimit) {
        if (box.l < boxLimit.left) {
            box.l = boxLimit.left;
        }
        if (box.r > boxLimit.right) {
            box.r = boxLimit.right;
        }
        if (box.b < boxLimit.bottom) {
            box.b = boxLimit.bottom;
        }
        if (box.t > boxLimit.top) {
            box.t = boxLimit.top;
        }
        return [box.l, box.b, box.r, box.t];
    }
    validateBox(box, systemMapLimit, EPSG) {
        const box4326 = proj.transformExtent(box, EPSG, sclMapConstant$1.EPSG_4326);
        const bbox = {
            l: box4326[0],
            b: box4326[1],
            r: box4326[2],
            t: box4326[3]
        };
        // systemMapLimit : [ [ top, left ], [bottom, right ] ] 
        const boxLimit = {
            left: systemMapLimit[0][1],
            bottom: systemMapLimit[1][0],
            right: systemMapLimit[1][1],
            top: systemMapLimit[0][0],
        };
        const boxEPSG = this.validateBoxInBound(bbox, boxLimit);
        return proj.transformExtent(boxEPSG, sclMapConstant$1.EPSG_4326, EPSG);
    }
    addSearchAddress(apiKey, wrapper, cb) {
        console.log('Need to bring back GoogleMapLoader ?');
        // GoogleMapsLoader.KEY = apiKey;
        // GoogleMapsLoader.LIBRARIES = 'places';
        // GoogleMapsLoader.SENSOR = true;
        // GoogleMapsLoader.load(function(google) {
        //     const autocomplete = new google.maps.places.Autocomplete(
        //         wrapper,
        //         { types: ['geocode'] });
        //     google.maps.event.addListener(autocomplete, 'place_changed', function() {
        //         const place = autocomplete.getPlace();
        //         const lat = place.geometry.location.lat();
        //         const lon = place.geometry.location.lng();
        //         if (cb && typeof cb == 'function') {
        //             cb(place, lat, lon);
        //         }
        //     });
        // });
    }
    clearAllFeatures() {
        // this.source.clear();//13835
        for (let i = 1; i < this.layerAssets.length; i++) { // start with layer index of asset from 1 to n
            this.layerAssets[i].getSource().clear(); // 13835
        }
    }
    clearAllFeaturesLayer(layerIndex) {
        if (layerIndex > this.layerAssets.length || !this.layerAssets[layerIndex].getSource()
            || this.layerAssets[layerIndex].get('isCluster')) {
            return;
        }
        this.layerAssets[layerIndex].getSource().clear();
    }
    updateSize() {
        this.map.updateSize();
    }
    getLatLngFromPixel(pixel) {
        const coordinate = this.map.getCoordinateFromPixel(pixel);
        const coor = proj.transform(coordinate, this.EPSG, 'EPSG:4326');
        return coor;
    }
    getPixelFromCoordinate(coordinate) {
        const coor = proj.transform(coordinate, this.EPSG, 'EPSG:4326');
        const pixel = this.map.getPixelFromCoordinate(coordinate);
        return { coor, pixel };
    }
    findFeatureByClick(evt, assetType, assetSelectionsAvailable, sType) {
        const features = [];
        const coordinate = evt.feature.getGeometry().getCoordinates();
        const obj = this.getPixelFromCoordinate(coordinate);
        const existedFeature = this.getFeaturesFromMap(features, obj.pixel, assetType, assetSelectionsAvailable, sType);
        return { coor: obj.coor, pixel: obj.pixel, features, existedFeature };
    }
    storeSelectedAssets(feature, isPrimary) {
        const fId = feature.getId();
        const fPro = feature.getProperties();
        const assetType = feature.get('assetType');
        if (this.selectedAssets == null) {
            this.selectedAssets = [];
        }
        const len = this.selectedAssets.length;
        for (let i = 0; i < len; i++) {
            const iId = this.selectedAssets[i].getId();
            if (iId === fId) {
                if (isPrimary) {
                    const f = this.layerAssets[this.layerIndexPrimary].getSource().getFeatureById(iId);
                    if (f == null) {
                        this.addSelectedAssetsIcon(feature, this.layerIndexPrimary, this.stylePrimaryAssetFunc.bind(this));
                    }
                }
                else {
                    const f = this.layerAssets[this.layerIndexSecondary].getSource().getFeatureById(iId);
                    if (f == null) {
                        this.addSelectedAssetsIcon(feature, this.layerIndexSecondary, this.styleSecondaryAssetFunc.bind(this));
                    }
                }
                this.selectedAssets[i] = feature;
                return;
            }
        }
        this.selectedAssets.push(feature);
        // 13835
        if (isPrimary) {
            this.addSelectedAssetsIcon(feature, this.layerIndexPrimary, this.stylePrimaryAssetFunc.bind(this));
        }
        else {
            this.addSelectedAssetsIcon(feature, this.layerIndexSecondary, this.styleSecondaryAssetFunc.bind(this));
        }
        // this.source.addFeature(feature); // 13835
    }
    addSelectedAssetsIcon(feature, layerIndex, styleFunc) {
        feature.set('zIndex', layerIndex);
        feature.setStyle(styleFunc(feature, null));
        this.layerAssets[layerIndex].getSource().addFeature(feature);
        this.layerAssets[layerIndex].setVisible(true);
    }
    updateStoredSelectedAssetVisualize(id, handlebarsContext, primaryIcon, primaryAssetSelection, secondaryIcon, secondaryAssetSelection, handlebarAssetFn) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.selectedAssets) {
                return;
            }
            const len = this.selectedAssets.length;
            for (let i = 0; i < len; i++) {
                const feature = this.selectedAssets[i];
                let fId = feature.getId();
                if (fId.indexOf('_') > -1) {
                    fId = fId.split('_')[0];
                }
                if (id.indexOf(fId) > -1) {
                    const p = feature.getProperties();
                    let isPrimary = false;
                    if (p.assetType === SclMapConstantService.ASSET_PRIMARY_TYPE) {
                        isPrimary = true;
                    }
                    if (isPrimary) {
                        const primary = yield handlebarAssetFn(handlebarsContext, primaryIcon, primaryAssetSelection, true);
                        this.setFeatureProperties(feature, { primary });
                        feature.setStyle(this.stylePrimaryAssetFunc(feature, null));
                    }
                    else {
                        const secondary = yield handlebarAssetFn(handlebarsContext, secondaryIcon, secondaryAssetSelection, false);
                        this.setFeatureProperties(feature, { secondary });
                        feature.setStyle(this.styleSecondaryAssetFunc(feature, null));
                    }
                    break;
                }
            }
        });
    }
    removeSelectedAssetsById(id) {
        let fId = id;
        let mode = 'NA';
        if (fId && fId.indexOf('primary') > -1) {
            mode = 'primary';
        }
        else if (fId && fId.indexOf('secondary') > -1) {
            mode = 'secondary';
        }
        if (fId && fId.indexOf('_') > -1) {
            fId = fId.split('_')[0];
        }
        const len = this.selectedAssets.length;
        for (let i = len - 1; i > -1; i--) {
            const iId = this.selectedAssets[i].getId();
            if ((iId && iId.indexOf(mode) > -1 && iId.indexOf(fId) > -1) || iId === fId) {
                this.selectedAssets.splice(i, 1);
                this.removeItemFromMap(iId);
            }
        }
    }
    removeLayerFeatures() {
        // console.log('***********************open layer removeLayerFeatures***************************');
        // this.source.clear();//will re-write for mantis 13835
        this.clearAllFeatures(); // as same as this.clearAllFeatures() will remove removeLayerFeatures function
    }
    // copy from sclAssetLayers.removeUnselectedAsset
    removeUnselectedAsset(assets, unSelectedAssetIds, type) {
        for (let i = 0; i < unSelectedAssetIds.length; i++) {
            const priAsset = unSelectedAssetIds[i];
            for (let j = 0; j < assets.length; j++) {
                const id = assets[j].properties.linkAssets[0].documentId;
                if (id === priAsset) {
                    this.removeItemFromMap(id + '_' + type);
                    assets.splice(j, 1);
                }
            }
        }
    }
    updateLayers(pLayerAssets) {
        // remove feature in all layersz
        this.removeLayerFeatures();
        // remove old layers
        for (let i = 1; i < this.layerAssets.length; i++) { // start with layer index of asset from 1 to n
            this.map.removeLayer(this.layerAssets[i]);
        }
        // add new layers
        const obj = { layerAssets: pLayerAssets };
        this.createLayers(obj);
        if (this.layerAssets.length > 0) {
            for (let iLa = 1; iLa < this.layerAssets.length; iLa++) { // start with layer index of asset from 1 to n
                this.map.addLayer(this.layerAssets[iLa]);
            }
        }
    }
    // ************** use for psma layer reverse function *******************************************
    psmaStyleFunction(feature, resolution) {
        if (typeof feature !== 'object' || typeof feature.getProperties() === 'undefined') {
            return null;
        }
        const p = feature.getProperties();
        const description = feature.getProperties().description;
        const label = (typeof description === 'undefined' || description === null) ? '' : description + '';
        let image = new Circle({
            radius: 3,
            fill: new Fill({
                color: [255, 127, 39, 1]
            }),
            stroke: new Stroke({
                color: [255, 0, 0, 1],
                width: 1.5
            })
        });
        if (p.icon) {
            const anchor = [0.5, 0.5];
            image = new Icon(({
                src: p.icon,
                anchor
            }));
        }
        const style = new Style({
            fill: new Fill({
                color: 'rgba(255,255,255,0.4)'
            }),
            stroke: new Stroke({
                color: '#3399CC',
                width: 1.25
            }),
            text: new Text({
                font: '12px Arial',
                fill: new Fill({ color: '#000' }),
                stroke: new Stroke({
                    color: '#fff', width: 2
                }),
                textBaseline: 'top',
                // get the text from the feature - `this` is ol.Feature
                // and show only under certain resolution
                text: label
            }),
            image,
            // zIndex: 10000 //13835
        });
        return style;
    }
    psmaCreateLayer(psmaPoints) {
        if (typeof this.psmaReverse === 'undefined' || this.psmaReverse === null) {
            this.psmaReverse = {};
            this.layerAssets[this.layerIndexAddress].getSource().addFeatures(psmaPoints); // 13835
            this.psmaReverse.psmaSourceVector = this.layerAssets[this.layerIndexAddress].getSource();
            this.layerAssets[this.layerIndexAddress].setStyle(this.psmaStyleFunction.bind(this)); // 13835
            this.psmaReverse.psmaLayer = this.layerAssets[this.layerIndexAddress]; // 13835
        }
        return this.psmaReverse;
    }
    psmaCreatePoint(coor, properties, psmaPoints) {
        const coorMap = proj.transform(coor, 'EPSG:4326', this.EPSG); // 'EPSG:3111'
        const iconFeature = new Feature(new Point(coorMap));
        iconFeature.setProperties(properties);
        // this.psmaReverse.psmaSourceVector.addFeature(iconFeature);//13835
        this.layerAssets[this.layerIndexAddress].getSource().addFeature(iconFeature); // 13835
        psmaPoints.push(iconFeature);
        return psmaPoints;
    }
    psmaCreatePointClick(coor, radius, psmaPoints) {
        const circle4326 = circular(coor, radius); // openlayer 5
        const circle3857 = circle4326.clone().transform('EPSG:4326', this.EPSG); // 'EPSG:3111'
        const clickFeature = new Feature(circle3857);
        // this.psmaReverse.psmaSourceVector.addFeature(clickFeature);//13835
        this.layerAssets[this.layerIndexAddress].getSource().addFeature(clickFeature); // 13835
        psmaPoints.push(clickFeature);
        return psmaPoints;
    }
    psmaRemovePoint(psmaPoints, psmaSourceVector) {
        for (let i = 0; i < psmaPoints.length; ++i) {
            if (psmaPoints[i] == null) {
                continue;
            }
            psmaSourceVector.removeFeature(psmaPoints[i]);
        }
        return { psmaPoints, psmaSourceVector };
    }
    psmaDistanceCoords(coorA, coorB) {
        const distance = getDistance(coorA, coorB); // openlayer 5
        return distance;
    }
    // copy from sclUtilMap.positionView
    positionView(lat, lon, zoom, EPSG) {
        // if(this.wmsState.finishLoad == false || this.wmsState.tileCount == 0){
        //     this.positionObject = { hasCall: true, lat: lat, lon: lon, zoom: zoom, epsg: EPSG };
        //     return;
        // }
        lat = (typeof lat !== 'undefined') ? lat : 0;
        lon = (typeof lon !== 'undefined') ? lon : 0;
        zoom = (typeof zoom !== 'undefined') ? zoom : 2;
        EPSG = (typeof EPSG !== 'undefined') ? EPSG : 'EPSG:3857';
        this.view.setCenter(proj.transform([lon, lat], 'EPSG:4326', EPSG));
        this.view.setZoom(zoom);
    }
    //
    setCenterMapViewByCoordinates(bbox) {
        // new bounding box
        const bottom = bbox[1][1];
        const left = bbox[0][0];
        const top = bbox[0][1];
        const right = bbox[1][0];
        let ext = [left, bottom, right, top]; // [minlon, minlat, maxlon, maxlat];
        ext = olExtent.applyTransform(ext, proj.getTransform('EPSG:4326', this.EPSG));
        this.view.fit(ext, { size: this.map.getSize(),
            constrainResolution: false
        });
    }
    // 15262
    setCenter(lat, lon) {
        const center = proj.transform([lon, lat], 'EPSG:4326', this.EPSG);
        this.view.setCenter(center);
    }
    setSelectAssetCluster(features, currentSelected) {
        for (let i = 0; i < features.length; i++) {
            currentSelected.push(features[i].feature);
        }
    }
    extendToCoordinate(coord) {
        const currentLoc = proj.transform(this.map.getView().getCenter(), this.EPSG, 'EPSG:4326');
        let ext = boundingExtent([coord, currentLoc]);
        ext = proj.transformExtent(ext, proj.get('EPSG:4326'), proj.get(this.EPSG));
        this.map.getView().fit(ext, {
            size: this.map.getSize(),
            padding: [50, 0, 50, 0]
        });
    }
    getFeatureCoordinate(feature) {
        let geom = cloneDeep(feature.getGeometry());
        geom = geom.transform(this.EPSG, 'EPSG:4326');
        const type = geom.getType();
        const coords = geom.getCoordinates();
        let coordArray = cloneDeep(coords);
        const finalCoords = [];
        ;
        if (type == 'LineString') {
            for (let i = 0; i < coords.length - 1; i++) {
                finalCoords.push([coords[i], coords[i + 1]]);
            }
            coordArray = [];
            for (let i = 0; i < coords.length; i++) {
                coordArray.push(coords[i]);
            }
        }
        else if (type == 'Polygon') {
            for (let i = 0; i < coords[0].length - 1; i++) {
                finalCoords.push([coords[0][i], coords[0][i + 1]]);
            }
            coordArray = [];
            for (let i = 0; i < coords[0].length; i++) {
                coordArray.push(coords[0][i]);
            }
        }
        else if (type == 'MultiLineString') {
            for (let i = 0; i < coords.length; i++) {
                for (let j = 0; j < coords[i].length - 1; j++) {
                    finalCoords.push([coords[i][j], coords[i][j + 1]]);
                }
            }
            coordArray = [];
            for (let i = 0; i < coords.length; i++) {
                for (let j = 0; j < coords[i].length; j++) {
                    coordArray.push(coords[i][j]);
                }
            }
        }
        else if (type == 'MultiPolygon') {
            for (let i = 0; i < coords.length; i++) {
                for (let j = 0; j < coords[i][0].length - 1; j++) {
                    finalCoords.push([coords[i][0][j], coords[i][0][j + 1]]);
                }
            }
            coordArray = [];
            for (let i = 0; i < coords.length; i++) {
                for (let j = 0; j < coords[i][0].length; j++) {
                    coordArray.push(coords[i][0][j]);
                }
            }
        }
        return { coords: finalCoords, type, coordArray };
    }
}
/** @nocollapse */ /** @nocollapse */ SclMappingFunctionOpenLayersService.ɵfac = function SclMappingFunctionOpenLayersService_Factory(t) { return new (t || SclMappingFunctionOpenLayersService)(i0.ɵɵinject(i0.ChangeDetectorRef)); };
/** @nocollapse */ /** @nocollapse */ SclMappingFunctionOpenLayersService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMappingFunctionOpenLayersService, factory: SclMappingFunctionOpenLayersService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMappingFunctionOpenLayersService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return [{ type: i0.ChangeDetectorRef }]; }, null);
})();

const sclMapConstant = SclMapConstantService;
const sclMapViews = new SclMapViewsService();
const sclAssetLayers = new SclAssetLayersService();
const sclProjectionConstant = SclProjectionConstantService;
setDefaultOptions({ css: true });
class SclMappingFunctionsArcGisService {
    constructor() {
        this.sclUtilMapService = new SclUtilMapService();
        this.selectedAssets = [];
        this.selectedFeatures = [];
        this.zoomFloor = 18; // 14254
        this.layerAssets = [];
        this.compActionType = ''; // 14310: '' = no action, 'primary', 'secondary', ....
        this.ActionControls = [];
        this.lstHeatWeight = [];
        this.heatDatas = [];
        this.heatLayerConfig = {};
        this.fitCoors = []; // map has call fitCoordsAction or not
        this.mapLoaded = false; // map hasn't load successfull
        this.drawingMode = 'single';
        this.color = 'black';
        this.multiColor = 'red';
        this.drawingShapeSingle = [];
        this.drawingShapeMulti = { point: [], line: [], polygon: [] }; // for sc-boundary
        this.textSymbolVerticalAlignment = ['baseline', 'top', 'middle', 'bottom'];
        this.textSymbolHorizontalAlignment = ['left', 'right', 'center', 'justify'];
        this.isMapReady = false;
        this.controlBtns = [];
        this.mouseHoverFeature = null;
    }
    load(cb) {
        this.lib = {};
        loadModules(['esri/Map',
            'esri/views/MapView',
            'esri/views/SceneView',
            'esri/layers/FeatureLayer',
            'esri/layers/GraphicsLayer',
            'esri/Graphic',
            'esri/core/watchUtils',
            'esri/geometry/support/webMercatorUtils',
            'esri/Color',
            'esri/geometry/Multipoint',
            'esri/geometry/Circle',
            'esri/geometry/Point',
            'esri/symbols/Font',
            'esri/symbols/TextSymbol',
            'esri/widgets/Fullscreen',
            'esri/geometry/Extent',
            'esri/widgets/Sketch/SketchViewModel',])
            .then(([Map, MapView, SceneView, FeatureLayer, GraphicsLayer, Graphic, watchUtils, webMercatorUtils, Color, Multipoint, Circle, Point, Font, TextSymbol, Fullscreen, Extent, SketchViewModel]) => {
            this.lib = {
                Map, MapView, SceneView, FeatureLayer, GraphicsLayer, Graphic, watchUtils, webMercatorUtils, Color, Multipoint, Circle, Point,
                Font, TextSymbol, Fullscreen, Extent, SketchViewModel
            };
            if (cb && typeof cb === 'function') {
                cb();
            }
        }).catch(() => {
            if (cb && typeof cb === 'function') {
                cb();
            }
        });
    }
    interactionSelect() {
        // TO DO
    }
    interactionModify() {
        // TO DO
    }
    interactionSelectMultiple(isActive, cb) {
        // TO DO
    }
    checkGeoJson(geojson) {
        if (typeof geojson.features === 'undefined' || geojson.features.length == null || geojson.features.length === 0) {
            return false;
        }
        const f0 = geojson.features[0];
        if (typeof f0.type !== 'undefined' && typeof f0.geometry !== 'undefined'
            && typeof f0.geometry.type !== 'undefined') {
            return true;
        }
        return false;
    }
    clampZoomFloor() {
        if (this.mapView.zoom > this.zoomFloor) {
            this.mapView.goTo({
                zoom: this.zoomFloor
            });
        }
    }
    getTile(mapView, isShow, self) {
        const tile = '';
        // TO DO
        return tile;
    }
    multiLayers(mapViews) {
        return [];
    }
    // copy from sclUtilMap
    setView(lng, lat, zoom, EPSG, minResolution, maxResolution, maxZoom) {
        // TO DO
        // return view;
    }
    createLayerSourceNormal(zIndex, pStyle, title, layerDisplayOnly) {
        let objStyle = {
            color: 'black',
            fill: null,
            fillOpacity: 1,
            lineCap: null,
            lineDash: null,
            lineWidth: 1,
            imageAnchor: [0.5, 0.5],
            imageFileNo: ''
        };
        if (pStyle) {
            objStyle = {
                color: (pStyle.color ? pStyle.color : 'black'),
                fill: (pStyle.fill ? pStyle.fill : null),
                fillOpacity: (pStyle.fillOpacity ? pStyle.fillOpacity : 1),
                lineCap: (pStyle.lineCap ? pStyle.lineCap : null),
                lineDash: (pStyle.lineDash ? pStyle.lineDash : null),
                lineWidth: (pStyle.lineWidth ? pStyle.lineWidth : 1),
                imageAnchor: (pStyle.imageAnchor ? pStyle.imageAnchor : [0.5, 0.5]),
                imageFileNo: (pStyle.imageFileNo ? pStyle.imageFileNo : '')
            };
        }
        return {
            graphicLayer: new this.lib.GraphicsLayer(),
            zIndex,
            style: objStyle,
            title,
            layerDisplayOnly
        };
    }
    createEmptyLayer(zIndex, pStyle, title, isHeatMap, options) {
        let newLayer;
        let layerDisplayOnly = false;
        if (options && options.layerDisplayOnly) {
            layerDisplayOnly = options.layerDisplayOnly;
        }
        if (isHeatMap) {
            const renderer = {
                type: 'heatmap',
                field: 'weight',
                colorStops: [
                    { ratio: 0, color: 'rgba(255, 140, 0, 0)' },
                    { ratio: 0.75, color: 'rgba(255, 140, 0, 1)' },
                    { ratio: 0.9, color: 'rgba(255, 0,   0, 1)' }
                ],
                minPixelIntensity: 0,
                maxPixelIntensity: 100,
                blurRadius: 10
            };
            if (options != null && typeof options.gradient !== 'undefined') {
                renderer.colorStops = [];
                const factor = parseFloat((1 / options.gradient.length).toFixed(2));
                let ratio = 0;
                for (let i = 0; i < options.gradient.length; i++) {
                    renderer.colorStops.push({ ratio, color: options.gradient[i] });
                    ratio += factor;
                    if (ratio > 1) {
                        ratio = 1;
                    }
                }
            }
            if (options != null && typeof options.blur !== 'undefined') {
                renderer.blurRadius = options.blur;
            }
            const aLayer = new this.lib.FeatureLayer({
                fields: [
                    {
                        name: 'id',
                        alias: 'id',
                        type: 'string'
                    },
                    {
                        name: 'weight',
                        alias: 'weight',
                        type: 'double'
                    }
                ],
                objectIdField: 'id',
                geometryType: 'point',
                // spatialReference: view.spatialReference,
                renderer,
                source: []
            });
            newLayer = {
                graphicLayer: aLayer,
                zIndex,
                isHeatMap: true,
                layerDisplayOnly: true
            };
        }
        else {
            newLayer = this.createLayerSourceNormal(zIndex, pStyle, title, layerDisplayOnly);
        }
        newLayer.layerQuery = options;
        return newLayer;
    }
    createLayerAsset(options) {
        // 1) UI controls (zoom, map selector. etc)
        // 2) Tooltips, other popup controls
        // 3) User added items : address pins, selections, etc
        // 4) Objects returned from "primaryAssetFilter"
        // 5) Objects returned from "secondaryAssetFilter"
        // 6) Objects returned from a "filter" query at the root of the component
        // 7) Items returned from the layers[0] entry
        // 8) items returned from layers[1] entry
        // 9) Items returned from layers[n] entry, where n is the last layer in the array
        // 10) Base map images
        let layerQuery = [];
        let hasFilterQuery = false;
        let hasSecondary = false;
        let styleSecondary = null;
        let hasPrimary = false;
        let stylePrimary = null;
        let hasUserItems = false;
        let styleSelected = null;
        let hasAddressPoint = false;
        let stylePoint = null;
        if (options.layerQuery) {
            layerQuery = options.layerQuery;
        }
        if (options.hasFilterQuery) {
            hasFilterQuery = options.hasFilterQuery;
        }
        if (options.hasSecondary) {
            hasSecondary = options.hasSecondary;
        }
        if (options.styleSecondary) {
            styleSecondary = options.styleSecondary;
        }
        if (options.hasPrimary) {
            hasPrimary = options.hasPrimary;
        }
        if (options.stylePrimary) {
            stylePrimary = options.stylePrimary;
        }
        if (options.hasUserItems) {
            hasUserItems = options.hasUserItems;
        }
        if (options.styleSelected) {
            styleSelected = options.styleSelected;
        }
        if (options.hasAddressPoint) {
            hasAddressPoint = options.hasAddressPoint;
        }
        if (options.stylePoint) {
            stylePoint = options.stylePoint;
        }
        let layerIndex = 0;
        if (this.layerAssets == null) {
            this.layerAssets = [];
        }
        if (layerQuery) { // 9,8,7
            for (let i = 0; i < layerQuery.length; i++) {
                if (layerQuery[i].query.indexOf('_layer') < 0) {
                    continue;
                }
                let style = {};
                if (layerIndex < layerQuery.length) {
                    style = layerQuery[layerIndex].layer;
                }
                layerIndex++;
                this.layerAssets.push(this.createEmptyLayer(layerIndex, style, 'layer' + layerIndex, layerQuery[i].isHeatMap, layerQuery[i].layer));
            }
        }
        if (hasFilterQuery) { // 6
            let style = {};
            if (layerIndex < layerQuery.length) {
                style = layerQuery[layerIndex].layer;
            }
            layerIndex++;
            this.layerAssets.push(this.createEmptyLayer(layerIndex, style, 'filter', null, null));
            this.layerIndexFilter = layerIndex;
        }
        if (hasSecondary) { // 5
            layerIndex++;
            this.layerAssets.push(this.createEmptyLayer(layerIndex, this.convertStylePrimary(styleSecondary, 'secondary'), 'secondary', null, null));
            this.layerIndexSecondary = layerIndex;
        }
        if (hasPrimary) { // 4
            layerIndex++;
            this.layerAssets.push(this.createEmptyLayer(layerIndex, this.convertStylePrimary(stylePrimary, 'primary'), 'primary', null, null));
            this.layerIndexPrimary = layerIndex;
        }
        if (hasUserItems) { // 3
            layerIndex++;
            this.layerAssets.push(this.createEmptyLayer(layerIndex, this.convertStylePrimary(styleSelected, ''), 'selectedItems', null, null));
            this.layerIndexUser = layerIndex;
        }
        if (hasAddressPoint) { // 3
            layerIndex++;
            this.layerAssets.push(this.createEmptyLayer(layerIndex, stylePoint, 'addressPoint', null, null));
            this.layerIndexAddress = layerIndex;
        }
        // tooltips
        this.layerIndexTooltips = layerIndex + 1;
        // controls button
        this.layerIndexControl = layerIndex + 2;
    }
    convertStylePrimary(style, type) {
        let defaultImgFileNo = sclMapConstant.MAP_MARKER;
        if (type === 'primary') {
            defaultImgFileNo = sclMapConstant.MAP_PRIMARY_ASSET;
        }
        else if (type === 'secondary') {
            defaultImgFileNo = sclMapConstant.MAP_SECONDARY_ASSET;
        }
        let imgFileNo = style.selectionImageFileNo;
        if (imgFileNo && imgFileNo !== sclMapConstant.MAP_MARKER &&
            imgFileNo !== sclMapConstant.MAP_PRIMARY_ASSET && imgFileNo !== sclMapConstant.MAP_SECONDARY_ASSET) {
            imgFileNo = '/api/getFile/' + imgFileNo.replace('api/getFile/', '').replace('/api/getFile/', '');
        }
        return {
            color: (style.selectionColor ? style.selectionColor : 'black'),
            fill: (style.selectionFill ? style.selectionFill : null),
            fillOpacity: (style.selectionFillOpacity ? style.selectionFillOpacity : 1),
            lineCap: (style.selectionLineCap ? style.selectionLineCap : null),
            lineDash: (style.selectionLineDash ? style.selectionLineDash : null),
            lineWidth: (style.selectionLineWidth ? style.selectionLineWidth : 1),
            imageAnchor: (style.selectionImageAnchor ? style.selectionImageAnchor : [0.5, 0.5]),
            imageFileNo: (imgFileNo ? imgFileNo : defaultImgFileNo)
        };
    }
    createLayers(initObj) {
        this.layerAssets = [];
        this.layerAssets.push(this.createLayerSourceNormal(0, {}, 'layer0', false));
        let layerQuery = [];
        if (this.type === 0) { // sc-boundary
            this.createLayerAsset({ layerQuery, hasAddressPoint: true, stylePoint: initObj.styleAddress });
        }
        else if (this.type === 1) { // sc-address-map
            if (initObj.layerAssets) {
                layerQuery = initObj.layerAssets;
            }
            this.createLayerAsset({ layerQuery, hasFilterQuery: true, hasUserItems: true, styleSelected: initObj.selectionStyle });
        }
        else if (this.type === 2) { // sc-street-address
            this.createLayerAsset({ layerQuery, hasAddressPoint: true, stylePoint: initObj.styleAddress });
        }
        else if (this.type === 3) { // sc-selected-asset
            if (initObj.layerAssets) {
                layerQuery = initObj.layerAssets;
            }
            this.createLayerAsset({ layerQuery, hasFilterQuery: true,
                hasSecondary: true, styleSecondary: initObj.secondaryAssetSelection,
                hasPrimary: true, stylePrimary: initObj.primaryAssetSelection,
                hasAddressPoint: true, stylePoint: initObj.styleAddress });
        }
    }
    createHeatMap(layerIndex) {
        const min = Math.min.apply(null, this.lstHeatWeight);
        const max = Math.max.apply(null, this.lstHeatWeight);
        const addFeatures = [];
        for (let i = 0; i < this.heatDatas.length; i++) {
            let weight = (this.heatDatas[i].weight - min) / (max - min); // clamp weight 0..1
            if (isNaN(weight)) {
                if (max === min) {
                    weight = 1;
                }
                else {
                    weight = 0;
                }
            }
            if (weight > 1) {
                weight = 1;
            }
            // created for owl range of data
            const coord = this.heatDatas[i].location;
            const pf = {
                geometry: {
                    type: 'point',
                    longitude: coord[0],
                    latitude: coord[1]
                }
            };
            this.heatDatas[i].weight = weight;
            this.setFeatureProperties(pf, this.heatDatas[i]);
            addFeatures.push(pf);
        }
        this.heatDatas = []; // reset
        this.lstHeatWeight = []; // reset
        this.layerAssets[layerIndex].graphicLayer.applyEdits({
            addFeatures
        });
    }
    init(initObj) {
        this.divWrapper = initObj.divWrapper;
        this.selectedAssets = [];
        if (initObj.setDirty) {
            this.setDirtyFunction = initObj.setDirty;
        }
        this.type = initObj.style;
        let coordinates;
        if (initObj.formatGeoJSON) { // use for sc-boundary
            coordinates = initObj.formatGeoJSON;
        }
        if (initObj.setupMapDone) {
            this.setupMapDone = initObj.setupMapDone;
        }
        // 13835
        if (initObj.selectionStyle) {
            this.selectionStyle = initObj.selectionStyle;
        }
        if (initObj.primaryAssetSelection) {
            this.primaryAssetSelection = initObj.primaryAssetSelection;
        }
        if (initObj.secondaryAssetSelection) {
            this.secondaryAssetSelection = initObj.secondaryAssetSelection;
        }
        if (initObj.color) {
            this.color = initObj.color;
        }
        if (initObj.multiColor) {
            this.multiColor = initObj.multiColor;
        }
        if (initObj.setDirty) {
            this.setDirtyFunction = initObj.setDirty;
        }
        if (initObj.layersRedraw) {
            this.layersRedraw = initObj.layersRedraw;
        }
        if (initObj.heightNum) {
            this.heightNum = initObj.heightNum;
        }
        if (initObj.mapId) {
            this.mapId = initObj.mapId;
        }
        if (initObj.onTilesLoaded) {
            this.onTilesLoaded = initObj.onTilesLoaded;
        }
        if (initObj.singleSelectMode) {
            this.funcSingleSelectMode = initObj.singleSelectMode;
        }
        if (initObj.zoomFloor) {
            this.zoomFloor = initObj.zoomFloor;
        }
        if (initObj.layers) {
            this.tileLayers = initObj.layers;
        }
        if (initObj.toolTipOnFeatureHover) {
            this.toolTipOnFeatureHover = initObj.toolTipOnFeatureHover;
        }
        if (initObj.setupTooltipUI) {
            this.setupTooltipUI = initObj.setupTooltipUI;
        }
        if (initObj.fullScreenEvent) {
            this.fullScreenEvent = initObj.fullScreenEvent;
        }
        if (initObj.target) {
            this.mapDiv = initObj.target;
        }
        this.defaultLat = (initObj.defaultLat ? initObj.defaultLat : -37.8);
        this.defaultLon = (initObj.defaultLon ? initObj.defaultLon : 144.9);
        this.defaultZoom = (initObj.defaultZoom ? initObj.defaultZoom : 14);
        this.drawingShapeMulti = { point: [], line: [], polygon: [] };
        this.map = new this.lib.Map({
            basemap: 'topo-vector'
        });
        this.mapView = new this.lib.MapView({
            container: initObj.target,
            map: this.map,
            center: [this.defaultLon, this.defaultLat],
            zoom: this.defaultZoom,
            // navigation: {
            //     mouseWheelZoomEnabled: scrollWheel
            // }
        });
        if (initObj.disableMouseWheel) {
            this.mapView.on('mouse-wheel', function (event) {
                // prevents zooming with the mouse-wheel event
                event.stopPropagation();
            });
        }
        if (initObj.style === 0) {
            if (coordinates && this.checkGeoJson(coordinates)) {
                // TO DO : draw asset/add feature by geo json
            }
        }
        else if (initObj.style === 1) { // sc-address-map
        }
        else if (initObj.style === 2) {
            if (coordinates && this.checkGeoJson(coordinates)) {
                // TO DO : draw asset/add feature by geo json
            }
        }
        else if (initObj.style === 3) {
            this.addressImageAnchor = initObj.addressImageAnchor;
            this.primaryImageAnchor = initObj.primaryImageAnchor;
            this.secondaryImageAnchor = initObj.secondaryImageAnchor;
            if (coordinates && this.checkGeoJson(coordinates)) {
                // TO DO : draw asset/add feature by geo json
            }
        }
        this.createLayers(initObj);
        // TO DO
        // let mZoom = (this.type == 1 ? 12 : 19);//13885 && 13924-2
        // this.view = this.setView(lon, lat, zoom, this.EPSG, initObj.minResolution, initObj.maxResolution, mZoom);//
        if (coordinates) {
            this.clampZoomFloor();
        }
        // TO DO
        // let controls = (initObj.controls) ? initObj.controls : [];
        // this.map = this.initializeMap(initObj.configService, controls, initObj.target, this.view
        //     , initObj.interactions, initObj.disableMouseWheel, null , this.tileLayers);
        for (let i = 0; i < this.layerAssets.length; i++) {
            this.map.add(this.layerAssets[i].graphicLayer, i);
        }
        const fullscreen = new this.lib.Fullscreen({
            view: this.mapView
        });
        this.mapView.ui.add(fullscreen, 'top-right');
        // detect fullscreen mode
        this.lib.watchUtils.watch(fullscreen.viewModel, 'state', (value) => {
            let isFullScreen = false;
            if (value === 'ready') {
                initObj.target.style.width = '100%';
                initObj.target.style.height = '100%';
            }
            else if (value === 'active') {
                isFullScreen = true;
            }
            if (!this.isBottom) {
                this.elementCtrl.style.top = ((initObj.target.offsetHeight - 45) / 2 - (this.customControlHeight / 2)) + 'px';
            }
            if (this.fullScreenEvent != null && typeof this.fullScreenEvent === 'function') {
                this.fullScreenEvent(this.mapDiv.offsetHeight, isFullScreen);
            }
        });
        // //test test zoom in/out button when clicking
        // this.mapView.watch('zoom', function(newValue) {
        this.lib.watchUtils.watch(this.mapView, 'zoom', (newValue) => {
            if (this.divZoomIn) {
                this.divZoomIn.title = 'Zoom In (' + newValue + ')';
            }
            if (this.divZoomOut) {
                this.divZoomOut.title = 'Zoom Out (' + newValue + ')';
            }
            for (let i = 1; i < this.layerAssets.length; i++) {
                if (this.isHeatLayer(i) || !this.layerAssets[i].layerQuery || !this.layerAssets[i].layerQuery.labelDisplayZoom) {
                    continue;
                } // heat map and not effect by labelDisplayZoom
                const labelDisplayZoom = this.layerAssets[i].layerQuery.labelDisplayZoom;
                if (labelDisplayZoom > newValue) {
                    this.layerAssets[i].graphicLayer.graphics.forEach((feature) => {
                        if (feature.attributes && feature.attributes.lb) {
                            feature.attributes.lb.symbol.text = '';
                        }
                    });
                }
                else {
                    this.layerAssets[i].graphicLayer.graphics.forEach((feature) => {
                        if (feature.attributes && feature.attributes.lb) {
                            feature.attributes.lb.symbol.text = feature.attributes.label.labelText;
                        }
                    });
                }
            }
            if (this.type === 1) {
                this.showHeatLayer(newValue);
            }
        });
        this.mapView.ui.move('zoom', 'bottom-right');
        this.mapView.when(function () {
            // This function will execute once the promise is resolved
            console.log('view loaded successfully');
            if (this.setupTooltipUI && (typeof this.setupTooltipUI === 'function')) {
                this.setupTooltipUI();
                this.setupTooltipUI = null; // call one time when init map
            }
            if (this.type === 0) { // sc-boundary
                const pointSymbol = {
                    type: 'simple-marker',
                    style: 'circle',
                    color: this.color,
                    size: '16px',
                    outline: {
                        color: this.color,
                        width: 1
                    }
                };
                const polylineSymbol = {
                    type: 'simple-line',
                    color: this.color,
                    width: '4',
                    style: 'solid',
                    outline: {
                        color: this.color,
                        width: 1
                    }
                };
                const polygonSymbol = {
                    type: 'simple-fill',
                    color: this.color,
                    style: 'solid',
                    outline: {
                        color: this.color,
                        width: 1
                    }
                };
                // create a new sketch view model
                this.layerAssets[0].graphicLayer.id = 'tempGraphics';
                this.sketchViewModel = new this.lib.SketchViewModel({
                    view: this.mapView,
                    layer: this.layerAssets[0].graphicLayer,
                    updateOnGraphicClick: false,
                    pointSymbol,
                    polylineSymbol,
                    polygonSymbol
                });
                this.finalColor = this.color;
                this.tempColor = 'blue';
                this.setSketchColor(this.tempColor, this.finalColor);
                if (coordinates && coordinates.features) { // initObj.formatGeoJSON
                    let fullExtent = null;
                    try {
                        for (let i = 0; i < coordinates.features.length; i++) {
                            const json = coordinates.features[i];
                            const type = json.geometry.type;
                            let idx = i + '';
                            let extent = null;
                            if (type === 'Point') {
                                let g1 = this.createPointNormal(json.geometry.coordinates[0], json.geometry.coordinates[1], pointSymbol);
                                g1 = this.sketchItemSetAttribute(g1, 'single', this.color, 'blue', idx);
                                this.sketchViewModel.layer.add(g1);
                                this.drawingShapeSingle.push(g1);
                                extent = new this.lib.Extent({
                                    xmin: g1.geometry.x, ymin: g1.geometry.y,
                                    xmax: g1.geometry.x, ymax: g1.geometry.y
                                });
                                if (extent) {
                                    if (!fullExtent) {
                                        fullExtent = extent.clone();
                                    }
                                    else {
                                        fullExtent.union(extent);
                                    }
                                }
                            }
                            else if (type === 'LineString') {
                                let g2 = this.createLineNormal(json.geometry.coordinates, polylineSymbol);
                                g2.geometry = this.lib.webMercatorUtils.geographicToWebMercator(g2.geometry);
                                g2 = this.sketchItemSetAttribute(g2, 'single', this.color, 'blue', idx);
                                this.sketchViewModel.layer.add(g2);
                                this.drawingShapeSingle.push(g2);
                                extent = g2.geometry.extent;
                                if (extent) {
                                    if (!fullExtent) {
                                        fullExtent = extent.clone();
                                    }
                                    else {
                                        fullExtent.union(extent);
                                    }
                                }
                            }
                            else if (type === 'Polygon') {
                                let g3 = this.createPolygonNormal(json.geometry.coordinates, polygonSymbol);
                                g3.geometry = this.lib.webMercatorUtils.geographicToWebMercator(g3.geometry);
                                g3 = this.sketchItemSetAttribute(g3, 'single', this.color, 'blue', idx);
                                this.sketchViewModel.layer.add(g3);
                                this.drawingShapeSingle.push(g3);
                                extent = g3.geometry.extent;
                                if (extent) {
                                    if (!fullExtent) {
                                        fullExtent = extent.clone();
                                    }
                                    else {
                                        fullExtent.union(extent);
                                    }
                                }
                            }
                            else if (type === 'MultiPoint') {
                                for (let j1 = 0; j1 < json.geometry.coordinates.length; j1++) {
                                    idx = idx + j1;
                                    const coor = json.geometry.coordinates[j1];
                                    let g4 = this.createPointNormal(coor[0], coor[1], pointSymbol);
                                    g4.symbol.color = this.multiColor;
                                    g4.symbol.outline.color = this.multiColor;
                                    g4 = this.sketchItemSetAttribute(g4, 'multi', this.multiColor, 'green', idx);
                                    this.sketchViewModel.layer.add(g4);
                                    this.drawingShapeMulti.point.push(g4);
                                    extent = new this.lib.Extent({
                                        xmin: g4.geometry.x, ymin: g4.geometry.y,
                                        xmax: g4.geometry.x, ymax: g4.geometry.y
                                    });
                                    if (extent) {
                                        if (!fullExtent) {
                                            fullExtent = extent.clone();
                                        }
                                        else {
                                            fullExtent.union(extent);
                                        }
                                    }
                                }
                            }
                            else if (type === 'MultiLineString') {
                                for (let j2 = 0; j2 < json.geometry.coordinates.length; j2++) {
                                    idx = idx + j2;
                                    const coor = json.geometry.coordinates[j2];
                                    let g5 = this.createLineNormal(coor, polylineSymbol);
                                    g5.geometry = this.lib.webMercatorUtils.geographicToWebMercator(g5.geometry);
                                    g5.symbol.color = this.multiColor;
                                    g5.symbol.outline.color = this.multiColor;
                                    g5 = this.sketchItemSetAttribute(g5, 'multi', this.multiColor, 'green', idx);
                                    this.sketchViewModel.layer.add(g5);
                                    this.drawingShapeMulti.line.push(g5);
                                    extent = g5.geometry.extent;
                                    if (extent) {
                                        if (!fullExtent) {
                                            fullExtent = extent.clone();
                                        }
                                        else {
                                            fullExtent.union(extent);
                                        }
                                    }
                                }
                            }
                            else if (type === 'MultiPolygon') {
                                for (let j = 0; j < json.geometry.coordinates.length; j++) {
                                    idx = idx + j;
                                    const coor = json.geometry.coordinates[j];
                                    let g = this.createPolygonNormal(coor, polygonSymbol);
                                    g.geometry = this.lib.webMercatorUtils.geographicToWebMercator(g.geometry);
                                    g.symbol.color = this.multiColor;
                                    g.symbol.outline.color = this.multiColor;
                                    g = this.sketchItemSetAttribute(g, 'multi', this.multiColor, 'green', idx);
                                    this.sketchViewModel.layer.add(g);
                                    this.drawingShapeMulti.polygon.push(g);
                                    extent = g.geometry.extent;
                                    if (extent) {
                                        if (!fullExtent) {
                                            fullExtent = extent.clone();
                                        }
                                        else {
                                            fullExtent.union(extent);
                                        }
                                    }
                                }
                            }
                        }
                        if (fullExtent) {
                            fullExtent.spatialReference = this.mapView.spatialReference;
                            this.mapView.goTo(fullExtent);
                        }
                    }
                    catch (err) {
                        console.log(err);
                    }
                }
                // Listen to create-complete event to add a newly created graphic to view
                this.sketchViewModel.on('create', (event) => {
                    if (event.state === 'complete') {
                        // console.log('create');
                        const idx = (new Date()).toISOString();
                        event.graphic = this.sketchItemSetAttribute(event.graphic, this.drawingMode, this.finalColor, this.tempColor, idx);
                        // console.log(event);
                        if (this.drawingMode === 'single') {
                            this.drawingShapeSingle.push(event.graphic);
                        }
                        else {
                            const geomType = event.graphic.geometry.type;
                            if (geomType === 'point') {
                                this.drawingShapeMulti.point.push(event.graphic);
                            }
                            else if (geomType === 'polyline') {
                                this.drawingShapeMulti.line.push(event.graphic);
                                // console.log('polyline, coords = ' + event.graphic.geometry.paths);
                            }
                            else if (geomType === 'polygon') {
                                this.drawingShapeMulti.polygon.push(event.graphic);
                                // console.log('polyline, coords = ' + event.graphic.geometry.rings);
                            }
                        }
                        if (this.drawBtn) {
                            this.drawBtn.click();
                            setTimeout(() => {
                                this.drawBtn.click();
                            }, 100);
                        }
                        if (this.setDirtyFunction && typeof this.setDirtyFunction === 'function') {
                            this.setDirtyFunction();
                        }
                    }
                });
                // Listen the sketchViewModel's update-complete and update-cancel events
                this.sketchViewModel.on('update', (event) => {
                    if (this.actionType === 'select') {
                        // console.log(event);
                        // console.log('this.sketchViewModel.updateGraphics.length = ' + this.sketchViewModel.updateGraphics.length);
                        if (this.sketchViewModel.updateGraphics.length !== 1 || event.tool == null) {
                            this.sketchViewModel.complete();
                            // this.sketchViewModel.cancel();
                            this.editGraphic = null;
                            // console.log('%c ***** CANCEL EDIT', 'color:blue');
                            return;
                        }
                        if (event.state === 'complete' || event.state === 'cancel') {
                            this.editGraphic = null;
                            // console.log('%c |===> set this.editGraphic = null here', 'color:blue');
                        }
                        if ((event.state === 'start' || event.state === 'complete' || event.state === 'cancel')
                            && this.setDirtyFunction && typeof this.setDirtyFunction === 'function') {
                            this.setDirtyFunction();
                        }
                        return;
                    }
                    else {
                        console.log('invalid action for sc-boundary');
                    }
                });
            }
            this.mapLoaded = true;
            const findBtnZoom = setInterval(() => {
                this.divZoomIn = document.querySelector('[title="Zoom in"]');
                // console.log('findBtnZoom, this.divZoomIn = ' + this.divZoomIn);
                if (this.divZoomIn) {
                    clearInterval(findBtnZoom);
                    this.divZoomIn.title = 'Zoom In (' + this.mapView.zoom + ')';
                    this.divZoomOut = document.querySelector('[title="Zoom out"]');
                    this.divZoomOut.title = 'Zoom Out (' + this.mapView.zoom + ')';
                }
            }, 200);
            // if map have custom control then add custom control to map
            if (this.ActionControls.length > 0) {
                const height = 32;
                const width = 32; // default button of arc is 32 x 32 px
                this.divCustomControl = document.createElement('DIV');
                this.divCustomControl.id = 'customControl';
                this.customControlHeight = 0;
                this.isBottom = false;
                if (this.type === 0 && this.heightNum < 3 || (this.type === 3 && this.heightNum === 1)) { // sc-boundary
                    this.isBottom = true;
                }
                for (let i = 0; i < this.ActionControls.length; i++) {
                    for (let j = 0; j < this.ActionControls[i].childNodes.length; j++) {
                        for (let k = 0; k < this.ActionControls[i].childNodes[j].childNodes.length; k++) {
                            this.ActionControls[i].childNodes[j].childNodes[k].style.width = width + 'px';
                            this.ActionControls[i].childNodes[j].childNodes[k].style.height = height + 'px';
                        }
                        this.customControlHeight += this.ActionControls[i].childNodes[j].childNodes.length * height;
                        if (this.isBottom) {
                            this.ActionControls[i].childNodes[j].style.display = 'flex';
                        }
                        else {
                            this.ActionControls[i].childNodes[j].style.display = 'grid';
                        }
                        this.divCustomControl.appendChild(this.ActionControls[i].childNodes[j]);
                    }
                }
                initObj.target.appendChild(this.divCustomControl);
                // this.customControlHeight /= 2;
                // console.log('%c this.customControlHeight = ' + this.customControlHeight, 'color:blue');
                this.elementCtrl.classList.add('gis-custom-control'); // must define this class in css of each component
                if (this.isBottom) {
                    const css = {
                        // position: 'relative',
                        'z-index': 1000,
                        // , left: '10px'
                        width: this.elementCtrl.offsetWidth + 'px'
                        // , height: height + 'px'
                        // , bottom: '35px'
                        // , display: 'flex'
                    };
                    Object.assign(this.divCustomControl.style, css);
                    this.mapView.ui.add(this.divCustomControl, 'bottom-left');
                }
                else {
                    const css = {
                        // position: 'absolute',
                        'z-index': 1000,
                        // , left: '10px'
                        height: this.elementCtrl.offsetHeight + 'px'
                        // , width: width + 'px'
                        // , top: (this.mapView.height - 45 - this.customControlHeight / 2) + 'px'
                        // , display: 'grid'
                    };
                    Object.assign(this.divCustomControl.style, css);
                    this.mapView.ui.add(this.divCustomControl, 'top-left');
                    this.elementCtrl.style.top = ((this.mapView.height - 45) / 2 - (this.customControlHeight / 2)) + 'px';
                }
            }
            if (this.fitCoors) {
                this.fitCoordsAction();
                if (this.type === 2 && this.marker) {
                    //     this.mapView.center = [this.marker.geometry.longitude, this.marker.geometry.latitude];
                    //     this.mapView.zoom = 18;
                    this.clampZoomFloor();
                }
            }
            //
            if (this.setupMapDone && typeof this.setupMapDone === 'function') {
                this.setupMapDone();
            }
            // if(this.onTilesLoaded && typeof this.onTilesLoaded === 'function'){
            //     this.onTilesLoaded();
            // }
            this.isMapReady = true;
        }.bind(this)).catch(function (err) {
            console.log(err);
        });
    }
    createPointNormal(lon, lat, symbol) {
        const g = new this.lib.Graphic({
            geometry: {
                type: 'point',
                longitude: lon,
                latitude: lat,
                spatialReference: this.mapView.spatialReference
            },
            symbol: symbol
        });
        return g;
    }
    createLineNormal(coords, symbol) {
        const g = new this.lib.Graphic({
            geometry: {
                type: 'polyline',
                paths: coords,
                spatialReference: this.mapView.spatialReference
            },
            symbol: symbol
        });
        return g;
    }
    createPolygonNormal(coords, symbol) {
        const g = new this.lib.Graphic({
            geometry: {
                type: 'polygon',
                rings: coords,
                spatialReference: this.mapView.spatialReference
            },
            symbol: symbol
        });
        return g;
    }
    sketchItemSetAttribute(graphic, realType, finalColor, tempColor, idx) {
        graphic.attributes = {
            finalColor: finalColor,
            tempColor: tempColor,
            realType: realType,
            idx: idx
        };
        return graphic;
    }
    showHeatLayer(zoom) {
        // if we have heat map and zoomLevel
        for (const f in this.heatLayerConfig) {
            if (this.heatLayerConfig[f].zoomLevel) {
                if (zoom < this.heatLayerConfig[f].zoomLevel) {
                    this.layerAssets[f].graphicLayer.visible = false;
                }
                else {
                    this.layerAssets[f].graphicLayer.visible = true;
                }
            }
        }
    }
    checkIsFullScreenSupport() {
        const body = document.body;
        return !!(body.webkitRequestFullscreen ||
            (body.mozRequestFullScreen) ||
            (body.msRequestFullscreen) ||
            (body.requestFullscreen));
    }
    mapMoveEnd(moveEndFunc) {
        // detect when map is moved
        this.lib.watchUtils.whenTrue(this.mapView, 'stationary', () => {
            // Get the new extent of view/map whenever map is updated.
            if (this.mapView.extent) {
                const debugleftTop = this.lib.webMercatorUtils.xyToLngLat(this.mapView.extent.xmin, this.mapView.extent.ymin);
                const debugrightBottom = this.lib.webMercatorUtils.xyToLngLat(this.mapView.extent.xmax, this.mapView.extent.ymax);
                console.log('%c MAP IS MOVED, min = ' + debugleftTop + ', max = '
                    + debugrightBottom, 'color:blue');
                if (this.fitCoors && this.fitCoors.length > 0) {
                    this.fitCoors = null; // reset
                    let currentZoom = this.mapView.zoom;
                    if (this.type === 3) { // sc-selected-asset
                        if (this.fitCoordCount === 1) {
                            currentZoom = currentZoom - 2;
                            if (currentZoom < 0) {
                                currentZoom = 1;
                            }
                            this.mapView.zoom = currentZoom;
                        }
                    }
                    else if (this.type === 1) { // sc-address-map
                        if (this.initialZoomChange && this.initialZoomChange !== 0) {
                            currentZoom += this.initialZoomChange;
                            this.mapView.zoom = currentZoom;
                        }
                    }
                    if (this.mapView.zoom < 0) {
                        this.mapView.zoom = 1;
                    }
                    console.log('%c after FIT, zoom = ' + this.mapView.zoom, 'color:blue');
                    this.clampZoomFloor();
                    console.log('%c |===> after clampZoomFloor, zoom = ' + this.mapView.zoom, 'color:blue');
                }
                if (moveEndFunc && typeof moveEndFunc === 'function') {
                    moveEndFunc();
                }
            }
        });
        // this.mapView.on("pointer-up", function(evt){
        //     if(moveEndFunc && typeof moveEndFunc === 'function'){
        //         moveEndFunc();
        //     }
        // });
    }
    createTextStyle(label, color, type) {
        // TO DO
    }
    getAnchor(icon, anchor) {
        if ((icon === sclMapConstant.MAP_MARKER || icon === sclMapConstant.MAP_PRIMARY_ASSET
            || icon === sclMapConstant.MAP_SECONDARY_ASSET) && anchor == null) {
            anchor = [0.5, 1.0]; // system defined Images
        }
        if (anchor == null) {
            anchor = [0.5, 0.5];
        } // no image anchor & is override image
        return anchor;
    }
    // copy from sclStyleUtil
    getPointStyle(color, icon, imageAnchor, geom, label, t) {
        // TO DO
    }
    getMultiPointStyle(properties) {
        // TO DO
    }
    getLineStyle(pColor, properties, geom, t) {
        // TO DO
    }
    lableStyle(geom, label, color, t) {
        // TO DO
    }
    colorWithAlpha(color, alpha) {
        // TO DO
    }
    addStyleControlButton(btn) {
        btn.onmouseover = function () {
            if (btn.style.backgroundColor === 'grey') {
                return;
            }
            btn.style.backgroundColor = 'lightgrey';
        };
        btn.onmouseout = function () {
            if (btn.style.backgroundColor === 'grey') {
                return;
            }
            btn.style.backgroundColor = 'white';
        };
    }
    initializeMap(ConfigService, controls, target, view, interactions, disableMouseWheel, mapLayers, multiLayers) {
        // TO DO
    }
    addInteractionSnap() {
        // TO DO
    }
    removeInteractionSnap() {
        // TO DO
    }
    drawDefaultStyle(drawStart, drawEnd) {
        // TO DO
    }
    drawPrimaryStyle(drawStart, drawEnd) {
        // TO DO
    }
    drawCustomStyle(drawStart, drawEnd) {
        // TO DO
    }
    addInteractionDraw(drawStart, drawEnd) {
        if (drawStart && drawEnd) {
            this.interactionDraw = this.mapView.on('click', (event) => {
                this.mapView.hitTest(event.screenPoint).then((response) => {
                    const features = [];
                    const graphics = response.results;
                    graphics.forEach((graphic) => {
                        const att = graphic.graphic.attributes;
                        if (att && att.isAsset && !att.layerDisplayOnly) {
                            features.push(graphic.graphic);
                        }
                    });
                    const mp = this.lib.webMercatorUtils.webMercatorToGeographic(event.mapPoint);
                    const obj = { event, clickFeature: features, latLng: { lat: mp.y, lng: mp.x } };
                    drawStart(obj);
                    drawEnd(obj);
                });
            });
        }
    }
    removeInteractionDraw() {
        if (this.interactionDraw) {
            this.interactionDraw.remove();
        }
    }
    // use for sc-address-map
    setLayerSelectAsset(event) {
        const style = this.layerAssets[this.layerIndexUser].style;
        this.mapView.hitTest(event.screenPoint).then((response) => {
            let fs = [];
            if (this.multipleSelection) {
                const graphics = response.results;
                graphics.forEach((graphic) => {
                    const att = graphic.graphic.attributes;
                    if (att && att.isAsset && !att.layerDisplayOnly) {
                        fs.push(graphic.graphic);
                    }
                });
                fs = this.getFeaturesCollection({ feature: fs });
                if (fs.length > 0) {
                    let isDirty = false;
                    let lstAdd = [];
                    let isRemove = false;
                    for (let i = 0; i < fs.length; i++) {
                        const f = fs[i].feature;
                        const fId = this.getFeatureId(f);
                        let added = false;
                        let lb;
                        for (let k = this.selectedFeatures.length - 1; k > -1; k--) {
                            const kId = this.getFeatureId(this.selectedFeatures[k]);
                            if (kId === fId) {
                                added = true;
                                if (f.attributes.zIndex === this.layerIndexUser) {
                                    isRemove = true;
                                    this.selectedFeatures.splice(k, 1);
                                    if (f.attributes.lb) {
                                        lb = f.attributes.lb;
                                    }
                                    this.layerAssets[this.layerIndexUser].graphicLayer.graphics.remove(f);
                                }
                                // break;
                            }
                        }
                        if (added) {
                            lstAdd = []; // quit this forEach ignore add feature logic then call setDirtyFunction
                        }
                        else {
                            lstAdd.push(f);
                        }
                    }
                    if (isRemove) {
                        isDirty = true;
                        lstAdd = []; // quit this forEach ignore add feature logic then call setDirtyFunction
                    }
                    lstAdd.forEach((f, j) => {
                        const g = f.clone();
                        g.attributes.zIndex = this.layerIndexUser;
                        if (g.attributes.type === 'Point' || g.attributes.type === 'MultiPoint') {
                            if (style.imageFileNo) {
                                g.symbol.url = style.imageFileNo;
                            }
                        }
                        if (g.attributes.lb) {
                            delete g.attributes.lb;
                        }
                        this.selectedFeatures.push(g);
                        this.addFeature(g, this.layerIndexUser);
                        isDirty = true;
                    });
                    if (isDirty && this.setDirtyFunction) {
                        this.setDirtyFunction(this.selectedFeatures);
                    }
                }
            }
            else {
                if (this.funcSingleSelectMode) {
                    const graphics = response.results;
                    graphics.forEach((graphic) => {
                        const att = graphic.graphic.attributes;
                        if (att && att.isAsset) {
                            fs.push(graphic.graphic);
                        }
                    });
                    let fea;
                    if (fs.length > 0) {
                        fea = fs[0];
                    }
                    this.funcSingleSelectMode({ fea });
                }
            }
        });
    }
    setSketchColor(sketchColor, graphicColor) {
        this.sketchViewModel.activeFillSymbol.color = sketchColor;
        this.sketchViewModel.activePointSymbol.color = sketchColor;
        this.sketchViewModel.activeLineSymbol.color = sketchColor;
        this.sketchViewModel.updatePolygonSymbol.color = sketchColor;
        this.sketchViewModel.updatePolylineSymbol.color = sketchColor;
        this.sketchViewModel.updatePointSymbol.color = sketchColor;
        this.sketchViewModel.activeVertexSymbol.color = sketchColor;
        this.sketchViewModel.pointSymbol.color = graphicColor;
        this.sketchViewModel.pointSymbol.outline.color = graphicColor;
        this.sketchViewModel.polylineSymbol.color = graphicColor;
        this.sketchViewModel.polylineSymbol.outline.color = graphicColor;
        this.sketchViewModel.polygonSymbol.color = graphicColor;
        this.sketchViewModel.polygonSymbol.outline.color = graphicColor;
    }
    // use for sc-boundary
    drawActionClickMap(event) {
        this.mapView.hitTest(event).then((response) => {
            const graphics = response.results;
            if (graphics && graphics.length > 0) {
                let isDelete = false;
                for (let i = 0; i < graphics.length; i++) {
                    const g = graphics[i];
                    if (!this.editGraphic && g && g.graphic && g.graphic.layer.id === 'tempGraphics' && this.actionType === 'select') {
                        this.editGraphic = g.graphic;
                        this.sketchViewModel.layer.add(this.editGraphic);
                        const finalColor = this.editGraphic.attributes.finalColor;
                        const tempColor = this.editGraphic.attributes.tempColor;
                        this.sketchViewModel.complete();
                        this.sketchViewModel.update([this.editGraphic], {
                            tool: 'reshape',
                            toggleToolOnClick: true,
                        });
                        this.setSketchColor(tempColor, finalColor);
                        break;
                    }
                    if (g.graphic.layer.id !== 'tempGraphics') {
                        this.sketchViewModel.complete();
                    }
                    if (this.actionType === 'delete') {
                        if (g && g.graphic && g.graphic.attributes) {
                            const idx = g.graphic.attributes.idx;
                            if (g.graphic.attributes.realType === 'single') {
                                for (let i1 = 0; i1 < this.drawingShapeSingle.length; i1++) {
                                    const item = this.drawingShapeSingle[i1];
                                    if (item.attributes && item.attributes.idx === idx) {
                                        this.drawingShapeSingle.splice(i1, 1);
                                        break;
                                    }
                                }
                            }
                            else {
                                if (g.graphic.geometry.type === 'point') {
                                    for (let i2 = 0; i2 < this.drawingShapeMulti.point.length; i2++) {
                                        const item = this.drawingShapeMulti.point[i2];
                                        if (item.attributes && item.attributes.idx === idx) {
                                            this.drawingShapeMulti.point.splice(i2, 1);
                                            break;
                                        }
                                    }
                                }
                                else if (g.graphic.geometry.type === 'polyline') {
                                    for (let i3 = 0; i3 < this.drawingShapeMulti.line.length; i3++) {
                                        const item = this.drawingShapeMulti.line[i3];
                                        if (item.attributes && item.attributes.idx === idx) {
                                            this.drawingShapeMulti.line.splice(i3, 1);
                                            break;
                                        }
                                    }
                                }
                                else if (g.graphic.geometry.type === 'polygon') {
                                    for (let i4 = 0; i4 < this.drawingShapeMulti.polygon.length; i4++) {
                                        const item = this.drawingShapeMulti.polygon[i4];
                                        if (item.attributes && item.attributes.idx === idx) {
                                            this.drawingShapeMulti.polygon.splice(i4, 1);
                                            break;
                                        }
                                    }
                                }
                            }
                            this.sketchViewModel.layer.remove(g.graphic);
                            isDelete = true;
                        }
                        else {
                            console.log('error, this graphic is invalid');
                        }
                    }
                }
                if (isDelete && this.setDirtyFunction && typeof this.setDirtyFunction === 'function') {
                    this.setDirtyFunction();
                }
            }
        });
    }
    addInteraction() {
        // TO DO
    }
    btnAddEvent(btn) {
        // TO DO
    }
    deselectAllControlBtn(currentBtnId) {
        if (this.sketchViewModel) {
            this.sketchViewModel.cancel();
        }
        for (let i = 0; i < this.controlBtns.length; i++) {
            if (this.controlBtns[i].id === currentBtnId) {
                continue;
            }
            this.controlBtns[i].style.backgroundColor = 'white';
        }
    }
    modeAction(e) {
        if (this.drawingMode === 'single') {
            if (e && e.currentTarget && e.currentTarget.title) {
                e.currentTarget.title = 'Multi mode';
            }
            this.drawingMode = 'multi';
            this.modeLabel.innerHTML = 'layers';
            this.tempColor = 'green';
            this.finalColor = this.multiColor;
        }
        else {
            if (e && e.currentTarget && e.currentTarget.title) {
                e.currentTarget.title = 'Single mode';
            }
            this.drawingMode = 'single';
            this.modeLabel.innerHTML = 'layers_clear';
            this.tempColor = 'blue';
            this.finalColor = this.color;
        }
        this.actionType = 'mode';
        this.setSketchColor(this.tempColor, this.finalColor);
        this.deselectAllControlBtn(e.currentTarget.id);
    }
    selectAction(e) {
        this.deselectAllControlBtn(e.currentTarget.id);
        if (e.currentTarget.style.backgroundColor === 'grey') {
            e.currentTarget.style.backgroundColor = 'white';
            this.actionType = '';
        }
        else {
            e.currentTarget.style.backgroundColor = 'grey';
            this.actionType = 'select';
        }
    }
    pointAction(e) {
        this.deselectAllControlBtn(e.currentTarget.id);
        this.drawBtn = e.currentTarget;
        if (e.currentTarget.style.backgroundColor === 'grey') {
            e.currentTarget.style.backgroundColor = 'white';
            this.actionType = '';
            this.sketchViewModel.cancel();
        }
        else {
            e.currentTarget.style.backgroundColor = 'grey';
            this.actionType = 'drawPoint';
            this.sketchViewModel.create('point');
        }
    }
    polygonAction(e) {
        this.drawBtn = e.currentTarget;
        this.deselectAllControlBtn(e.currentTarget.id);
        if (e.currentTarget.style.backgroundColor === 'grey') {
            e.currentTarget.style.backgroundColor = 'white';
            this.actionType = '';
            this.sketchViewModel.cancel();
        }
        else {
            e.currentTarget.style.backgroundColor = 'grey';
            this.actionType = 'drawPolygon';
            this.sketchViewModel.create('polygon');
        }
    }
    lineAction(e) {
        this.drawBtn = e.currentTarget;
        this.deselectAllControlBtn(e.currentTarget.id);
        if (e.currentTarget.style.backgroundColor === 'grey') {
            e.currentTarget.style.backgroundColor = 'white';
            this.actionType = '';
            this.sketchViewModel.cancel();
        }
        else {
            e.currentTarget.style.backgroundColor = 'grey';
            this.actionType = 'drawLine';
            this.sketchViewModel.create('polyline');
        }
    }
    deleteAction(e) {
        this.deselectAllControlBtn(e.currentTarget.id);
        if (e.currentTarget.style.backgroundColor === 'grey') {
            e.currentTarget.style.backgroundColor = 'white';
            this.actionType = '';
        }
        else {
            this.actionType = 'delete';
            e.currentTarget.style.backgroundColor = 'grey';
        }
        if (this.setDirtyFunction) {
            this.setDirtyFunction();
        }
    }
    locationAction(e) {
        this.deselectAllControlBtn(e.currentTarget.id);
        if (e.currentTarget.style.backgroundColor === 'grey') {
            e.currentTarget.style.backgroundColor = 'white';
            this.actionType = '';
        }
        else {
            this.actionType = 'location';
            e.currentTarget.style.backgroundColor = 'grey';
        }
    }
    getLocation() {
        // NOTE : no need here, will move to component ifself
        // if(scope.disabled) return;
        // scope.isVisible = "true";
        // if (navigator.geolocation) {
        //     navigator.geolocation.getCurrentPosition(scope.showPosition);
        // } else {
        //     scope.error = "Geolocation is not supported by this browser.";
        // }
    }
    // clone from sclMapViews.addRadioButton and have modify
    addRadioButton(document, element, layers, compId) {
        // TO DO
    }
    addMapViewControl(element, mapViewLayers, compId, layerIds) {
        // TO DO
    }
    // call this function for draw on map
    addControlDraw(compId, pOptions, cb) {
        const layerIds = [];
        const element = document.createElement('div'); // div wrapper
        // TO DO
        // if(pOptions != null){
        //     self.addMapViewControl(element, pOptions.mapViewLayers, compId, layerIds);
        // }
        // add button mode
        let btnId = compId + 'Mode';
        this.modeLabel = document.createElement('i');
        this.modeLabel.setAttribute('class', 'material-icons');
        this.modeLabel.innerHTML = (this.drawingMode === 'single' ? 'layers_clear' : 'layers');
        const modeBtn = sclMapViews.createUIButton(document, this.modeAction.bind(this), 'ol-has-tooltip', (this.drawingMode === 'single' ? 'Single mode' : 'Multi mode'), null);
        modeBtn.appendChild(this.modeLabel);
        modeBtn.id = btnId;
        layerIds.push(modeBtn.id);
        // add button select
        btnId = compId + 'Select';
        const selectBtn = sclMapViews.createUIButton(document, this.selectAction.bind(this), 'ol-has-tooltip', 'Select', null);
        let iSpan = document.createElement('i');
        iSpan.setAttribute('class', 'material-icons');
        iSpan.innerHTML = 'create';
        selectBtn.appendChild(iSpan);
        selectBtn.id = btnId;
        layerIds.push(selectBtn.id);
        // add button point
        btnId = compId + 'Point';
        const pointBtn = sclMapViews.createUIButton(document, this.pointAction.bind(this), 'ol-has-tooltip', 'Point', null);
        iSpan = document.createElement('i');
        iSpan.setAttribute('class', 'material-icons');
        iSpan.innerHTML = 'pin_drop';
        pointBtn.appendChild(iSpan);
        pointBtn.id = btnId;
        layerIds.push(pointBtn.id);
        // add button line
        btnId = compId + 'Line';
        const lineBtn = sclMapViews.createUIButton(document, this.lineAction.bind(this), 'ol-has-tooltip', 'Line', null);
        iSpan = document.createElement('i');
        iSpan.setAttribute('class', 'material-icons');
        iSpan.innerHTML = 'linear_scale';
        lineBtn.appendChild(iSpan);
        lineBtn.id = btnId;
        layerIds.push(lineBtn.id);
        // add button polygon
        btnId = compId + 'Polygon';
        const polygonBtn = sclMapViews.createUIButton(document, this.polygonAction.bind(this), 'ol-has-tooltip', 'Polygon', null);
        iSpan = document.createElement('i');
        iSpan.setAttribute('class', 'material-icons');
        iSpan.innerHTML = 'turned_in_not';
        polygonBtn.appendChild(iSpan);
        polygonBtn.id = btnId;
        layerIds.push(polygonBtn.id);
        // add button location
        btnId = compId + 'CurrentLocation';
        const locationBtn = sclMapViews.createUIButton(document, this.locationAction.bind(this), 'ol-has-tooltip', 'Current Location', null);
        iSpan = document.createElement('i');
        iSpan.setAttribute('class', 'material-icons');
        iSpan.innerHTML = 'my_location';
        locationBtn.appendChild(iSpan);
        locationBtn.id = btnId;
        layerIds.push(locationBtn.id);
        // add button delete
        btnId = compId + 'Delete';
        const deleteBtn = sclMapViews.createUIButton(document, this.deleteAction.bind(this), 'ol-has-tooltip', 'Delete', null);
        iSpan = document.createElement('i');
        iSpan.setAttribute('class', 'material-icons');
        iSpan.innerHTML = 'delete';
        deleteBtn.appendChild(iSpan);
        deleteBtn.id = btnId;
        layerIds.push(deleteBtn.id);
        const elementCtrl = document.createElement('div');
        elementCtrl.className = 'select-action ol-control custom-control';
        elementCtrl.appendChild(modeBtn);
        elementCtrl.appendChild(selectBtn);
        elementCtrl.appendChild(pointBtn);
        elementCtrl.appendChild(lineBtn);
        elementCtrl.appendChild(polygonBtn);
        elementCtrl.appendChild(locationBtn);
        elementCtrl.appendChild(deleteBtn);
        this.elementCtrl = elementCtrl;
        this.controlBtns = [modeBtn, selectBtn, pointBtn, lineBtn, polygonBtn, locationBtn, deleteBtn];
        this.btnAddEvent(modeBtn);
        this.btnAddEvent(selectBtn);
        this.btnAddEvent(pointBtn);
        this.btnAddEvent(lineBtn);
        this.btnAddEvent(polygonBtn);
        this.btnAddEvent(locationBtn);
        this.btnAddEvent(deleteBtn);
        element.appendChild(elementCtrl);
        this.ActionControls.push(element);
        if (cb && typeof cb === 'function') {
            cb(layerIds);
        }
    }
    // test redraw layers
    testRedraw(e) {
        // TO DO
    }
    addTestBtn(element) {
        // TO DO
    }
    addControl(ActionControl, element, options) {
        this.ActionControls.push(element);
    }
    setupControl(ActionControl) {
        // TO DO
    }
    mapClickEvent(cb) {
        this.mapView.on('click', (evt) => {
            if (this.type === 0) { // sc-boundary
                this.drawActionClickMap(evt);
            }
            else if (this.type === 1) { // sc-address-map
                this.setLayerSelectAsset(evt);
            }
            else {
                evt.latLng = { lat: evt.mapPoint.latitude, lng: evt.mapPoint.longitude };
                if (cb && typeof cb === 'function') {
                    cb(evt);
                }
            }
        });
    }
    mapPointerMoveEvent(cb) {
        this.mapView.on('pointer-move', (event) => {
            this.mapView.hitTest(event).then((response) => {
                const lst = response.results.filter((result) => {
                    return (result.graphic.attributes && result.graphic.attributes.isAsset);
                });
                if (this.mouseHoverFeature) {
                    this.layerAssets[this.mouseHoverFeature.attributes.zIndex].graphicLayer.graphics.remove(this.mouseHoverFeature);
                    this.mouseHoverFeature = null; // reset
                }
                if (lst && lst.length > 0) {
                    try {
                        this.mouseHoverFeature = lst[0].graphic.clone();
                    }
                    catch (err) {
                        console.log('err = ' + err);
                    }
                }
                if (this.mouseHoverFeature) {
                    if (this.type === 3) { // selected-asset
                        let color = '#0099FF'; // default ol blue
                        if (this.compActionType === 'primary') {
                            color = 'limegreen';
                        }
                        else if (this.compActionType === 'secondary') {
                            color = 'black';
                        }
                        else {
                            if (this.toolTipOnFeatureHover && (typeof this.toolTipOnFeatureHover === 'function')) {
                                this.toolTipOnFeatureHover(this.mouseHoverFeature);
                            }
                        }
                        if (this.mouseHoverFeature.attributes.type !== 'Point') {
                            if (this.mouseHoverFeature.attributes.type === 'LineString'
                                || this.mouseHoverFeature.attributes.type === 'MultiLineString'
                                || this.mouseHoverFeature.attributes.type === 'Polyline') {
                                this.mouseHoverFeature.symbol.color = color;
                            }
                            else {
                                this.mouseHoverFeature.symbol.outline.color = color;
                                this.mouseHoverFeature.symbol.color = 'white';
                                this.mouseHoverFeature.symbol.color.a = 0.5;
                            }
                            this.layerAssets[this.mouseHoverFeature.attributes.zIndex].graphicLayer.graphics.add(this.mouseHoverFeature);
                        }
                    }
                    if (cb && typeof cb === 'function') {
                        cb({ fea: this.mouseHoverFeature, pixel: [event.x, event.y] });
                    }
                }
            });
        });
    }
    getPointFeature(location, image, name, id, relatedAsset, color, layerDisplayOnly, tooltip, anchor, type, layerName) {
        // TO DO
    }
    updateLocation(lat, lon, id, image, name, proId, isMapClick) {
        if (!isMapClick) {
            this.mapView.center = [lon, lat];
        }
        if (this.marker) {
            this.removeFeature(this.marker, this.layerIndexAddress);
        }
        if (!image) {
            image = sclMapConstant.MAP_MARKER;
        }
        if (image && image.charAt(0) !== '/') {
            image = '/' + image;
        }
        this.marker = this.createPoint(lon, lat, { id: proId, image, name });
        // this.source.addFeature(this.marker);//13835
        this.addFeature(this.marker, this.layerIndexAddress);
    }
    removeLocation(feature) {
        if (feature && this.layerAssets[this.layerIndexAddress] && this.layerAssets[this.layerIndexAddress].graphicLayer) {
            this.layerAssets[this.layerIndexAddress].graphicLayer.graphics.remove(feature);
        }
        this.marker = null;
    }
    zoomToLocation(lat, lon) {
        this.mapView.goTo({
            center: [lon, lat],
            zoom: 20
        });
    }
    zoomToValue(zoomValue) {
        // if (!zoomValue && this.defaultZoom ) { zoomValue = this.defaultZoom; } // 14707
        if (zoomValue) {
            this.mapView.goTo({
                zoom: zoomValue
            });
        }
    }
    // 14781
    centerDefault() {
        this.mapView.goTo({
            center: [this.defaultLon, this.defaultLat],
            zoom: 18
        });
    }
    // 14781
    fitLayersOLD(layersIndexFit, hasDefaultCoord) {
        let fullExtent = null;
        let count = 0;
        if (hasDefaultCoord) {
            const geometry = {
                type: 'point',
                longitude: this.defaultLon,
                latitude: this.defaultLat
            };
            const extent = this.createExtentForPoint(geometry);
            fullExtent = extent.clone();
            count++;
        }
        for (let i = 0; i < layersIndexFit.length; i++) {
            const idx = layersIndexFit[i];
            if (this.isHeatLayer(idx)) {
                continue; // heat map
            }
            const layer = this.layerAssets[idx].graphicLayer;
            const graphics = layer.graphics;
            for (let j = 0; j < graphics.length; j++) {
                const f = graphics.getItemAt(j);
                if (!f || !f.attributes || !f.attributes.isAsset || !f.geometry) {
                    continue;
                }
                let extent = f.geometry.extent;
                if (f.geometry.type === 'point') {
                    extent = this.createExtentForPoint(f.geometry);
                }
                if (extent) {
                    count++;
                    if (!fullExtent) {
                        fullExtent = extent.clone();
                    }
                    else {
                        fullExtent.union(extent);
                    }
                }
            }
        }
        if (fullExtent) {
            if (count === 1) { // esri can not extent 1 coordinate
                this.mapView.goTo({
                    center: [fullExtent.xmin, fullExtent.ymin],
                    zoom: 20
                });
            }
            else {
                this.mapView.goTo(fullExtent).then(function () {
                });
            }
        }
    }
    fitLayers(layersIndexFit, hasDefaultCoord) {
        let fullExtent = null;
        let count = 0;
        if (hasDefaultCoord) {
            const geometry = {
                type: 'point',
                longitude: this.defaultLon,
                latitude: this.defaultLat
            };
            const extent = this.createExtentForPoint(geometry);
            fullExtent = extent.clone();
            count++;
        }
        for (let i = 0; i < layersIndexFit.length; i++) {
            const idx = layersIndexFit[i];
            if (this.isHeatLayer(idx)) {
                continue; // heat map
            }
            const layer = this.layerAssets[idx].graphicLayer;
            const graphics = layer.graphics;
            if (graphics.length === 0) {
                continue;
            }
            const f0 = graphics.getItemAt(0);
            if (graphics.length === 1 && f0.geometry.type === 'point') { // esri can not extent 1 coordinate
                const extent = this.createExtentForPoint(f0.geometry);
                this.mapView.goTo({
                    center: [extent.xmin, extent.ymin],
                    zoom: 20
                });
            }
            else {
                const e = graphics
                    .map(g => g.geometry)
                    .reduce((acc, geom) => ({
                    xmin: Math.min(acc.xmin, geom.longitude),
                    ymin: Math.min(acc.ymin, geom.latitude),
                    xmax: Math.max(acc.xmax, geom.longitude),
                    ymax: Math.max(acc.ymax, geom.latitude)
                }), {
                    xmin: Number.MAX_SAFE_INTEGER,
                    ymin: Number.MAX_SAFE_INTEGER,
                    xmax: Number.MIN_SAFE_INTEGER,
                    ymax: Number.MIN_SAFE_INTEGER
                });
                const extent = new this.lib.Extent(e);
                if (extent) {
                    count++;
                    this.mapView.extent = extent.expand(2);
                }
            }
        }
    }
    createMarkerAsset(lat, lon, id, image, name, type) {
        let f = this.getFeatureById(id);
        if (!f) {
            f = this.createPoint(lon, lat, { image, name, type: 'Point' });
        }
        if (type) {
            f.attributes.assetType = type;
        }
        f.attributes.id = id;
        if (type === sclMapConstant.ASSET_PRIMARY_TYPE) {
            this.addFeature(f, this.layerIndexPrimary);
            this.storeSelectedAssets(f, true);
        }
        else if (type === sclMapConstant.ASSET_SECONDARY_TYPE) {
            this.addFeature(f, this.layerIndexSecondary);
            this.storeSelectedAssets(f, false);
        }
        else {
            this.addFeature(f, this.layerIndexAddress);
        }
        return [lon, lat];
    }
    getGEOJSON(cb) {
        const geoJson = { type: 'FeatureCollection', features: [] };
        if (this.drawingShapeSingle) { // single shape
            for (let i1 = 0; i1 < this.drawingShapeSingle.length; i1++) {
                const g = this.drawingShapeSingle[i1]; // graphic
                const geomType = g.geometry.type;
                if (geomType === 'point') {
                    geoJson.features.push({
                        type: 'Feature',
                        properties: null,
                        geometry: {
                            type: 'Point',
                            coordinates: [g.geometry.longitude, g.geometry.latitude]
                        }
                    });
                }
                else if (geomType === 'polyline') {
                    const coors1 = [];
                    const path0 = g.geometry.paths[0];
                    for (let j1 = 0; j1 < path0.length; j1++) {
                        const xy1 = path0[j1];
                        const lngLat1 = this.lib.webMercatorUtils.xyToLngLat(xy1[0], xy1[1]);
                        coors1.push(lngLat1);
                    }
                    geoJson.features.push({
                        type: 'Feature',
                        properties: null,
                        geometry: {
                            type: 'LineString',
                            coordinates: coors1
                        }
                    });
                }
                else if (geomType === 'polygon') {
                    const ring0 = g.geometry.rings[0];
                    const coors2 = [[]];
                    for (let j2 = 0; j2 < ring0.length; j2++) {
                        const xy2 = ring0[j2];
                        const lngLat = this.lib.webMercatorUtils.xyToLngLat(xy2[0], xy2[1]);
                        coors2[0].push(lngLat);
                    }
                    geoJson.features.push({
                        type: 'Feature',
                        properties: null,
                        geometry: {
                            type: 'Polygon',
                            coordinates: coors2
                        }
                    });
                }
            }
        }
        if (this.drawingShapeMulti) { // multi shape
            if (this.drawingShapeMulti.point && this.drawingShapeMulti.point.length > 0) {
                const coors3 = [];
                for (let i1 = 0; i1 < this.drawingShapeMulti.point.length; i1++) {
                    const g = this.drawingShapeMulti.point[i1]; // graphic
                    coors3.push([g.geometry.longitude, g.geometry.latitude]);
                }
                geoJson.features.push({
                    type: 'Feature',
                    properties: null,
                    geometry: {
                        type: 'MultiPoint',
                        coordinates: coors3
                    }
                });
            }
            if (this.drawingShapeMulti.line && this.drawingShapeMulti.line.length > 0) {
                const coors4 = [];
                for (let i = 0; i < this.drawingShapeMulti.line.length; i++) {
                    const g = this.drawingShapeMulti.line[i];
                    const lst = [];
                    for (let j = 0; j < g.geometry.paths.length; j++) {
                        const j0 = g.geometry.paths[j];
                        for (let k = 0; k < j0.length; k++) {
                            const xy = j0[k];
                            const lngLat = this.lib.webMercatorUtils.xyToLngLat(xy[0], xy[1]);
                            lst.push(lngLat);
                        }
                    }
                    coors4.push(lst);
                }
                geoJson.features.push({
                    type: 'Feature',
                    properties: null,
                    geometry: {
                        type: 'MultiLineString',
                        coordinates: coors4
                    }
                });
            }
            if (this.drawingShapeMulti.polygon && this.drawingShapeMulti.polygon.length > 0) {
                const coors = [];
                for (let i = 0; i < this.drawingShapeMulti.polygon.length; i++) {
                    const g = this.drawingShapeMulti.polygon[i];
                    const lst = [];
                    for (let j = 0; j < g.geometry.rings.length; j++) {
                        const lst0 = [];
                        const j0 = g.geometry.rings[j];
                        for (let k = 0; k < j0.length; k++) {
                            const xy = j0[k];
                            const lngLat = this.lib.webMercatorUtils.xyToLngLat(xy[0], xy[1]);
                            lst0.push(lngLat);
                        }
                        lst.push(lst0);
                    }
                    coors.push(lst);
                }
                geoJson.features.push({
                    type: 'Feature',
                    properties: null,
                    geometry: {
                        type: 'MultiPolygon',
                        coordinates: coors
                    }
                });
            }
        }
        if (cb && typeof cb === 'function') {
            cb(geoJson);
        }
    }
    transformEPSG(long, lat, from, to) {
        // TO DO
    }
    checkMapEmpty(pCanvas) {
        // TO DO
    }
    isHeatLayer(layerIndex) {
        if (layerIndex < this.layerAssets.length) {
            const isHeatMap = this.layerAssets[layerIndex].isHeatMap;
            if (isHeatMap) {
                return true;
            }
            return false;
        }
        return false;
    }
    setMinMax(minMax, lng, lat) {
        if (!lat || !lng) {
            return minMax;
        }
        if (lat < minMax.minLat) {
            minMax.minLat = lat;
        }
        else if (lat > minMax.maxLat) {
            minMax.maxLat = lat;
        }
        if (lng < minMax.minLng) {
            minMax.minLng = lng;
        }
        else if (lng > minMax.maxLng) {
            minMax.maxLng = lng;
        }
        return minMax;
    }
    // arcGIS unsupport extent for a point
    createExtentForPoint(geom) {
        // let xy = webMercatorUtils.lngLatToXY(geom.longitude, geom.latitude);
        // let ext = new Extent({
        //     xmin: xy[0],
        //     ymin: xy[1],
        //     xmax: xy[0],
        //     ymax: xy[1],
        //     spatialReference: this.mapView.spatialReference
        // });
        // return ext;
        const ext = new this.lib.Extent({
            xmin: geom.longitude,
            ymin: geom.latitude,
            xmax: geom.longitude,
            ymax: geom.latitude,
            spatialReference: 4326
        });
        return ext;
    }
    fit(ConfigService, maxZoom, initialZoomChange, isCheckEmpty) {
        // zoom to show all the features
        this.initialZoomChange = initialZoomChange;
        this.fitCoors = [];
        let fullExtent = null;
        let countAdd = 0;
        for (let i = 1; i < this.layerAssets.length; i++) {
            if (this.isHeatLayer(i)) {
                continue; // heat map
            }
            const layer = this.layerAssets[i].graphicLayer;
            const graphics = layer.graphics;
            for (let j = 0; j < graphics.length; j++) {
                const f = graphics.getItemAt(j);
                if (!f || !f.attributes || !f.attributes.isAsset || !f.geometry) {
                    continue;
                }
                let extent = f.geometry.extent;
                if (f.geometry.type === 'point') {
                    extent = this.createExtentForPoint(f.geometry);
                }
                if (extent) {
                    if (!fullExtent) {
                        fullExtent = extent.clone();
                    }
                    else {
                        fullExtent.union(extent);
                    }
                    countAdd++;
                }
            }
        }
        if (fullExtent) {
            console.log('%c arcGIS FIT, this.fitCoors = ' + this.fitCoors + ', mapLoaded = ' + this.mapLoaded, 'color:blue');
            this.fitCoors.push([fullExtent.xmin, fullExtent.ymin]);
            this.fitCoors.push([fullExtent.xmax, fullExtent.ymax]);
            this.mapView.goTo(fullExtent).then(function () {
            });
        }
    }
    fitCoords(coords) {
        // calculate bounds base on collection of coordinates
        if (!coords || coords.length === 0) {
            return;
        }
        this.fitCoors = coords;
    }
    fitCoordsAction() {
        this.fitCoordCount = this.fitCoors.length;
        console.log('arcGIS fit action , type = ' + this.type + ', fitCoordCount = ' + this.fitCoordCount);
        if (this.fitCoordCount < 2) { // esri can not extent 1 coordinate
            if (this.fitCoordCount === 1) {
                this.mapView.goTo({
                    center: this.fitCoors[0],
                    zoom: this.zoomFloor
                });
            }
            this.fitCoors = null;
            return;
        }
        let xMin = this.fitCoors[0][0];
        let yMin = this.fitCoors[0][1];
        let xMax = this.fitCoors[0][0];
        let yMax = this.fitCoors[0][1];
        for (let i = 0; i < this.fitCoors.length; i++) {
            const x = this.fitCoors[i][0];
            const y = this.fitCoors[i][1];
            if (x > xMax) {
                xMax = x;
            }
            if (x < xMin) {
                xMin = x;
            }
            if (y > yMax) {
                yMax = y;
            }
            if (y < yMin) {
                yMin = y;
            }
        }
        const leftTop = this.lib.webMercatorUtils.lngLatToXY(xMin, yMin);
        const rightBottom = this.lib.webMercatorUtils.lngLatToXY(xMax, yMax);
        const ext = new this.lib.Extent({
            xmin: leftTop[0],
            ymin: leftTop[1],
            xmax: rightBottom[0],
            ymax: rightBottom[1],
            spatialReference: this.mapView.spatialReference
        });
        this.mapView.extent = ext;
        let currentZoom = this.mapView.zoom;
        if (this.type === 3) { // sc-selected-asset
            if (this.fitCoordCount === 1) {
                currentZoom = currentZoom - 2;
                if (currentZoom < 0) {
                    currentZoom = 1;
                }
                this.mapView.zoom = currentZoom;
            }
        }
        else if (this.type === 1) { // sc-address-map
            if (this.initialZoomChange && this.initialZoomChange !== 0) {
                currentZoom += this.initialZoomChange;
                this.mapView.zoom = currentZoom;
            }
        }
        if (this.mapView.zoom < 0) {
            this.mapView.zoom = 1;
        }
        console.log('%c fitCoord, mapZoom = ' + this.mapView.zoom, 'color:blue');
        this.clampZoomFloor();
        this.fitCoors = null;
        this.fitCoordCount = 0;
    }
    mapReadOnly(isReadOnly) {
        // TO DO
    }
    getAllFeatures() {
        const features = [];
        for (let i = 1; i < this.layerAssets.length; i++) {
            if (this.isHeatLayer(i)) {
                continue;
            } // heat map
            this.layerAssets[i].graphicLayer.graphics.forEach((feature) => {
                if (feature.attributes && feature.attributes.isAsset) {
                    features.push(feature);
                }
            });
        }
        return features;
    }
    getFeaturesFromMap(features, pixel, type, assetSelectionsAvailable) {
        let existedFeature;
        for (let i = features.length - 1; i > -1; i--) {
            if (!features[i] || !features[i].attributes) {
                continue;
            }
            const zIndex = features[i].attributes.zIndex;
            if (features[i].attributes.id.indexOf(type) > -1) {
                existedFeature = features[i];
                features.splice(i, 1);
                continue;
            }
            if ((type === 'primary' && features[i].attributes.id.indexOf('secondary') > -1)
                || (type === 'secondary' && features[i].attributes.id.indexOf('primary') > -1)) {
                features.splice(i, 1);
                continue;
            }
            if (assetSelectionsAvailable) {
                const iAssetSelectionsAvailable = assetSelectionsAvailable[((zIndex - 1) < 0 ? 0 : (zIndex - 1))];
                if (iAssetSelectionsAvailable != null && iAssetSelectionsAvailable.indexOf(type) < 0) {
                    let sType = type;
                    if (type != null && type.trim().length > 0) {
                        sType = type.charAt(0).toUpperCase() +
                            ((type != null && sType.trim().length > 1) ? type.slice(1) : '');
                    }
                    console.log('sc-selected-asset: The assetSelectiosAvailable field is not set to allow ' + sType + ' selections for this layer');
                    features.splice(i, 1); // remove this feature
                }
            }
        }
        return existedFeature;
    }
    getAssetProperties(feature, relatedFields, coordinates, typeAsset, typeSelection) {
        let name = '';
        let id = '';
        if (feature.attributes) {
            name = feature.attributes.name;
            id = feature.attributes.id;
        }
        const propertiesLinkAsset = {
            documentId: id,
            name
        };
        const asset = {
            type: 'Feature',
            properties: {
                type: typeAsset,
                linkAssets: []
            }
        };
        if (!typeSelection || typeSelection === 'featureCollection') {
            asset.geometry = {
                type: 'Point',
                coordinates
            };
        }
        else if (typeSelection !== 'undefined' && typeSelection === 'Asset') {
            const t = feature.attributes.type;
            asset.geometry = {
                type: t,
                coordinates
            };
        }
        if (!id) {
            return '';
        }
        if (relatedFields) {
            for (const field in relatedFields) {
                if (relatedFields.hasOwnProperty(field)) {
                    const value = feature.attributes[field];
                    if (value) {
                        propertiesLinkAsset[field] = value;
                    }
                }
            }
        }
        asset.properties.linkAssets.push(propertiesLinkAsset);
        return asset;
    }
    removeUnselectedAssetItem(existAsset, assets, type) {
        if (existAsset) {
            let isExist = false;
            let idExistAsset = existAsset.properties.linkAssets[0].documentId;
            if (idExistAsset && idExistAsset.indexOf('_') > -1) {
                idExistAsset = idExistAsset.split('_')[0];
            }
            for (let j = 0; j < assets.length; j++) {
                const item = assets[j];
                let idItem = item.properties.linkAssets[0].documentId;
                if (!idItem) {
                    continue;
                }
                if (idItem.indexOf('_') > -1) {
                    idItem = idItem.split('_')[0];
                }
                if (idItem === idExistAsset) {
                    assets.splice(j, 1);
                    isExist = true;
                }
            }
            const len = this.selectedAssets.length;
            for (let i = len - 1; i > -1; i--) {
                let iId = this.getFeatureId(this.selectedAssets[i]);
                if (iId && iId.indexOf('_') > -1) {
                    iId = iId.split('_')[0];
                }
                if (iId === idExistAsset) {
                    const f = this.selectedAssets[i];
                    if (!f || !this.getFeatureId(f)) {
                        continue;
                    }
                    if (type === 'primary' && f.attributes.assetType.indexOf(type) > -1) {
                        this.removeFeature(f, this.layerIndexPrimary);
                        this.selectedAssets.splice(i, 1);
                        isExist = true;
                    }
                    else if (type === 'secondary' && f.attributes.assetType.indexOf(type) > -1) {
                        this.removeFeature(f, this.layerIndexSecondary);
                        this.selectedAssets.splice(i, 1);
                        isExist = true;
                    }
                }
            }
            return isExist;
        }
        return false;
    }
    parseAssetsFromFeatures(features, assetField, coor, typeAsset, mode) {
        if (mode === 'Asset') {
            return this.getAssetProperties(features, assetField.relatedFields, coor, typeAsset, mode);
        }
        else {
            const assets = [];
            for (let i = 0; i < features.length; i++) {
                const asset = this.getAssetProperties(features[i], assetField.relatedFields, coor[i], typeAsset, null);
                if (!asset) {
                    return;
                }
                assets.push(asset);
            }
            return assets;
        }
    }
    getAllFeaturesSelected() {
        // TO DO
    }
    addInteractionSelect(currentSelected) {
        if (this.selectedFeatures == null || (currentSelected != null && this.selectedFeatures.length !== currentSelected.length)) {
            this.selectedFeatures = currentSelected;
        }
        // TO DO : override style or remove graphics ?
        // let self = this;
        // this.layerAssets[this.layerIndexUser].forEach(function(f){
        //     self.layerAssets[self.layerIndexUser].overrideStyle(f, {zIndex: self.layerIndexUser, visible: true});
        // });
        // for(let i = 0; i < this.selectedFeatures.length; i++){
        //     let id = this.getFeatureId(this.selectedFeatures[i]);//this.selectedFeatures[i].j.id;
        //     if(id && id.indexOf("_") > -1) id = id.split("_")[0];
        //     for(let j = 0; j < this.layerIndexFilter + 1; j++){
        //         if(this.isHeatLayer(j)) continue;//heat map
        //         this.layerAssets[j].forEach(function(f){
        //             let fId = self.getFeatureId(f);
        //             if(fId && fId.indexOf(id) > -1){//if(f.j.id.indexOf(id) > -1){
        //                 self.layerAssets[j].overrideStyle(f, {zIndex: j});
        //             }
        //         });
        //     }
        // }
        this.multipleSelection = true;
    }
    removeInteractionSelect() {
        this.multipleSelection = false;
        // TO DO : override style or remove graphics ?
        // let self = this;
        // this.layerAssets[this.layerIndexUser].forEach(function(f){
        //     self.layerAssets[self.layerIndexUser].overrideStyle(f, {visible: false});
        // });
        // for(let i = 0; i < this.selectedFeatures.length; i++){
        //     let id = this.getFeatureId(this.selectedFeatures[i]);//this.selectedFeatures[i].j.id;
        //     if(id && id.indexOf("_") > -1) id = id.split("_")[0];
        //     for(let j = 0; j < this.layerIndexFilter + 1; j++){
        //         if(this.isHeatLayer(j)) continue;//heat map
        //         this.layerAssets[j].forEach(function(f){
        //             let fId = self.getFeatureId(f);
        //             if(fId && fId.indexOf(id) > -1){// if(f.j.id.indexOf(id) > -1){
        //                 self.layerAssets[j].overrideStyle(f, {zIndex: j});
        //             }
        //         });
        //     }
        // }
    }
    showLayer(options) {
        if (options.isShow) {
            this.layerAssets[options.layerIndex].graphicLayer.visible = true;
            this.addInteractionSelect(options.currentSelected);
        }
        else {
            this.layerAssets[options.layerIndex].graphicLayer.visible = false;
            this.removeInteractionSelect();
        }
    }
    activeInteractionSelect(isActive) {
        this.multipleSelection = isActive;
    }
    drawActionDelete(evt) {
        // TO DO
    }
    drawActionProperties(evt) {
        // TO DO
    }
    traverseCoor(coor, obj) {
        if (Array.isArray(coor)) {
            for (let i = 0; i < coor.length; i++) {
                if (Array.isArray(coor[i])) {
                    this.traverseCoor(coor[i], obj);
                }
                else {
                    if (isNaN(coor[i])) {
                        obj.hasNaN = true;
                    }
                    else {
                        coor[i] = Number(coor[i]);
                    }
                }
            }
        }
    }
    createLabel(lat, lng, label, id, color) {
        const font = new this.lib.Font();
        font.size = (!label.labelFontSize) ? '12px' : ((typeof label.labelFontSize === 'string') ?
            (label.labelFontSize.replace('px', '') + 'px') : (label.labelFontSize + 'px'));
        if (label.labelFontWeight) {
            const weight = label.labelFontWeight.toLowerCase();
            if (weight === 'italic') {
                font.style = weight;
            }
            else {
                font.weight = weight;
            }
        }
        font.family = (label.labelFont) ? label.labelFont : 'Arial';
        const currentZoom = this.mapView.zoom;
        const displayZoom = (label.labelDisplayZoom === '' || label.labelDisplayZoom == null) ? 9 :
            (label.labelDisplayZoom > 17 ? 17 : label.labelDisplayZoom);
        const text = (currentZoom < displayZoom ? undefined : ((label.labelText === '' || label.labelText == null) ?
            undefined : label.labelText));
        const textSymbol = new this.lib.TextSymbol(text);
        textSymbol.color = (label.labelColor ? label.labelColor : color).toLowerCase();
        textSymbol.haloColor = (label.labelOutlineColor) ? label.labelOutlineColor.toLowerCase() : 'black';
        textSymbol.haloSize = (!label.labelOutlineWidth) ? '0px' : ((typeof label.labelOutlineWidth === 'string') ?
            (label.labelOutlineWidth.replace('px', '') + 'px') : (label.labelOutlineWidth + 'px'));
        textSymbol.angle = (label.labelRotation) ? label.labelRotation : 0;
        if (this.textSymbolVerticalAlignment.indexOf(label.labelTextBaseline) > -1) {
            textSymbol.verticalAlignment = label.labelTextBaseline;
        }
        else {
            textSymbol.verticalAlignment = 'baseline';
        }
        if (this.textSymbolHorizontalAlignment.indexOf(label.labelTextAlign) > -1) {
            textSymbol.horizontalAlignment = label.labelTextAlign;
        }
        else {
            textSymbol.horizontalAlignment = 'center';
        }
        textSymbol.xoffset = (!label.labelOffsetX) ? '0px' : ((typeof label.labelOffsetX === 'string') ?
            (label.labelOffsetX.replace('px', '') + 'px') : (label.labelOffsetX + 'px'));
        textSymbol.yoffset = (!label.labelOffsetY) ? '0px' : ((typeof label.labelOffsetY === 'string') ?
            (label.labelOffsetY.replace('px', '') + 'px') : (label.labelOffsetY + 'px'));
        textSymbol.font = font;
        const pt = new this.lib.Point(lng, lat);
        const lb = new this.lib.Graphic(pt, textSymbol);
        lb.attributes = {
            id: 'lb_' + id,
            isAsset: false
        };
        return lb;
    }
    updateLabelAllLayers() {
        // just declare
    }
    setupPointSymbol(options) {
        // TO DO : anchor
        let color = 'black';
        let width = 1;
        if (options.color) {
            color = options.color;
        }
        if (options.width) {
            width = options.width;
        }
        color = new this.lib.Color(color.toLowerCase());
        let symbol = {
            type: 'simple-marker',
            color,
            outline: {
                color,
                width
            }
        };
        if (options && options.image) {
            if (options.image.charAt(0) !== '/') {
                options.image = '/' + options.image;
            }
            let anchor = [0, 0];
            if (options.anchor) {
                anchor = options.anchor;
            }
            const size = 24;
            anchor = this.getAnchor(options.image, anchor);
            let xoffset = 0;
            let yoffset = 0;
            if (anchor) {
                xoffset = size * anchor[0]; // default width icon of arcGIS = 12px
                yoffset = size * anchor[1]; // default height icon of arcGIS = 12px
            }
            symbol = {
                type: 'picture-marker',
                url: options.image,
                width: size,
                height: size,
                xoffset,
                yoffset
            };
        }
        return symbol;
    }
    // this.coorAnchor = function(coor, offset){
    //     let num = coor;
    //     let sN1 = num.toString().split('.')[0];
    //     let sN2 = num.toString().split('.')[1];
    //     let n2 = parseInt(sN2);
    //     n2 = n2 - offset;
    //     let sNewNum = sN1 + '.' + n2;
    //     let newNum = parseFloat(sNewNum);
    //     return newNum;
    // };
    coorAnchor(coor, offset) {
        const num = coor;
        const sN1 = num.toString().split('.')[0];
        const sN2 = num.toString().split('.')[1];
        let n2 = parseInt(sN2, 10);
        n2 = n2 - offset;
        const s = n2 + '';
        const len = sN2.length - s.length;
        let s2 = '';
        for (let i = 0; i < len; i++) {
            s2 += '0';
        }
        s2 += n2;
        const sNewNum = sN1 + '.' + s2;
        const newNum = parseFloat(sNewNum);
        return newNum;
    }
    createPoint(lng, lat, options) {
        const symbol = this.setupPointSymbol(options);
        // re-calculate lat/lng
        if (options && options.image) {
            // lat = lat - Math.floor(lat) - symbol.yoffset;
            // lng = lng - Math.floor(lng) - symbol.xoffset;
            lat = this.coorAnchor(lat, symbol.yoffset);
            lng = this.coorAnchor(lng, symbol.xoffset);
        }
        const point = new this.lib.Graphic({
            geometry: {
                type: 'point',
                longitude: lng,
                latitude: lat
            },
            symbol,
            attributes: {
                isAsset: true
            }
        });
        this.setFeatureProperties(point, options);
        return point;
    }
    createLine(coords, options) {
        let color = 'black';
        let width = 1;
        if (options) {
            if (options.color) {
                color = options.color;
            }
            if (options.width) {
                width = options.width;
            }
        }
        color = new this.lib.Color(color.toLowerCase());
        let cap = 'square';
        let dash = 'solid';
        if (options && options.layer) {
            if (options.layer.lineCap) {
                cap = options.layer.lineCap;
            }
            if (options.layer.lineDash) {
                dash = 'dash';
            }
        }
        const line = new this.lib.Graphic({
            geometry: {
                type: 'polyline',
                paths: coords
            },
            symbol: {
                type: 'simple-line',
                color,
                width,
                cap,
                style: dash
            },
            attributes: {
                isAsset: true
            }
        });
        this.setFeatureProperties(line, options);
        return line;
    }
    createPolygon(coords, options) {
        let color = 'black';
        let outlineColor = 'black';
        let width = 1;
        if (options) {
            if (options.color) {
                color = options.color;
            }
            if (options.width) {
                width = options.width;
            }
            if (options.fillColor) {
                outlineColor = options.fillColor;
            }
        }
        color = new this.lib.Color(color.toLowerCase());
        outlineColor = new this.lib.Color(outlineColor.toLowerCase());
        let cap = 'square';
        let dash = 'solid';
        if (options && options.layer) {
            if (options.layer.lineCap) {
                cap = options.layer.lineCap;
            }
            if (options.layer.lineDash) {
                dash = 'dash';
            }
        }
        const polygon = new this.lib.Graphic({
            geometry: {
                type: 'polygon',
                rings: coords
            },
            symbol: {
                type: 'simple-fill',
                color,
                outline: {
                    type: 'simple-line',
                    color: outlineColor,
                    width,
                    cap,
                    style: dash
                }
            },
            attributes: {
                isAsset: true
            }
        });
        this.setFeatureProperties(polygon, options);
        return polygon;
    }
    createMultiPoint(coords, options) {
        if (options.image) {
            delete options.image;
        }
        const mpJson = { points: coords };
        const geom = new this.lib.Multipoint(mpJson);
        const symbol = this.setupPointSymbol(options);
        const obj = new this.lib.Graphic({
            geometry: geom,
            symbol,
            attributes: {
                isAsset: true
            }
        });
        this.setFeatureProperties(obj, options);
        obj.attributes.coordinatesData = coords;
        obj.attributes.type = 'MultiPoint';
        return obj;
    }
    createMultiLineString(coords, options) {
        const obj = this.createLine(coords[0], options);
        obj.attributes.type = 'MultiLineString';
        obj.attributes.coordinatesData = coords;
        for (let i = 1; i < coords.length; i++) {
            obj.geometry.paths.push(coords[i]);
        }
        return obj;
    }
    createMultiPolygon(coords, options) {
        const obj = this.createPolygon(coords[0], options);
        for (let i = 1; i < coords.length; i++) {
            const p = this.createPolygon(coords[i], options);
            obj.geometry.rings.push(p.geometry.rings[0]);
        }
        obj.attributes.type = 'MultiPolygon';
        obj.attributes.coordinatesData = coords;
        return obj;
    }
    createFeatureByType(coord, type, options) {
        let feature;
        options.type = type;
        if (options.tooltips) {
            const tooltip = options.tooltips;
            options.tooltip = tooltip;
            delete options.tooltips;
        }
        if (type === 'Point') {
            const lng = Number(coord[0]);
            const lat = Number(coord[1]);
            if (isNaN(lng) || isNaN(lat)) {
                return null;
            }
            let img = sclMapConstant.MAP_MARKER;
            if (options.point) {
                img = options.point;
            }
            if (options.imageFileNo) {
                if (options.imageFileNo === sclMapConstant.MAP_MARKER
                    || options.imageFileNo === sclMapConstant.MAP_PRIMARY_ASSET
                    || options.imageFileNo === sclMapConstant.MAP_SECONDARY_ASSET) {
                    img = options.imageFileNo;
                }
                else {
                    img = '/api/getFile/' + options.imageFileNo.replace('/api/getFile/', '');
                }
            }
            if (options.image) {
                img = options.image;
            }
            options.image = img;
            feature = this.createPoint(lng, lat, options);
            if (options.label) {
                feature.attributes.lb = this.createLabel(lat, lng, options.label, options.id, options.color);
            }
        }
        else {
            const hasNaN = false;
            const obj = { hasNaN };
            this.traverseCoor(coord, obj);
            if (obj.hasNaN) {
                return null;
            }
            if (type === 'LineString' || type === 'Polyline') {
                feature = this.createLine(coord, options);
            }
            else if (type === 'Polygon') {
                feature = this.createPolygon(coord, options);
            }
            else if (type === 'MultiPoint') {
                feature = this.createMultiPoint(coord, options);
            }
            else if (type === 'MultiLineString') {
                feature = this.createMultiLineString(coord, options);
            }
            else if (type === 'MultiPolygon') {
                feature = this.createMultiPolygon(coord, options);
            }
            let color = 'purple';
            // Changed to use color setup in selected asset for handlebars
            if (options.color) {
                color = options.color;
            }
            const relatedAssets = (options.relatedAsset ? options.relatedAsset : '');
            const url = (options.url ? options.url : '');
            const primaryMultiPopup = (options.primaryMultiPopup ? options.primaryMultiPopup : '');
            const secondaryMultiPopup = (options.secondaryMultiPopup ? options.secondaryMultiPopup : '');
            const properties = sclAssetLayers.createLineProperties(options.layer, options.name, color, options.id, options.tooltip, primaryMultiPopup, secondaryMultiPopup, options.layerDisplayOnly, relatedAssets, url);
            for (const p in properties) {
                if (properties.hasOwnProperty(p) && !feature.attributes.hasOwnProperty(p)) {
                    feature.attributes[p] = properties[p];
                }
            }
            if (options.label) {
                const coord1 = feature.geometry.extent.center;
                feature.attributes.lb = this.createLabel(coord1.latitude, coord1.longitude, options.label, options.id, options.color);
            }
        }
        if (options.layer) {
            feature.attributes.layer = options.layer;
        }
        return feature;
    }
    setFeatureProperties(feature, properties) {
        if (!feature.attributes) {
            feature.attributes = {};
        }
        if (properties) {
            for (const p in properties) {
                if (properties.hasOwnProperty(p)) {
                    feature.attributes[p] = properties[p];
                }
            }
        }
    }
    resetFeatureProperties(feature, properties) {
        feature.attributes = properties;
    }
    getFeatureProperty(feature, propertyName) {
        return feature.attributes[propertyName];
    }
    getFeatureProperties(feature, fieldNames) {
        const p = {};
        const pro = feature.attributes;
        for (let i = 0; i < fieldNames.length; i++) {
            p[fieldNames[i]] = pro[fieldNames[i]];
        }
        return p;
    }
    getFeatureId(feature) {
        return feature.attributes.id;
    }
    setFeatureId(feature, id) {
        feature.attributes.id = id;
    }
    getFeatureGeomType(feature) {
        const t = feature.attributes.type;
        return t;
    }
    getFeatureById(id) {
        let f = null;
        for (let i = 1; i < this.layerAssets.length; i++) {
            if (this.isHeatLayer(i)) {
                continue;
            } // heat map
            const graphics = this.layerAssets[i].graphicLayer.graphics;
            for (let j = 0; j < graphics.length; j++) {
                const fea = graphics.getItemAt(j);
                if (!fea || !fea.attributes || !fea.attributes.isAsset) {
                    continue;
                }
                const fId = this.getFeatureId(fea);
                if (fId === id) {
                    f = fea;
                    break;
                }
            }
            if (f) {
                break;
            }
        }
        return f;
    }
    getFeatureByLayer(id, layerIndex) {
        if (layerIndex > this.layerAssets.length - 1) {
            return null;
        }
        if (this.isHeatLayer(layerIndex)) {
            return null; // heat map
        }
        let f = null;
        const graphics = this.layerAssets[this.layerIndexUser].graphicLayer.graphics;
        const len = graphics.length;
        for (let i = 0; i < len; i++) {
            const fea = graphics.getItemAt(i);
            const fId = this.getFeatureId(fea);
            if (fId === id) {
                f = fea;
                return;
            }
        }
        return f;
    }
    getFeatureByPixel(pixel) {
        return { feature: pixel.fea };
    }
    featureClone(fea, layerIndex) {
        const g = fea.clone();
        if (g.attributes.lb) {
            delete g.attributes.lb;
        }
        if (layerIndex === this.layerIndexUser && g.attributes
            && (g.attributes.type === 'Point' || g.attributes.type === 'MultiPoint')) {
            const style = this.layerAssets[layerIndex].style;
            if (style.imageFileNo) {
                g.symbol.url = style.imageFileNo;
            }
        }
        return g;
    }
    getEventByPixel(pixel) {
        // TO DO
    }
    getFeaturesCollection(options) {
        const lst = [];
        if (options.feature && options.feature.length > 0) {
            for (let i = 0; i < options.feature.length; i++) {
                lst.push({ feature: options.feature[i] });
                const fId = options.feature[i].attributes.id;
                const zIndex = options.feature[i].attributes.zIndex;
                if (this.isHeatLayer(zIndex)) {
                    continue;
                } // heat map
                const layer = this.layerAssets[zIndex].graphicLayer.graphics;
                layer.forEach((graphic) => {
                    const att = graphic.attributes;
                    let id0 = att.id;
                    if (att && att.id && att.id !== fId) {
                        if (att.id.indexOf('_') > -1) {
                            id0 = att.id.split('_')[0];
                        }
                        if (fId.indexOf(id0) > -1) {
                            lst.push({ feature: graphic });
                        }
                    }
                });
            }
        }
        return lst;
    }
    getFeaturesCollectionId(id, isClone) {
        const fs = [];
        for (let i = 0; i < this.layerAssets.length; i++) {
            if (this.isHeatLayer(i)) {
                continue;
            } // heat map
            const graphics = this.layerAssets[i].graphicLayer.graphics;
            graphics.forEach((f) => {
                if (f.attributes && f.attributes.isAsset) {
                    const fId = f.attributes.id;
                    if (fId && fId.indexOf(id) > -1) {
                        let isExist = false;
                        for (let k = 0; k < fs.length; k++) {
                            if (!fs[k].attributes) {
                                continue;
                            }
                            if (fs[k].attributes.id === fId) {
                                isExist = true;
                                break;
                            }
                        }
                        if (!isExist) {
                            if (isClone) {
                                const g = f.clone();
                                if (g.attributes.lb) {
                                    delete g.attributes.lb;
                                }
                                if (this.type === 1) { // sc-address-map
                                    const style = this.layerAssets[this.layerIndexUser].style;
                                    if (style.imageFileNo) {
                                        g.symbol.url = style.imageFileNo;
                                    }
                                }
                                fs.push(g);
                            }
                            else {
                                fs.push(f);
                            }
                        }
                    }
                }
            });
        }
        return fs;
    }
    updateStyleByFeature(layerClone, color, imageFileNo, anchor, style) {
        const currentStyle = cloneDeep(style);
        if (color) {
            currentStyle.color = color;
        }
        if (layerClone.fill) {
            currentStyle.fill = layerClone.fill;
        }
        if (layerClone.fillOpacity) {
            currentStyle.fillOpacity = layerClone.fillOpacity;
        }
        if (layerClone.lineCap) {
            currentStyle.lineCap = layerClone.lineCap;
        }
        if (layerClone.lineDash) {
            currentStyle.lineDash = layerClone.lineDash;
        }
        if (layerClone.lineWidth) {
            currentStyle.lineWidth = layerClone.lineWidth;
        }
        if (anchor) {
            currentStyle.imageAnchor = anchor;
        }
        if (imageFileNo) {
            currentStyle.imageFileNo = imageFileNo;
        }
        return currentStyle;
    }
    featureUpdateStyle(feature, style) {
        if (feature.attributes && style) {
            if (feature.attributes.type === 'Point' || feature.attributes.type === 'MultiPoint') {
                if (style.fill && style.fill.indexOf('{') > -1) {
                    return;
                }
                if (style.color) {
                    feature.symbol.color = style.color.toLowerCase();
                }
                if (style.fill) {
                    feature.symbol.color = style.fill.toLowerCase();
                }
                //
                if (style.fillOpacity) {
                    feature.symbol.color.a = style.fillOpacity;
                }
                if (feature.symbol.outline) {
                    if (style.lineWidth) {
                        feature.symbol.outline.width = style.lineWidth;
                    }
                    if (style.color) {
                        feature.symbol.outline.color = style.color.toLowerCase();
                    }
                }
                if (style.imageAnchor) {
                    if (feature.symbol.width) {
                        feature.symbol.xoffset = feature.symbol.width * style.imageAnchor[0];
                    }
                    if (feature.symbol.height) {
                        feature.symbol.yoffset = feature.symbol.height * style.imageAnchor[1];
                    }
                }
            }
            else if (feature.attributes.type === 'LineString' || feature.attributes.type === 'MultiLineString' ||
                feature.attributes.type === 'Polyline') {
                if (style.color && style.color.indexOf('{') > -1) {
                    return;
                }
                if (style.color) {
                    feature.symbol.color = style.color.toLowerCase();
                }
                if (style.lineWidth) {
                    feature.symbol.width = style.lineWidth;
                }
                if (style.lineCap) {
                    feature.symbol.cap = style.lineCap;
                }
                if (style.lineDash) {
                    feature.symbol.style = 'dash';
                }
            }
            else { // polygon
                if (style.fill && style.fill.indexOf('{') > -1) {
                    return;
                }
                if (style.fill) {
                    feature.symbol.color = style.fill.toLowerCase();
                }
                if (style.fillOpacity && feature.symbol.color) {
                    feature.symbol.color.a = style.fillOpacity;
                }
                if (!feature.symbol.outline) {
                    feature.symbol.outline = { color: 'black', width: 1 };
                }
                if (style.lineWidth) {
                    feature.symbol.outline.width = style.lineWidth;
                }
                if (style.color) {
                    feature.symbol.outline.color = style.color.toLowerCase();
                }
                if (style.lineCap) {
                    feature.symbol.outline.cap = style.lineCap;
                }
                if (style.lineDash) {
                    feature.symbol.outline.style = 'dash';
                }
            }
        }
    }
    addFeature(feature, layerIndex) {
        if (!feature) {
            return;
        }
        const style = this.layerAssets[layerIndex].style;
        if (!feature.attributes) {
            feature.attributes = {};
        }
        feature.attributes.zIndex = 0;
        if (layerIndex && layerIndex < this.layerAssets.length) {
            feature.attributes.zIndex = layerIndex;
            if ((style.color && style.color.indexOf('{') > -1) || (style.fill && style.fill.indexOf('{') > -1)) {
                const handlebarStyle = this.updateStyleByFeature(feature.attributes.layer, feature.attributes.color, null, null, style);
                this.featureUpdateStyle(feature, handlebarStyle);
            }
            else {
                this.featureUpdateStyle(feature, style);
            }
            const graphics = this.layerAssets[layerIndex].graphicLayer.graphics;
            let isAdded = false;
            graphics.forEach((f, i) => {
                if (f.attributes.id === feature.attributes.id) {
                    isAdded = true;
                    return;
                }
            });
            if (!isAdded) {
                graphics.add(feature);
                if (feature.attributes.lb) {
                    graphics.add(feature.attributes.lb);
                }
            }
        }
    }
    removeFeature(feature, layerIndex) {
        if (layerIndex) {
            if (layerIndex > this.layerAssets.length) {
                return;
            }
            if (feature.attributes.lb) {
                this.layerAssets[layerIndex].graphicLayer.graphics.remove(feature.attributes.lb);
            }
            this.layerAssets[layerIndex].graphicLayer.graphics.remove(feature);
        }
        else {
            const zIndex = feature.attributes.zIndex;
            if (feature.attributes.lb) {
                this.layerAssets[zIndex].graphicLayer.graphics.remove(feature.attributes.lb);
            }
            this.layerAssets[zIndex].graphicLayer.graphics.remove(feature);
        }
    }
    removeItemFromMap(id) {
        for (let i = 0; i < this.layerAssets.length; i++) {
            const layer = this.layerAssets[i].graphicLayer.graphics;
            if (!layer) {
                continue;
            }
            layer.forEach((graphic) => {
                const att = graphic.attributes; // graphic.graphic.attributes;
                if (att && att.id && att.id === id) {
                    if (att.lb) {
                        layer.remove(att.lb);
                    }
                    layer.remove(graphic); // layer.remove(graphic.graphic);
                }
            });
        }
    }
    getMapSize() {
        return [this.mapView.width, this.mapView.height];
    }
    getBoundingBox(options) {
        const extent = this.mapView.extent;
        if (extent) {
            const leftTop = this.lib.webMercatorUtils.xyToLngLat(extent.xmin, extent.ymin);
            const rightBottom = this.lib.webMercatorUtils.xyToLngLat(extent.xmax, extent.ymax);
            if (isNaN(leftTop[0]) || isNaN(leftTop[1]) || isNaN(rightBottom[0]) || isNaN(rightBottom[1])) {
                return null;
            }
            const left = leftTop[0];
            const bottom = rightBottom[1];
            const right = rightBottom[0];
            const top = leftTop[1];
            let minLon = left;
            let maxLon = right;
            if (left > right) {
                minLon = right;
                maxLon = left;
            }
            let minLat = bottom;
            let maxLat = top;
            if (bottom > top) {
                minLat = top;
                maxLat = bottom;
            }
            return { minLon, maxLat, maxLon, minLat, zoom: this.mapView.zoom };
            // return { left: leftTop[0], top: leftTop[1], right: rightBottom[0], bottom: rightBottom[1], zoom: this.mapView.zoom};
        }
        return null;
    }
    addSearchAddress(apiKey, wrapper, cb) {
        // TO DO
    }
    clearAllFeatures() {
        // TO DO
    }
    clearAllFeaturesLayer(layerIndex) {
        if (layerIndex > this.layerAssets.length) {
            return;
        }
        this.layerAssets[layerIndex].graphicLayer.removeAll();
    }
    updateSize() {
        // TO DO
    }
    getLatLngFromPixel(pixel) {
        return [];
    }
    getPixelFromCoordinate(coordinate) {
        // TO DO
    }
    findFeatureByClick(evt, sType, assetSelectionsAvailable) {
        const features = evt.clickFeature;
        const coor = [evt.event.mapPoint.longitude, evt.event.mapPoint.latitude];
        const pixel = [evt.event.x, evt.event.y];
        const existedFeature = this.getFeaturesFromMap(features, pixel, sType, assetSelectionsAvailable);
        return { coor, pixel, features, existedFeature };
    }
    checkFeatureExist(layerIndex, id) {
        this.layerAssets[layerIndex].graphicLayer.graphics.find(function (fea) {
            return fea.attributes.id === id;
        });
    }
    _storeSelectedAsset(feature, isPrimary) {
        if (!this.selectedAssets) {
            this.selectedAssets = [];
        }
        const len = this.selectedAssets.length;
        if (!feature.attributes) {
            return;
        }
        const fId = feature.attributes.id;
        for (let i = 0; i < len; i++) {
            const iPro = this.selectedAssets[i].attributes;
            if (!iPro) {
                continue;
            }
            const iId = iPro.id;
            if (iId === fId) {
                if (isPrimary) {
                    let isExist;
                    isExist = this.checkFeatureExist(this.layerIndexPrimary, iId);
                    if (!isExist) {
                        this.addFeature(feature, this.layerIndexPrimary);
                        this.setFeatureProperties(feature, { zIndex: this.layerIndexPrimary });
                    }
                }
                else {
                    let isExist;
                    isExist = this.checkFeatureExist(this.layerIndexSecondary, iId);
                    if (!isExist) {
                        this.addFeature(feature, this.layerIndexSecondary);
                        this.setFeatureProperties(feature, { zIndex: this.layerIndexSecondary });
                    }
                }
                this.selectedAssets[i] = feature;
                return;
            }
        }
        this.selectedAssets.push(feature);
        if (isPrimary) {
            this.addFeature(feature, this.layerIndexPrimary);
        }
        else {
            this.addFeature(feature, this.layerIndexSecondary);
        }
    }
    storeSelectedAssets(feature, isPrimary) {
        this._storeSelectedAsset(feature, isPrimary);
    }
    updateStoredSelectedAssetVisualize(id, primary, secondary) {
        if (!this.selectedAssets) {
            return;
        }
        const len = this.selectedAssets.length;
        for (let i = 0; i < len; i++) {
            const feature = this.selectedAssets[i];
            const p = feature.attributes;
            let fId = p.id;
            if (fId.indexOf('_') > -1) {
                fId = fId.split('_')[0];
            }
            if (id.indexOf(fId) > -1) {
                this.setFeatureProperties(feature, { primary, secondary });
                break;
            }
        }
    }
    removeSelectedAssetsById(id) {
        let fId = id;
        let mode = 'NA';
        if (fId && fId.indexOf('primary') > -1) {
            mode = 'primary';
        }
        else if (fId && fId.indexOf('secondary') > -1) {
            mode = 'secondary';
        }
        if (fId && fId.indexOf('_') > -1) {
            fId = fId.split('_')[0];
        }
        const len = this.selectedAssets.length;
        for (let i = len - 1; i > -1; i--) {
            if (!this.selectedAssets[i].attributes) {
                continue;
            }
            const iId = this.selectedAssets[i].attributes.id;
            if ((iId && iId.indexOf(mode) > -1 && iId.indexOf(fId) > -1) || iId === fId) {
                this.selectedAssets.splice(i, 1);
                this.removeItemFromMap(iId);
            }
        }
    }
    removeLayerFeatures() {
        for (let i = 1; i < this.layerAssets.length; i++) {
            if (this.isHeatLayer(i)) {
                continue; // heat map
            }
            this.layerAssets[i].graphicLayer.graphics.removeAll();
        }
    }
    // copy from sclAssetLayers.removeUnselectedAsset
    removeUnselectedAsset(assets, unSelectedAssetIds, type) {
        // TO DO
    }
    updateLayers(pLayerAssets) {
        // remove feature in all layers
        this.removeLayerFeatures();
        // remove old layers
        for (let i = 1; i < this.layerAssets.length; i++) {
            this.map.remove(this.layerAssets[i].graphicLayer);
        }
        // add new layers
        const obj = { layerAssets: pLayerAssets };
        this.createLayers(obj);
        for (let i = 1; i < this.layerAssets.length; i++) {
            this.map.add(this.layerAssets[i].graphicLayer, i);
        }
    }
    // ************** use for psma layer reverse function *******************************************
    psmaStyleFunction() {
        // No need
    }
    psmaCreateLayer(psmaPoints) {
        if (!this.psmaReverse) {
            this.psmaReverse = {};
            for (let i = 0; i < psmaPoints.length; i++) {
                this.addFeature(psmaPoints[i], this.layerIndexAddress); // 13835
            }
            this.psmaReverse.psmaSourceVector = this.layerAssets[this.layerIndexAddress]; // 13835
            this.psmaReverse.psmaLayer = this.layerAssets[this.layerIndexAddress]; // 13835
        }
        return this.psmaReverse;
    }
    psmaCreatePoint(coor, properties, psmaPoints) {
        const symbol = {
            type: 'simple-marker',
            color: 'rgba(255, 127, 39, 1)',
            outline: {
                color: 'rgba(255, 0, 0, 1)',
                width: 1
            },
            size: 4
        };
        const circleGeom = new this.lib.Circle({
            center: coor,
            radius: 0.1
        });
        const point = new this.lib.Graphic({
            geometry: circleGeom,
            symbol
        });
        this.setFeatureProperties(point, properties);
        this.addFeature(point, this.layerIndexAddress);
        psmaPoints.push(point);
        return psmaPoints;
    }
    psmaCreatePointClick(coor, radius, psmaPoints) {
        // let symbol = this.setupPointSymbol({type: 'Polygon'})
        const symbol = {
            type: 'simple-fill',
            color: 'rgba(255,255,255,0.4)',
            outline: {
                color: '#3399CC',
                width: 1
            }
        };
        const center = new this.lib.Point({ latitude: coor[1], longitude: coor[0], spatialReference: this.mapView.spatialReference });
        const circleGeom = new this.lib.Circle({
            center,
            radius
        });
        const circle = new this.lib.Graphic({
            geometry: circleGeom,
            symbol
        });
        this.addFeature(circle, this.layerIndexAddress);
        psmaPoints.push(this.marker);
        psmaPoints.push(circle);
        return psmaPoints;
    }
    psmaRemovePoint(psmaPoints, psmaSourceVector) {
        for (let i = 0; i < psmaPoints.length; ++i) {
            // if(!psmaPoints[i]) continue;
            psmaSourceVector.graphicLayer.graphics.remove(psmaPoints[i]);
        }
        return { psmaPoints, psmaSourceVector };
    }
    rad(x) {
        return x * Math.PI / 180;
    }
    psmaDistanceCoords(coorA, coorB) {
        const R = 6378137; // Earth’s mean radius in meter
        const dLat = this.rad(coorB[1] - coorA[1]);
        const dLong = this.rad(coorB[0] - coorA[0]);
        const a = Math.sin(dLat / 2) * Math.sin(dLat / 2) +
            Math.cos(this.rad(coorA[1])) * Math.cos(this.rad(coorB[1])) *
                Math.sin(dLong / 2) * Math.sin(dLong / 2);
        const c = 2 * Math.atan2(Math.sqrt(a), Math.sqrt(1 - a));
        const d = R * c;
        return d; // returns the distance in meter
    }
    // copy from this.sclUtilMapService.positionView
    positionView(lat, lon, zoom, EPSG) {
        lat = typeof lat !== 'undefined' ? lat : 0;
        lon = typeof lon !== 'undefined' ? lon : 0;
        zoom = typeof zoom !== 'undefined' ? zoom : 2;
        EPSG = typeof EPSG !== 'undefined' ? EPSG : 'EPSG:3857';
        this.mapView.zoom = zoom; // This will trigger a zoom_changed on the map
        this.mapView.center = [lon, lat];
    }
    //
    setCenterMapViewByCoordinates(bbox) {
        const xmin = bbox[0][0];
        const ymin = bbox[0][1];
        const xmax = bbox[1][0];
        const ymax = bbox[1][1];
        const ext = new this.lib.Extent({
            xmin,
            ymin,
            xmax,
            ymax
        });
        this.mapView.extent = ext; // Updates the view without animation
    }
    // 15262
    setCenter(lat, lon) {
        this.mapView.center = [lon, lat];
    }
}
/** @nocollapse */ /** @nocollapse */ SclMappingFunctionsArcGisService.ɵfac = function SclMappingFunctionsArcGisService_Factory(t) { return new (t || SclMappingFunctionsArcGisService)(); };
/** @nocollapse */ /** @nocollapse */ SclMappingFunctionsArcGisService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMappingFunctionsArcGisService, factory: SclMappingFunctionsArcGisService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMappingFunctionsArcGisService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return []; }, null);
})();

class SclMapRulesInterfaceService {
    constructor(clientRulesService) {
        this.clientRulesService = clientRulesService;
        this.intervalDelay = 2000;
    }
    init(formbirdInjectorService, changedDocumentService, subs) {
        this.formbirdInjectorService = formbirdInjectorService;
        this.changedDocumentService = changedDocumentService;
        this.subs = subs;
    }
    initWatchInterval(ClientRuleService, $interval, cb) {
        ClientRuleService.$interval = $interval;
        ClientRuleService.intervalDelay = this.intervalDelay;
        $interval(function () {
            cb();
        }, this.intervalDelay);
    }
    // Generic global variable functions
    // These should be moved to a seperate library at some stage when I can work out how to call it from
    //   both the components load function and then the rules script
    setRCGlobal(component, componentName, variable, value) {
        const varName = component + '_' + componentName + '_' + variable;
        this.clientRulesService.setSharedValue(varName, { value: value, time: new Date().getTime() });
        // logger.info("setRCGlobal: setSharedValue["+varName+"].value = "+JSON.stringify(ClientRulesService.getSharedValue(varName).value));
    }
    getRCGlobal(component, componentName, variable) {
        const varName1 = component + '_' + componentName + '_' + variable;
        // logger.info("getRCGlobal: getSharedValue["+varName+"].value == "+JSON.stringify(ClientRulesService.getSharedValue(varName).value));
        return this.clientRulesService.getSharedValue(varName1).value;
    }
    watchRCGlobal(component, componentName, variable, callback) {
        const varName2 = component + '_' + componentName + '_' + variable;
        // logger.info("watchRCGlobal : Not yet implemented. No callback for " + varName);
    }
    // Map "layers" functions
    getMapLayers(component, componentName) {
        return this.getRCGlobal(component, componentName, 'layers-field');
    }
    setMapLayers(component, componentName, layers, isFirstSet, componentDefinition, documentId) {
        this.setRCGlobal(component, componentName, 'layers-field', layers);
        if (isFirstSet) {
            this.createWatchLayers(componentDefinition, documentId);
        }
    }
    createWatchLayers(componentDefinition, documentId) {
        const field = componentDefinition;
        const varName = field.componentName + '_' + field.name + '_' + 'layers-field';
        const observeOnScope = new Observable(observer => {
            observer.next(this.clientRulesService.getSharedValue(varName));
            observer.complete();
        });
        observeOnScope.subscribe({
            next: change => {
                const newValue = change; // change.newValue;
                console.log("Observable Watch Function for field.layers", change, newValue.value);
                const objValue = newValue.value;
                componentDefinition.layers = objValue;
            }
        });
    }
    watchLayers(component, componentName, callback) {
        this.watchRCGlobal(component, componentName, 'layers-field', callback);
    }
    // Map view bounding box coordinates
    setCurrentMapviewCoords(component, componentName, value, isFirstSet, isSetOnMoveEnd, componentDefinition, documentId, MapFunc) {
        this.setRCGlobal(component, componentName, 'MapBoundingBox', value);
        if (isFirstSet) {
            this.createWatchMapviewCoords(componentDefinition, documentId, MapFunc);
        }
        this.setRCGlobal(component, componentName, 'isSetOnMoveEnd', isSetOnMoveEnd ? true : false);
    }
    getCurrentMapViewCoordsIsSetOnMoveEnd(component, componentName) {
        return this.getRCGlobal(component, componentName, 'isSetOnMoveEnd');
    }
    getCurrentMapviewCoords(component, componentName) {
        return this.getRCGlobal(component, componentName, 'MapBoundingBox');
    }
    createWatchMapviewCoords(componentDefinition, documentId, MapFunc) {
        const field = componentDefinition;
        const ClientRulesService = this.formbirdInjectorService.get('ClientRulesService');
        // var observeOnScope = $injector.get('observeOnScope');
        const varName = field.componentName + '_' + field.name + '_' + 'MapBoundingBox';
        const scopeSub = this.changedDocumentService.watchDocument(documentId).subscribe(objValue => {
            if (objValue) {
                const latlng = objValue[1];
                // logger.info("sclMapRulesInterface=>Observable Watch Function for MapviewCoords, latlng= " + latlng,scope.MapFunc);
                // logger.info("sclMapRulesInterface, ol = " + ol);
                if (MapFunc && (objValue != null && objValue.length === 2)) {
                    if (!ClientRulesService.getSharedValue(field.componentName + '_' + field.name + '_' + 'isSetOnMoveEnd').value) {
                        // logger.info("setCentermapViewByCoordinates is triggered");
                        MapFunc.mapObj.setCenterMapViewByCoordinates(objValue);
                    }
                }
            }
        });
        this.subs.add(scopeSub);
    }
}
/** @nocollapse */ /** @nocollapse */ SclMapRulesInterfaceService.ɵfac = function SclMapRulesInterfaceService_Factory(t) { return new (t || SclMapRulesInterfaceService)(i0.ɵɵinject(i1.ClientRulesService)); };
/** @nocollapse */ /** @nocollapse */ SclMapRulesInterfaceService.ɵprov = /** @pureOrBreakMyCode */ i0.ɵɵdefineInjectable({ token: SclMapRulesInterfaceService, factory: SclMapRulesInterfaceService.ɵfac, providedIn: 'root' });
(function () {
    (typeof ngDevMode === "undefined" || ngDevMode) && i0.ɵsetClassMetadata(SclMapRulesInterfaceService, [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], function () { return [{ type: i1.ClientRulesService }]; }, null);
})();

/*
 * Public API Surface of formbird-mapping
 */

/**
 * Generated bundle index. Do not edit.
 */

export { AddressDetails, FormbirdMappingModule, GeoAutoCompleteModule, GeoAutocompleteComponent, HttpService, SanitizeHtmlPipe, SanitizingModule, SclAssetLayersService, SclMapConstantService, SclMapGeoCodeFarmService, SclMapGeoDocService, SclMapGeoHereService, SclMapGeoPSMAService, SclMapGeoPsmaFarmService, SclMapGeoVicmapService, SclMapRulesInterfaceService, SclMapViewsService, SclMappingFunctionOpenLayersService, SclMappingFunctionsArcGisService, SclProjectionConstantService, SclUtilMapService };
//# sourceMappingURL=formbird-mapping.mjs.map
